/*
	Backtracking - 30 puncte
	Constantin Galatan
*/

#include <fstream>
#include <iostream>
#include <climits>
#include <algorithm>
using namespace std;


#define sus 0
#define dr  1
#define jos 2
ifstream fin("joc.in");
ofstream fout("joc.out");

const int di[] = { -1, 0, 1 },
	      dj[] = { 0, 1, 0 };

int a[2][5001];
int sol[2][5001];
int Smax = -99999;
int n;
int K, k;

void Read();
void Rec(int l, int c, int s);
int OK(int i, int j, int d);

int main()
{
	Read();
	k = 1;
	Rec(0, 0, 0);
	fout << Smax << '\n';
	fout.close();
}

void Rec(int i, int j, int s)
{
	int temp = k;
	if ( i == 1 && j == n - 1)
	{
		if ( s + a[1][n-1] > Smax )
			Smax = s + a[1][n-1];
		return;
	}
	int iv, jv;
	sol[i][j] = 1;
	for (int d = 0; d < 3; ++d )
	{
		iv = i + di[d];
		jv = j + dj[d];
		if ( OK(iv, jv, d) )
		{
			if ( d == 1 ) k++;
			if ( d == 0 || d == 2 ) k = 1;
			Rec(iv, jv, s + a[i][j]);
			if ( d == 0 || d == 2 ) k = temp;
		}
	}
	sol[i][j] = 0;
}

int OK(int i, int j, int d)
{
	if ( d == 1 && k + 1 > K) return 0;
	if ( i < 0 || i >= 2 || j < 0 || j >= n ) return 0;
	if ( sol[i][j] == 1 ) return 0;
	return 1;
}

void Read()
{
	fin >> n >> K;
	for ( int i = 0; i < 2; ++i )
		for ( int j = 0; j < n; ++j )
			fin >> a[i][j];
	fin.close();

}

