#include <iostream>
#include <fstream>
#include <algorithm>
#include <cassert>
#include <memory.h>
using namespace std;

const char iname[] = "gaz.in";
const char oname[] = "gaz.out";

const int MAX_N = 105;
const int MAX_L = 1005;
const int INF   = 0x3f3f3f3f;

int bst[2][MAX_N * MAX_L];

int main(void) {
    FILE *fi = fopen(iname, "r");
    int L, P, D, C, N, G[MAX_N], S[MAX_N];

    assert(fscanf(fi, "%d %d %d %d", &L, &P, &D, &C) == 4);
    assert(fscanf(fi, "%d", &N) == 1);
    for (int i = 0; i < N; ++ i)
        assert(fscanf(fi, "%d", &G[i]) == 1);

    S[N] = 0;
    for (int i = N - 1; i >= 0; -- i)
        S[i] = G[i] + S[i + 1];

    int stp = 0;
    memset(bst[stp], INF, sizeof bst[stp]);
    for (int j = G[0]; j <= S[0]; ++ j)
        bst[stp][j] = P;

    for (int i = 0; i < N - 1; ++ i) {
        memset(bst[stp ^ 1], INF, sizeof bst[stp ^ 1]);
        for (int j = G[i]; j <= S[i]; ++ j) {
            int alpha = max(0, j - G[i] - L);
            for (int k = max(G[i + 1], j - G[i]); k <= S[i + 1]; ++ k)
                bst[stp ^ 1][k] = min(bst[stp ^ 1][k], bst[stp][j] + alpha * C + (k > j - G[i]) * P);
        }
        stp ^= 1;
    }

    fprintf(fopen(oname, "w"), "%d\n", bst[stp][G[N - 1]] + S[0] * D);
//  printf("%d\n", bst[stp][G[N - 1]] + S[0] * D);

    fclose(fi);
    return 0;
}
