#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <algorithm>
#include <cassert>
using namespace std;

const char iname[] = "mesaje.in";
const char oname[] = "mesaje.out";

const int MAX_MESAJE = 128;

vector < vector <string> > mesaje;
vector < pair < pair < vector <int>, int>, string > > words_in_common;

int compare(pair < pair < vector <int>, int>, string > a, pair < pair < vector <int>, int>, string > b) {
    vector <int> va = a.first.first, vb = b.first.first;
    for (int i = 0; i < (int) va.size(); ++ i) {
        if (va[i] != vb[i])
            return va[i] > vb[i];
    }
    return a.first.second <= b.first.second;
}

int main(void) {
    ifstream in(iname);
    string str;

    while (getline(in, str)) {
        assert(0 < str.size() && str.size() < 30003);
        istringstream iss(str);
        vector <string> temp;

        while (iss >> str) {
            temp.push_back(str);
            assert(str.size() < 21);
        }
        mesaje.push_back(temp);
    }
    in.close();

    for (int i = 0; i < (int) mesaje.size() - 1; ++ i)
        assert(mesaje[i].size() == mesaje[i + 1].size());
    assert(mesaje.size() < 129);

    for (int idx = (int) mesaje.size() - 1; idx >= 0 && words_in_common.size() == 0; idx --) {
        for (int i = 0; i < (int) mesaje[idx].size(); ++ i) {
            if (mesaje[0][i] == mesaje[idx][i])
                words_in_common.push_back(make_pair(make_pair(vector <int>(), i), mesaje[0][i]));
        }
    }

    for (int i = 0; i < (int) words_in_common.size(); ++ i) {
        for (int j = 0; j < (int) mesaje.size(); ++ j) {
            if (words_in_common[i].second == mesaje[j][words_in_common[i].first.second])
                words_in_common[i].first.first.push_back(j);
        }
        reverse(words_in_common[i].first.first.begin(), words_in_common[i].first.first.end());
    }
    sort(words_in_common.begin(), words_in_common.end(), compare);

    ofstream out(oname);
    out << words_in_common.size() << "\n";
    for (int i = 0; i < (int) words_in_common.size(); ++ i) {
        reverse(words_in_common[i].second.begin(), words_in_common[i].second.end());
        out << words_in_common[i].second << " ";
    }
    out.close();

    return 0;
}
