#include <fstream>
#include <iostream>
#include <map>

using namespace std;

map<int,int> fre;
int a[300][300],n,m,k,dst=0,kc=0,x,y;

void citire() {
	int i,j;
	ifstream fin("submatrix.in");
	fin>>n>>m>>k;
	for (i=0;i<n;i++)
		for (j=0;j<m;j++)
			fin>>a[i][j];
}

inline void add(int x,int y) {
	if (fre[a[x][y]]++==0)
		kc++;
}

inline void sub(int x,int y) {
	if (--fre[a[x][y]]==0)
		kc--;
}

inline void extend() {
	int i,j;
	++dst;
	for (i=x;i<x+dst;i++)
		add(i,y+dst-1);
	for (j=y;j<y+dst-1;j++)
		add(x+dst-1,j);
}

inline void shrink() {
	int i,j;
	for (i=x;i<x+dst;i++)
		sub(i,y+dst-1);
	for (j=y;j<y+dst-1;j++)
		sub(x+dst-1,j);
	--dst;
}

inline void move_down() {
	int j;
	if (x<n-dst)
		for (j=y;j<y+dst;j++) {
			sub(x,j);
			add(x+dst,j);
		}
}

inline void move_right() {
	int i;
	if (y<m-dst)
		for (i=x;i<x+dst;i++) {
			sub(i,y);
			add(i,y+dst);
		}
}

inline void move_left() {
	int i;
	if (y>0)
		for (i=x;i<x+dst;i++) {
			add(i,y-1);
			sub(i,y+dst);
		}
}

inline int valid() {
	return (kc<=k);
}

inline int ext_possible() {
	return ((x+dst < n) && (y+dst < m));
}

int dist() {
	for (x=0;x<=n-dst;x++) {
		if (x%2==0) {
			for (y=0;y<=m-dst;y++) {
				while (valid() && ext_possible()) {
					extend();
					if (!valid()) {
						shrink();
						break;
					}
				}
				move_right();
			}
			y--;
		}
		else {
			for (;y>=0;y--) {
				while (valid() && ext_possible()) {
					extend();
					if (!valid()) {
						shrink();
						break;
					}
				}
				move_left();
			}
			y++;
		}
		move_down();
	}
	return dst;
}

void afisare() {
	ofstream fout("submatrix.out");
	fout<<dist()<<"\n";
	fout.flush();
	fout.close();
}

int main() {
	citire();
	afisare();
	return 0;
}
