#include <cstdio>
#include <vector>
using namespace std;

#define Nmax 10010

int n, m, i, nr, x, y, P, M;
int vizP[Nmax], vizM[Nmax];
vector <int> G[Nmax], T[Nmax];

void dfsP (int nod) {
	
	for (int i = 0; i < (int) G[nod].size (); i++) {
		if (!vizP[ G[nod][i] ]) {
			vizP[ G[nod][i] ] = 1, P++;
			dfsP (G[nod][i]);
		}
	}
}

void dfsM (int nod) {
	
	for (int i = 0; i < (int) T[nod].size (); i++) {
		if (!vizM[ T[nod][i] ]) {
			vizM[ T[nod][i] ] = 1, M++;
			dfsM (T[nod][i]);
		}
	}
}

int main () {

	scanf ("%d %d", &n, &m);
	printf ("0\n");
	fflush (stdout);
	
	M = P = vizP[1] = vizM[1] = 1;
	for (i = 1; i <= m; i++) {
		scanf ("%d %d", &x, &y);
		G[x].push_back (y);
		T[y].push_back (x);
		
		if (vizP[x] == 1) 
			dfsP (x);
		
		if (vizM[y] == 1) 
			dfsM (y);
		
		if (M == n && P == n) {
			printf ("1\n");
			fflush (stdout);
			return 0;
		}
		else {
			printf ("0\n");
			fflush (stdout);
		}
	}
	
	return 0;
}
