#include <cstdio>
#include <algorithm>
#include <list>
using namespace std;

#define Nmax 305
#define MOD 666013

int n, m, k, NR;
int a[Nmax][Nmax];
list < pair <int, int> > H[MOD + 10];
void citire ();

void add (int x) {
	
	list < pair <int, int> >::iterator it;
	int nod = x % MOD;
	
	for (it = H[nod].begin (); it != H[nod].end (); it++)
		if (it->first == x) {
			it->second++;
			return ;
		}
	
	H[nod].push_back ( make_pair (x, 1)); NR++;
}

void del (int x) {
	
	list < pair <int, int> >::iterator it;
	int nod = x % MOD;
	
	for (it = H[nod].begin (); it != H[nod].end (); it++)
		if (it->first == x) {
			it->second--;
			
			if (!it->second) {
				NR--;
				H[nod].erase (it);
			}
			
			return ;
		}
} 

int cont (int L) {

	int i, j, l, q, N;
	NR = 0; // 
	
	for (i = 1; i <= n; i++) {
		N = i + L - 1;
		if (N > n) break;
		
		for (j = 1; j <= L; j++) 
			for (l = i; l <= N; l++)	
				add (a[l][j]);
		
		if (NR <= k) {
			for (j = 1; j <= L; j++) 
				for (l = i; l <= N; l++)	
					del (a[l][j]);
			
			return 1;
		}
		
		for (; j <= m; j++) { 
			for (l = i; l <= N; l++)	
				del (a[l][j - L]);
			
			for (l = i; l <= N; l++)	
				add (a[l][j]);
			
			if (NR <= k) {
				for (l = i; l <= N; l++)
					for (q = j - L + 1; q <= j; q++)
						del (a[l][q]);
				
				return 1;
			}
		}
		
		for (j = m - L + 1; j <= m; j++) 
			for (l = i; l <= N; l++)	
				del (a[l][j]);
	}
	
	return 0;
}

int main () {

	freopen ("submatrix.in", "r", stdin);
	freopen ("submatrix.out", "w", stdout);
	
	citire ();
	
	int p = 1, u = min (n, m), mij, sol = 0;
	while (p <= u) {
		mij = (p + u) >> 1;
		if ( cont (mij) ) {
			sol = mij;
			p = mij + 1;
		}
		else
			u = mij - 1;
	}

	printf ("%d", sol);
	
	return 0;
}

void citire () {

	int i, j;
	
	scanf ("%d %d %d", &n, &m, &k);
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			scanf ("%d", &a[i][j]);
}
