#include <stdio.h>
#include <algorithm>
using namespace std;
#define NMAX 310
struct xyz{
	int x,y,z;};
xyz v[NMAX*NMAX];
struct comp2{
	bool operator()(const xyz &a, const xyz &b){
		return a.z < b.z;
	}
};
int a[NMAX][NMAX];
int f[NMAX*NMAX];
int m, n, k, nrk;
void citire(int &poz){
	int nr = 0;
	for(int i = 1; i <= m; ++i)
		for(int j = 1; j <= n; ++j){
			v[++nr].x = i;
			v[nr].y = j;
			scanf("%d", &v[nr].z);
		}
	sort( v + 1, v + nr + 1, comp2());
	int val = 0;
	for(int i = 1; i <= nr; ++i)
		if(v[i].z == val)
			a[v[i].x][v[i].y] = poz;
		else {
			a[v[i].x][v[i].y] = ++poz;
			val = v[i].z;
		}
}
inline void colt(int x, int y, int L){
	for(int i = x; i < x + L; ++i)
		for(int j = y; j < y + L; ++j){
			if(f[a[i][j]] == 0) nrk++;
			f[a[i][j]]++;
		}
}
inline void elim_col(int x, int y, int L){
	for(int i = x; i < x + L; ++i){
		f[a[i][y]] --;
		if(f[a[i][y]] == 0) nrk--;
	}
}
inline void add_col(int x, int j, int L){
	for(int i = x; i < x + L; ++i){
		if(f[a[i][j]] == 0) nrk++;
		f[a[i][j]]++;
	}
}
bool valid(int L){
	for(int i = 1; i <= m-L+1; ++i){
		colt(i, 1, L);
		if(nrk <= k) {
			for(int j = 1; j <= L; ++j)
				elim_col(i, j, L);
			return 1;
		}
		for(int j = L + 1; j <= n; ++j){
			elim_col(i, j - L, L);
			add_col(i, j, L);
			if(nrk <= k) {
				for(int p = j - L + 1; p <= j; ++p)
					elim_col(i, p, L);
				return 1;
			}
		}
		for(int j = n - L + 1; j <= n; ++j)
			elim_col(i, j, L);
	}
	return 0;
}
int main(){
	freopen("submatrix.in" ,"r", stdin);
	freopen("submatrix.out" ,"w", stdout);
	scanf("%d%d%D", &m, &n, &k);
	int poz = 0;
	citire(poz);
	int L = min(m, n);
	if(poz <= k){
		printf("%d\n", L);
		return 0;
	}
	int step = 1;
	for(; step <= L; step <<= 1);
	step >>= 1;
	int sol = 0;
	for(; step; step >>= 1)
		if(valid(step+sol)) sol += step;
	printf("%d\n", sol);
	return 0;
}
