#include <cstdio>
#include <vector>
#define MaxN 10024
#define pb(x) push_back(x)

using namespace std;

vector <int> G[MaxN],g[MaxN]; //graf initial si graf transpus

int N,M;
int in[MaxN]; // arata daca in nodul i intra vreo muchie
int out[MaxN]; // arata daca nodul din i iese vreo muchie
int uz[MaxN];
int C[MaxN],L; // coada de noduri
int i,x,y,sw;

void dfs(int nod)
{
    int i;
    uz[nod]=1;
    for(i=0;i<G[nod].size();i++)
    {
        if(!uz[G[nod][i]])
            dfs(G[nod][i]);
        out[nod]=1; in[G[nod][i]]=1;
    }
    C[++L]=nod;
}
void dfs2(int nod)
{
    uz[nod]=1;
    int i;

    for(i=0;i<G[nod].size();i++)
        if(!uz[G[nod][i]])
            dfs2(G[nod][i]);
}

int conex()
{
    int i;
    for(i=1;i<=N;i++)
        in[i]=out[i]=uz[i]=0;

    for(i=1;i<=N;i++)
        if(!in[i] && !out[i])
            dfs(i);

    for(i=1;i<=N;i++)
        uz[i]=0;
    dfs2(C[1]);
    for(i=1;i<=N;i++)
        if(!uz[i])
            return 0;
    return 1;
}

int main()
{
    scanf("%d%d",&N,&M);
    printf("0\n");
    fflush(stdout);

    for(i=1;i<=M && !sw;i++)
    {
        scanf("%d%d",&x,&y);
        G[x].pb(y); g[y].pb(x);
        if(!in[x] || !out[y])
        {
            in[y]=out[x]=1;
            printf("0\n");
            fflush(stdout);
        }
        else
            if(i>=N-1)
            {
                sw=conex();
                printf("%d\n",sw);
                fflush(stdout);
            }
    }

    return 0;
}
