#include <cstdio>
#include <cstring>
#include <algorithm>
#define MAX 310
using namespace std;
char S[10000];
int POZ;
int vec[MAX*MAX],lvec,assvec[MAX*MAX],lassvec;
int freq[MAX*MAX];
int A[MAX][MAX];
int M,K,N;


int citeste(int &POZ){
	while (S[POZ]<'0' || S[POZ]>'9') ++POZ;
	int rez=0;
	while (S[POZ]>='0' && S[POZ]<='9'){
		rez*=10;
		rez+=(S[POZ]-'0');
		++POZ;
	}

	return rez;
}



int cbinvec(int p,int u,int vl){

	int m=(p+u)/2;
	if (assvec[m]==vl) return m; 
	if (assvec[m]<vl) return cbinvec(m+1,u,vl);
	if (assvec[m]>vl) return cbinvec(p,m-1,vl);

}


int verif(int latura){

	for (int i=1;(i+latura-1)<=M;++i){
		
		for (int c1=1;c1<=lassvec;++c1) freq[c1]=0;
		
		int ndist=0;

		for (int c1=i;c1<=(i+latura-1);++c1)
			for (int c2=1;c2<=latura;++c2){
				if (freq[A[c1][c2]]==0) ++ndist;
				freq[A[c1][c2]]++;
			}

		if (ndist<=K) return 1;

		for (int ending=latura+1;ending<=N;++ending){
			
			for (int c1=i;c1<=(i+latura-1);++c1){
				--freq[A[c1][ending-latura]];
				if (freq[A[c1][ending-latura]]==0) --ndist;
				if (freq[A[c1][ending]]==0) ++ndist;
				++freq[A[c1][ending]];
			}
			if (ndist<=K) return 1;
		}

	}

	return 0;
}



int main(){
	
	freopen("submatrix.in","r",stdin);
	freopen("submatrix.out","w",stdout);

	scanf("%d%d%d\n",&M,&N,&K);

	lvec=0;

	for (int i=1;i<=M;++i){
		fgets(S+1,9000,stdin);
		POZ=1;
		for (int j=1;j<=N;++j) {
			A[i][j]=citeste(POZ);
			vec[++lvec]=A[i][j];
		}
	}


	fclose(stdin);

	sort(vec+1,vec+lvec+1);

	lassvec=1;
	assvec[1]=vec[1];
	for (int i=2;i<=lvec;++i)
		if (vec[i]!=assvec[lassvec]) assvec[++lassvec]=vec[i];

	for (int i=1;i<=M;++i)
		for (int j=1;j<=N;++j)
			A[i][j]=cbinvec(1,lassvec,A[i][j]);

	int lsup=M;
	if (N<lsup) lsup=N;

	int linf=1;

	int rez=0;

	while (linf<=lsup){
		int mij=(linf+lsup)/2;
		if (verif(mij)){ rez=mij; linf=mij+1; } else lsup=mij-1;
	}


	printf("%d\n",rez);

	fclose(stdout);

	return 0;
}
