#include <fstream>
#include <bitset>
using namespace std;

const int NMAX = 300;

int N, k, perm[NMAX], ans, secv = 1;
bitset<NMAX> inperm;

bool check()
{
	int secv = 1;
	for (int i = 1; i <= N; ++i)
		if (perm[i] < perm[i + 1] && ++secv > k) return false;
		else secv = 0;
	return true;
}

void back(int x)
{
	if (x == N + 1) {
		ans++;
		return;
	}
	
	for (int i = 1; i <= N; ++i)
		if ( !inperm[i] ) {
			inperm[i] = true;
			perm[x] = i;
			if (x > 1 && perm[i] > perm[i - 1]) {
				++secv;
				if (secv > k) {
					inperm[i] = false;
					--secv;
					continue;
				}
			}
			else secv = 1;
			back(x + 1);
			inperm[i] = false;
			if (x > 1 && perm[i] > perm[i - 1]) --secv;
		}
}

int main()
{
	int R;
	ifstream f1("kmax.in");
	ofstream f2("kmax.out");
	f1 >> N >> k >> R;
	back(1);
	f2 << ans % R << endl;
	f1.close();
	f2.close();
	return 0;
}
