#include <algorithm>
#include <vector>
using namespace std;

#define MAX 10005
#define DIM 305

int aux[DIM*DIM],viz[DIM*DIM];
int n,m,LIM,p,rez,pozitie=MAX-1;
int v[DIM][DIM],a[DIM][DIM];
char buff[MAX];

inline int isdigit (char ch)
{
    if (ch>='0' && ch<='9')
        return 1;
    return 0;
}

inline void cit (int &nr)
{
    for ( ; !isdigit (buff[pozitie]); )
        if (++pozitie==MAX)
        {
            fread (buff,1,MAX,stdin);
            pozitie=0;
        }
    for (nr=0; isdigit (buff[pozitie]); )
    {
        nr=nr*10+buff[pozitie]-'0';
        if (++pozitie==MAX)
        {
            fread (buff,1,MAX,stdin);
            pozitie=0;
        }
    }
}

void read ()
{
    int i,j;

    cit (n); cit (m); cit (LIM);
    for (i=1; i<=n; ++i)
        for (j=1; j<=m; ++j)
        {
            cit (a[i][j]);
            aux[++p]=a[i][j];
        }
}

inline int norm (int val)
{
    int st,dr,mij,val0;

    val0=0;
    for (st=1, dr=p; st<=dr; )
    {
        mij=(st+dr)/2;
        if (val>aux[mij])
            st=mij+1;
        else
        {
            val0=mij;
            dr=mij-1;
        }
    }
    return val0;
}

void init ()
{
    int i,j;

    sort (aux+1,aux+p+1);
    for (i=1; i<=n; ++i)
        for (j=1; j<=m; ++j)
            v[i][j]=norm (a[i][j]);
}

inline int check (int l)
{
    int i,j,k,semn,nrk;

    nrk=0;
    memset (viz,0,sizeof (viz));
    for (i=1; i<=l; ++i)
        for (j=1; j<=l; ++j)
            if (++viz[v[i][j]]==1)
                ++nrk;
    if (nrk<=LIM)
        return 1;
    for (semn=i=1; i<=n-l+1; ++i, semn^=1)
        if (semn)
        {
            if (i!=1)
            {
                j=1;
                for (k=0; k<l; ++k)
                {
                    if (--viz[v[i-1][j+k]]==0)
                        --nrk;
                    if (++viz[v[i+l-1][j+k]]==1)
                        ++nrk;
                }
                if (nrk<=LIM)
                    return 1;
            }
            for (j=2; j<=m-l+1; ++j)
            {
                for (k=0; k<l; ++k)
                {
                    if (--viz[v[i+k][j-1]]==0)
                        --nrk;
                    if (++viz[v[i+k][j+l-1]]==1)
                        ++nrk;
                }
                if (nrk<=LIM)
                    return 1;
            }
        }
        else
        {
            j=m-l+1;
            for (k=0; k<l; ++k)
            {
                if (--viz[v[i-1][j+k]]==0)
                    --nrk;
                if (++viz[v[i+l-1][j+k]]==1)
                    ++nrk;
            }
            if (nrk<=LIM)
                return 1;
            for (j=m-l; j>=1; --j)
                if (i!=1)
                {
                    for (k=0; k<l; ++k)
                    {
                        if (--viz[v[i+k][j+l]]==0)
                            --nrk;
                        if (++viz[v[i+k][j]]==1)
                            ++nrk;
                    }
                    if (nrk<=LIM)
                        return 1;
                }
        }
    return 0;
}

void solve ()
{
    int i,j;
    int st,dr,mij;

    for (rez=st=1, dr=min (n,m); st<=dr; )
    {
        mij=(st+dr)/2;
        if (check (mij))
        {
            rez=mij;
            st=mij+1;
        }
        else
            dr=mij-1;
    }
    printf ("%d",rez);
}

int main ()
{
    freopen ("submatrix.in","r",stdin);
    freopen ("submatrix.out","w",stdout);

    read ();
    init ();
    solve ();

    return 0;
}
