#include <cstdio>
#include <algorithm>
using namespace std;

int n, m, k;
int a[302][302];
int x[9001], end;


void read() {

    scanf("%d %d %d", &n, &m, &k);

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            scanf("%d ", &a[i][j]);

}

int found(int num) {

    for (int i = 1; i <= end; i++)
        if (x[i] == num)
            return 1;

    return 0;

}

int verif(int xS, int yS, int xD, int yD) {
    int dif = 0;
    end = 0;
    for (int i = xS; i <= xD; i++)
        for (int j = yS; j <= yD; j++)
            if (!found(a[i][j])) {
                x[++end] = a[i][j];
                dif++;
                if (dif > k)
                    return 0;
            }

    return 1;

}

void solve() {
    for (int l = min(n, m); l >= 1; l--)
        for (int i = 1; i <= n - l + 1; i++)
            for (int j = 1; j <= m - l + 1; j++)
                if (verif(i, j, i + l - 1, j + l - 1) == 1) {
                    printf("%d\n", l);
                    return;
                }
}

int main() {

    freopen("submatrix.in", "r", stdin);
    freopen("submatrix.out", "w", stdout);

    read();
    solve();

    return 0;
}
