#include <stdio.h>
#include <algorithm>

#define Nmax 312

using namespace std;

int n,m,k,maxim,v[Nmax][Nmax],sol,fr[Nmax*Nmax],cnt,cnt2,p1,p2,lat;
struct elem{
    int nr,x,y;
};

elem norm[Nmax*Nmax];

void qsort(int st,int dr)
{
    int i=st,j=dr,mid=norm[(st+dr)/2].nr;
    elem tmp;
    do
        {
            while(norm[i].nr<mid) ++i;
            while(norm[j].nr>mid) --j;
            if(i<=j)
                {
                    tmp=norm[i];
                    norm[i]=norm[j];
                    norm[j]=tmp;
                    ++i;
                    --j;
                }
        }while(i<=j);

    if(i<dr)    qsort(i,dr);
    if(j>st)    qsort(st,j);
}

bool cmp(elem a,elem b)
{
    return a.nr<b.nr;
}

int brut(int l)
{
    int i,j,t,q,nr;
    for(i=1;i<=n-l+1;++i)
        for(j=1;j<=m-l+1;++j)
            {
                nr=0;
                for(t=i;t<=i+l-1;++t)
                    for(q=j;q<=j+l-1;++q)
                        {
                            if(!fr[v[t][q]])
                                ++nr;
                            ++fr[v[t][q]];
                        }
                for(t=i;t<=i+l-1;++t)
                    for(q=j;q<=j+l-1;++q)
                        {
                            --fr[v[t][q]];
                        }
                if(nr<=k)
                    {
                        p1=i;
                        p2=j;
                        lat=l;
                        return 1;
                    }
            }
    return 0;
}

int solutie(int l)
{
    int i,j,nr=0,t,q;
    for(t=1;t<=n-l+1;++t)
        {
        nr=0;
        for(i=0;i<l;++i)
            for(j=1;j<=l;++j)
                {
                    if(!fr[v[i+t][j]])
                        ++nr;
                    ++fr[v[i+t][j]];
                }
        if(nr<=k)
            {
                for(i=0;i<l;++i)
                    for(j=1;j<=l;++j)
                        --fr[v[i+t][j]];
                return 1;
            }
        for(j=l+1;j<=m;++j)
            {
                for(i=0;i<l;++i)
                    {
                        --fr[v[i+t][j-l]];
                        if(!fr[v[i+t][j-l]])
                            --nr;
                    }
                for(i=0;i<l;++i)
                    {
                        if(!fr[v[i+t][j]])
                            ++nr;
                        ++fr[v[i+t][j]];
                    }
                if(nr<=k)
                    {
                        for(q=j-l+1;q<=j;++q)
                            for(i=0;i<l;++i)
                                --fr[v[i+t][q]];
                        return 1;
                    }
            }
        for(j=m-l+1;j<=m;++j)
            for(i=0;i<l;++i)
                --fr[v[i+t][j]];
        }
    return 0;
}

int gaseste(int l)
{
    int i,j;
    if(maxim<=30)
        return brut(l);
    return solutie(l);
}

int main()
{
    int i,j;

    freopen("submatrix.in","r",stdin);
    freopen("submatrix.out","w",stdout);

    scanf("%d%d%d",&n,&m,&k);

    for(i=1;i<=n;++i)
        for(j=1;j<=m;++j)
            {
                scanf("%d",&v[i][j]);
                norm[++cnt].nr=v[i][j];
                norm[cnt].x=i;
                norm[cnt].y=j;
            }

  //  qsort(1,cnt);

    sort(norm+1,norm+cnt+1,cmp);

    for(i=1;i<=cnt;++i)
        {
            if(norm[i].nr!=norm[i-1].nr)
                {
                    ++cnt2;
                    while(norm[i].nr==norm[i+1].nr)
                        {
                            norm[i].nr=cnt2;
                            ++i;
                        }
                    norm[i].nr=cnt2;
                }
        }

    for(i=1;i<=cnt;++i)
        {
            v[norm[i].x][norm[i].y]=norm[i].nr;
        }


    maxim=min(n,m);
    int st=1,dr=maxim;

    while(st<=dr)
        {
            int mid=(st+dr)/2;
            int ok=gaseste(mid);
            if(ok)
                {
                    sol=mid;
                    st=mid+1;
                }
            else
                dr=mid-1;
        }
    printf("%d\n",sol);
    return 0;
}
