#include <iostream>
#include <string>
#include <vector>

using namespace std;

#define PB push_back
#define NM 10005

vector<int> G[NM], GT[NM];
vector<int> CCT[NM];

int N, M, cc, P[NM], PT[NM], intr, intrt, vz, vzt;

char viz[NM], vizt[NM];

void DF (int nod)
{
	viz[nod] = 1;
	++vz;
	
	for(int i = 0; i < (int) G[nod].size(); ++i)
	{
		int nnod = G[nod][i];
		if (!viz[nnod]) DF (nnod);
	}	
}

void DFT (int nod)
{
	vizt[nod] = 1;
	++vzt;
	
	for(int i = 0; i < (int) GT[nod].size(); ++i)
	{
		int nnod = GT[nod][i];
		if (!vizt[nnod]) DFT (nnod);
	}	
}

int main()
{
	int a, b;
	
	//freopen("conex.in","r",stdin);
	//freopen("conex.out","w",stdout);
	
	scanf ("%d %d", &N, &M);
	
	printf("0\n");
	fflush(stdout);
	
	for (int i = 1; i < N; ++i)
	{
		scanf ("%d %d", &a, &b);
		G[a].PB(b);
		GT[b].PB(a);
		
		printf ("0\n");
		fflush(stdout);
	}	
	
	DF (1); 
	DFT (1);
	
	for (int i = N; i <= M; ++i)
	{
		scanf ("%d %d", &a, &b);
		G[a].PB(b);
		GT[b].PB(a);
		
		if (viz[a] && !viz[b]) DF(b);
		if (vizt[b] && !vizt[a]) DFT(a);
		
		if (vz == N && vzt == N)
		{
			printf ("1\n");
			fflush(stdout);
			return 0;
		}			
		else 
		{
			printf ("0\n");
			fflush(stdout);
		}
		
		/*
		for (int j = 1; j <= P[0]; ++j) printf ("%d ",P[j]);
		
		printf("\n");

		for (int j = 1; j <= PT[0]; ++j) printf ("%d ",PT[j]);

		printf("\n");	
		*/
	}	
	
	//printf("%d %d",vz, vzt);
	
	return 0;
}
