#include <cstdio>
#include <algorithm>
using namespace std;

#define NMAX 350

long n, r, num, k, x[NMAX];

long correct()
{
	long num = 1;
	for (long i = 1; i < n; ++i)
		if (x[i] < x[i + 1])
		{
			++num;
			if (num > k)
				return 0;
		}
		else
			num = 1;
	return 1;
}

int main()
{
	freopen ("kmax.in", "rt", stdin);
	freopen ("kmax.out", "wt", stdout);
	
	scanf("%ld %ld %ld", &n, &k, &r);

	if (k == 1)
	{
		printf("1\n");
		return 0;
	}

	if (k == n)
	{
		long rez = 1;
		for (long i = 1; i <= n; ++i)
			rez = (rez * i) % r;
		printf("%ld\n", rez);
		return 0;
	}

	for (long i = 1; i <= n; ++i)
		x[i] = i;

	if (correct())
		++num;

	while (next_permutation(x + 1, x + n + 1))
	{
		if (correct())
			++num;			
	}

	printf("%ld\n", num % r);

	return 0;
}

