#include <cstdio>
#include <cstring>
using namespace std;

#define P1 100007
#define P2 45607
#define P3 321537
#define NMAX 350

long id, num, maxim = -1, n, m, k, x[NMAX][NMAX], h1[P1 + 50], h2[P2 + 50], h3[P3 + 50];

void addh(long o)
{
	long r1 = o % P1, r2 = o % P2, r3 = o % P3;
	
	if ((h1[r1] != id) || (h2[r2] != id) || (h3[r3] != id))
	{
		h1[r1] = h2[r2] = h3[r3] = id, ++num;
	}
}

void reseth()
{
	memset(h1, 0, sizeof(h1));
	memset(h2, 0, sizeof(h2));
	memset(h3, 0, sizeof(h3));
}

int main()
{
	freopen ("submatrix.in", "rt", stdin);
	freopen ("submatrix.out", "wt", stdout);

	scanf("%ld %ld %ld", &n, &m, &k);

	for (long i = 1; i <= n; ++i)
		for (long j = 1; j <= m; ++j)
			scanf("%ld", &x[i][j]);

	++id;
	num = 0;
	if (n < m)
	{
		for (long i = 1; i <= n; ++i)
			for (long j = 1; j <= n; ++j)
				addh(x[i][j]);
		if (num <= k)
		{
			maxim = n;
			printf("%ld\n", maxim);
			return 0;
		}
	}
	else
	{
		for (long i = 1; i <= m; ++i)
			for (long j = 1; j <= m; ++j)
				addh(x[i][j]);
		if (num <= k)
		{
			maxim = n;
			printf("%ld\n", maxim);
			return 0;
		}
	}

	for (long i = 1; i <= n; ++i)
		for (long j = 1; j <= m; ++j)
		{
			++id;
			num = 0;

			for (long l = 0; num <= k && j + l <= m && i + l <= n; ++l)
			{
				for (long a = j; a <= j + l; ++a)
					addh(x[i + l][a]);

				for (long a = i; a <= i + l; ++a)
					addh(x[a][j + l]);
				
				if (num <= k)
				{
					if (maxim < l)
					{
						maxim = l;
/*						printf("----- %ld\n", num);
						for (long b = i; b <= i + l; ++b)
						{
							for (long c = j; c <= j + l; ++c)
								printf("%ld ", x[b][c]);
							printf("\n");
						}
						printf("-----\n");*/
					}
				}
			}
		}

	printf("%ld\n", maxim + 1);
	return 0;
}

