#include <stdio.h>
#define nmax (13*1000)
#define mmax (43*1000)
struct lista
{
	int n,p; //nodul si pozitia
} l[mmax]; //lista grafului
struct nod
{
	int gin; //grad intrare
	int gou; //gread iesire
	int p; //pozitia catre lista
} no[nmax]; //informatiile nodurilor
int viz[nmax]; //vector de vizite pentru parcurgeri
int n,m; //numarul de noduri/muchii
int nrl; //numarul de elemente din lista
int nrp; //numarul de ordine al parcurgerii
int last=1; //primul nod ce nu e bun

inline int max(int a, int b)
{
	if(a>b) return a; return b;
}

inline void push(int x, int y)
{
	++nrl, l[nrl].n=y, l[nrl].p=no[x].p, no[x].p=nrl, no[y].gin++, no[x].gou++;
}

void read(int nr)
{
	int i,x,y;
	for(i=1;i<=nr;i++)
	{
		printf("0\n");
		fflush(stdout);
		scanf("%d %d",&x,&y);
		push(x,y);
	}
}

void dfs(int x)
{
	viz[x]=nrp;
	int i;
	for(i=no[x].p;i;i=l[i].p)
		if(viz[l[i].n]!=nrp)
			dfs(l[i].n);
}

int verif()
{
	int i,j;
	for(i=last;i<=n;i++)
	{
		++nrp, dfs(i);
		for(j=1;j<=n;j++)
			if(viz[j]!=nrp)
			{
				last=i;
				return 0;
			}
	}
	return 1;
}

int nr_gr_zero()
{
	int i,gin=0,gou=0;
	for(i=1;i<=n;i++)
	{
		if(!no[i].gin) gin++;
		if(!no[i].gou) gou++;
	}
	return max(gin,gou);
}

int main()
{
	scanf("%d %d",&n,&m);
	int nr;
	
	if(n==1)
	{
		printf("1\n");
		fflush(stdout);
		return 0;
	}
	
	for(nr=nr_gr_zero();nr;nr=nr_gr_zero())
		read(nr);
	
	while(!verif())
		read(1);
	
	printf("1\n");
	fflush(stdout);
	
	return 0;
}
