#include <stdio.h>
#include <memory.h>
#define NMAX 10001

char bullet[NMAX][NMAX];
int n,m;
long bullets=0;

void ensureLink(int fri, int toi) {
	if (bullet[fri][toi]) return;
	else {
//		fprintf(stderr,"DEBUG: ensured link from %d to %d [now bullets: %d]\n",fri,toi,bullets+1);
		bullet[fri][toi]=1;
		bullets++;
		for (int i=0; i<n; i++)
			if (bullet[i][fri]==1)
				ensureLink(i,toi);
		for (int i=0; i<n; i++)
			if (bullet[toi][i]==1)
				ensureLink(fri,i);
	}
}

int main (void) {
	FILE * fi = stdin;
	FILE * fo = stdout;

	memset(bullet,0,sizeof(bullet));

	fscanf(fi,"%d %d",&n, &m);
	bool bail=false;
	int i=0;
	if (n==0) {
		fprintf(fo,"1\n");
		fflush(fo);
	} else {
		fprintf(fo,"0\n");
		fflush(fo);

		while (!bail && i<m) {
			int fri, toi;
			fscanf(fi,"%d %d",&fri,&toi);
			fri--; toi--;

			ensureLink(fri,toi);

			if (bullets==n*n) {
				fprintf(fo,"1\n");
				fflush(fo);
				bail=true;
			} else {
				fprintf(fo,"0\n");
				fflush(fo);
			}
			i++;
		}
	}
	return 0;
}