//by Puni Andrei-Paul
//Time complexity: O(n + m)
//Space complexity: O(n + m)
//Method: depth first search
//Working time: 10 minutes
#include <iostream>
#include <vector>
#include <queue>
#include <stdio.h>

using namespace std;

#define Nmax 10100

int n,m, nr = 1, nrt = 1;
//o sa tin muchile in coada ..
queue<int> l[Nmax], lt[Nmax];

bool ajunge[Nmax], ajunget[Nmax];

void df(int nod)
{
    if (!ajunge[nod])
    {
        ++nr;
        ajunge[nod] = true;
    }

    while (!l[nod].empty())
    {
        if (!ajunge[l[nod].front()])
            df(l[nod].front());
        l[nod].pop();
    }
}

void dft(int nod)
{
    if (!ajunget[nod])
    {
        ++nrt;
        ajunget[nod] = true;
    }
    
    while (!lt[nod].empty())
    {
        if (!ajunget[lt[nod].front()])
            dft(lt[nod].front());
        lt[nod].pop();
    }
}

int main()
{
    //cin >> n >> m;
    scanf("%d%d", &n,&m);
    
    int a,b;
    
    ajunge[1] = true;
    ajunget[1] = true;
    
    while (nr < n || nrt < n)
    {
        //cout << "nu este\n";
        //cout.flush();
        printf("0\n");
        fflush(stdout);
        
        //cin >> a >> b;
        scanf("%d%d", &a, &b);

        l[a].push(b);
        lt[b].push(a);

        if (ajunge[a] && !ajunge[b])
            df(a);

        if (ajunget[b] && !ajunget[a])
            dft(b);
    }
    
    //cout << "este\n";
    //cout.flush();
    
	printf("1\n");
	fflush(stdout);


    return 0;
}
