//by Puni Andrei-Paul
//Time complexity: O((n + m)*m)
//Space complexity: O(n + m)
//Method: Kosaraju's_algorithm / depth first search
//Working time: 15 minutes
//brut opt c

#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

#define Nmax 10100

int n,m;

vector <int> l[Nmax], lt[Nmax];
int post[Nmax], nrEl;
char viz[Nmax];

void df(int nod)
{
    viz[nod] = 1;
    for (int i = 0; i < (int)l[nod].size(); ++i)
        if (viz[l[nod][i]] == 0)
            df(l[nod][i]);
    post[++post[0]] = nod;
}

void dft(int nod)
{
    ++nrEl;
    viz[nod] = 0;
    for (int i = 0; i < (int)lt[nod].size(); ++i)
        if (viz[lt[nod][i]] == 1)
            dft(lt[nod][i]);
}

int main()
{
    //cin >> n >> m;
    scanf("%d %d", &n, &m);
    
    int a,b;
    
    for (int i=1;i<=m;++i)
    {
        //cout << "nu este\n";
        //cout.flush();
        printf("0\n");
        fflush(stdout);
        
        //cin >> a >> b;
        scanf("%d%d", &a, &b);
        
        
        l[a].push_back(b);
        lt[b].push_back(a);
        
        if (i < n) continue;
        
        nrEl = 0;
        
        memset(viz, 0, sizeof viz);
        
        post[0] = 0;
        
        for (int j=1;j<=n;++j)
        if (viz[j] == 0)
            df(j);

        dft(post[post[0]]);
        
        if (nrEl == n)
            break;
    }
    
    //cout << "este\n";
    //cout.flush();
    
	printf("1\n");
	fflush(stdout);


    return 0;
}
