//Gheorghe Cosmin
//Solutie O(N! * N)
#include <stdio.h>
#include <algorithm>
using namespace std;

int N, K, MOD;

int get_brut(int N, int K)
{
	int a[N + 10], rez = 0, i;

	a[0] = 0;
	for (i = 1; i <= N; i++) a[i] = i;

	do {
		int k = 0;
		for (i = 1; i <= N; i++) {
			if (a[i] > a[i - 1]) k++;
			else k = 1;
			if (k > K) break;
		}

		rez += i == N + 1;
	} while (next_permutation(a + 1, a + N + 1));

	return rez;
}

int main()
{
	int i, j, k, MOD;

	freopen("kmax.in", "r", stdin);
	freopen("kmax.out", "w", stdout);

	scanf("%d %d %d", &N, &K, &MOD);

	printf("%d\n", get_brut(N, K) % MOD);

	return 0;
}
