/*
	Airinei Adrian, Iasi
	Complexitate O(N^3)
*/

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;

#define MAXN 310

int N, M, K, A[MAXN][MAXN], cnt[MAXN*MAXN], res;
vector<int> V;

void diag(int i, int j)
{
	int x, y, k, num = 1, L;
	L = 1, cnt[A[i][j]] = 1;
	while(i+1 <= N && j+1 <= M)
	{
		i++, j++, L++;
		for(x = i-L+1; x <= i; x++)
			if(cnt[A[x][j]] == 0)
				num++, cnt[A[x][j]] = 1;
			else
				cnt[A[x][j]]++;
		for(y = j-L+1; y < j; y++)
			if(cnt[A[i][y]] == 0)
				num++, cnt[A[i][y]] = 1;
			else
				cnt[A[i][y]]++;
		while(num > K)
		{
			for(x = i-L+1; x <= i; x++)
			{
				cnt[A[x][j-L+1]]--;
				if(cnt[A[x][j-L+1]] == 0)
					num--;
			}
			for(y = j; y > j-L+1; y--)
			{
				cnt[A[i-L+1][y]]--;
				if(cnt[A[i-L+1][y]] == 0)
					num--;
			}
			L--;
		}
		res = max(res, L);
	}
}

void read_and_solve(void)
{
	int i, j, k;
	scanf("%d %d %d", &N, &M, &K);
	for(i = 1; i <= N; i++)
		for(j = 1; j <= M; j++)
			scanf("%d", &A[i][j]), V.push_back(A[i][j]);

	vector<int>::iterator it;
	sort(V.begin(), V.end());
	V.resize(unique(V.begin(), V.end())-V.begin());
	for(i = 1; i <= N; i++)
		for(j = 1; j <= M; j++)
		{
			it = lower_bound(V.begin(), V.end(), A[i][j]);
			A[i][j] = (int)(it-V.begin());
		}
	res = 1;
	for(i = 1; i <= N; i++)
	{
		memset(cnt, 0, sizeof(cnt));
		diag(i, 1);
	}
	for(j = 2; j <= M; j++)
	{
		memset(cnt, 0, sizeof(cnt));
		diag(1, j);
	}

	printf("%d\n", res);
}

int main(void)
{
	freopen("submatrix.in", "rt", stdin);
	freopen("submatrix.out", "wt", stdout);

	read_and_solve();

	return 0;
}





		




