# include <fstream>
# include <iostream>
# define DIM 55
using namespace std;
int n, D[DIM], E, dmax=-100000, sol, dmin, d[DIM];

void read ()
{
	int d, DD=0;
	ifstream fin ("stalpi.in");
	fin>>n>>E;
	for(int i=2;i<=n;i++)
	{
		fin>>d;
		D[i]=d-DD;
		if (D[i]>dmax)dmax=D[i];
		DD=d;
	}
	dmin=d/(n-1);
	if (d%(n-1)!=0)++dmin;
	sol=dmax;
}

void caut (int I, int dd, int &e)
{
	int p=d[I]-dd, dist;
	for (int i=I-1, j=I+1;d[I]>dd && (i || j<n) && p && e>=0;)
	{
		if (d[I]>dd && d[i]<dd && i)
		{
			dist=dd-d[i];
			if (dist>p)
				dist=p;
			p-=dist;
			d[i]+=dist;
			e-=(I-i)*dist;
			if (e>=0)
				d[I]-=dist;
		}
		if (d[I]>dd && d[j]<dd && j<n)
		{
			dist=dd-d[j];
			if (dist>p)
				dist=p;
			p-=dist;
			d[j]+=dist;
			e-=(j-I)*dist;
			if (e>=0)
				d[I]-=dist;
		}
		if (i)--i;
		if (j<n)++j;
	}
}

int pot (int dd)
{
	int e=E;
	for (int i=1;i<n;i++)
		d[i]=D[i+1];
	for (int i=1;i<n && e>=0;i++)
		if (d[i]>dd)
		{
			caut(i, dd, e);
			if (d[i]>dd)
				return 0;
		}
	if (e>=0 && d[n-1]<=dd)
		return 1;
	return 0;
}	
				
				
void solve (int st, int dr)
{
	if (st==dr)
	{
		if (st<sol && pot(st))
			sol=st;
		return;
	}
	int m=(st+dr)/2;
	if (pot(m))
	{
		if (m<sol)sol=m;
		solve (st, m);
	}
	else
		solve (m+1, dr);
}
		
int main()
{
	read ();
	solve (dmin, dmax);
	ofstream fout ("stalpi.out");
	fout<<sol;
	return 0;
}
