// Balan Catalin
// 8 Apr 2010 - 8:07
// ONI 2010 - Proba 2 - stalpi
#include <cstdio>
#include <cstdlib>
#include <deque>
using namespace std;

#define NMAX 52
#define DMAX 10003
#define INF 0x3f3f3f3f

inline int min(int a, int b)
{
	return (a<b?a:b);
}
inline int max(int a, int b)
{
	return (a>b?a:b);
}
inline int abs(int a)
{
	return (a>0?a:-a);
}
inline void done(int a)
{
	printf("%d\n", a);
	exit(0);
}

int n, E, di[NMAX], R[NMAX][DMAX];

int main()
{
	freopen("stalpi.in", "r", stdin);
	freopen("stalpi.out", "w", stdout);

	scanf("%d %d", &n, &E);
	for (int i = 2; i <= n; ++i)
	{
		scanf("%d", &di[i]);
	}
	int Dst = di[n] / (n-1);
	int Ddr = di[n];
	int rez = 1;
	if ( (n-1)*Dst < di[n]) ++Dst;
	
	while (Dst <= Ddr)
	{
		int Dmin = (Dst+Ddr+1)>>1;
		int OK = 0;
//		fprintf(stderr, "%d %d %d --------------\n", Dst, Ddr, Dmin);
		R[1][0] = 0;
		for (int j = 1; j <= di[n]; ++j) R[1][j] = INF;
		for (int i = 2; i < n; ++i)
		{
			int st = max(0, di[n]-Dmin*(n-i+1));
			int dr = min(di[n]-1, (i-1)*Dmin);
			for (int j = dr+1; j <= di[n]; ++j) R[i][j] = INF;
			deque < pair < int, int > > DQ;
			DQ.clear();
			int p = max(st-Dmin, 0);
			for (int q = p; q < st; ++q)
			{
				while (!DQ.empty() && DQ.back().second > R[i-1][q])
					DQ.pop_back();
				DQ.push_back( make_pair(q, R[i-1][q]) );
			}
			for (int j = st; j <= dr; ++j)
			{
				R[i][j] = INF;

				while (!DQ.empty() && DQ.front().first < j-Dmin)
					DQ.pop_front();
				R[i][j] = min( R[i][j], abs( di[i] - j ) + DQ.front().second );
			
				while (!DQ.empty() && DQ.back().second > R[i-1][j])
					DQ.pop_back();
				DQ.push_back( make_pair(j, R[i-1][j]) );

//				fprintf(stderr, "%d %d %d\n", i, j, R[i][j]);
			}
		}
		for (int j = max( 0, di[n]-Dmin); j < di[n]; ++j)
		{
			if (R[n-1][j] <= E)
			{
				OK = 1;
				break;
			}
		}
//		fprintf(stderr, "%d ", OK);
		if (OK)
		{
			rez = Dmin;
			Ddr = Dmin-1;
		} else {
			Dst = Dmin+1;
		}
	}

	done(rez);


	return EXIT_SUCCESS;
}
