#include<fstream>
#define min(a,b) (a.v<b.v?a:b)
#define max(a,b) (a.v>b.v?a:b)
using namespace std;

int n,m,lvl,k=0;
struct interv{
	int st,v,fi;
};
struct nod{
	interv Min,min,med,max,Max;
}f[1600000]; //N(logN) elem.
ofstream fout("diff.out");

void update() {
	int c,l2=lvl;
	l2--;
	c = (1<<l2);
	while (l2) {
		while (c<k) {
			f[c].med.v = f[c<<1].med.v + f[c<<1+1].med.v;
			f[c].med.st = f[c<<1].med.st;
			f[c].med.fi = f[c<<1+1].med.fi;
			if (f[c<<1].med.v + f[c<<1+1].min.v < f[c<<1].min.v ) {
				f[c].min.v = f[c<<1].med.v + f[c<<1+1].min.v;
				f[c].min.st = f[c<<1].med.st;
				f[c].min.fi = f[c<<1+1].min.fi;
			}
			else
				f[c].min = f[c<<1].min;
			if (f[c<<1].max.v + f[c<<1+1].med.v > f[c<<1+1].max.v) {
				f[c].max.v = f[c<<1].max.v + f[c<<1+1].med.v;
				f[c].max.st = f[c<<1].max.st;
				f[c].max.fi = f[c<<1].max.fi;
			}
			else
				f[c].max = f[c<<1+1].max;
			f[c].Min = min(f[c<<1].Min, f[c<<1+1].Min);
			f[c].Min = min(f[c].Min, f[c].min);
			f[c].Max = max(f[c<<1].Max, f[c<<1+1].Max);
			f[c].Max = min(f[c].Max, f[c].max);
			c++;
		}
		l2--;
		c = (1<<l2);
	}
}

void query(int nr) {
	int c;
	if (nr<f[0].Min.v || nr>f[0].Max.v) {
		fout<<"-1\n";return;
	}
	if (n==0) {
		c = 1<<lvl;
		if (!f[c].min.v)
			fout<<f[c].med.fi<<" "<<f[c].med.fi+1<<"\n";
		else
			fout<<(f[c].med.st - f[c].med.st)<<" "<<(f[c].med.st - f[c].med.st + 1)<<"\n";
		return;
	}
	if (nr>0) {
		c = 1;
		while (c<1<<lvl) {
			if (f[c<<1].Max.v==f[c].Max.v) {
				c = c<<1;
				continue;
			}
			if (f[c<<1+1].Max.v==f[c].Max.v) {
				c = c<<1+1;
				continue;
			}
			//if (f[c].Max == f[c].max) {
				if (f[c<<1].max.v >= nr)
					fout<<f[c<<1].max.st<<" "<<f[c<<1].max.st+nr<<"\n";
				else
					fout<<(f[c].max.fi - nr + 2*f[c<<1].min.v)<<" "<<f[c].max.fi<<"\n";
			//}
		}
	}
	if (nr<0);
}

void program() {
	ifstream fin("diff.in");
	int c,last=0,i;
	fin>>n>>m;
	lvl=0;
	//nr de nivele ale arborelui	
	while (n>(1<<lvl)) lvl++;
	k = 1<<lvl;
	f[k].med.st = 0;
	f[k].min.st = 0;
	for (i=0;i<n;i++) {
		fin>>c;
		if (c==0 && last==1) {
			f[k].med.fi = i-1;
			f[k].Min = f[k].min;
			f[k].Max = f[k].max;
			f[k].med.v = f[k].min.v + f[k].max.v;
			k++;
			f[k].med.st = i;
		}
		if (c==0) {
			last = 0;
			f[k].min.v--;
			f[k].min.fi++;
		}
		else {
			if (last==0) {
				f[k].max.st = i;
				f[k].max.fi = i;
			}
			last = 1;
			f[k].max.v++;
			f[k].max.fi++;
		}
	}
	f[k].med.fi = i-1;
	f[k].Min = f[k].min;
	f[k].Max = f[k].max;
	f[k].med.v = f[k].min.v + f[k].max.v;
	
	update();
	for (i=0;i<m;i++) {
		fin>>c;
		query(c);
	}
	fin.close();
	fout.close();
}

int main() {
	program();
	return 0;
}
