#include <cstdio>
#include <algorithm>
using namespace std;

#define Mmax 100010
#define INF 0x3f3f3f3f

struct querY {int x, y;} Q[Mmax];

void citire (), afisare (); 
int n, m, N, Poz, val, rez, S, D;
int poz[Mmax], A[Mmax], AI[Mmax * 4];
long long Sol[Mmax];

#define MIJ ((st + dr) >> 1)
#define N1 (nod << 1)
#define N2 ((nod << 1) + 1)

void update (int nod, int st, int dr) {
	
	if (st == dr) {
		AI[nod] = val;
		return ;
	}
	
	if (Poz <= MIJ) update (N1, st, MIJ);
	else update (N2, MIJ + 1, dr);
	
	AI[nod] = min (AI[N1], AI[N2]);
}

void query (int nod, int st, int dr) {
	
	if (st == 1 && dr == 1) {
		if (AI[nod] < D) rez = A[1];
		else rez = 0;
		return ;
	}
	
	if (st == dr) {
		rez = A[st];
		return ;
	}
	
	if (AI[N2] < D) query (N2, MIJ + 1, dr);
	else query (N1, st, MIJ);
}

void rezolva () {
	
	Q[0].x = 0; Q[0].y = n;
	
	int i, cur, x, y;
	for (i = 1; i <= m; i++) {
		
		cur = poz[i]; x = Q[cur].x; y = Q[cur].y;
		while (N && Q[ A[N] ].y < x ) {
			N--;
			val = INF; Poz = N + 1;
			update (1, 1, m);
		}
		
		D = cur; rez = 0;
		query (1, 1, m);
		
		Sol[cur] = (long long) (x - Q[rez].x) * (long long) (n - y + 1);
		if (Q[rez].x != 0) Sol[cur]+= (long long) (Q[rez].y - y);
		
		A[++N] = cur;
		val = cur; Poz = N;
		update (1, 1, m);
	}
}

int main () {

	freopen ("minuni.in", "r", stdin);
	freopen ("minuni.out", "w", stdout);

	memset (AI, INF, sizeof (AI));
	citire ();
	rezolva ();
	afisare ();
	
	return 0;
}

int cmp (int a, int b) {
	return Q[a].x < Q[b].x;
}

void citire () {

	int i;
	
	scanf ("%d %d", &n, &m);
	for (i = 1; i <= m; i++) {
		scanf ("%d %d", &Q[i].x, &Q[i].y);
		poz[i] = i;
	}
	
	sort (poz + 1, poz + 1 + m, cmp);
}

void afisare () {
	
	for (int i = 1; i <= m; i++)
		printf ("%lld\n", Sol[i]);
}
