// O (log Dn * n * Dn)

#include <cstdio>
#include <algorithm>
using namespace std;

#define Nmax 52
#define Dmax 10010
#define INF 0x3f3f3f3f

int n, i, E, j, sol, Min, l;
int D[Nmax], a[Nmax][Dmax], De[Dmax];

int cont (int X) {
	
	memset (a[1], INF, sizeof (a[1]));
	a[1][0] = 0;
	
	int p, u;
	
	for (i = 2; i <= n - 1; i++) { 
		a[i][0] = a[i - 1][0] + D[i];
		p = u = 1; De[1] = a[i - 1][0];
		
		for (j = 1; j <= D[n]; j++) { 
			
			while (p <= u && De[p] < j - X) p++;
			while (p <= u && a[i - 1][j] < a[i - 1][De[u]]) u--;
			
			De[++u] = j;
			
			if (a[i - 1][ De[p] ] != INF) a[i][j] = a[i - 1][ De[p] ] + abs (D[i] - j);
			else a[i][j] = INF;
		}
	}
	
	for (i = D[n]; i >= D[n] - X && i >= 0; i--)
		if (a[n - 1][i] <= E) return 1;
	
	return 0;
}

int main () {

	freopen ("stalpi.in", "r", stdin);
	freopen ("stalpi.out", "w", stdout);

	scanf ("%d %d", &n, &E);
	for (i = 2; i <= n; i++)
		scanf ("%d", &D[i]);

	int p = 0, u = D[n], mij;
	
	while (p <= u) {
		mij = (p + u) >> 1;
		if (cont (mij)) {
			sol = mij;
			u = mij - 1;
		}
		else
			p = mij + 1;
	}
	
	printf ("%d", sol);
	
	return 0;
}
