#include <cstdio>
#include <cstdlib>
#include <algorithm>
#define infile "diff.in"
#define outfile "diff.out"
#define MaxN 100024
#define MaxK 200024

using namespace std;

int f[MaxN],b[MaxN];
int N,M,Nr;
int K[MaxK],o[MaxK];
int x[MaxK],y[MaxK];

void read()
{
    scanf("%d%d",&N,&M);
    int i,x;
    for(i=1;i<=N;i++)
    {
        scanf("%d",&x);
        if(!x)
            f[i]=f[i-1]+1, b[i]=b[i-1];
        else
            b[i]=b[i-1]+1, f[i]=f[i-1];
    }

    for(i=1;i<=M;i++)
    {
        scanf("%d",&K[i]);
        o[i]=i;
    }
}

int cmp(int x,int y)
{
    return K[x]<K[y];
}

void cauta(int val,int i,int j)
{
    int st=1,dr=M,m;
    while(st<=dr)
    {
        m=(st+dr)/2;
        if(val==K[o[m]])
        {
            x[o[m]]=i; y[o[m]]=j;
            return;
        }
        if(val>K[o[m]])
            st=m+1;
        else
            dr=m-1;
    }

    if(val==K[o[st]])
        x[o[st]]=i, y[o[st]]=j;
    if(val==K[o[dr]])
        x[o[dr]]=i, y[o[dr]]=j;
}

void solve()
{
    int i,j;
    int F,B;
    for(i=1;i<N;i++)
        for(j=i+1;j<=N;j++)
        {
            F=f[j]-f[i-1];
            B=b[j]-b[i-1];
            cauta(B-F,i,j);
        }
}

void write()
{
    int i;
    for(i=1;i<=M;i++)
        if(!x[i])
            printf("-1\n");
        else
            printf("%d %d\n",x[i],y[i]);
}

int main()
{
    freopen(infile,"r",stdin);
    freopen(outfile,"w",stdout);

    read();
    sort(o+1,o+M+1,cmp);
    solve();
    write();

    fclose(stdin);
    fclose(stdout);
    return 0;
}
