#include <cstdio>
#include <algorithm>
#include <set>
#define MAXM 100010
using namespace std;
struct muchie{
	int x,y;
} v[MAXM];
struct eveniment{
	int nod,interval,type;
} vev[MAXM*2];
int includer[MAXM];
set<int> A;
struct capat{
	int fin,interv;
} finale[MAXM];
int N,M,Ne;


inline bool cmp(const eveniment &A,const eveniment &B){
	return (A.nod<B.nod);
}

inline bool cmp_fin(const capat &A,const capat &B){
	return (A.fin<B.fin);
}


int cbinfin(int p,int u,int valoare){
	int m=(p+u)/2;
	if (finale[m].fin==valoare) return finale[m].interv;
	if (finale[m].fin<valoare) return cbinfin(m+1,u,valoare);
	if (finale[m].fin>valoare) return cbinfin(p,m-1,valoare);
}

int main(){

	freopen("minuni.in","r",stdin);
	freopen("minuni.out","w",stdout);

	scanf("%d%d",&N,&M);

	Ne=0;

	for (int i=1;i<=M;++i)
		{

			scanf("%d%d",&v[i].x,&v[i].y);
			vev[++Ne].nod=v[i].x;
			vev[Ne].interval=i;
			vev[Ne].type=0;

			vev[++Ne].nod=v[i].y;
			vev[Ne].interval=i;
			vev[Ne].type=1;

			finale[i].fin=v[i].y;
			finale[i].interv=i;
		}

	fclose(stdin);

	v[0].x=0;
	v[0].y=N+1;
	finale[M+1].fin=N+1;
	finale[M+1].interv=0;

	sort(vev+1,vev+Ne+1,cmp);
	sort(finale+1,finale+M+2,cmp_fin);

	A.insert(N+1);

	for (int i=1;i<=Ne;++i)
		if (vev[i].type==0){
			set<int>::iterator it=A.upper_bound(v[vev[i].interval].y);

			int dad=*it;

			includer[vev[i].interval]=cbinfin(1,M+1,dad);

			A.insert(v[vev[i].interval].y);

		}

	for (int i=M;i>=1;--i)
		while (includer[i]>i) includer[i]=includer[includer[i]];
	

	for (int i=1;i<=M;++i){

		int capatst=v[includer[i]].x;
		int capatdr=v[includer[i]].y;

		int liberest=v[i].x;
		int liberedr=N-v[i].y+1;

		long long nefrec=(long long)liberest*(long long)liberedr;

		nefrec-=((long long)capatst*(long long)(N-capatdr+1));

		printf("%lld\n",nefrec);
	}

	fclose(stdout);

	return 0;
}

		
