#include <vector>
#include <map>
#include <fstream>

using namespace std;

int main(){
    ifstream in("diff.in");
    ofstream out("diff.out");

    int n,m;in>>n>>m;

    vector<int> fete(n+1,0);
    vector<int> baieti(n+1,0);\

    for(int i=1;i<=n;i++){
        int gen;
        in>>gen;

        baieti[i]=baieti[i-1];
        fete[i]=fete[i-1];

        if(gen) baieti[i]++;
        else fete[i]++;

    }

    map<int,pair<int,int> > harta;
    for(int i=1;i<=n;i++){
        for(int j=i;j<=n;j++){
            int dif=baieti[j]-baieti[i-1]-fete[j]+fete[i-1];
            harta[dif]=make_pair(i,j);
        }
    }

    for(int i=0;i<m;i++){
        int dif;in>>dif;

        map<int,pair<int,int> >::iterator it=harta.find(dif);

        if(it==harta.end()){
            out<<"-1\n";
        }else{
            out<<it->second.first<<" "<<it->second.second<<"\n";
        }
    }
    out.close();
    in.close();
    return 0;
}
