#include <algorithm>
#include <vector>
using namespace std;

#define pb push_back
#define DIM 100005
#define LIM1 3005
#define sc second
#define fs first

pair <int,int> sol[(LIM1<<1)];
vector <int> viz[(DIM<<1)];
int dif[DIM];
int n,m;

void read ()
{
    int i,x;

    scanf ("%d%d",&n,&m);
    for (i=1; i<=n; ++i)
    {
        scanf ("%d",&x);
        if (x)
            dif[i]=dif[i-1]+1;
        else
            dif[i]=dif[i-1]-1;
        viz[dif[i]+DIM].pb (i);
    }
}

void do_brut1 ()
{
    int i,j,x;

    for (i=1; i<n; ++i)
        for (j=i; j<=n; ++j)
        {
            x=dif[j]-dif[i-1]+LIM1;
            if (!sol[x].fs && !sol[x].sc)
            {
                sol[x].fs=i;
                sol[x].sc=j;
            }
        }
    for (i=1; i<=m; ++i)
    {
        scanf ("%d",&x);
        x+=LIM1;
        if (!sol[x].fs && !sol[x].sc)
            printf ("-1\n");
        else
            printf ("%d %d\n",sol[x].fs,sol[x].sc);
    }
}

void do_brut2 ()
{
    vector <int> :: iterator it;
    int i,j,ok,x;

    for (i=1; i<=m; ++i)
    {
        scanf ("%d",&x);
        for (ok=j=0; j<n && !ok; ++j)
            if (viz[dif[j]+DIM+x].size ())
                for (it=viz[dif[j]+DIM+x].begin (); it!=viz[dif[j]+DIM+x].end () && !ok; ++it)
                    if (*it>j)
                    {
                        printf ("%d %d\n",j+1,*it);
                        ok=1;
                    }
        if (!ok)
            printf ("-1\n");
    }
}

void randomizat ()
{
    srand (time (0));
    vector <int> :: iterator it;
    int i,j,ok,x,nr;

    for (i=1; i<=m; ++i)
    {
        scanf ("%d",&x);
        ok=0;
        for (nr=1; nr<=10; ++nr)
            for (j=0; j<n; j+=rand ()%100+1)
                if (viz[dif[j]+DIM+x].size ())
                    for (it=viz[dif[j]+DIM+x].begin (); it!=viz[dif[j]+DIM+x].end () && !ok; ++it)
                        if (*it>j)
                        {
                            printf ("%d %d\n",j+1,*it);
                            ok=1;
                        }
        if (!ok)
            printf ("-1\n");
    }
}

int main ()
{
    freopen ("diff.in","r",stdin);
    freopen ("diff.out","w",stdout);

    read ();
    if (n<=3000)
        do_brut1 ();
    else if (m<=500)
        do_brut2 ();
    else
        randomizat ();

    return 0;
}
