#include <algorithm>
#include <vector>
#include <queue>
using namespace std;

#define INF (1<<30)+5
#define pb push_back

vector <vector <int> > dst,g;
queue <int> q;
int n,m,nrt;

void laba ()
{
    int i,x,y;

    scanf ("%d%d",&n,&m);
    for (i=1; i<=m; ++i)
    {
        scanf ("%d%d",&x,&y);
        printf ("%lld\n",1LL*x*(n-y+1));
    }
}

inline int bf (int sursa)
{
    vector <int> :: iterator it;
    vector <int> aux;
    int i,nod,nrc=0;

    aux.resize (n-sursa+5);
    aux.assign (n-sursa+5,INF);
    aux[0]=0;
    for (q.push (sursa); !q.empty (); q.pop ())
    {
        nod=q.front ();
        for (it=g[nod].begin (); it!=g[nod].end (); ++it)
            if (aux[nod-sursa]+1<=aux[*it-sursa])
            {
                aux[*it-sursa]=aux[nod-sursa]+1;
                q.push (*it);
            }
    }
    for (i=sursa+1; i<=n; ++i)
    {
        if (dst[sursa][i-sursa]!=aux[i-sursa])
            ++nrc;
        dst[sursa][i-sursa]=aux[i-sursa];
    }
    return nrc;
}

void solve_brut ()
{
    int i,j,x,y;

    scanf ("%d%d",&n,&m);
    dst.resize (n+5);
    g.resize (n+5);
    for (i=1; i<n; ++i)
    {
        g[i].pb (i+1);
        dst[i].resize (n-i+5);
    }
    for (i=1; i<n; ++i)
        for (j=i+1; j<=n; ++j)
            dst[i][j-i]=j-i;
    for (i=1; i<=m; ++i)
    {
        scanf ("%d%d",&x,&y);
        g[x].pb (y);
        nrt=0;
        for (j=1; j<=x; ++j)
            nrt+=bf (j);
        printf ("%d\n",nrt);
    }
}

int main ()
{
    freopen ("minuni.in","r",stdin);
    freopen ("minuni.out","w",stdout);

    solve_brut ();

    return 0;
}
