#include <cstdio>
#include <utility>
#include <algorithm>
using namespace std;
#define fi first
#define se second
#define mp make_pair
FILE *in,*out;
pair<int,int > b[100005],a[100005],c[100005],d[100005];
int arb[14][500005];
int kkt[14][500005];
pair<int,int> arb2[500005];
int nr;
inline int maxim(int x,int y)
{
	return x>y?x:y;
}
int query(int nod,int nivel,int a,int b,int c,int d)
{
	if (c>d)
		return 0;
	if (c<=a&&b<=d)
		return arb[nivel][nod];
	int m=(a+b)/2,r1=0,r2=0;
	if (c<=m)
		r1=query(nod*2,nivel,a,m,c,d);
	if (d>m)
		r2=query(nod*2+1,nivel,m+1,b,c,d);
	return maxim(r1,r2);
}
void update(int nod,int nivel,int a,int b,int poz,int val)
{
	if (a==b)
	{
		arb[nivel][nod]=val;
		return ;
	}
	int m=(a+b)/2;
	if (poz<=m)
		update(nod*2,nivel,a,m,poz,val);
	else
		update(nod*2+1,nivel,m+1,b,poz,val);
	arb[nivel][nod]=maxim(arb[nivel][nod*2],arb[nivel][nod*2+1]);
}
/*void init(int nod,int x,int y)
{
	if (y==x)
		arb[0]=b[x]
}*/
int query2(int nod,int nivel,int x,int y,int z,int t)
{
	if (z<1)
		return 0;
	if (y<=z)
	{
		// ma aflu in arb[nivel][nod] intre arb2[nod].fi ... arb2[nod].se
		return query(1,nivel,1,nr,lower_bound(kkt[nivel]+arb2[nod].fi,kkt[nivel]+arb2[nod].se+1,t)-kkt[nivel],arb2[nod].se);
	}
	int r1=0,r2=0,m=(x+y)/2;
	r1=query2(nod*2,nivel+1,x,m,z,t);
	if (z>m)
		r2=query2(nod*2+1,nivel+1,m+1,y,z,t);
	return maxim(r1,r2);
}
void update2(int nod,int nivel,int x,int y,int z,int t)
{
	int aux;
	aux=lower_bound(kkt[nivel]+arb2[nod].fi,kkt[nivel]+arb2[nod].se+1,t)-kkt[nivel];
	if (aux==arb2[nod].se+1)
	{
		return ;
	}
	update(1,nivel,1,nr,aux,z);
	if (x==y)
	{
		return;
	}
	int m=(x+y)/2;
	if (z<=m)
		update2(nod*2,nivel+1,x,m,z,t);
	else
		update2(nod*2+1,nivel+1,m+1,y,z,t);
}
void init(int nod,int nivel,int x,int y,int def)
{
	if (x==y)
	{
		arb2[nod]=mp(def+1,def+1);
		kkt[nivel][def+1]=d[b[x].se].se;
		return ;
	}
	int m=(x+y)/2;
	init(nod*2,nivel+1,x,m,def);
	init(nod*2+1,nivel+1,m+1,y,arb2[nod*2].se);
	int i=arb2[nod*2].fi,j=arb2[nod*2+1].se,lims=arb2[nod*2].se,limd=arb2[nod*2+1].se,poz=def;
	while (i<=lims||j<=limd)
	{
		if (i<=lims&&(kkt[nivel+1][i]<=kkt[nivel+1][j]||j>limd))
		{
			poz++;
			kkt[nivel][poz]=kkt[nivel+1][i];
			i++;
		}
		else
		{
			poz++;
			kkt[nivel][poz]=kkt[nivel+1][j];
			j++;
		}
	}
	arb2[nod]=mp(def+1,limd);
}
int main()
{
	int n,m,i;
	long long rez,aux;
	in=fopen("minuni.in","r");
	out=fopen("minuni.out","w");
	fscanf(in,"%d%d",&n,&m);
	nr=0;
	for (i=1;i<=m;i++)
	{
		fscanf(in,"%d%d",&a[i].fi,&a[i].se);
		if (a[i].fi>=a[i].se)
			continue;
		nr++;
		b[nr]=mp(a[i].fi,i);
		c[nr]=mp(a[i].se,i);
	}
	sort(b+1,b+nr+1);
	sort(c+1,c+nr+1);
	for (i=1;i<=nr;i++)
	{
		d[b[i].se].fi=i;
		d[c[i].se].se=i;
	}
	init(1,0,1,nr,0);
	for (i=1;i<=m;i++)
	{
		if (a[i].fi>=a[i].se)
		{
			fprintf(out,"0\n");
			continue;
		}
		if (d[i].fi==1||d[i].se==nr)
			aux=0;
		else
			aux=query2(1,0,1,nr,d[i].fi-1,d[i].se+1);
		rez=((long long)a[i].fi-b[aux].fi)*(n-a[i].se+1);
		fprintf(out,"%lld\n",rez);
		update2(1,0,1,nr,d[i].fi,d[i].se);
	}
	//init arb
	/*init(1,1,nr);*/
	/*u=0;
	for (i=1;i<=m;i++)
	{
		if (a[i].fi>=a[i].se)
		{
			fprintf(out,"0\n");
			continue;
		}
		while (p<=u&&q[p].se<=a[i].fi)
			p++;
		while (u>0&&q[u].se<=a[i].fi)
			u--;
		if (u==0)
			aux=0;
		else
			aux=q[p].fi;
	//	aux=query(1,1,nr,1,c[i]-1);
		rez=(a[i].fi-aux)*(n-a[i].se+1);
		fprintf(out,"%lld\n",rez);
		while (u>0)
		{
		}
	//	update(1,1,nr,c[i],c[i]);
	}*/
/*	for (i=1;i<=nr;i++)
	{a
		rez[i]=(b[i].fi-b[i-1].fi)*(n-a[b[i].se].se+1);
	}	
	for (i=1;i<=m;i++)
		fprintf(out,"%lld\n",rez[i]);*/
	fclose(in);
	fclose(out);
	return 0;
}
