#include <fstream>
#include <vector>
#include <cstring>

#define NMAX 100100
using namespace std;

struct point{int x, y; };

vector<vector<int> > Calc;

int N, M;
vector<int> Gasit;
point KSol[NMAX * 2];
int A[NMAX], Pre[NMAX], Exista[2 * NMAX];

ofstream fout("diff.out");
ifstream fin("diff.in");

void Solve1(void)
{
	int i, t, j;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= i; j++)
			if (KSol[ Pre[i] - Pre[j - 1] + NMAX].x == 0)
				KSol[ Pre[i] - Pre[j - 1] + NMAX].x = j, KSol[ Pre[i] - Pre[j - 1] + NMAX].y = i;
			
			
	for (i = 1; i <= M; i++)
	{
		fin >>t;
		
		if (abs(t) > N) 
			fout <<"-1\n";
		else
		{
			if (KSol[t + NMAX].x == 0) 
				fout <<"-1\n";
			else 
				fout <<KSol[t + NMAX].x <<' ' <<KSol[t + NMAX].y <<'\n';
		}
	}
}

void Solve2(void)
{
	int i, j, k, t, ok;
	
	for (i = 1; i <= M; i++)
	{
		fin >>t;
		ok = 1;
		
		if (abs(t) > N) 
			fout <<"-1\n";
		else
		{		
			for (j = 1; j <= N; j++)
			{
				if ( abs(Pre[j] - t) <= N )
				{
					if (Exista[Pre[j] - t + NMAX] != 0 || Pre[j] - t == 0) 
						fout <<Exista[Pre[j] - t + NMAX] + 1 <<' '<<j <<'\n', j = 2 * N, ok = 0;
					if (!Exista[Pre[j] + NMAX]) Exista[Pre[j] + NMAX] = j;		

				}
			}			
			if (ok) fout <<"-1\n";
			memset(Exista, 0, sizeof(Exista));
		}
	}
}

int main()
{	
	fin >>N >>M;
	
	int i;
	
	for (i = 1; i <= N; i++)
	{
		fin >>A[i];
		if (A[i] == 0) A[i] = -1;
		Pre[i] = Pre[i - 1] + A[i];
	}
	if (N <= 3000) 
		Solve1();
	else
		Solve2();
	
	fout.close();
	
	return 0;
}
