#include <fstream>
#include <cstring>
#include <set>

#define DISMAX 10100
#define NMAX 52
#define INFI 107e
using namespace std;

int best[2][NMAX][DISMAX];

multiset<int> S;
int N, E, DMAX, A[NMAX], sol;

inline int maxim(int a, int b)
{
	if (a < b) 
		return a;
	else 
		return b;
}

void ReadAll(void)
{
	ifstream fin("stalpi.in");
	
	fin >>N >>E;
	int i;
	
	for (i = 1; i < N; i++)
		fin >>A[i];
	
	DMAX = A[N - 1];
	N--;
	N--;
	
	fin.close();
}

void Solve(void)
{
	int st = DMAX / (N + 1), end = DMAX, m, i, j, top;
	
	while (st <= end)
	{
		m = (st + end) / 2;
		S.clear();
		memset(best, 9999, sizeof(best));
		
		for (j = 0; j <= DMAX; j++)
			best[0][0][j] = best[1][0][j] = 0;
		
		for (i = 1; i <= N; i++)
		{
			for (j = 1; j <= m * i && j <= DMAX; j++)
				best[1][i][j] = best[0][i-1][j] + abs(j - A[i]);
			
			for (j = 1; j <= DMAX; j++)
			{
				S.insert(best[1][i][j]);
				top = *S.begin();
				if (j - m > 0)
					S.erase(S.find(best[1][i][j - m]));
				best[0][i][j] = top;
			}
		}
		
		if (best[0][N][DMAX] > E) st = m + 1;
		else end = m - 1, sol = m;
	}
}

void Afiseaza(void)
{
	ofstream fout("stalpi.out");
	
	fout <<sol <<'\n';
	
	fout.close();
}

int main()
{
	ReadAll();
	
	Solve();
	
	Afiseaza();
	
	return 0;
}