#include<stdio.h>
#include<algorithm>
#include<queue>
#include<vector>

using namespace std;

#define Nmax 55
#define Mmax 110
#define inf 0x3f3f3f3f
#define mp make_pair
#define pb push_back
#define fs first
#define sc second

int a[Nmax],b[Nmax],E,N;
int F[Mmax][Mmax],d[Mmax],p[Mmax],v[Mmax];
int M,S,D;
vector < pair<int,int> > l[Nmax];

struct cmp
{
    bool operator()(int a,int b)
    {
        return (d[a] > d[b]);
    }
};
priority_queue< int,vector<int> ,cmp> Heap;

inline int dijkstra()
{
    int nod;
    for(int i=1;i<=M;++i)
        {
        d[i]=inf;
        v[i]=0;
        p[i]=0;
        }
    d[S]=0;
    v[S]=1;
    Heap.push(S);
    vector< pair<int,int> >::iterator it;
    for(; !Heap.empty() ;)
        {
        nod=Heap.top();
        v[nod]=0;
        Heap.pop();
        for(it=l[nod].begin();it!=l[nod].end();++it)
            if (d[ it->fs ] > d[ nod ] + it->sc && F[nod][it->fs])
                {
                d[ it->fs ] = d[ nod ] + it->sc;
                p[ it->fs ] = nod;
                if (!v[ it->fs ])
                    {
                    v[ it->fs ]=1;
                    Heap.push( it->fs );
                    }
                }
        }

    return (d[D]!=inf);
}

inline int solutie(int k)
{
    int Sum=0;
    M=2*N+2;
    S=M-1; D=M;
    for(int i=1;i<=M;++i)
        for(int j=1;j<=M;++j)
            F[i][j]=0;
    for(int i=1;i<=M;++i)
        l[i].clear();

    for(int i=1;i<=N;++i)
        if (b[i] > k)
            {
            for(int j=1;j<=N;++j)
                {
                l[i].pb( mp(j+N,abs(i-j)) );
                l[j+N].pb( mp(i,abs(i-j)) );
                F[i][j+N]=b[i]-k;
                }
            l[S].pb( mp(i,0) );
            F[S][i]=b[i]-k;
            Sum += b[i]-k;
            }
        else
            {
            l[i+N].pb( mp(D,0) );
            F[i+N][D]=k-b[i];
            }

    int Min,Cost,Cuplaj;
    Cost = 0;
    Cuplaj=0;
    for(int ok=dijkstra() ; ok ;)
        {
        Min = inf;
        for(int i=D; i!=S ;i=p[i])
            if (Min > F[p[i]][i])
                Min = F[p[i]][i];
        for(int i=D; i!=S ;i=p[i])
            {
                F[p[i]][i] -= Min;
                F[i][p[i]] += Min;
            }

        Cost += Min*d[D];
        Cuplaj += Min;

        ok=dijkstra();
        }
    return (Cuplaj == Sum && Cost <= E);
}

void solve()
{
    int Max = 0;
    for(int i=1;i<N;++i)
        if (Max < b[i])
            Max = b[i];

    int st= a[N] / (N-1),dr=Max,last = Max+1,mid;

    --N;
    while( st<=dr )
        {
        mid = st+(dr-st)/2;
        if (solutie(mid))
            {
            dr=mid-1;
            last=mid;
            }
        else
            st=mid+1;
        }
    printf("%d\n",last);
}

void cit()
{
    freopen("stalpi.in","r",stdin);
    freopen("stalpi.out","w",stdout);
    scanf("%d%d",&N,&E);
    for(int i=1;i<N;++i)
        {
        scanf("%d",&a[i+1]);
        b[i] = a[i+1] - a[i];
        }
}

int main()
{
    cit();
    solve();
    return 0;
}
