#include <fstream>
#include <algorithm>
#define IN "minuni.in"
#define OUT "minuni.out"
#define L 100005
#define oo 1000005

using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

int H[L*4];
int Pmax[L*4];
int poz[L];
int x[L], y[L], ind[L],  W[L];
int m, P, S, D, Rez, n;
int A[100];
int nr1=0;
int B[100];
int nr2=0;
int sum[100];
int num;

struct cmp
{
    bool operator ()(const int &a, const int &b)const
    {
        return x[a] < x[b];
    }
};

void citire()
{
    fin >> n >> m;
    for (int i=1;i<=m;i++)
    {
        fin>>x[i]>>y[i];
        ind[i]=i;
    }
    sort(ind + 1 , ind + m + 1, cmp());
    for (int i=1;i<=m;i++)
        W[ind[i]] = i;

}

void upd(int nod,int st,int dr)
{
    if (st==dr)
    {
        H[nod]=1;
        Pmax[nod]=st;
        return ;
    }
    int mij=(st+dr)>>1;
    if (P<=mij)
        upd(nod<<1, st, mij);
    else
        upd((nod<<1)+1, mij+1, dr);
    H[nod] = H[nod<<1]+ H [(nod<<1)+1];
    Pmax[nod] =  max(Pmax[nod<<1], Pmax[(nod<<1)+1]);
}

void calc(int nod,int st,int dr)
{
    if (S<=st && D>=dr)
    {
        Rez=max(Rez, Pmax[nod]);
        return ;
    }
    int mij=(st+dr)>>1;
    if (S<=mij)
        calc(nod<<1, st, mij);
    if (D>mij)
        calc((nod<<1)+1, mij+1, dr);
}

void inmulteste(int a,int b)
{
    nr1=nr2=0;
    while (a)
    {
        A[nr1++]=a%10;
        a/=10;
    }

    while (b)
    {
        B[nr2++]=b%10;
        b/=10;
    }

    for (int i=0;i<nr1;i++)
    {
        int T=0;
        for (int j=0;j<nr2;j++)
        {
            sum[i+j]+=A[i]*B[j]+T;
            T=sum[i+j]/10;
            sum[i+j]=sum[i+j]%10;
        }
        if (T)
            sum[i+nr2]+=T;
    }
    for (int i=0;i<nr1;i++)
        A[i]=0;
    for (int j=0;j<nr2;j++)
        B[j]=0;
    num=99;
    while (sum[num]==0 && num>=0)
        num--;
    for (int i=num;i>=0;i--)
    {
        fout<<sum[i];
        sum[i]=0;
    }
    fout <<"\n";
}

void solve()
{
    for (int i=1;i<=m;i++)
    {
        Rez=0;
        P=W[i];
        upd(1, 1, m);
        S=1;
        D=W[i]-1;
        if (D>=S)
            calc(1, 1, m);
        if (Rez!=0 && y[Rez] > y[i]  && x[Rez] < x[i])
            inmulteste(x[i]-x[Rez], y[Rez]-y[i]);
        else
            inmulteste(x[i], n-y[i]+1);
    }
}

int main()
{
    citire();
    solve();
    return 0;
}
