#include <iostream>
#include <string>
#include <ctime>

using namespace std;

#define NM 100005

int N, M, B[NM];

int A[NM];

int CSP[NM][2], CSM[NM][2];

void baga60()
{
	int start = clock();
	
	int D;
	
	for (int i = 1; i <= N; ++i)
		for (int j = 1; j <= i; ++j)
		{
			int tot = i - j + 1;
			int b = B[i] - B[j-1];
			int f = tot - b;
			
			if (b - f >= 0)
			{			
				if (!CSP[b - f][0])
				{
					CSP[b - f][0] = j;
					CSP[b - f][1] = i;
				}
			}	
			else 
				if(!CSM[f - b][0])
				{
					CSM[f - b][0] = j;
					CSM[f - b][1] = i;
				}	
		}	
	
	while (M--)
	{
		scanf ("%d", &D);
		if (D>=0) 
		{
			if (D > N) 
			{	
				printf ("-1\n");
				continue;
			}	
			if (!CSP[D][0]) 
			{	
				printf ("-1\n");
				continue;
			}
			
			printf ("%d %d\n", CSP[D][0], CSP[D][1]);	
		}	
		else
		{
			if ( -D > N) 
			{	
				printf ("-1\n");
				continue;
			}	
			if (!CSM[-D][0]) 
			{
				printf ("-1\n");	
				continue;
			}	
			
			printf ("%d %d\n", CSM[-D][0], CSM[-D][1]);
		}	
	}

	int stop = clock();

	//printf ("%lf", (double)(stop - start)/CLOCKS_PER_SEC);	
}

int main()
{
	freopen ("diff.in", "r", stdin);
	freopen ("diff.out", "w", stdout);
	
	scanf ("%d %d", &N, &M);
	
	for (int i = 1; i <= N; ++i)
	{
		scanf ("%d", &A[i]);
		B[i] = B[i-1] + A[i];
	}	
	
	//if (N <= 3000 && M <= 200000) 
	baga60();
	
	return 0;
}