#include<fstream>
using namespace std;

ifstream fin("diff.in");
ofstream fout("diff.out");

int N,M,K;
int X[100010],T[100010];

/*
void swap(int i,int j)
{
    X[i]^=X[j]^=X[i]^=X[j];
    T[i]^=T[j]^=T[i]^=T[j];
}

void heapsort()
{
    for(int i=1;i<=N;i++)
    {
        int j=i;
        while(j/2 && X[j/2]<X[j])
        {
            swap(j,j/2);
            j/=2;
        }
    }

    int Nh=N;
    while(Nh>1)
    {
        swap(1,Nh);
        Nh--;

        int i=1,j;
        while(1)
        {
            j=i*2;
            if(j>Nh) break;
            if(j+1<=Nh && X[j+1]>X[j]) j++;
            if(X[j]<X[j/2]) break;
            swap(j,j/2);
            i=j;
        }
    }

}

int bin(int nr, int i)
{
    int li=1,lf=N;
    int last_mij=0;
    while(lf-li>1)
    {
        int mij=(li+lf)/2;
        if(X[mij]<nr)
        {
            if(X[mij]==nr && T[mij]>T[i])
            {
                li=mij+1;
                if(last_mij==mij)
                    return 0;
                last_mij=mij;
            }
            else
            {
                li=mij;
                last_mij=mij;
            }
        }
        else
        {
            if(X[mij]==nr && T[mij]>T[i])
            {
                lf=mij-1;
                if(last_mij==mij)
                    return 0;
                last_mij=mij;
            }
            else
            {
                lf=mij;
                last_mij=mij;
            }
        }
    }
    if(X[lf]==nr) return T[lf];
    if(X[li]==nr) return T[li];
    return 0;
}

void solve()
{
    int sol;
    for(int i=1;i<=N;i++)
        if(sol=bin(X[i]-K,i))
        {
            fout<<(sol+1)<<" "<<T[i]<<"\n";
            return;
        }
    fout<<"-1\n";
}

int main()
{
    fin>>N>>M;
    for(int i=1;i<=N;i++)
    {
        int c;
        fin>>c;
        if(c==0)
            X[i]=X[i-1]-1;
        else
            X[i]=X[i-1]+1;
        T[i]=i;

    }
    heapsort();
    for(int i=1;i<=M;i++)
    {
        fin>>K;
        solve();
    }
    return 0;
}
*/
int solve()
{
        for(int i=1;i<=N;i++)
            for(int j=i+1;j<=N;j++)
            {
                if(X[j]-X[i-1] == K)
                {
                    fout<<i<<" "<<j<<"\n";
                    return 1;
                }
            }
        return 0;
}

int main()
{
    fin>>N>>M;
    for(int i=1;i<=N;i++)
    {
        int c;
        fin>>c;
        if(c==0)
            X[i]=X[i-1]-1;
        else
            X[i]=X[i-1]+1;

    }
    for(int i=1;i<=M;i++)
    {
        fin>>K;
        if(!solve())
            fout<<"-1\n";
    }
    return 0;
}

