#include<stdio.h>
#include<algorithm>
using namespace std;

FILE *fin=fopen("minuni.in","r"),
    *fout=fopen("minuni.out","w");
#define Mmax 100010

int N,M;
int X[Mmax],Y[Mmax],T[Mmax],P[Mmax];
long long rez[Mmax];

void swap(int i,int j)
{
    X[i]^=X[j]^=X[i]^=X[j];
    Y[i]^=Y[j]^=Y[i]^=Y[j];
    T[i]^=T[j]^=T[i]^=T[j];
    P[T[i]]^=P[T[j]]^=P[T[i]]^=P[T[j]];

}

void heapsort()
{
    for(int i=1;i<=M;i++)
    {
        int j=i;
        while(j/2 && X[j/2]<X[j])
        {
            swap(j,j/2);
            j/=2;
        }
    }

    int Nh=M;
    while(Nh>1)
    {
        swap(1,Nh);
        Nh--;

        int i=1,j;
        while(1)
        {
            j=i*2;
            if(j>Nh) break;
            if(j+1<=Nh && X[j+1]>X[j]) j++;
            if(X[j]<X[j/2]) break;
            swap(j,j/2);
            i=j;
        }
    }

}

int inglobat(int k)
{
    int poz=P[k];
    for(int i=P[k];i;i--)
        if(X[i]<X[poz] && Y[i]>Y[poz] && T[i]<T[poz])
            return i;
    return 0;

}

int main()
{
    fscanf(fin,"%d %d",&N,&M);
    for(int i=1;i<=M;i++)
    {
        fscanf(fin,"%d %d",&X[i],&Y[i]);
        T[i]=i;
        P[i]=i;
    }
    heapsort();
    for(int i=1;i<=M;i++)
    {
        int poz=inglobat(i);
        rez[i]=(long long)(N-Y[P[i]]+1)*(X[P[i]]-X[poz]);
        fprintf(fout,"%lld\n",rez[i]);
    }
    return 0;
}
