#include <fstream>
#include <algorithm>
#include <cmath>

using namespace std;

inline int p(int i){return i/2;}
inline int l(int i){return 2*i;}
inline int r(int i){return 2*i+1;}

int h[50];
int v[50];
int pos[50];
int s;

void sift(int i){
    if(v[h[i]]<v[h[l(i)]]||v[h[i]]<v[h[r(i)]]){
        int a=max(v[h[l(i)]],v[h[r(i)]]);
        if(a==v[h[l(i)]]){
            swap(pos[h[i]],pos[h[l(i)]]);
            swap(h[i],h[l(i)]);
            sift(l(i));
        }
        else{
            swap(pos[h[i]],pos[h[r(i)]]);
            swap(h[i],h[r(i)]);
            sift(r(i));
        }
    }
}

void percolate(int i){
    if(p(i)>0&&v[h[p(i)]]<v[h[i]]){
        swap(pos[h[i]],pos[h[p(i)]]);
        swap(h[i],h[p(i)]);
        percolate(p(i));
    }
}

void build(int* d){
    int i;
    for(i=0;i<=s;i++){
            if(i<s)
                v[i+1]=d[i];
            h[i]=i;
            pos[i]=i;
    }
    for(i=s;i>0;i--)
        percolate(i);
}

int getMax(){
    return v[h[1]];
}

int main(){
    ifstream in("stalpi.in");
    ofstream out("stalpi.out");

    int n,e;
    int d[50];
    int d2[50];

    in>>n>>e;
    s=n-1;

    int i;

    for(i=0;i<n;i++){
        in>>d[i];
        if(i)
            d2[i]=d[i]-d[i-1];
        else
            d2[0]=d[0];
    }

    /*double m=d[n-2]/(double)(n-1);

    int c=0;
    for(i=0;i<n-2;i++)
        if(d[i]-(i+1)*m>=0)
            c+=round(d[i]-i*m);
        else
            c-=round(d[i]-i*m);
    */
   /* if(c<=e)
        out<<(int)round(m);
    else{*/
        if(n==3){
                int max=0;
                for(i=1;i<n;i++)
                    if(d2[i]>max)
                        max=d2[i];
                out<<max;
        }
        else{
             int max=0;
            for(i=1;i<n;i++)
                if(d2[i]>max)
                    max=d2[i];
            build(d2);
            while(e){
                int dir=h[1];

                if(h[1]==s)
                    dir--;
                else if(h[1]==1)
                    dir++;
                else if(v[dir+1]<v[dir-1])
                    dir++;
                else
                    dir--;

                v[h[1]]--;
                sift(1);
                v[dir]++;
                percolate(pos[dir]);

                if(v[h[1]]<max)
                    max=v[h[1]];

                e--;
            }
            out<<max;
        }
   // }


    return 0;
}
