#include<stdio.h>
#define infile "diff.in"
#define outfile "diff.out"
#define nmax (100*1013)
struct raspuns
{
	int x,y; //intervalul de copii
	char viz; //ca sa stim daca are raspuns :d
} poz[nmax],neg[nmax]; //pentru valorile pozitive si negative
char s[nmax]; //sirul cu valorile
int x[nmax]; //x[i]=s[1..i]
int n; //numarul de copii
int m; //numarul de intrebari

inline int modul(int x)
{
	if(x<0) return -x; return x;
}

void read()
{
	int i;
	scanf("%d %d\n",&n,&m);
	for(i=1;i<=n;i++)
		scanf("%c ",&s[i]);
}

void init()
{
	int i,j,k;
	
	//transformam sirul in valori
	for(i=1;i<=n;i++)
		s[i]-='0';
	
	//transformam tot pe s in felul urmator:
	//baiat: 1
	//fata: -1
	for(i=1;i<=n;i++)
		if(!s[i])
			--s[i];
	
	//consturim vectorul x
	for(i=1;i<=n;i++)
		x[i]=x[i-1]+s[i];
	
	//trebuie sa incercam sa construim
	//tablourile pentru raspunsuri
	for(i=1;i<=n;i++)
		for(j=i;j<=n;j++)
		{
			k=x[j]-x[i-1];
			if(k<0 && !neg[-k].viz) neg[-k].viz=1, neg[-k].x=i, neg[-k].y=j;
			else if(k>=0 && !poz[k].viz) poz[k].viz=1, poz[k].x=i, poz[k].y=j;
		}
}

void solve()
{
	int k;
	while(m--)
	{
		scanf("%d\n",&k);
		if(modul(k)>n) printf("-1\n");
		else if(k<0)
		{
			if(neg[-k].viz) printf("%d %d\n",neg[-k].x,neg[-k].y);
			else printf("-1\n");
		}
		else
		{
			if(poz[k].viz) printf("%d %d\n",poz[k].x,poz[k].y);
			else printf("-1\n");
		}
	}
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	
	read();
	init();
	solve();
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
