#include<stdio.h>
#define infile "stalpi.in"
#define outfile "stalpi.out"
#define nmax 53
#define dmax (13*1000)
int dp[nmax][dmax]; //dp[i][j]=efortul minim, pentru un d fixat, de a duce pe i la pozitia j
int d[nmax]; //distanta fiecarui stalp fata de primul stalp
int n; //numarul de stalpi
int e; //efortul maxim de care dispunem
int dmin; //distanta maxima minima

inline int modul(int x)
{
	if(x<0) return -x; return x;
}

inline int min(int a, int b)
{
	if(a<b) return a; return b;
}

void read()
{
	int i;
	scanf("%d %d\n",&n,&e);
	for(i=2;i<=n;i++)
		scanf("%d",&d[i]);
}

int verif(int dist)
{
	int deq[dmax],st,dr; //deque :x
	int i,j;
	
	//initializam dp-ul
	dp[1][0]=0;
	for(j=1;j<=d[n];j++) dp[1][j]=e+1;
	
	//construim restul dp-ului
	for(i=2;i<=n;i++)
	{
		//initializam deq-ul
		st=1,dr=0;
		//facem dinamica pentru acest stalp
		for(j=0;j<=d[n];j++)
		{
			while(st<=dr && dp[i-1][deq[dr]] >= dp[i-1][j]) dr--;
			deq[++dr]=j;
			while(j-deq[st]>dist) st++;
			dp[i][j]=dp[i-1][deq[st]]+modul(j-d[i]);
		}
	}
	
	if(dp[n][d[n]]<=e) return 1;
	return 0;
}

void solve()
{
	int st=0, dr=d[n], mij;
	while(st<=dr)
	{
		mij=(st+dr)>>1;
		if(verif(mij)) dmin=mij, dr=mij-1;
		else st=mij+1;
	}
}

void write()
{
	printf("%d\n",dmin);
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	
	read();
	solve();
	write();
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
