//Cosmin
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define MMAX 100010
#define INF 1000000010
#define LL long long

#define MP make_pair
#define ff first
#define ss second

int N, M;

int xx[MMAX], yy[MMAX];

vector <pair<int, int> > vec;
int poz[MMAX];

int aint[MMAX << 4];

void update(int x, int y, int q, int poz, int val)
{
	if (x == y) { aint[q] = val; return; }

	int mij = (x + y) >> 1;

	if (poz <= mij) update(x, mij, q << 1, poz, val);
	if (poz > mij) update(mij + 1, y, (q << 1) + 1, poz, val);

	aint[q] = max(aint[q << 1], aint[(q << 1) + 1]);
}

vector <pair<pair<int, int>, int> > inter;

void get_inter(int x, int y, int q, int a, int b)
{
	if (a <= x && y <= b) {
		inter.push_back(MP(MP(x, y), q));
		return;
	}

	int mij = (x + y) >> 1;

	if (a <= mij) get_inter(x, mij, q << 1, a, b);
	if (mij < b) get_inter(mij + 1, y, (q << 1) + 1, a, b);
}

int get_val(int x, int y, int q, int val)
{
	if (x == y) return vec[x].ss;

	int mij = (x + y) >> 1;

	if (aint[(q << 1) + 1] >= val) return get_val(mij + 1, y, (q << 1) + 1, val);
	return get_val(x, mij, q << 1, val);
}

int afla_tata(int x, int y, int val) // trebuie sa aflu valoarea cea mai din dreapta intervalului x-y care e >= val
{
	if (x > y) return 0;

	inter.clear();

	get_inter(1, M, 1, x, y);

	int n = inter.size();

	for (int i = n - 1; i >= 0; i--) {
		int x = inter[i].ff.ff;
		int y = inter[i].ff.ss;
		int q = inter[i].ss;

		if (aint[q] >= val) return get_val(x, y, q, val);
	}

	return 0;
}

int main()
{
	int i, x, y, px, mt, xt, yt;

	freopen("minuni.in", "r", stdin);
	freopen("minuni.out", "w", stdout);

	scanf("%d %d", &N, &M);

	vec.push_back(MP(-1, 0));

	xx[0] = 0; yy[0] = N + 1;
	for (i = 1; i <= M; i++) {
		scanf("%d %d", &xx[i], &yy[i]);

		vec.push_back(MP(xx[i], i));
	}

	sort(vec.begin(), vec.end());

	for (i = 1; i <= M; i++) poz[vec[i].ss] = i;

	for (i = 1; i <= M; i++) {
		x = xx[i], y = yy[i];
		px = poz[i];

		mt = afla_tata(1, px - 1, y);

		xt = xx[mt]; yt = yy[mt];

		LL nr = (LL) x * (yt - y) + (LL) (x - xt) * (N - y + 1) - (LL) (x - xt) * (yt - y);

		printf("%lld\n", nr);

		update(1, M, 1, px, y);
	}

	return 0;
}

