//e gresita
#include <iostream>
#define NMAX 100100
using namespace std;

bool mod[NMAX];
int to[NMAX],from[NMAX],sir[NMAX];
int N;

void citire()
{
    scanf("%d",&N);

    for(int i=1;i<=N;i++)
    {
        scanf("%d",&sir[i]);
        to[i]=sir[i];
        from[sir[i]]=i;
    }
}

int circuleaza[NMAX];

void make_neighbour(int x)
{
    memset(circuleaza,0,sizeof(circuleaza));
    int unde=x;
    int prev=unde;
    while(circuleaza[x]==0)
    {
        circuleaza[x]=1;
        prev=x;
        x=to[x];
    }
    to[prev]=unde;
    mod[prev]=true;
    from[unde]=prev;
}

int lungime(int x)
{
    int l=1;
    memset(circuleaza,0,sizeof(circuleaza));
    while(circuleaza[x]==0)
    {
        circuleaza[x]=1;
        x=to[x];
        l++;
    }
    return l;
}

int ind[NMAX],lung[NMAX],indd[NMAX];

struct cmp
{
    bool operator()(const int &a,const int &b)const
    {
        return lung[a]<lung[b];
    }
};

void make_circ()
{
    int nr=0;
    for(int i=1;i<=N;i++)
        if(from[i]==0)
        {
            ind[nr]=i;
            indd[nr]=nr+1;
            lung[nr++]=lungime(i);
        }
    sort(indd,indd+nr,cmp());
    for(int i=nr-1;i>=0;i--)
        make_neighbour(ind[indd[i]]);
}

void solve_circ()
{
    for(int i=1;i<=N;i++)
        from[to[i]]=i;

    memset(circuleaza,0,sizeof(circuleaza));
    int i=1,x,prev;
    while(i<=N)
    {
        x=i;
        while(circuleaza[x]==0)
        {
            circuleaza[x]=1;
            prev=x;
            x=to[x];
        }

        while(i<=N && circuleaza[i])
            i++;

        to[prev]=i;
        mod[prev]=true;
    }
    to[prev]=1;
}


void reconstituire()
{
    int x=1;
    while(to[x]!=1)
    {
        x=to[x];
        if(sir[x]!=to[x])
            printf("%d %d\n",x,to[x]);
    }
}

void numara()
{
    int nr=0;
    for(int i=1;i<=N;i++)
        if(mod[i])
            nr++;
    printf("%d\n",nr);
}

int main()
{
    freopen ("telefon.in","r",stdin);
    freopen ("telefon.out","w",stdout);
    citire();
    make_circ();
    solve_circ();
    numara();
    reconstituire();
    return 0;
}
