using namespace std;

#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>
#include <bitset>
#include <vector>
#include <cstdio>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <algorithm>

#define II inline
#define f first
#define s second
#define oo (1<<30)
#define pb push_back
#define mp make_pair
#define ll long long
#define CC(V) memset((V),0,sizeof((V)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);++(i) )
#define REP(i,b) for(int (i)=0;(i)<(b);++(i))
#define FORit(it,V) for(__typeof((V).begin()) it = ((V).begin());it != ((V).end());++it)

#define IN  "teroristi.in"
#define OUT "teroristi.out"
#define K_MAX (1<<20)
#define N_MAX (1<<10)
#define Sigma 256

typedef pair<int,int> pi;
typedef vector<int> VI;

const int Dst = 998;
const int Src = 999; 

int R,K,N,M,M1[Sigma],M2[N_MAX];
int F[N_MAX],T[N_MAX],Q[N_MAX],C[N_MAX][N_MAX];
char V[K_MAX];
int Sol[K_MAX];

vector<VI> A(N_MAX);
vector< pair<char,char> > M4(N_MAX),V2(K_MAX);
vector<char> M3(N_MAX);
vector< queue<int> > M5(N_MAX),M6(N_MAX);
bitset<(N_MAX)> viz,type;

II int code(char x,char y)
{
	return (x - 'a') * 27 + (y - 'a');
}

II void scan()
{
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);
	
	scanf("%d%d\n",&K,&M);
	fgets(V+1,1<<20,stdin);
	
	FOR(i,1,K)
	{
		if(M1[ (int)V[i] ] == 0)
		{
			M1[ (int)V[i] ] = ++N;
			M3[ N ] = V[i]; 
			type[N] = false;
		}
		M5[ M1[ (int)V[i] ] ].push(i);
		++F[ M1[ (int)V[i] ] ];
	}
	
	char x,y,buffer[9];
	FOR(i,1,M)
	{
		fgets(buffer,8,stdin);
		x = buffer[0];
		y = buffer[2];
		
		if(M2[ code(x,y) ] == 0)
		{
			M2[ code(x,y) ] = ++N;
			M4[N] = mp(x,y);
			type[N] = true;
		}
		V2[i] = mp(x,y);
		M6[ M2[ code(V2[i].f,V2[i].s) ] ].push(i);
		++F[ M2[ code(V2[i].f,V2[i].s) ] ];
	}
}

II void add_edge(int x,int y,int cap)
{
	//fprintf("edge %d->%d cap:%d\n",x,y,cap);
	
	A[x].pb(y);
	A[y].pb(x);
	C[x][y] = cap;
}

II bool BF()
{
	viz.reset();
	CC(T);
	Q[Q[0]=1] = Src;
	viz[Src] = true;
	
	FOR(i,1,Q[0])
	{
		int nod = Q[i];
		FORit(it,A[nod])
			if(!viz[*it] && C[nod][*it])
			{
				viz[*it] = true;
				Q[++Q[0]] = *it;
				T[*it] = nod;
			}
	}
	return viz[Dst];
}

II int max_flow()
{
	int flow = 0;
	for(;BF();)
	{
		FOR(i,1,N)
		{
			if(!C[i][Dst] || !viz[i])
				continue;
			
			int rem = C[i][Dst];
			for(int nod = i;T[nod];rem = min(rem,C[ T[nod] ][nod]),nod = T[nod]);
			
			if(!rem)
				continue;
			C[i][Dst] -= rem;
			C[Dst][i] += rem;
			
			for(int nod = i;T[nod];C[ T[nod] ][nod] -= rem,C[nod][ T[nod] ] += rem,nod = T[nod]);
			flow += rem;
		}
	}
	
	return flow;
}

II void solve()
{
	FOR(i,1,N)
		if(type[i] == false)
			add_edge(Src,i,F[i]);
		else
			add_edge(i,Dst,F[i]);
	
	FOR(i,1,N)
	{
		if(type[i] != false)
			continue;
		FOR(j,1,N)
		{
			if(type[j] != true)
				continue;
			pair<char,char> tip = M4[j];
			
			if(tip.f == M3[i] || tip.s == M3[i])
			{
				//printf("[%c,%c] cu %c \n",tip.f,tip.s,M3[j]);
				add_edge(i,j,1<<25);
			}
		}
	}
	
	int rez = max_flow();
	//printf("Flow = %d\n",rez);
	
	FOR(i,1,N)
	{
		if(type[i] != false)
			continue;
		FOR(j,1,N)
		{
			if(type[j] != true)
				continue;
			
			for(;C[j][i];--C[j][i])
			{
				Sol[ M5[i].front() ] = M6[j].front();
				M5[i].pop();
				M6[j].pop();
			
				pair<char,char> tip = M4[j];
				//printf("[%c,%c] cu %c \n",tip.f,tip.s,M3[i]);
			}
		}
	}
	
	FOR(i,1,K)
		printf("%d ",Sol[i]);
}

int main()
{
	scan();
	solve();
	
	return 0;
}
