#include <cstdio>
#include <cstdlib>
using namespace std;

// PARSARE

#define CHUNK 8192
char Pbuf[CHUNK];
int Pp = CHUNK-1;
inline int get()
{
	while (Pbuf[Pp] < '0' || Pbuf[Pp] > '9')
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	int x = 0;	


	while (Pbuf[Pp] >= '0' && Pbuf[Pp] <= '9')
	{
		x = x*10+Pbuf[Pp]-'0';
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	}
	return x;
}

// END PARSARE

int T, mod;

void CaseMic( int x1, int y1, int x2, int y2 )
{
	int a[1003][1003];
	a[0][0] = 0;
	for (int i = 1; i <= 1000; ++i)
		a[i][0] = (a[0][i] = i+a[i-1][0])%mod;
	for (int i = 1; i <= 1000; ++i)
		for (int j = 1; j <= 1000; ++j)
		{
			a[i][j] = (a[i][j-1] + a[i-1][j] - a[i-1][j-1] + i^j )%mod;
		}
	for (;T;--T)
	{
		printf("%d\n", (a[x2][y2]+a[x1][y2]-a[x1][y2]-a[x2][y1])%mod);
		if (T-1)
		{
			x1 = get();
			y1 = get();
			x2 = get();
			y2 = get();
		}
	}
	
}

void CaseL1L2( int x1, int y1, int x2, int y2 )
{
	for (;T;--T)
	{
		if (T-1)
		{
			x1 = get();
			y1 = get();
			x2 = get();
			y2 = get();
		}
	}

}

void CaseP( int x1, int y1, int x2, int y2 )
{
	for (;T;--T)
	{
		if ( ((x2-x1)%2) && ((y2-y1)%2) ) printf("0\n"); // daca laturile sunt pare
		else if ( ((x2-x1+1)%4) == 0 ) printf("0\n");
		else if ( ((y2-y1+1)%4) == 0 ) printf("0\n"); // daca una din laturi e divizibila cu 4
		else if ( ((x2-x1)%2) || ((y2-y1)%2) ) printf("1\n"); // una e div cu 2, cealalta nu
		else
		{
			int x = x2-x1;
			x>>=1;
			int y = y2-y1;
			y>>=1;
			x = (x+y)%2;
			printf("%d\n", ((x1^y1)+x)%2);
		}
		if (T-1)
		{
			x1 = get();
			y1 = get();
			x2 = get();
			y2 = get();
		}
	}
}

int main()
{
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);

	T = get();
	mod = get();
	int x1 = get();
	int y1 = get();
	int x2 = get();
	int y2 = get();
	
	if (p == 2) { CaseP(x1,y1,x2,y2); exit(EXIT_SUCCESS); }
	if (x2 <= 1000 && y2 <= 1000) { CaseMic(x1,y1,x2,y2); exit(EXIT_SUCCESS) };


	for (;T;--T)
	{
		int x1 = get();
		int y1 = get();
		int x2 = get();
		int y2 = get();
		int rez = 0;
		rez = getSum(x2,y2) + getSum(x1,y1) - getSum(x1,y2) - getSum(x2,y1);
		printf("%d\n", rez%mod);
	}

	return EXIT_SUCCESS;
}

