#include<cstdio>
#include<vector>
#define MAXN 100001

using namespace std;

int n,i,x,y,dst,cst,D,sol;
int dist[MAXN],dmax[MAXN],v[MAXN];
vector <int> g[MAXN], d[MAXN];

void dfs1(int nod)
{
	unsigned int i;
	int dmx = dist[nod], nnod;
	v[nod] = 1;
	for(i=0; i<g[nod].size(); i++)
	{
		nnod = g[nod][i];
		if(!v[nnod])
		{
			dist[nnod] = dist[nod] + d[nod][i];
			dfs1(nnod);
			if(dmax[nnod] > dmx)
				dmx = dmax[nnod];
		}
	}
	dmax[nod] = dmx;
}
	
void dfs2(int nod, int inc)
{
	unsigned int i;
	int nnod,x;
	v[nod] = 0;
	for(i=0; i<g[nod].size(); i++)
	{
		nnod = g[nod][i];
		if(v[nnod])
		{
			x = D - dmax[nnod] - inc;
			sol += x;
			dfs2(nnod, x+inc);
		}
	}
}

int main(void)
{
	freopen("arb.in","r",stdin);
	freopen("arb.out","w",stdout);
	scanf("%d",&n);
	for(i=1;i<n;i++)
	{
		scanf("%d%d%d%d",&x,&y,&dst,&cst);
		g[x].push_back(y);
		g[y].push_back(x);
		d[x].push_back(dst);
		d[y].push_back(dst);
	}
	dfs1(1);
	D = dmax[1];
	dfs2(1,0);
	printf("%d\n",sol);
	return 0;
}
	