#include<cstdio>
#include<algorithm>
#include<vector>
#define MAXN 2002
#define PEE 3.14159

using namespace std;

struct cuib{int x1,x2,y1,y2,mod;};

int n,i,j,sol;
cuib v[MAXN];
int cml[MAXN],viz[MAXN];
vector <int> g[MAXN];

int dist(int x1, int y1, int x2, int y2)
{
	return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
}

//dreptungiul 1 in dreptunghiul 2
int did(int lx1, int ly1, int rx1, int ry1, int lx2, int ly2, int rx2, int ry2)
{
	if(lx1 >= lx2 && ly1 >= ly2 && rx1 <= rx2 && ry1 <= ry2)
		return 1;
	return 0;
}

//cerc 1 in dreptunghi 2
int cid(int x, int y, int r, int lx, int ly, int rx, int ry)
{
	if ((x - r) >= lx && (x + r) <= rx && (y + r) <= ry && (y - r) >= ly)
		return 1;
	return 0;
}

//cerc 1 in cerc 2
int cic(int x2, int y2, int r2, int x1, int y1, int r1)
{
	int d = dist(x1, y1, x2, y2);
	if(r1<r2)
		return 0;
	if(d <= r1 * r1 + r2 * r2 - 2 * r1 * r2)
		return 1;
	return 0;
}

//dr 1 in cerc 2
int dic(int lx, int ly, int rx, int ry, int x, int y, int r)
{
	int d1 = dist(x, y, lx, ly),
		d2 = dist(x, y, lx, ry),
		d3 = dist(x, y, rx, ry),
		d4 = dist(x, y, rx, ly),
		rr = r*r;
	if(d1 <= rr && d2 <= rr && d3 <=rr && d4 <= rr)
		return 1;
	return 0;
}

void dfs(int x)
{
	unsigned int i;
	cml[x] = 1;
	viz[x] = 1;
	for(i = 0; i < g[x].size(); i++)
	{
		if(!viz[g[x][i]])
			dfs(g[x][i]);
		if(cml[g[x][i]] + 1 > cml[x])
			cml[x] = cml[g[x][i]] + 1;
	}
}
	

int main(void)
{
	freopen("cuiburi.in","r",stdin);
	freopen("cuiburi.out","w",stdout);
	scanf("%d",&n);
	for(i=1;i<=n;i++)
	{
		scanf("%d",&v[i].mod);
		if(v[i].mod)
		{
			scanf("%d%d%d",&v[i].x1,&v[i].y1,&v[i].y2);
			//v[i].arie = PEE * v[i].y2 * v[i].y2;
		}
		else
		{
			scanf("%d%d%d%d",&v[i].x1,&v[i].y1,&v[i].x2,&v[i].y2);
			//v[i].arie = (v[i].x2 - v[i].x1) * (v[i].y2 - v[i].y1);
		}
	}
	//sort(v+1,v+n+1,cmp);
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if(i!=j)
			{
				if(v[i].mod == 1 && v[j].mod == 1)
				{
					if(v[i].x1 == v[j].x1 && v[i].y1 == v[j].y1 && v[i].y2 == v[j].y2)
					{
						if(i < j)
							g[j].push_back(i);
					}
					else
						if(cic(v[i].x1, v[i].y1, v[i].y2, v[j].x1, v[j].y1, v[j].y2))
							g[j].push_back(i);
				}
				if(v[i].mod == 1 && v[j].mod == 0)
				{
					if(cid(v[i].x1, v[i].y1, v[i].y2, v[j].x1, v[j].y1, v[j].x2, v[j].y2))
						g[j].push_back(i);
				}
				if(v[i].mod == 0 && v[j].mod == 1)
				{
					if(dic(v[i].x1, v[i].y1, v[i].x2, v[i].y2, v[j].x1, v[j].y1, v[j].y2))
						g[j].push_back(i);
				}
				if(v[i].mod == 0 && v[j].mod == 0)
				{
					if(v[i].x1 == v[j].x1 && v[i].y1 == v[j].y1 && v[i].y2 == v[j].y2 && v[i].y1 == v[j].y1)
					{
						if(i < j)
							g[j].push_back(i);
					}
					else
						if(did(v[i].x1, v[i].y1, v[i].x2, v[i].y2, v[j].x1, v[j].y1, v[j].x2, v[j].y2))
							g[j].push_back(i);
				}
			}
	for(i=1;i<=n;i++)
	{
		memset(cml, 0, sizeof(cml));
		memset(viz, 0, sizeof(viz));
		dfs(i);
		if(cml[i] > sol)
			sol = cml[i];
	}
	printf("%d\n",sol);
	return 0;
}
