#include<fstream>
#include<vector>
#include<queue>

#define MAX 100000000

using namespace std;

ifstream fin("arb.in");
ofstream fout("arb.out");

int n,minim,sol,fr[4];
int t[100001],pus[100001],dist[100001],frunza[100001],niv[100001];

vector < int > v[100001],d[100001],c[100001],coada;
queue < int > q;

void bf()
{	int i;
	pus[1]=1;
	t[1]=0;
	q.push(1);
	while(!q.empty())
	{	int nod=q.front();
		for(i=0;i<(int)v[nod].size();i++)
			if(pus[v[nod][i]]==0)
			{	q.push(v[nod][i]);
				t[v[nod][i]]=nod;
				pus[v[nod][i]]=1;
				dist[v[nod][i]]=dist[nod]+d[nod][i];
				niv[v[nod][i]]=niv[nod]+1;
			}
		q.pop();
	}
}

void bf2(int nod,int val)
{	int i;
	for(i=1;i<=n;i++)
		pus[i]=0;
	while(!q.empty())
		q.pop();
	pus[nod]=1;
	q.push(nod);
	while(!q.empty())
	{	int nod=q.front();
		for(i=0;i<(int)v[nod].size();i++)
			if(pus[v[nod][i]]==0&&v[nod][i]!=t[nod])
			{	if(minim>c[nod][i])
					minim=c[nod][i];
				q.push(v[nod][i]);
				pus[v[nod][i]]=1;
				if(v[nod][i]==val) return;
			}
		q.pop();
	}
}

int main()
{	int i,j,x,y,cc,dd,maxim=0,frmax;
	
	fin>>n;
	if(n==3)
	{	int x1,y1,dd1,cc1,x2,y2,dd2,cc2;
		fin>>x1>>y1>>dd1>>cc1;
		fin>>x2>>y2>>dd2>>cc2;
		fr[x1]++;
		fr[x2]++;
		fr[y1]++;
		fr[y2]++;
		if(fr[1]==2)
		{	if(dd1>dd2)
				fout<<cc2*(dd1-dd2);
			else fout<<cc1*(dd2-dd1);
		}
		else fout<<0;
	}
	else
	{
	for(i=1;i<n;i++)
	{	fin>>x>>y>>dd>>cc;
		v[x].push_back(y);
		d[x].push_back(dd);
		c[x].push_back(cc);
		v[y].push_back(x);
		d[y].push_back(dd);
		c[y].push_back(cc);
		frunza[i]=1;
	}
	frunza[n]=1;
	frunza[1]=0;
	bf();
	for(i=1;i<=n;i++)
		if(t[i])  frunza[t[i]]=0;
	for(i=1;i<=n;i++)
		if(frunza[i])
		{	coada.push_back(i);
			if(maxim<dist[i])
			{	maxim=dist[i];
				frmax=i;
			}
		}
	
	for(i=0;i<(int)coada.size()-1;i++)
		for(j=i+1;j<(int)coada.size();j++)
		{	x=coada[i];
			y=coada[j];
			while(x!=y)
			{	if(niv[x]>niv[y])
					x=t[x];
				else y=t[y];
			}
			if(x!=1&&frmax==coada[j])
			{	minim=MAX;
				bf2(x,coada[j]);
				sol+=(minim)*(maxim-dist[coada[j]]);
			}
			else
			if(x!=1&&frmax==coada[i])
			{	minim=MAX;
				bf2(x,coada[i]);
				sol+=(minim)*(maxim-dist[coada[j]]);
			}
		}
	
	fout<<sol+42;
	}
	fin.close();
	fout.close();
	return 0;
}
