#include<fstream>
#include<vector>
#include<cmath>

using namespace std;

ifstream fin("cuiburi.in");
ofstream fout("cuiburi.out");

int n,maxim;
int pus[2001],niv[2001];

struct cuib
{	int t;
	int x,y,r;
	int lx,ly,rx,ry;
}a[2001];

vector <int> v[2001];

double dist(int x1,int x2,int y1,int y2)
{
	return sqrt((double)(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

void df(int nod,int nivel)
{	pus[nod]=1;
	niv[nod]=nivel;
	for(int i=0;i<(int)v[nod].size();i++)
		if(pus[v[nod][i]]==0)
			df(v[nod][i],nivel+1);
		else if(niv[v[nod][i]]<nivel+1)
				niv[v[nod][i]]=nivel+1;
}

void c_max()
{	int i;
	for(i=1;i<=n;i++)
	{	if(maxim<niv[i]) maxim=niv[i];
		niv[i]=0;
		pus[i]=0;
	}
}

int main()
{	int i,j;
	
	fin>>n;
	
	for(i=1;i<=n;i++)
	{	fin>>a[i].t;
		if(a[i].t==0)
			fin>>a[i].lx>>a[i].ly>>a[i].rx>>a[i].ry;
		else fin>>a[i].x>>a[i].y>>a[i].r;
	}
	
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if(i!=j)
			{	if(a[i].t==0&&a[j].t==0)
				{	if(a[i].lx<=a[j].lx&&a[j].lx<=a[i].rx && a[i].lx<=a[j].rx&&a[i].rx && a[i].ly<=a[j].ly&&a[j].ly<=a[i].ry && a[i].ly<=a[j].ry&&a[j].ry<=a[i].ry)
					{	v[i].push_back(j);
					
					}
				}
				else 
				if(a[i].t==1&&a[j].t==1)
				{	if(dist(a[i].x,a[j].x,a[i].y,a[j].y)+a[j].r<=a[i].r)
					{	v[i].push_back(j);
					
					}
				}
				else 
				if(a[i].t==0&&a[j].t==1)
				{
					if(a[i].lx<=a[j].x-a[j].r&&a[i].rx>=a[i].x+a[i].r&&a[i].ly<=a[j].y-a[j].r&&a[i].ry>=a[j].y+a[i].r)
					{	v[i].push_back(j);
					
					}
				}
				else 
				if(a[i].t==1&&a[j].t==0)
				{
					if(dist(a[i].x,a[j].lx,a[i].y,a[j].ly)<=a[i].r&&dist(a[i].x,a[j].rx,a[i].y,a[j].ry)<=a[i].r)
					{	v[i].push_back(j);
					
					}
				}
			}
	for(i=1;i<=n;i++)
	{	df(i,1);
		c_max();
	}
	fout<<maxim;
	fin.close();
	fout.close();
	return 0;
}
