#include<fstream>
#include<vector>

using namespace std;

const char iname[]="arb.in";
const char oname[]="arb.out";
const int maxn=100005;
const long long inf=(1LL<<62);

ifstream f(iname);
ofstream g(oname);

struct nod
{
    int x,d,c;
    nod(int _x,int _d,int _c):x(_x),d(_d),c(_c){}
};

vector<nod> E[maxn];

int i,j,n,dis[maxn],A[maxn],x,y,d,c;

long long rez,cost[maxn];

void build(int x)
{
    int maxd=0;
    for(vector<nod>::iterator it=E[x].begin();it!=E[x].end();++it)
        if(A[x]!=it->x)
            A[it->x]=x,build(it->x),maxd=max(maxd,dis[it->x]+it->d);
    if(maxd==0)
    {
        cost[x]=inf;
        return;
    }
    for(vector<nod>::iterator it=E[x].begin();it!=E[x].end();++it)
        if(A[x]!=it->x)
        {
            if(dis[it->x]+it->d!=maxd)
                rez+=(maxd-dis[it->x]-it->d)*min(cost[it->x],(long long)it->c);
            cost[x]+=min(cost[it->x],(long long)it->c);
        }
    dis[x]=maxd;
}

int main()
{
    f>>n;
    for(i=1;i<n;++i)
        f>>x>>y>>d>>c,E[x].push_back(nod(y,d,c)),E[y].push_back(nod(x,d,c));

    build(1);

    g<<rez<<"\n";

    f.close();
    g.close();

    return 0;
}
