#include<fstream>
#include<list>

using namespace std;

const char iname[]="cuiburi.in";
const char oname[]="cuiburi.out";
const int maxn=2005;

ifstream f(iname);
ofstream g(oname);

int dis(int x1,int y1,int x2,int y2)
{
    return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
}

struct fig
{
    int t,x1,y1,x2,y2;
    fig(int _t,int _x1,int _y1,int _r):t(_t),x1(_x1),y1(_y1),x2(_r){}
    fig(int _t,int _x1,int _y1,int _x2,int _y2):t(_t),x1(_x1),y1(_y1),x2(_x2),y2(_y2){}
    fig():t(0),x1(0),y1(0),x2(0),y2(0){}
    bool operator<=(fig& b)
    {
        if(t==1&&b.t==1)
            if(x2<=b.x2&&dis(x1,y1,b.x1,b.y1)<=(b.x2-x2)*(b.x2-x2))
                return true;
            else
                return false;
        if(t==1&&b.t==0)
            if(x1-x2>=b.x1&&x1+x2<=b.x2&&y1-x2>=b.y1&&y1+x2<=b.y2)
                return true;
            else
                return false;
        if(t==0&&b.t==0)
            if(x1>=b.x1&&y1>=b.y1&&x2<=b.x2&&y2<=b.y2)
                return true;
            else
                return false;
        if(dis(b.x1,b.y1,x1,y1)<=b.x2*b.x2&&dis(b.x1,b.y1,x2,y2)<=b.x2*b.x2&&dis(b.x1,b.y1,x1,y2)<=b.x2*b.x2&&dis(b.x1,b.y1,x2,y1)<=b.x2*b.x2)
            return true;
        return false;
    }
} a[maxn];

void read(fig &a)
{
    f>>a.t;
    if(a.t)
        f>>a.x1>>a.y1>>a.x2;
    else
        f>>a.x1>>a.y1>>a.x2>>a.y2;
}

list<int> E[maxn];

int n,grad[maxn],ans[maxn],maxt,i,j;

void go(int x)
{
    if(ans[x])
        return;
    ans[x]=grad[x];
    for(list<int>::iterator it=E[x].begin();it!=E[x].end();++it)
        go(*it),ans[x]=max(ans[x],ans[*it]+grad[x]);
}

int main()
{
    f>>n;
    for(i=1;i<=n;++i)
        read(a[i]),grad[i]=1;
    for(i=1;i<=n;++i)
        if(grad[i])
            for(j=i+1;j<=n;++j)
                if(a[i]<=a[j])
                    if(a[j]<=a[i])
                        ++grad[i],grad[j]=0;
                    else
                        E[j].push_back(i);
                else
                    if(a[j]<=a[i])
                        E[i].push_back(j);

    for(i=1;i<=n;++i)
        go(i),maxt=max(maxt,ans[i]);

    g<<maxt<<"\n";

    f.close();
    g.close();

    return 0;
}
