#include<fstream>
#include<list>

using namespace std;

const char iname[]="telefon.in";
const char oname[]="telefon.out";
const int maxn=100005;

ifstream f(iname);
ofstream g(oname);

int v[maxn],n,i,j,ans[maxn][2],A[maxn],k,height[maxn],r,been[maxn],vout[maxn],vin[maxn],teams[maxn],capat[maxn],has[maxn],start;

list<int> E[maxn],out,in;
list<int>::iterator x,y;

int anc(int x)
{
    int y=x,v;
    for(;x!=A[x];x=A[x]);
    v=x;
    x=y;
    for(;x!=v;)
    {
        y=A[x];
        A[x]=v;
        x=y;
    }
    return v;
}

void merge(int x,int y)
{
    if(height[x]<height[y])
        A[x]=y;
    else
        A[y]=x;
    if(height[x]==height[y])
        ++height[x];
}

void go(int i)
{
    been[i]=1;
    if(been[v[i]]==0)
        go(v[i]);
    if(E[v[i]].size()>1)
        out.push_back(i);
    if(E[i].size()==0)
        in.push_back(i);
    merge(anc(i),anc(v[i]));
}

void build(int i)
{
    if(capat[i])
        return;
    capat[i]=i;
    list<int>::iterator jt=E[i].begin();
    for(list<int>::iterator it=E[i].begin();it!=E[i].end();++it)
        if(v[*it]==i)
            build(*it);
    for(list<int>::iterator it=E[i].begin();it!=E[i].end();++it)
        if(v[*it]==i&&(capat[*it]!=start||*it==start))
        {
            if(capat[i]==i)
            {
                capat[i]=capat[*it];
                continue;
            }
            ans[++r][0]=*it;ans[r][1]=capat[i];v[*it]=capat[i];
            capat[i]=capat[*it];
        }
    for(list<int>::iterator it=E[i].begin();it!=E[i].end();++it)
        if(v[*it]==i&&capat[*it]==start&&capat[i]!=i&&*it!=capat[i])
            ans[++r][0]=*it,ans[r][1]=capat[i],v[*it]=capat[i],capat[i]=start;
       /* if(v[*it]==i)
        {
            ++jt;
            while(jt!=E[i].end()&&v[*jt]!=i&&capat[*jt]!=start)
                ++jt;
            if(jt!=E[i].end())
                ans[++r][0]=*jt,ans[r][1]=capat[*it],v[*jt]=capat[*it],capat[*it]=capat[*jt],capat[i]=capat[*it],++it,jt=it;
            else
            {
                --jt;
                if(*it!=*jt&&capat[*jt]==start&&(capat[i]!=start||i==start))
                    ans[++r][0]=*jt,ans[r][1]=capat[*it],v[*jt]=capat[*it],capat[*it]=capat[*jt];
                else
                    capat[i]=capat[*it],++it,jt=it;
            }
        }
        else
            ++it;*/
}

int main()
{
    f>>n;
    for(i=1;i<=n;++i)
        f>>v[i],E[v[i]].push_back(i),A[i]=i,height[i]=1;

    for(i=1;i<=n;++i)
        if(been[i]==0)
            go(i);

    for(i=1;i<=n;++i)
    {
        if(E[i].size()==0)
            vin[anc(i)]=i;
        if(E[v[i]].size()>1&&vin[anc(i)]!=i)
            vout[anc(i)]=i;
        if(vout[anc(i)]==0&&vin[anc(i)]==0)
            vout[anc(i)]=i,vin[anc(i)]=v[i];
        else
            if(vout[anc(i)]==0)
                vout[anc(i)]=i;
    }
    for(i=1;i<=n;++i)
        if(vin[i]&&vout[i])
            teams[++k]=i;
    if(k>1)
    {
        for(i=1;i<k;++i)
            ans[++r][0]=vout[teams[i]],ans[r][1]=vin[teams[i+1]],v[vout[teams[i]]]=vin[teams[i+1]],E[vin[teams[i+1]]].push_back(vout[teams[i]]);
        ans[++r][0]=vout[teams[k]];ans[r][1]=vin[teams[1]];v[vout[teams[k]]]=vin[teams[1]];E[vin[teams[1]]].push_back(vout[teams[k]]);
    }

    in.clear();
    for(i=1;i<=n;++i)
        start=i,build(i);

    g<<r<<"\n";
    for(i=1;i<=r;++i)
        g<<ans[i][0]<<" "<<ans[i][1]<<"\n";

    f.close();
    g.close();

    return 0;
}
