#include<cstdio>
#include<cstring>
#include<list>
#include<queue>

using namespace std;

const char iname[]="teroristi.in";
const char oname[]="teroristi.out";
const int maxn=1000005;
const int maxl=30;
const int inf=1<<30;

int n,i,j,m,F[maxl*maxl][maxl*maxl],C[maxl*maxl][maxl*maxl],need[maxl],have[maxl],S=0,D=26*27+1,minf,flow;

list<int> E[maxl*maxl],v,R[maxl*maxl],ANS[maxl];

char s[maxn],x,y,aux;

int A[maxl*maxl];

queue<int> Q;

int flux()
{
    memset(A,-1,sizeof(A));
    A[S]=S;
    Q.push(S);
    int x;
    while(!Q.empty())
    {
        x=Q.front();
        Q.pop();
        if(x==D)
            continue;
        for(list<int>::iterator it=E[x].begin();it!=E[x].end();++it)
            if(A[*it]==-1&&C[x][*it]-F[x][*it]>0)
                Q.push(*it),A[*it]=x;
    }
    return A[D]!=-1;
}


int main()
{
    freopen(iname,"r",stdin);
    freopen(oname,"w",stdout);
    scanf("%d%d\n",&n,&m);
    fgets(s,sizeof(s),stdin);
    for(i=0;i<n;++i)
        ++need[s[i]-'a'+1];
    for(i=1;i<=m;++i)
    {
        scanf("%c %c",&x,&y);
        scanf("\n");
        have[x-'a'+1],++have[y-'a'+1];
        x-='a'-1;
        y-='a'-1;
        if(x>y)
            aux=x,x=y,y=aux;
        if(C[x*26+y][x]==0)
            E[x*26+y].push_back(x),E[x].push_back(x*26+y);
        if(C[x*26+y][y]==0)
            E[x*26+y].push_back(y),E[y].push_back(x*26+y);
        C[x*26+y][x]=inf;
        C[x*26+y][y]=inf;
        if(C[0][x*26+y]==0)
            E[0].push_back(x*26+y),E[x*26+y].push_back(0);
        ++C[0][x*26+y];
        R[x*26+y].push_back(i);
    }
    for(i=1;i<=26;++i)
        if(need[i])
            E[i].push_back(D),C[i][D]=need[i],v.push_back(i);

    for(flow=0;flux();)
        for(list<int>::iterator it=v.begin();it!=v.end();++it)
        {
            A[D]=*it;
            if(A[*it]==-1)
                continue;
            minf=inf;
            for(i=D;i!=S;i=A[i])
                minf=min(minf,C[A[i]][i]-F[A[i]][i]);
            if(minf==0)
                continue;
            for(i=D;i!=S;i=A[i])
                F[A[i]][i]+=minf,F[i][A[i]]-=minf;
            flow+=minf;
        }

    for(i=27;i<D;++i)
        for(j=1;j<=26;++j)
            while(F[i][j]>0)
                ANS[j].push_back(R[i].back()),R[i].pop_back(),--F[i][j];

    for(i=0;i<n;++i)
        printf("%d ",ANS[s[i]-'a'+1].back()),ANS[s[i]-'a'+1].pop_back();

    printf("\n");

    fclose(stdin);
    fclose(stdout);

    return 0;
}
