#include <stdio.h>
#include <vector>
#include <string.h>
#define NMAX 1000005
#define LMAX 55
#define HMAX 2005
#define pb push_back
#define sigma 26
#define INF 2000000000
using namespace std;
int n,m,sol[LMAX];
char A[NMAX],line[LMAX],found;
int CA[HMAX][HMAX],F[HMAX][HMAX],dad[HMAX],Q[HMAX],flow,fmin;
inline int lit(char x)
{
	return x>='a' && x<='z';
}
char B[NMAX],C[NMAX],viz[HMAX];
vector <int> D[HMAX];
void read()
{
	scanf("%d%d\n",&n,&m);
	int i,j;
	fgets(A+1,NMAX,stdin);
	for (i=1; i<=m; i++)
	{
		fgets(line+1,LMAX,stdin);
		j=0;
		while (lit(line[j+1]))
		{
			j++;
			B[i]=line[j];
		}
		while (!lit(line[j+1]))
			j++;
		while (lit(line[j+1]))
		{
			j++;
			C[i]=line[j];
		}
	}
}
void back(int k)
{
	if (k==n+1)
	{
		found=1;
		return ;
	}
	if (found)
		return ;
	int i;
	for (i=1; i<=m; i++)
		if (!viz[i] && (B[i]==A[k] || C[i]==A[k]))
		{
			viz[i]=1;
			sol[k]=i;
			back(k+1);
			viz[i]=0;
			if (found)
				return ;
		}
}
void show()
{
	int i;
	for (i=1; i<=n; i++)
		printf("%d ",sol[i]);
	printf("\n");
}
void init()
{
	int i,j;
	for (i=1; i<=m; i++)
	{
		CA[0][i]=1;
		D[0].pb(i);
		D[i].pb(0);
	}
	for (i=1; i<=m; i++)
		for (j=1; j<=n; j++)
		{
			if (B[i]==A[j])
			{
				D[i].pb(m+j);
				D[m+j].pb(i);
				CA[i][m+j]=1;
			}
			if (C[i]==A[j])
			{
				D[i].pb(m+j);
				D[m+j].pb(i);
				CA[i][m+j]=1;
			}
		}
	for (i=1; i<=n; i++)
	{
		CA[m+i][m+n+1]=1;
		D[m+i].pb(m+n+1);
		D[m+n+1].pb(m+i);
	}
}
inline int min(int x,int y)
{
	return x<y ? x : y;
}
int BF()
{
	memset(viz,0,sizeof(viz));
	Q[0]=0;
	Q[++Q[0]]=0;
	int i,j,nod,act;
	for (i=1; i<=Q[0]; i++)
	{
		nod=Q[i];
		for (j=0; j<D[nod].size(); j++)
		{
			act=D[nod][j];
			if (CA[nod][act]==F[nod][act] || viz[act])
				continue ;
			Q[++Q[0]]=act;
			dad[act]=nod;
			viz[nod]=1; 
			if (act==n+m+1)
				return 1;
		}
	}
	return 0;
}
void solve()
{
	int nod;
	while (BF())
	{
		nod=m+n+1;
		fmin=INF;
		for ( ; nod!=0; nod=dad[nod])
			fmin=min(fmin,CA[dad[nod]][nod]-F[dad[nod]][nod]);
		nod=m+n+1;
		for ( ; nod!=0; nod=dad[nod])
		{
			F[dad[nod]][nod]+=fmin;
			F[nod][dad[nod]]-=fmin;
		}
	}
}
void show2()
{
	int i,j;
	for (i=1; i<=n; i++)
		for (j=1; j<=m; j++)
			if (F[j][m+i])
			{
				printf("%d ",j);
				break ;
			}
	printf("\n");
}
int main()
{
	freopen("teroristi.in","r",stdin);
	freopen("teroristi.out","w",stdout);
	read();
	if (n<=15 && m<=15)
	{
		back(1);
		show();
		return 0;
	}
	if (n<=1000 && m<=1000)
	{
		init();
		solve();
		show2();
		return 0;
	}
	return 0;
}
