#include <stdio.h>
#include <vector>
#define FOR(i,a,b) for(i=a;i<=b;++i)
#define MAXN 100010
#define INF 0xffffff

using namespace std;

long long n,i,x,y,a,b;
long long cost[MAXN],tt[MAXN],dist[MAXN];
long long d[MAXN],cmin[MAXN];
long long res;
vector<long long> v[MAXN];

inline long long min(long long a,long long b)
{
    if (a < b) return a;
    return b;
}

void init(long long nod)
{
    vector<long long>::iterator it;
    for (it = v[nod].begin();it!=v[nod].end();++it)
        init(*it);
    if (v[nod].empty())
    {
        cmin[nod] = INF;
    }
}

void df(long long nod)
{
     long long max=0,sum=0;
     vector<long long>::iterator it;

     for (it = v[nod].begin();it!=v[nod].end();++it)
     {
         df(*it);
         if (dist[*it]+d[*it] > max) max = dist[*it]+d[*it];
     }

     for (it = v[nod].begin();it!=v[nod].end();++it)
     {
         res+=(max-d[*it]-dist[*it])*min(cost[*it],cmin[*it]);
         sum+=min(cost[*it],cmin[*it]);
     }
     if (!v[nod].empty()) cmin[nod] = sum;
     d[nod] = max;
}

int main()
{
    freopen("arb.in","r",stdin);
    freopen("arb.out","w",stdout);

    scanf("%d\n",&n);
    FOR (i,1,n-1)
    {
        scanf("%lld %lld %lld %lld\n",&x,&y,&a,&b);

        dist[y] = a;
        cost[y] = b;
        tt[y] = x;
        v[x].push_back(y);
    }

    init(1);
    df(1);

    /*FOR (i,1,n) printf("%d ",cmin[i]);
    printf("\n");
    FOR (i,1,n) printf("%d ",d[i]);
    printf("\n");*/

    printf("%lld\n",res);

    return 0;
}
