#include<stdio.h>

const int N=501,T=52;

int n,t,q,p[T][N][N],pmax[T][N][N];

inline int max( int a,int b )
{
	return (a>b ? a:b);
}

inline int mod( int x )
{
	return ( x<0 ? -x:x );
}

inline int dist(int a,int b,int c,int d)
{
	return (mod(c-a)+mod(d-b));
}

void calc_pmax( int x,int y,int z )
{
	for( int i=0 ; i<n ; ++i )
		for( int j=0 ; j<n ; ++j )
			pmax[z][i][j]= max( pmax[z][i][j] , p[z][x][y] - dist(x,y,i,j) );
}

void read()
{
	scanf("%d%d%d",&n,&t,&q);
	for( int i=0 ; i<n ; ++i )
		for( int j=0 ; j<n ; ++j )
		{
			scanf("%d",&p[1][i][j] );
			calc_pmax(i,j,1);
		}
}

void afis(int z)
{
	printf("Ziua %d\n",z);
	for( int i=0 ; i<n ; ++i,printf("\n") )
		for( int j=0 ; j<n ; ++j )
			printf("%d ",p[z][i][j]);
	printf("\n\n\n");
	for( int i=0 ; i<n ; ++i,printf("\n") )
		for( int j=0 ; j<n ; ++j )
			printf("%d ",pmax[z][i][j]);
	printf("\n\n\n");
}

void solve()
{
	for( int z=2 ; z<=t+1 ; ++z )
	{
		for( int i=0 ; i<n ; ++i )
			for( int j=0 ; j<n ; ++j )
			{
				p[z][i][j]= z + ( p[z-1][i][j] + (z-1)*pmax[z-1][i][j] )%q;
				calc_pmax(i,j,z);
			}
	}
	int rez=0;
	
	for( int i=0 ; i<n ; ++i )
		for( int j=0 ; j<n ; ++j )
			rez= ( rez + p[t+1][i][j] ) % q;

	printf("%d\n",rez);
}

int main()
{
	freopen("v2d.in","r",stdin);
	freopen("v2d.out","w",stdout);
	read();
	solve();
	return 0;
}
