#include<fstream>
#define dmax 2010
#define maxarie 1000000000
#define pi 3.14159265358979

using namespace std;

int t[dmax],x1d[dmax],x2d[dmax],y1d[dmax],y2d[dmax],x1c[dmax],y1c[dmax],rc[dmax];
int v[dmax],viz[dmax],multipl[dmax];
int nr,nrmax=1;

int dist(int x1,int y1, int x2, int y2)
{
 return ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

int includdrept(int a, int b)
{
 if (x1d[a]>=x1d[b] && x1d[a]<=x2d[b] && x2d[a]>=x1d[b] && x2d[a]<=x2d[b] && y1d[a]>=y1d[b] && y1d[a]<=y2d[b]  && y2d[a]>=y1d[b] && y2d[a]<=y2d[b])
	 return 1;
 return 0;
}

int includcerc(int a, int b)
{
 if (dist(x1c[a],y1c[a],x1c[b],y1c[b]) <= (rc[b]-rc[a])*(rc[b]-rc[a]) && rc[b]>=rc[a])
	 return 1;
 return 0;
}

int includdsic(int a, int b)
{
 if (t[a]==0 && t[b]==0)
	 return includdrept(a,b); else
	 if (t[a]==1 && t[b]==1)
		 return includcerc(a,b); else
		 if (t[a]==1 && t[b]==0)
			 if (x1c[a]+rc[a] <= x2d[b] && x1c[a]-rc[a] >= x1d[b] && y1c[a]+rc[a] <= y2d[b] && y1c[a]-rc[a] >= y1d[b])
				 return 1; else
				 return 0; else
			 if (t[a]==0 && t[b]==1)
				 if (x1d[a]<=x1c[b]+rc[b] && x1d[a]>=x1c[b]-rc[b] && x2d[a]<=x1c[b]+rc[b] && x2d[a]>=x1c[b]-rc[b] && y1d[a]<=y1c[b]+rc[b] && y1d[a]>=y1c[b]-rc[b] && y2d[a]<=y1c[b]+rc[b] && y2d[a]>=y1c[b]-rc[b])
					 return 1; else
					 return 0;
 return 0;
}

int aried(int a)
{
 return ((x2d[a]-x1d[a])*(y2d[a]-y1d[a]));
}

int ariec(int a)
{
 return rc[a];
}

double ariedsic(int a)
{
 if (t[a]==0)
	 return aried(a); else
	 return 2*pi*rc[a]*rc[a];
}

void calculare(int k) 
{ 
 viz[k]=1;
 nr++;
 if (multipl[k]!=0)
	 nr=nr+multipl[k];
 
 if (v[k]!=0)
	 calculare(v[k]);
}

int main()
{
 int n,i,j,dr=0,ce=0,min,drcaut,cecaut,csidcaut;
 double mindc;	
 
 ifstream fin("cuiburi.in");
 ofstream fout("cuiburi.out");
 fin>>n;
 ce=dr=0;
 for (i=1; i<=n; i++)
	 {
	  fin>>t[i];
	  if (t[i]==0)
		  {
		   dr++;
		   fin>>x1d[i]>>y1d[i]>>x2d[i]>>y2d[i];
		  } else
		  {
		   ce++;
		   fin>>x1c[i]>>y1c[i]>>rc[i];
		  }
	 }
 
 if (dr==n) /*numai dreptunghiuri*/
	 {
	  for (i=1; i<=n; i++)
		 if (viz[i]==0)
		  {
		   min=maxarie; drcaut=0;
		   for (j=1; j<=n; j++)
			  if (i!=j && includdrept(i,j)==1 && aried(j)<min && aried(j)!=aried(i))
				  {
				   drcaut=j;
				   min=aried(j);
				  }	else
				  if (i!=j && includdrept(i,j)==1 && aried(j)<min && aried(j)==aried(i))
					  {
					   viz[j]=1;
					   multipl[i]++;
					  }
		   viz[i]=1;
		   if (drcaut!=0)
			   v[i]=drcaut;
		  }
	  
	  memset(viz,0,sizeof(v));
	  
	  for (i=1; i<=n; i++)
		  if (viz[i]==0 && v[i]!=0)
			  {
			   nr=0;
			   calculare(i);
			   
			   if (nr>nrmax)
				   nrmax=nr;
			  }
	  fout<<nrmax;
	 } else
		 
	 if (ce==n) /*numai cercuri*/
		 {
		  for (i=1; i<=n; i++)
			 if (viz[i]==0)
			  {
			   min=maxarie; cecaut=0;
			   for (j=1; j<=n; j++)
				   if (i!=j && includcerc(i,j)==1 && ariec(j)<min && ariec(j)!=ariec(i))
					   {
					    cecaut=j;
					    min=ariec(j);
					   } else
				   if (i!=j && includcerc(i,j)==1 && ariec(j)<min && ariec(j)==ariec(i))
					   {
					    viz[j]=1;
					    multipl[i]++;
					   }
			   viz[i]=1;
			   if (cecaut!=0)
				   v[i]=cecaut;
			  }
			 
		  memset(viz,0,sizeof(v));
	     
		  for (i=1; i<=n; i++)
			  if (viz[i]==0 && v[i]!=0)
				  {
				   nr=0;
				   calculare(i);
			     
				   if (nr>nrmax)
					   nrmax=nr;
				  }
		  fout<<nrmax;
		  
	     } else /*si dreptunghiuri si cercuri*/
		 {
		  for (i=1; i<=n; i++)
			 if (viz[i]==0)
			  {
			   mindc=maxarie; csidcaut=0;
			   for (j=1; j<=n; j++)
				   if (i!=j && includdsic(i,j)==1 && ariedsic(i)!=ariedsic(j))
					   {
						csidcaut=j;
						mindc=ariedsic(j);
					   } else
				    if (i!=j && includdsic(i,j)==1 && ariedsic(i)==ariedsic(j))
						{
					     viz[j]=1;
						 multipl[i]++;
						}	
			   viz[i]=1;
			   if (csidcaut!=0)
				   v[i]=csidcaut;
			  }
			 
		  memset(viz,0,sizeof(v));
	     
		  for (i=1; i<=n; i++)
			  if (viz[i]==0 && v[i]!=0)
				  {
				   nr=0;
				   calculare(i);
			     
				   if (nr>nrmax)
					   nrmax=nr;
				  }
		  fout<<nrmax;
		 }
	
 fin.close();
 fout.close();
 
 return 0;
}
