#include <cstdio>
#include <vector>
#define MAXN 100010
using namespace std;
int N;
struct ceva{
	int nod,cost,dist;
};
vector<ceva> G[MAXN];
long long R[MAXN],D[MAXN];
int Dmax[MAXN];
long long MARE;

void get_D(int nod,int dad){

	long long cmin=0;

	int ok=0;

	for (vector<ceva>::iterator it=G[nod].begin();it!=G[nod].end();++it){
		ceva Pr=*it;
		if (Pr.nod!=dad){
			get_D(Pr.nod,nod);
			ok=1;
			long long part=D[Pr.nod];
			if (Pr.cost<part) part=Pr.cost;
			cmin+=part;
		}
	}

	if (ok) D[nod]=cmin; else D[nod]=MARE;

}


void get_R(int nod,int dad){

	long long cmin=0;

	int  maxdist=0;

	for (vector<ceva>::iterator it=G[nod].begin();it!=G[nod].end();++it)
	
	if (it->nod!=dad){
		ceva Pr=*it;
		get_R(Pr.nod,nod);
		if ((Dmax[Pr.nod]+Pr.dist)>maxdist) maxdist=(Dmax[Pr.nod]+Pr.dist);
	}

	Dmax[nod]=maxdist;

	for (vector<ceva>::iterator it=G[nod].begin();it!=G[nod].end();++it)
	if (it->nod!=dad){
		ceva Pr=*it;
		long long cost=R[Pr.nod];

		int cur_dist=Dmax[Pr.nod]+Pr.dist;

		int diff=maxdist-cur_dist;

		long long  minimc=Pr.cost;
		if (D[Pr.nod]<minimc) minimc=D[Pr.nod];

		cost+=minimc*(long long)diff;
		cmin+=cost;
	}

	R[nod]=cmin;
}



int main(){


	MARE=10000000*10000000;

	freopen("arb.in","r",stdin);
	freopen("arb.out","w",stdout);


	scanf("%d",&N);

	for (int i=1;i<N;++i){
		int x,y,c,d;
		scanf("%d%d%d%d",&x,&y,&d,&c);

		ceva Pr;
		Pr.nod=y;
		Pr.cost=c;
		Pr.dist=d;

		G[x].push_back(Pr);
		Pr.nod=x;
		G[y].push_back(Pr);
	}

	fclose(stdin);

	get_D(1,0);
	get_R(1,0);


	printf("%lld\n",R[1]);

	fclose(stdout);

	return 0;
}
