#include <cstdio>
#include <vector>
#include <list>
#include <cstring>
#define MAXN 100010
using namespace std;
int N,vecin[MAXN],vecin2[MAXN],change[MAXN],Gin[MAXN];
vector<int> G[MAXN];
vector<int> exces;
struct cycle{
	int nod1,nod2;
};
vector<cycle> VC;
vector<int> Gfr[MAXN];
int VF, stiva[MAXN];
int rmk[MAXN],retmk[MAXN];


char viz[MAXN];


int make_cycle(int nod){

	viz[nod]=1;
	
	int rezultat=nod;

	while (viz[vecin[nod]]==0){
		nod=vecin[nod];
		viz[nod]=1;
		if (change[nod]>0) rezultat=nod;
	}

	return rezultat;
}	


void DFS(int nod){

	viz[nod]=1;

	for (vector<int>::iterator it=Gfr[nod].begin();it!=Gfr[nod].end();++it)
		if (viz[*it]==0) DFS(*it);

	++VF;
	stiva[VF]=nod;
}

int main(){

	freopen("telefon.in","r",stdin);
	freopen("telefon.out","w",stdout);

	scanf("%d",&N);

	for (int i=1;i<=N;++i){
		scanf("%d",&vecin[i]);
		Gfr[i].push_back(vecin[i]);
	}

	memset(viz,0,sizeof(viz));
	VF=0;
	for (int i=1;i<=N;++i) if (viz[i]==0) DFS(i);

	for (int i=1;i<=N;++i){
		rmk[stiva[i]]=N-i+1;
		retmk[N-i+1]=stiva[i];
	}


	memset(Gin,0,sizeof(Gin));

	for (int i=1;i<=N;++i){
		vecin2[rmk[i]]=rmk[vecin[i]];
	}

	for (int i=1;i<=N;++i){
		vecin[i]=vecin2[i];
		++Gin[vecin[i]];
		G[vecin[i]].push_back(i);
	}

	fclose(stdin);

	for (int i=1;i<=N;++i)
		if (Gin[i]>1) exces.push_back(i);

	memset(change,0,sizeof(change));


	int index=0;
	for (int i=1;i<=N;++i) 
		if (Gin[i]==0){
			if (Gin[exces[index]]==1) ++index;
			int nod=exces[index]; 
			
			unsigned int indice=G[nod].size()-1;
			while (G[nod][indice]==i) --indice;

			vecin[G[nod][indice]]=i;

			change[G[nod][indice]]=i;

			++Gin[i];
			--Gin[nod];

			if (indice==(G[nod].size()-1)) G[nod].pop_back(); else {
				G[nod][indice]=G[nod][indice+1];
				G[nod].pop_back();
			}
		}

	memset(viz,0,sizeof(viz));

	for (int i=1;i<=N;++i)if (viz[i]==0){
		cycle aux;
		aux.nod1=make_cycle(i);
		aux.nod2=vecin[aux.nod1];
		VC.push_back(aux);
	}

	unsigned int nc=VC.size();

	if (nc>1){

		for (unsigned int i=0;i<(nc-1);++i) 
			change[VC[i].nod1]=VC[i+1].nod2;

		change[VC[nc-1].nod1]=VC[0].nod2;
	}

	int nrchanges=0;

	for (int i=1;i<=N;++i) if (change[i]>0) ++nrchanges;

	printf("%d\n",nrchanges);

	for (int i=1;i<=N;++i) if (change[i]>0) printf("%d %d\n",retmk[i],retmk[change[i]]);

	fclose(stdout);

	return 0;
}
