#include <cstdio>
#include <algorithm>
#define MAXN 510
using namespace std;
int P[MAXN][MAXN],Pmax[MAXN][MAXN];
int T,Q,N;
pair<int,int> V[MAXN*MAXN];



int dist(int A,int B){
	int Ax=A/N;
	int Ay=A%N;
	int Bx=B/N;
	int By=B%N;
	int dif1=Ax-Bx;
	if (dif1<0) dif1=-dif1;
	int dif2=Ay-By;
	if (dif2<0) dif2=-dif2;

	int rez=dif1+dif2;
	return rez;
}



void generate_new(int DAY){


	int LV=0;
	
	for (int i=0;i<N;++i)
		for (int j=0;j<N;++j){
			++LV;
			V[LV]=make_pair(P[i][j],i*N+j);
		}

	sort(V+1,V+LV+1);

	for (int i=1;i<=LV;++i){

		int cass=-1000000000;
		int indice=LV;

		while (indice>=1 && V[indice].first>cass)if (indice!=i){
			int distanta=dist(V[indice].second,V[i].second);
			if ((V[indice].first-distanta)> cass)
				cass=V[indice].first-distanta;
			--indice;
		} else --indice;

		int cx=V[i].second/N;
		int cy=V[i].second%N;

		Pmax[cx][cy]=cass;
	}

	for (int i=0;i<N;++i)
		for (int j=0;j<N;++j){
			int corp=P[i][j]+DAY*Pmax[i][j];
			corp%=Q;
			if (corp<0) corp+=Q;
			P[i][j]=DAY+1+corp;
		}

}

int main(){

	freopen("v2d.in","r",stdin);
	freopen("v2d.out","w",stdout);

	scanf("%d%d%d",&N,&T,&Q);

	for (int i=0;i<N;++i)
		for (int j=0;j<N;++j)
			scanf("%d",&P[i][j]);

	fclose(stdin);

	for (int i=1;i<=T;++i) generate_new(i);


	int rez=0;
	for (int i=0;i<N;++i)
		for (int j=0;j<N;++j){
			rez+=P[i][j];
			rez%=Q;
		}


	printf("%d\n",rez);

	fclose(stdout);

	return 0;
}
	
