#include <iostream>
#include <math.h>
using namespace std;
#define INF -999999999

int N, cml[2005];

struct Cuib {
	int st;
	int x, y, r;
	int lx, ly, rx, ry;
} C[2005];

int CercCerc(int p, int q) {
	//incerc sa-l cuibaresc pe p in q
	if(C[p].x == C[q].x && C[p].y == C[q].y && C[p].r == C[q].r) {
		return 1;
	}
	double dist;
	dist=(C[p].x - C[q].x)*(C[p].x - C[q].x) + (C[p].y - C[q].y)*(C[p].y - C[q].y);
	dist=(double)sqrt(dist);
	if(dist + (double)C[p].r > (double)C[q].r) {
		return 0;
	}
	return 1;
}

int DreptDrept(int p, int q) {
	//incerc sa-l cuibaresc pe p in q
	if(C[p].lx>=C[q].lx && C[p].ly>=C[q].ly && C[p].rx<=C[q].rx && C[p].ry<=C[q].ry) {
		return 1;
	}
	return 0;
}

int CercDrept(int p, int q) {
	//incerc sa-l cuibaresc pe p in q
	if(C[p].x-C[p].r>=C[q].lx && C[p].x+C[p].r<=C[q].rx && C[p].y+C[p].r<=C[q].ry && C[p].y-C[p].r>=C[q].lx) {
		return 1;
	}
	return 0;
}

int DreptCerc(int p, int q) {
	//incerc sa-l cuibaresc pe p in q
	double dist;
	dist=(C[p].lx - C[q].x)*(C[p].lx - C[q].x) + (C[p].ly - C[q].y)*(C[p].ly - C[q].y);
	dist=(double)sqrt(dist);
	if(dist>C[q].r) { return 0; }
	
	dist=(C[p].rx - C[q].x)*(C[p].rx - C[q].x) + (C[p].ry - C[q].y)*(C[p].ry - C[q].y);
	dist=(double)sqrt(dist);
	if(dist>C[q].r) { return 0; }
	
	dist=(C[p].lx - C[q].x)*(C[p].lx - C[q].x) + (C[p].ry - C[q].y)*(C[p].ry - C[q].y);
	dist=(double)sqrt(dist);
	if(dist>C[q].r) { return 0; }
	
	dist=(C[p].rx - C[q].x)*(C[p].rx - C[q].x) + (C[p].ly - C[q].y)*(C[p].ly - C[q].y);
	dist=(double)sqrt(dist);
	if(dist>C[q].r) { return 0; }
	
	return 1;
}

int main() {
	FILE *f1=fopen("cuiburi.in", "r"), *f2=fopen("cuiburi.out", "w");
	int t, i, j, p, q;
	fscanf(f1, "%d\n", &N);
	for(i=1; i<=N; i++) {
		fscanf(f1, "%d", &t);
		if(t==0) {
			C[i].st=0; C[i].x=C[i].y=C[i].r=INF;
			fscanf(f1, "%d %d %d %d\n", &C[i].lx, &C[i].ly, &C[i].rx, &C[i].ry);
		}
		else {
			C[i].st=1; C[i].lx=C[i].ly=C[i].rx=C[i].ry=INF;
			fscanf(f1, "%d %d %d\n", &C[i].x, &C[i].y, &C[i].r);
		}
	}
	//bubble sort
	for(i=1; i<=N; i++) {
		for(j=1; j<=N; j++) {
			if(i!=j) {
				if(C[i].st==0 && C[j].st==0 && C[i].lx>C[j].lx) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==1 && C[j].st==1 && C[i].x>C[j].x) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==1 && C[j].st==0 && C[i].x>C[j].lx) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==0 && C[j].st==1 && C[i].lx>C[j].x) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==0 && C[j].st==0 && C[i].lx==C[j].lx && C[i].rx<C[j].rx) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==1 && C[j].st==1 && C[i].x==C[j].x && C[i].r<C[j].r) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==1 && C[j].st==0 && C[i].x==C[j].lx && C[j].rx>C[i].x + C[i].r) {
					swap(C[i], C[j]);
				}
				else if(C[i].st==0 && C[j].st==1 && C[i].lx==C[j].x && C[i].rx<C[j].x + C[j].r) {
					swap(C[i], C[j]);
				}
				
			}
		}
	}
	
	/**
	for(i=1; i<=N; i++) {
		cout<<C[i].st<<" ";
		if(C[i].st==0) {
			cout<<C[i].lx<<" "<<C[i].ly<<" "<<C[i].rx<<" "<<C[i].ry<<endl;
		}
		else {
			cout<<C[i].x<<" "<<C[i].y<<" "<<C[i].r<<endl;
		}
	}
	cout<<endl;
	**/
	
	cml[1]=1;
	for(i=2; i<=N; i++) {
		int pmax=0;
		for(j=1; j<=i-1; j++) {
			//incerc sa-l cuibaresc pe j in i
			if(C[j].st==0 && C[i].st==0) {
				p=DreptDrept(j, i);
			}
			else if(C[j].st==1 && C[i].st==1) {
				p=CercCerc(j, i);
			}
			else if(C[j].st==0 && C[i].st==1) {
				p=DreptCerc(j, i);
			}
			else if(C[j].st==1 && C[i].st==0) {
				p=CercDrept(j, i);
			}
			if(p) {
				pmax=max(pmax, cml[j]);
			}
		}
		cml[i]=pmax + 1;
	}
	fprintf(f2, "%d\n", cml[N]);
	fclose(f1); fclose(f2);
	return 0;
}
			
		
		