#include <iostream>
using namespace std;

int T, P, sol, A[1005][1005];
int l1, l2, c1, c2;

void generate() {
	int i, j, p;
	for(i=1; i<=1001; i++) {
		for(j=1; j<=1001; j++) {
			p=(i^j);
			A[i][j]=( A[i-1][j] + A[i][j-1] - A[i-1][j-1] + p)%P;
		}
	}
}

void brute() {
	int i, j;
	for(i=l1; i<=l2; i++) {
		for(j=c1; j<=c2; j++) {
			sol+=(i^j);
			sol=sol%P;
		}
	}
}

int main() {
	FILE *f1=fopen("xor.in", "r"), *f2=fopen("xor.out", "w");
	int i, j;
	fscanf(f1, "%d %d\n", &T, &P);
	generate();
	for(i=1; i<=T; i++) {
		sol=0;
		fscanf(f1, "%d %d %d %d\n", &l1, &c1, &l2, &c2);
		if(l2<=1000 & c2<=1000) {
			sol=0;
			sol=(A[l2][c2] - A[l2][c1-1] - A[l1-1][c2])%P;
            fprintf(f2, "%d\n", sol);
		}
		else {
			sol=0;
			brute();
			fprintf(f2, "%d\n", sol%P);
		}
	}
	fclose(f1); fclose(f2);
	return 0;
}