#include <fstream>
#include <algorithm>
#define IN "arb.in"
#define OUT "arb.out"
#define L 100005

using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

struct nod
{
    int y, d, c;
    nod *next;
}*V[L];

int *H, *Num, *Co;
int viz[L];
int Euler[L*4];
int F_ap[L*4];
int L_ap[L*4];
int n, x, y, d, c;
int Hmax[L];
int Rez;
int Final, Lol, nr;
int Inf, Poz, cate, OK;

int stg, dre;

void add(nod *&a,int i,int j,int k)
{
    nod *q=new nod;
    q->y=i;
    q->d=j;
    q->c=k;
    q->next=a;
    a=q;
}

void citire()
{
    fin>>n;
    for (int i=1;i<n;i++)
    {
        fin>>x>>y>>d>>c;
        add(V[x], y, d, c);
        add(V[y], x, d, c);
        Rez+=c;
    }
}

void df(int p)
{
    int D=0;
    viz[p]=1;
    for (nod *i=V[p]; i; i=i->next)
        if (!viz[i->y])
        {
            Hmax[i->y]=Hmax[p] + i->d;
            df(i->y);
            D=max(D, Hmax[i->y]);
        }
    Hmax[p]=max(D, Hmax[p]);
}

void df2(int p)
{
    int c=0;
    viz[p]=0;
    if (Hmax[p]<Lol)
    {
        c=Lol-Hmax[p];
        Final+=Lol-Hmax[p];
    }
    for (nod *i=V[p];i;i=i->next)
        if (viz[i->y])
        {
            Hmax[i->y]+=c;
            df2(i->y);
        }
}

void E(int p)
{
    viz[p]=1;
    for (nod *i=V[p];i;i=i->next)
        if (!viz[i->y])
        {
            Euler[nr++]=p;
            Euler[nr++]=i->y;
            if (!F_ap[i->y])
            {
                F_ap[i->y]=nr-1;
                L_ap[i->y]=nr-1;
            }
            E(i->y);
            L_ap[p]=nr-2;
        }
}

void update(int nod ,int st,int dr)
{
    if (st==dr)
    {
        H[nod]=Inf;
        Num[nod]=OK;
        Co[nod]=cate;
        return ;
    }
    int mij= (st+dr)>>1;
    if (Poz<=mij)
        update(nod<<1, st, mij);
    else
        update((nod<<1)+1, mij+1, dr);
    Num[nod]= Num[nod<<1] + Num[(nod<<1)+1];
}

void mij()
{
}

void df3(int p)
{
    viz[p]=0;
    for (nod *i=V[p];i;i=i->next)
        if (viz[i->y])
        {
            df3(p);
            //calc();
        }
}

void solve()
{
    if (Rez==n-1)
    {
        df(1);
        Lol=Hmax[1];
        df2(1);
        fout<<Final<<"\n";
        return ;
        //case 1;
    }
    else
    {
            fout<<"0\n";
    }
}

int main ()
{
    citire();
    solve();
    return 0;
}
