#include <fstream>
#define IN "teroristi.in"
#define OUT "teroristi.out"
#define L 1000005

using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

char s[L];
char  a[L], b[L];

struct nod
{
    int poz;
    nod *next;
}*V[26];

int n, m;

int st[L], dr[L];
int viz[L], v=1;

void add(nod *&a,int p)
{
    nod *q=new nod;
    q->poz=p;
    q->next=a;
    a=q;
}

void citire()
{
    fin>>n>>m;
    fin.getline(s+1, L);
    fin.getline(s+1, L);
    for (int i=1;i<=m;i++)
    {
        fin>>a[i]>>b[i];
        a[i]=a[i]-'a';
        b[i]=b[i]-'a';
    }

    for (int i=1;i<=n;i++)
        add(V[s[i]-'a'], i);
}

int da(int p)
{
    if (viz[p]==1)
        return 0;
    viz[p]=1;
    for (nod *i=V[a[p]];i;i=i->next)
        if (!st[i->poz] || da(st[i->poz]))
        {
            st[i->poz]=p;
            dr[p]=i->poz;
            return 1;
        }

    for (nod *i=V[b[p]];i;i=i->next)
        if (!st[i->poz] || da(st[i->poz]))
        {
            st[i->poz]=p;
            dr[p]=i->poz;
            return 1;
        }
    return 0;
}

void solve()
{
    int num=0;
    int ok=1;
    while (ok)
    {
        ok=0;
        for (int i=1;i<=m;i++)
            viz[i]=0;
        for (int i=1;i<=m;i++)
            if (!dr[i])
                if ( da(i))
                {
                    ok=1;
                    num++;
                }
        if (num==n)
            break;
    }
    for (int i=1;i<=n;i++)
        fout<<st[i]<<" ";
    fout<<"\n";
}

int main ()
{
    citire();
    solve();
    return 0;
}
