#include <cstdio>

int P[500][500],T,N,Q,P2[500][500];
void read();
void generate(int z);
int module(int x);
void copy();
int max(int i,int j);
int main()
{
	freopen("v2d.out","w",stdout);
	int z = 1;
	read();
	for (;z < T; ++z)
	{
		generate(z);
		copy();
	}
	
	int s = 0;
	for (int i = 0 ; i < N ; ++i)
	{
		for (int j = 0;  j < N ; ++j)
		{
			s = (s + P[i][j]) % Q;
		}
	}
	printf("%d\n",s);
	return 0;
}

void read()
{
	freopen("v2d.in","r",stdin);
	scanf("%d %d %d",&N,&T,&Q);
	for (int i = 0 ; i < N ; ++i)
	{
		for (int j = 0 ; j < N ; ++j)
		{
			scanf("%d",&P[i][j]);
		}
	}
}

int module(int x)
{
	if (x < 0)
		return -x;
	return x;
}

void generate(int z)
{
	for (int i = 0 ; i < N ; ++i)
	{
		for (int j = 0 ; j < N ; ++j)
		{
			P2[i][j] = z + 1 + (P[i][j] + z*max(i,j) % Q); 
		}
	}
}

int max(int i,int j)
{
	int maxim = 0;
	for (int q = 0 ; q < N ; ++q)
	{
		for (int p = 0 ; p < N ; ++p)
		{
			if (p != j || q != i)
			{
				if (P[p][q] - module(i - q) - module(j - p) > maxim)
					maxim = P[p][q] - module(i - q) - module(j - p);
			}
		}
	}
	return maxim;
	
}

void copy()
{
	for (int i =0 ; i < N;  ++i)
	{
		for (int j = 0; j < N ; ++j)
			P[i][j] = P2[i][j];
	}
}
