#include <stdio.h>

#define Nmax 100100
#define INF 1000000000

struct nod{
    int info,d,c;
    nod *next;
};

nod *p[Nmax];

int n,h[Nmax],v[Nmax],min[Nmax],ctot;
char fr[Nmax];

void add(int k,int l,int d,int c)
{
    nod *current=new nod;
    current->info=l;
    current->d=d;
    current->c=c;
    current->next=p[k];
    p[k]=current;
}

int minim(int a,int b)
{
    if(a<b)
        return a;
    return b;
}

void DF(int x,int dist)
{
    int ok=0,it=0,maxim=0,rez=0;
    v[x]=1;
    nod *current=p[x];
    h[x]=dist;

    while(current)
        {
            ++it;
            if(!v[current->info])
                DF(current->info,dist+current->d);
            if(h[current->info]>maxim)
                maxim=h[current->info];
            current=current->next;
        }

    if(it==0)
        {
            fr[x]=1;
            min[x]=INF;
            return ;
        }

    min[x]=INF;

    current=p[x];

    while(current)
        {
            if(fr[current->info])
                {
                    ok=1;
                    ctot+=current->c * (maxim-h[current->info]);
                    rez+=current->c;
                }
            else
                {
                    ctot+=minim(min[current->info],current->c) * (maxim-h[current->info]);
                    rez+=minim(min[current->info],current->c);
                }
            current=current->next;
        }
    min[x]=rez;
    h[x]=maxim;
}

int main()
{
    int i,x,y,d,c;

    freopen("arb.in","r",stdin);
    freopen("arb.out","w",stdout);

    scanf("%d",&n);

    if(n<3)
        {
            printf("0\n");
            return 0;
        }

    if(n==3)
        {
            int dist[5][5],cost[5][5];
            scanf("%d%d%d%d",&x,&y,&d,&c);
            dist[x][y]=d;
            cost[x][y]=c;
            scanf("%d%d%d%d",&x,&y,&d,&c);
            dist[x][y]=d;
            cost[x][y]=c;
            if(dist[1][2]>dist[1][3])
                ctot=(dist[1][2]-dist[1][3])*cost[1][3];
            if(dist[1][3]>dist[1][2])
                ctot=(dist[1][3]-dist[1][2])*cost[1][2];
            printf("%d\n",ctot);
            return 0;
        }

    for(i=1;i<=n;++i)
        min[i]=INF;

    for(i=1;i<n;++i)
        {
                scanf("%d%d%d%d",&x,&y,&d,&c);
                add(x,y,d,c);
        }

    DF(1,0);

    printf("%d\n",ctot);

    return 0;
}
