#include <fstream>
#include <vector>

using namespace std;

#define foreach(V) for(vector <nd> :: iterator it = (V).begin(); it != (V).end(); ++it)

const int MAX_N = 100005;

ifstream fin ("arb.in");
ofstream fout ("arb.out");

struct nd
{
	int x, d, c;
	nd(){};
	nd(int _x, int _d, int _c)
	{
		x = _x;
		d = _d;
		c = _c;
	}
};

int N, D[MAX_N], Dst[MAX_N], Cst[MAX_N], Cmin[MAX_N];
long long C[MAX_N];
vector <nd> V[MAX_N];

void citire()
{
	fin >> N;

	for(int i = 1; i < N; ++i)
	{
		int x, y, d, c;
		fin >> x >> y >> d >> c;

		V[x].push_back(nd(y, d, c));
		V[y].push_back(nd(x, d, c));
	}
}

void df1(int nod, int dst, int cst, int t)
{
	D[nod] = dst;
	Cst[nod] = cst;

	foreach(V[nod])
		if(it -> x != t)
			df1(it -> x, it -> d, it -> c, nod);
}

void dfs(int nod, int t)
{
	foreach(V[nod])
		if(it -> x != t)
			dfs(it -> x, nod);

	foreach(V[nod])
	{
		if(it -> x == t) continue;
		C[nod] += C[it -> x];
		Dst[nod] = max(Dst[nod], Dst[it -> x] + D[it -> x]);
	}

	int sum = 0;
	foreach(V[nod])
	{
		if(it -> x == t) continue;
		int dif = Dst[nod] - (Dst[it -> x] + D[it -> x]);
		C[nod] += 1LL * dif * Cmin[it -> x];
		sum += Cmin[it -> x];
	}
	

	if(sum > Cst[nod] || sum == 0)
		Cmin[nod] = Cst[nod];
	else
		Cmin[nod] = sum;
//	fprintf(stderr, "%d %d %d\n", nod, Dst[nod], C[nod]);
}

int main()
{
	citire();
	df1(1, 0, 0, 0);
	dfs(1, 0);

	/*for(int i = 1; i <= N; ++i)
		fprintf(stderr, "%d %d %d\n", i, D[i], Cst[i]);*/

	fout << C[1];
	return 0;
}
