#include <cstdio>

const int MAX_N = 1005;

int T, P, A[MAX_N][MAX_N];



void pre()
{
	for(int i = 1; i <= 1000; ++i)
		A[i][1] = A[1][i] = (A[i-1][1] + (i ^ 1)) % P;

	for(int i = 2; i <= 1000; ++i)
		for(int j = 2; j <= 1000; ++j)
		{
			A[i][j] = (A[i-1][j] + A[i][j-1] + (i ^ j)) % P;
			A[i][j] -= A[i-1][j-1];
			if(A[i][j] < 0) A[i][j] += P;
		}

//	fprintf(stderr, "%d %d\n", (2 ^ 1), A[2][4]);
}

void solve()
{
	int x1, y1, x2, y2;
	scanf("%d %d %d %d", &x1, &y1, &x2, &y2);

	int sum = (A[x2][y2] + A[x1-1][y1-1]) %P;
	int dif = (A[x1-1][y2] + A[x2][y1-1]) %P;

	sum -= dif;
	if(sum < 0) sum += P;
	printf("%d\n", sum);
}

int main()
{
	freopen("xor.in","rt",stdin);
	freopen("xor.out","wt",stdout);

	scanf("%d %d", &T, &P);

	pre();
	for(int i = 1; i <= T; ++i)
		solve();
}
