#include <cstdio>
#include <cstdlib>
#include <ctime>

using namespace std;

int l1, c1, l2, c2, n;
int tt, mod, z, u, zbun, ubun;
int p2[40], i;
long long sol;

void ff(int n, int poz, int &zero, int &unu) {
	zero = unu = (n / p2[poz + 1]) * p2[poz];
	int nr = (n & (p2[poz + 1] - 1));
	if (nr >= p2[poz]) {
		zero += p2[poz];
		unu += nr - p2[poz] + 1;
	}
	else
		zero += nr + 1;
}

void f(int left, int right, int poz, int &zero, int &unu) {
	int z1, z2, u1, u2;
	ff(left - 1, poz, z1, u1);
	ff(right, poz, z2, u2);

	zero = z2 - z1; unu = u2 - u1;
}

int main() {
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);

	for (i = 0; i <= 31; i++)
		p2[i] = (1 << i);


	scanf("%d%d", &tt, &mod);
	for (; tt > 0; tt--) {
		scanf("%d%d%d%d", &l1, &c1, &l2, &c2);
		sol = 0;
		for (int bit = 0; bit <= 30; bit++) {
			int z1, z2, u1, u2;
			z1 = z2 = u1 = u2 = 0;
			f(l1, l2, bit, z1, u1);
			f(c1, c2, bit, z2, u2);

//			fprintf(stderr, "%d %d   %d %d\n", z1, u1, z2, u2);

			sol = (sol + ((1LL * z1 * u2 % mod + 1LL * z2 * u1 % mod) * p2[bit]) % mod) % mod;
		}
		printf("%lld\n", sol);
	}


	return 0;
}
