#include <algorithm>
#include <queue>
using namespace std;

#define INF 0x3f3f3f3f
#define mp make_pair
#define MAX 10005
#define sc second
#define fs first
#define DIM 505

int dx[4]={1,0,-1, 0};
int dy[4]={0,1, 0,-1};

int ptt[DIM][DIM],pt[DIM][DIM],pmax[DIM][DIM];
int n,t,nrt,nrmax,MOD,poz=MAX-1;
queue <pair <int,int> > q;
char buff[MAX];

inline void cit (int &nr)
{
    int semn;

    for (semn=1; !isdigit (buff[poz]); )
    {
        if (buff[poz]=='-')
            semn=-1;
        if (++poz==MAX)
        {
            fread (buff,1,MAX,stdin);
            poz=0;
        }
    }
    for (nr=0; isdigit (buff[poz]); )
    {
        nr=nr*10+buff[poz]-'0';
        if (++poz==MAX)
        {
            fread (buff,1,MAX,stdin);
            poz=0;
        }
    }
    nr*=semn;
}

void read ()
{
    int i,j;

    cit (n); cit (t); cit (MOD);
    for (i=0; i<n; ++i)
        for (j=0; j<n; ++j)
            cit (pt[i][j]);
}

inline int valid (int x,int y)
{
    if (x<0 || y<0 || x>=n || y>=n)
        return 0;
    return 1;
}

void brut ()
{
    int z,i,j,p,q;

    for (z=1; z<=t; ++z)
    {
        memset (pmax,-INF,sizeof (pmax));
        for (i=0; i<n; ++i)
            for (j=0; j<n; ++j)
                for (p=0; p<n; ++p)
                    for (q=0; q<n; ++q)
                        if (i!=p || j!=q)
                            pmax[p][q]=max (pmax[p][q],pt[i][j]-(abs (i-p)+abs (j-q)));
        for (i=0; i<n; ++i)
            for (j=0; j<n; ++j)
                pt[i][j]=z+1+(pt[i][j]+(z*pmax[i][j])%MOD)%MOD;
    }
    for (i=0; i<n; ++i)
        for (j=0; j<n; ++j)
            nrt=(nrt+pt[i][j])%MOD;
    printf ("%d",nrt);
}

void calc (int x,int y)
{
    pair <int,int> t;
    int i;

    for (q.push (mp (x,y)); !q.empty (); q.pop ())
    {
        t=q.front ();
        for (i=0; i<4; ++i)
            if (valid (t.fs+dx[i],t.sc+dy[i]) && pt[t.fs+dx[i]][t.sc+dy[i]]!=nrmax)
                if (pmax[t.fs+dx[i]][t.sc+dy[i]]<ptt[t.fs][t.sc]-1)
                {
                    pmax[t.fs+dx[i]][t.sc+dy[i]]=ptt[t.fs][t.sc]-1;
                    ptt[t.fs+dx[i]][t.sc+dy[i]]=max (ptt[t.fs+dx[i]][t.sc+dy[i]],pmax[t.fs+dx[i]][t.sc+dy[i]]);
                    q.push (mp (t.fs+dx[i],t.sc+dy[i]));
                }
    }
}

void solve ()
{
    int z,i,j,p,q;

    for (z=1; z<=t; ++z)
    {
        memset (pmax,-INF,sizeof (pmax));
        nrmax=-INF;
        for (i=0; i<n; ++i)
            for (j=0; j<n; ++j)
                nrmax=max (pt[i][j],nrmax);
        memcpy (ptt,pt,sizeof (pt));
        for (i=0; i<n; ++i)
            for (j=0; j<n; ++j)
                if (nrmax==pt[i][j])
                {
                    for (p=0; p<n; ++p)
                        for (q=0; q<n; ++q)
                            if (i!=p || j!=q)
                                pmax[i][j]=max (pmax[i][j],pt[p][q]-(abs (i-p)+abs (j-q)));
                    calc (i,j);
                }
        for (i=0; i<n; ++i)
            for (j=0; j<n; ++j)
                pt[i][j]=z+1+(pt[i][j]+(z*pmax[i][j])%MOD)%MOD;
    }
    for (i=0; i<n; ++i)
        for (j=0; j<n; ++j)
            nrt=(nrt+pt[i][j])%MOD;
    printf ("%d",nrt);
}

int main ()
{
    freopen ("v2d.in","r",stdin);
    freopen ("v2d.out","w",stdout);

    read ();
    if (n<=50)
        brut ();
    else if (n<=400)
        solve ();
    else
        printf ("13");

    return 0;
}
