#include <cstdio>
#include <string>

using namespace std;

FILE *fin=fopen("arb.in","r");
FILE *fout=fopen("arb.out","w");

typedef struct _elem{
    struct _elem *next;
    int info;
    int d,c;
} elem;

elem* a[100000];
int cd[100000];
int lv[100000];

int ci[100000];
int pl[100000];
int dr[100000];

int main()
{
    int n;
    fscanf(fin,"%d",&n);
    if (n==1)
    {
        fprintf(fout,"0\n");
        fclose(fin);
        fclose(fout);
        return 0;
    }
    memset(a,0,sizeof(elem*)*(n+1));
    bool simple=true;
    for (int i=0; i<n-1; i++)
    {
        int x,y,dd,cc;
        fscanf(fin,"%d %d %d %d",&x,&y,&dd,&cc);
        x--; y--;
        elem* tmp=new elem;
        tmp->info=y;
        tmp->next=a[x];
        tmp->d=dd;
        tmp->c=cc;
        a[x]=tmp;
        if (cc!=1)
            simple=false;
    }
    int st=0,en=0;
    cd[st]=0;
    lv[0]=0;
    int drmax=0;
    while (st<=en)
    {
        elem* p=a[cd[st]];
        while (p)
        {
            cd[++en]=p->info;
            lv[p->info]=lv[cd[st]]+1;
            p=p->next;
        }
        st++;
    }

    int en_=en;
    while (lv[cd[en_]]==lv[cd[en]])
    {
        ci[cd[en]]=0x3f3f3f3f;
        pl[cd[en]]=0;
        dr[cd[en]]=0;
        en--;
    }
    while (en>=0)
    {
        int max=0;
        ci[cd[en]]=0;
        pl[cd[en]]=0;

        elem *p=a[cd[en]];
        while (p)
        {
            if (dr[p->info]+p->d>max)
            {
                max=dr[p->info]+p->d;
            }
            p=p->next;
        }
        dr[cd[en]]=max;

        p=a[cd[en]];
        if (!p)
            ci[cd[en]]=0x3f3f3f3f;
        while (p)
        {
            int cip=ci[p->info];
            if (p->c<cip)
                cip=p->c;
            pl[cd[en]]+=(max-(dr[p->info]+p->d))*cip;
            pl[cd[en]]+=pl[p->info];
            ci[cd[en]]+=cip;
            p=p->next;
        }
        en--;
    }
    fprintf(fout,"%d\n",pl[0]);
    fclose(fin);
    fclose(fout);
    return 0;
}
