#include <cstdio>
using namespace std;

#define NMAX 550

long n, r, t, q, sum, i, j, x[NMAX][NMAX];

long try1[NMAX][NMAX], try2[NMAX][NMAX], try3[NMAX][NMAX], try4[NMAX][NMAX], best_p[NMAX][NMAX];

inline long maxim(long a, long b)
{
	return a > b ? a : b;
}

void show(long a[NMAX][NMAX], long aux)
{
	printf("%ld:\n", aux);
	for (i = 1; i <= n; ++i)
	{
		for (j = 1; j <= n; ++j)
			printf("%ld ", a[i][j]);
		printf("\n");
	}
	printf("--\n");
}

int main()
{
	freopen ("v2d.in", "rt", stdin);
	freopen ("v2d.out", "wt", stdout);

	scanf("%ld %ld %ld", &n, &t, &q);

	for (i = 1; i <= n; ++i)
		for (j = 1; j <= n; ++j)
			scanf("%ld", &x[i][j]);

//	show(x, 13);

	for (long o = 1; o <= t; ++o)
	{
		//try 1
		try1[1][1] = 0;
		for (r = 2; r <= n; ++r)
		{
			j = r;
			for (i = 1; i < r; ++i)
			{
				try1[i][j] = maxim( maxim(x[i - 1][j], x[i][j - 1]) , maxim(try1[i - 1][j], try1[i][j - 1]) ) - 1;
			}

			i = r;
			for ( j = 1; j < r; ++j)
			{
				try1[i][j] = maxim( maxim(x[i - 1][j], x[i][j - 1]) , maxim(try1[i - 1][j], try1[i][j - 1]) ) - 1;
			}

			try1[r][r] = maxim( maxim(x[r - 1][r], x[r][r - 1]) , maxim(try1[r - 1][r], try1[r][r - 1]) ) - 1;
		}

//		show(try1, 1);

			//	try2[i][j] = maxim( maxim(x[i + 1][j], x[i][j + 1]) , maxim(try2[i + 1][j], try2[i][j + 1]) ) - 1;
			//	try3[i][j] = maxim( maxim(x[i - 1][j], x[i][j + 1]) , maxim(try3[i - 1][j], try3[i][j + 1]) ) - 1;
			//	try4[i][j] = maxim( maxim(x[i + 1][j], x[i][j - 1]) , maxim(try4[i + 1][j], try4[i][j - 1]) ) - 1;
		
		//try 2
		try2[n][n] = 0;
		for (r = n - 1; r >= 1; --r)
		{
			j = r;
			for (i = n; i > r; --i)
			{
				try2[i][j] = maxim( maxim(x[i + 1][j], x[i][j + 1]) , maxim(try2[i + 1][j], try2[i][j + 1]) ) - 1;
			}

			i = r;
			for (j = n; j > r; --j)
			{
				try2[i][j] = maxim( maxim(x[i + 1][j], x[i][j + 1]) , maxim(try2[i + 1][j], try2[i][j + 1]) ) - 1;
			}

			try2[r][r] = maxim( maxim(x[r + 1][r], x[r][r + 1]) , maxim(try2[r + 1][r], try2[r][r + 1]) ) - 1;
		}
//		show(try2, 2);

		//try 3
		try3[1][n] = 0;
		for (r = 2; r <= n; ++r)
		{
			j = n - r + 1;
			for (i = 1; i < r; ++i)
			{
				try3[i][j] = maxim( maxim(x[i - 1][j], x[i][j + 1]) , maxim(try3[i - 1][j], try3[i][j + 1]) ) - 1;
			}

			i = r;
			for (j = n; j > n - r + 1; --j)
			{
				try3[i][j] = maxim( maxim(x[i - 1][j], x[i][j + 1]) , maxim(try3[i - 1][j], try3[i][j + 1]) ) - 1;
			}

			try3[r][n - r + 1] = maxim( maxim(x[r - 1][n - r + 1], x[r][(n - r + 1) + 1]) , maxim(try3[r - 1][n - r + 1], try3[r][(n - r + 1) + 1]) ) - 1;
		}

//		show(try3, 3);

		//try 4
		try4[n][1] = 0;
		for (r = n - 1; r >= 1; --r)
		{
			j = n - r + 1;
			for (i = n; i > r; --i)
			{
				try4[i][j] = maxim( maxim(x[i + 1][j], x[i][j - 1]) , maxim(try4[i + 1][j], try4[i][j - 1]) ) - 1;
			}

			i = r;
			for (j = 1; j < n - r + 1; ++j)
			{
				try4[i][j] = maxim( maxim(x[i + 1][j], x[i][j - 1]) , maxim(try4[i + 1][j], try4[i][j - 1]) ) - 1;
			}

			try4[r][n - r + 1] = maxim( maxim(x[r + 1][n - r + 1], x[r][(n - r + 1) - 1]) , maxim(try4[r + 1][n - r + 1], try4[r][(n - r + 1) - 1]) ) - 1;
		}
//		show(try4, 4);

		for (i = 1; i <= n; ++i)
			for (j = 1; j <= n; ++j)
			{
				best_p[i][j] = maxim( maxim(try1[i][j], try2[i][j]) , maxim(try3[i][j], try4[i][j]) );
//				x[i][j] = o + 1 + ((x[i][j] + o * best_p[i][j]) % q);
			}
		
		for (i = 1; i <= n; ++i)
		{
			for (j = 1; j <= n; ++j)
			{
				long long aux = (x[i][j] + o * best_p[i][j]) % q;
				x[i][j] = o + 1 + aux;
			}
		}
//		show(best_p, 0);
	}

	sum = 0;
	for (i = 1; i <= n; ++i)
		for (j = 1; j <= n; ++j)
			sum = (sum + x[i][j]) % q;

	printf("%ld\n", sum % q);

	return 0;
}

