#include <algorithm>
#include <stdio.h>

#define MAX 1024

using namespace std;

int i, j, p, testCases, l1, l2, c1, c2;
int sum[MAX][MAX];

inline int cf1(int x)
{
	return (x + 1) / 2;
}

int main()
{
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);

	for (int i = 1; i <= 1000; i++)
		for (int j = 1; j <= 1000; j++)
			sum[i][j] = (i ^ j) + sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1];

	scanf("%d %d", &testCases, &p);

	if (p != 2)
	{
		for (; testCases; testCases--)
		{
			scanf("%d %d %d %d", &l1, &c1, &l2, &c2);

			printf("%d\n", (sum[l2][c2] + sum[l1 - 1][c1 - 1] - sum[l1 - 1][c2] - sum[l2][c1 - 1]) % p);
		}
	}
	else
	{
		for (; testCases; testCases--)
		{
			scanf("%d %d %d %d", &l1, &c1, &l2, &c2);

			int v1 = l2 - l1 + 1, nr11 = cf1(l2) - cf1(l1 - 1);
			int v2 = c2 - c1 + 1, nr12 = cf1(c2) - cf1(c1 - 1);

			printf("%d\n", ((nr11 * (v2 - nr12)) + (nr12 * (v1 - nr11))) % p);
		}
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}
