#include <stdio.h>
#include <stdlib.h>

#define MAX_N 510

int n, t, q, sum;
int A[MAX_N][MAX_N], pmax[MAX_N][MAX_N];

int main() {

	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);

	scanf("%d %d %d", &n, &t, &q);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			scanf("%d", &A[i][j]);

	for (int z = 1; z <= t; z++) {
		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				pmax[i][j] = 0;

    	for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++)
				for (int k = 1; k <= n; k++)
					for (int t = 1; t <= n; t++)
						if (!(i == k && j == t)) {
							if (pmax[k][t] < A[i][j] - abs(k - i) - abs(t - j))
								pmax[k][t] = A[i][j] - abs(k - i) - abs(t - j);
						}

		sum = 0;
		for (int i = 1; i <= n; i++)
			for (int j = 1; j <= n; j++) {
				A[i][j] = z + 1 + (A[i][j] + z * pmax[i][j]) % q;
    	    	sum = (sum + A[i][j]) % q;
			}
	}

	printf("%d\n", sum);

	return 0;
}
