#include <cstdio>

using namespace std;

#define LL long long

int T, P;

inline int sumLine(int Y1, int Y2, int b, int inv) {
    int mask = (1 << b) - 1;
    int Yb1 = Y1;
    if (Yb1 & mask) {
        Yb1 &= ~mask;
        Yb1 += (1 << b);
    }
    int Yb2 = Y2;
    if (Yb2 & mask) {
        Yb2 &= ~mask;
    }

    int SUM = 0;
    int VY1 = (Y1 & (1 << b)) ? (!inv) : inv;
    if (Yb1 <= Y2) {
        SUM = (SUM + (Yb1 - Y1) * VY1) % P;
    } else {
        SUM = (SUM + (Y2 - Y1 + 1) * VY1) % P;
    }

    if (Yb1 <= Yb2) {
        int pieces = (Yb2 - Yb1) / (1 << b);
        int VYb1 = (Yb1 & (1 << b)) ? (!inv) : inv;
        SUM = (SUM + (((LL)((pieces + 1) / 2) * VYb1) << b)) % P;
        SUM = (SUM + (((LL)(pieces / 2) * (!VYb1)) << b)) % P;
    }

    if (Yb2 >= Y1) {
        int VY2 = (Y2 & (1 << b)) ? (!inv) : inv;
        SUM = (SUM + (Y2 - Yb2 + 1) * VY2) % P;
    }

    return ((LL)SUM << b) % P;
}

inline int sum(int X1, int Y1, int X2, int Y2, int b) {
    int mask = (1 << b) - 1;
    int Xb1 = X1;
    if (Xb1 & mask) {
        Xb1 &= ~mask;
        Xb1 += (1 << b);
    }
    int Xb2 = X2;
    if (Xb2 & mask) {
        Xb2 &= ~mask;
    }

    int SUM = 0;
    int VX1 = sumLine(Y1, Y2, b, (X1 & (1 << b)) ? 1 : 0);
    if (Xb1 <= X2) {
        SUM = (SUM + ((LL)Xb1 - X1) * VX1) % P;
    } else {
        SUM = (SUM + ((LL)X2 - X1 + 1) * VX1) % P;
    }

    if (Xb1 <= Xb2) {
        int pieces = (Xb2 - Xb1) / (1 << b);
        int VXb1 = sumLine(Y1, Y2, b, (Xb1 & (1 << b)) ? 1 : 0);
        int notVXb1 = sumLine(Y1, Y2, b, (Xb1 & (1 << b)) ? 0 : 1);

        SUM = (SUM + (((((LL)(pieces + 1) / 2) * VXb1) % (LL)P) << b)) % P;
        SUM = (SUM + (((((LL)pieces / 2) * notVXb1) % (LL)P) << b)) % P;
    }

    if (Xb2 >= X1) {
        int VX2 = sumLine(Y1, Y2, b, (X2 & (1 << b)) ? 1 : 0);
        SUM = (SUM + ((LL)X2 - Xb2 + 1) * VX2) % P;
    }

    return SUM % P;
}

int main() {
    freopen("xor.in", "rt", stdin);
    freopen("xor.out", "wt", stdout);

    scanf("%d %d", &T, &P);
    for (; T; T--) {
        int X1, Y1, X2, Y2;
        scanf("%d %d %d %d", &X1, &Y1, &X2, &Y2);

        int SUM = 0;
        for (int k = 0; k < 31; k++) {
            SUM += sum(X1, Y1, X2, Y2, k);
            if (SUM >= P) {
                SUM -= P;
            }
        }
        printf("%d\n", SUM);
    }

    return 0;
}
