#include<stdio.h>
#define infile "xor.in"
#define outfile "xor.out"
int t; //numarul de teste
int modulo; //>:)

inline int min(int a, int b)
{
	if(a<b) return a; return b;
}

int bit_unu(int bit, int st, int dr)
{
	if(dr<(1<<bit)) return 0;
	int nr=0;
	int i,prim=st;
	
	if((st>>bit)&1)
	{ //daca avem 1, scadem ca sa fie primul din serie
		for(i=0;i<bit;i++)
			if((st>>i)&1)
				prim-=(1<<i);
		nr-=(st-prim);
	}
	else
	{ //trebuie sa adaugam pana ajungem la primul din serie
		for(i=0;i<bit;i++)
			if(!((st>>i)&1))
				prim+=(1<<i);
		prim++;
	}
	if(prim>dr) return 0;
	
	//adaugam valorile din intervalele intregi
	nr+=(((dr-prim+1)/(1<<(bit+1)))*(1<<bit));
	nr+=min(1<<i,(dr-prim+1)%(1<<(bit+1)));
	
	return nr;
}

int suma_bit(int bit, int l1, int c1, int l2, int c2)
{
	int lin=bit_unu(bit,l1,l2); //numarul de numere pe linie cu unu la bitul bit
	int col=bit_unu(bit,c1,c2); //numarul de numere pe coloana cu unu la bitul bit
	int dif_lin=l2-l1+1;
	int dif_col=c2-c1+1;
	return (int)( ( ((long long)1<<bit) * (((long long)lin*(dif_col-col) + (long long)col*(dif_lin-lin)) % modulo))%modulo );
}

int query(int l1, int c1, int l2, int c2)
{
	int i,sum=0;
	for(i=0;i<31;i++)
		sum=(sum+suma_bit(i,l1,c1,l2,c2))%modulo;
	return sum;
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	int l1,c1,l2,c2;
	
	scanf("%d %d\n",&t,&modulo);
	while(t--)
	{
		scanf("%d %d %d %d\n",&l1,&c1,&l2,&c2);
		printf("%d\n",query(l1,c1,l2,c2));
	}
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
