#include <fstream>
#include <vector>

#define NMAX 100100
using namespace std;

vector<int> G[NMAX];
int N, Tata[NMAX], Cost[NMAX], Lung[NMAX], LMax[NMAX], CMin[NMAX];
long long Best[NMAX];

inline int minim(int a, int b)
{
	if (a < b) return a;
	else return b;
}

inline int maxim(int a, int b)
{
	if (a > b) return a;
	else return b;
}

void Citire(void)
{
	ifstream fin("arb.in");
	
	fin >>N;
	
	int x, y, i;
	
	for (i = 1; i < N; i++)
	{
		fin >>x >>y;
		
		fin >>Lung[y] >>Cost[y];
		
		G[x].push_back(y);
		Tata[y] = x;
	}
	
	fin.close();
}

void DFS(int x)
{
	if (G[x].size() == 0)
	{
		CMin[x] = Cost[x];
		LMax[x] = Lung[x];
	}
	else
	{
		int Min2 = 0, i;
		
		for (i = 0; i < (int)G[x].size(); i++)
		{
			DFS(G[x][i]);
			LMax[x] = maxim(LMax[x], LMax[G[x][i]]);
			Min2 += CMin[G[x][i]];
		}
		
		for (i = 0; i < (int)G[x].size(); i++)
		{
			Best[x] += (LMax[x] - LMax[G[x][i]])*CMin[G[x][i]] + Best[G[x][i]];
		}
		LMax[x] += Lung[x];
		CMin[x] = minim(Cost[x], Min2);
	}
}

void Solve(void)
{
	DFS(1);
	
}

void Afisare(void)
{
	ofstream fout("arb.out");
	
	fout <<Best[1];
	
	fout.close();
}

int main()
{
	Citire();
	
	Solve();
	
	Afisare();
	
	return 0;
}
