#include <fstream>
#include <queue>
#include <algorithm>

#define NMAX 512
using namespace std;

struct stapan{int x, y;};
struct punct{ int cost; stapan S, L; };

int P[NMAX][NMAX], PMax[NMAX][NMAX], dx[4] = {0, 1, 0, -1}, dy[4] = {1, 0, -1, 0};
stapan Boss[NMAX][NMAX];

vector<punct> Q;
int N, T, R;

int compara(punct a, punct b)
{
	if (a.cost > b.cost)
		return 0;
	else return 1;
}

void ReadAll(void)
{
	ifstream fin("v2d.in");
	
	fin >>N >>T >>R;
	
	int i, j;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			fin >>P[i][j];
		
	fin.close();
}

void Solve(void)
{
	int i, j, z, xx, yy, Viz = 0,xxx,yyy;
	punct aux, aux2;
	
	for (z = 1; z <= T; z++)
	{
		Q.clear();
		Viz = 0;
		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				Boss[i][j].x = 0, Boss[i][j].y = 0, PMax[i][j] = -100;
			
		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
			{
				aux.S.x = i;
				aux.S.y = j;
				aux.cost = P[i][j];
				aux.L.x = i;
				aux.L.y = j;
				
				Q.push_back(aux);
				push_heap(Q.begin(), Q.end(), compara);
			}
			
		while(!Q.empty())
		{
			aux = Q[0];
			pop_heap(Q.begin(), Q.end(), compara);
			Q.erase( Q.end() );
			
			if (Boss[aux.S.x][aux.S.y].x == 0)
				Viz++, Boss[aux.S.x][aux.S.y].x = 1;
			
			for (i = 0; i < 4; i++)
			{
				xx = aux.L.x + dx[i];
				yy = aux.L.y + dy[i];
				
				if (xx <= N && xx > 0 && yy <= N && yy > 0 && ( (aux.S.x != xx) || (aux.S.y != yy) ))
				{
					if (Boss[xx][yy].x == 0)
					{
						PMax[xx][yy] = aux.cost - 1;
						Boss[xx][yy].x = aux.S.x;
						Boss[xx][yy].y = aux.S.y;
						
						aux2 = aux;
						aux2.L.x = xx;
						aux2.L.y = yy;
						aux2.cost--;
						Q.push_back(aux2);
						push_heap(Q.begin(), Q.end(), compara);
						
						Viz++;
					}
					xxx = Boss[xx][yy].x;
					yyy = Boss[xx][yy].y;
				
					if (PMax[aux.S.x][aux.S.y] < (P[xx][yy] - abs(xx - aux.S.x) - abs(yy- aux.S.y)))
						PMax[aux.S.x][aux.S.y] = P[xx][yy] - abs(xx - aux.S.x) - abs(yy- aux.S.y);
					if (PMax[aux.S.x][aux.S.y] < (PMax[xx][yy] - abs(xx - aux.S.x) - abs(yy- aux.S.y)) && 
						((xxx!=0) && 
						( (xxx != aux.S.x) ||  (yyy != aux.S.y))))
						PMax[aux.S.x][aux.S.y] < (PMax[xx][yy] - abs(xx - aux.S.x) - abs(yy- aux.S.y));
				}
			}
		}
		
		for (i = 1; i <= N; i++)
			for(j = 1; j <= N; j++)
			{
				P[i][j] = z + 1 + ((P[i][j] + z * PMax[i][j]) % R);
			}
	}
}

void Afiseaza()
{
	ofstream fout("v2d.out");
	
	int i, j, sum = 0;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
		{
			sum = (sum + P[i][j]) % R;
		}
	
	fout <<sum <<'\n';	
		
	fout.close();
}

int main()
{
	ReadAll();
	
	Solve();

	Afiseaza();
}