#include <fstream>
using namespace std;
#define TMAX 20004
int T,P;
int a[1024][1024];
int L1[TMAX],L2[TMAX],C1[TMAX],C2[TMAX];

ifstream fin("xor.in");
ofstream fout("xor.out");

void rezp2()
{
	int l1,l2,c1,c2,nl1,nl0,e11,e10;
	unsigned long long S;
	
	for (;T;--T)
	{
	 fin>>l1>>c1>>l2>>c2;
	 	 
	 nl1=nl0=(l2-l1)>>1;
	 if ((l2-l1+1)&1)
		 if ((l1^c1)&1) ++nl1;
	        else ++nl0;
	 
	 if ((c2-c1+1)&1) {e10=(c2-c1+1)>>1; e11=e10+1;}
	    else { e10=e11=(c2-c1+1)>>1;}
		
	 S=(nl1*e11)&1;
	 S+=(nl0*e10)&1;
	 S&=1;
	 
	 fout<<S<<"\n";
	}
	fout.close();
	fin.close();
}

void rez1000()
{
  int i,j,n,l1,l2,c1,c2; int S;
  n=1000;
  for (i=1;i<=n;++i) 	
   for (j=1;j<=n;++j)
   {
	 a[i][j]=(a[i-1][j]+a[i][j-1]-a[i-1][j-1]+(i^j))%P;
   }
  
  for (i=1;i<=T;++i)
  {
	//fin>>l1>>c1>>l2>>c2;
	l1=L1[i]; l2=L2[i]; c1=C1[i]; c2=C2[i];
	S=a[l2][c2]-a[l1-1][c2]-a[l2][c1-1]+a[l1-1][c1-1];
	if (S>=P) S%=P;
	   else while (S<0) S+=P;
	fout<<S<<"\n";
  }
  fout.close();
}

void brut()
{
	int i,l1,l2,c1,c2,j,t;
	for (t=1;t<=T;++t)
	{
		unsigned long long S=0;
		l1=L1[t]; l2=L2[t]; c1=C1[t]; c2=C2[t];		
		
		for (i=l1; i<=l2; ++i)
		{
		 for (j=c1;j<=c2;++j)
		  S=S+(i^j);
		 S%=P;
		}
		
		fout<<S<<"\n";
	}
}

int main()
{
	
	fin>>T>>P;
	
	if (P==2) {rezp2();  return 0;}
	
	bool ok=true, okll=true;
	int i;
	for (i=1;i<=T;++i)
	{
		fin>>L1[i]>>C1[i]>>L2[i]>>C2[i];
		if (L2[i]>1000 && C2[i]>1000) ok=false;
		//if (L1[i]!=L2[i]) okll=false;
	}
	fin.close();
	
		
	if (ok) {rez1000(); }
	   else brut();
	/*	if (okll) rezll();
	       else brut();*/
	
	fout.close(); 
	return 0;
}
