#include <stdio.h>
#include <algorithm>
#include <vector>
#define MAXN 100010
#define INF 1000000000

using namespace std;

vector< pair<int, int> > G1[MAXN], G2[MAXN], F[MAXN];
int i,n,x,y,cost,d;
int sum[MAXN];
int Fr[MAXN];
int Cost[MAXN];
int D[MAXN];
int Val[MAXN];
bool U[MAXN];

void make_arb(int nod)
{
	int i;
	U[nod] = true;
	vector< pair<int, int> >::iterator it;
	vector< pair<int, int> >::iterator it2;

	for (it=G1[nod].begin(), it2 = G2[nod].begin(); it!=G1[nod].end(); it++, it2++)
		if (!U[it->first]){
			F[nod].push_back(*it2);
			sum[it->first] += sum[nod]+it->second;
			make_arb(it->first);
		}
	if (G1[nod].size() == 1)
		Fr[++Fr[0]] = nod;
}

void calc_cost(int nod)
{
	Cost[nod] = 0;
	if (F[nod].size() == 0) Cost[nod] = INF;
	vector< pair<int, int> >::iterator it;

	for (it=F[nod].begin(); it!=F[nod].end(); it++){
		calc_cost(it->first);
		Cost[nod] += min(Cost[it->first] , it->second);
	}
}

void calc_din(int nod)
{
	if (F[nod].size() == 0){
		Val[nod] = sum[nod];
		D[nod] = 0;
		return;
	}

	vector< pair<int, int> >::iterator it;

	int maxim = 0;
	for (it=F[nod].begin(); it!=F[nod].end(); it++){
		calc_din(it->first);
		maxim = max(maxim, Val[it->first]);
		D[nod] += D[it->first];
	}

	for (it=F[nod].begin(); it!=F[nod].end(); it++)
		D[nod] += min(it->second, Cost[it->first])*(maxim - Val[it->first]);

	Val[nod] = maxim;
}

int main()
{
	freopen("arb.in","r",stdin);
	freopen("arb.out","w",stdout);
	scanf("%d",&n);
	for (i=1; i<n; i++){
		scanf("%d %d %d %d",&x,&y,&d, &cost);
		G1[x].push_back(make_pair(y, d));
		G1[y].push_back(make_pair(x, d));
		G2[x].push_back(make_pair(y, cost));
		G2[y].push_back(make_pair(x, cost));
	}

	make_arb(1);

	calc_cost(1);

	calc_din(1);

	printf("%d\n", D[1]);
	return 0;
}