#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX_N = 502;
const int INF = 0x3f3f3f3f;

#define x first
#define y second
#define mp make_pair

int n, t, MOD, m;
int a[MAX_N][MAX_N];
pair<int, pair<int, int> > b[MAX_N * MAX_N];

int cmp(pair<int, pair<int, int> > a, pair<int, pair<int, int> > b)
{
	return a.x > b.x;
}

int dist(int x1, int y1, int x2, int y2)
{
	return abs(x1 - x2) + abs(y1 - y2);
}

int find()
{
	int i, mx = -INF, p = -1;

	for (i = 1; i <= m; ++i)
	{
		if (b[i].y.x == 1 && b[i].y.y == 1)
			continue;

		if (mx < b[i].x - dist(1, 1, b[i].y.x, b[i].y.y))
			mx = b[i].x - dist(1, 1, b[i].y.x, b[i].y.y), p = i;
	}

	return p;
}

int main()
{
	int i, j;
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);

	scanf("%d %d %d", &n, &t, &MOD);

	for (i = 1; i <= n; ++i)
		for (j = 1; j <= n; ++j)
		{
			scanf("%d", &a[i][j]);
			b[++m].x = a[i][j];
			b[m].y = mp(i, j);
		}

	sort(b + 1, b + m + 1, cmp);

	for (int z = 1; z <= t; ++z)
	{
		int p = find();

		a[1][1] = z + 1 + ((a[1][1] + z * (b[p].x - dist(1, 1, b[p].y.x, b[p].y.y))) % MOD);

		for (i = 1; i <= n; ++i)
		{
			for (j = 1; j <= n; ++j)
			{
				if (i == 1 && j == 1)
					continue;

				if (i == b[p].y.x && j == b[p].y.y)
					++p;

				int val = b[p].x - dist(i, j, b[p].y.x, b[p].y.y);
				int mx = val, pp, k;

				for (k = p; k >= p - 80 && k >= 1; --k)
				{
					if (i == b[k].y.x && j == b[k].y.y)
						continue;

					int v = b[k].x - dist(i, j, b[k].y.x, b[k].y.y);
					if (v >= mx)
					{
						mx = v;
						pp = k;
					}
				}

				k = p;

				for (k = p; k <= p + 80 && k <= m; ++k)
				{
					if (i == b[k].y.x &&j == b[k].y.y)
						continue;

					int v = b[k].x - dist(i, j, b[k].y.x, b[k].y.y);
					if (v >= mx)
					{
						mx = v;
						pp = k;
					}
				}

				p = pp;

				a[i][j] = z + 1 + ((a[i][j] + z * (b[p].x - dist(i, j, b[p].y.x, b[p].y.y))) % MOD);
			}
		}

		m = 0;
		for (i = 1; i <= n; ++i)
		{
			for (j = 1; j <= n; ++j)
			{
				b[++m].x = a[i][j];
				b[m].y = mp(i, j);
			}
		}
		sort(b + 1, b + m + 1);
	}

	int sol = 0;

	for (i = 1; i <= n; ++i)
		for (j = 1; j <= n; ++j)
			sol = (sol + a[i][j]) % MOD;

	printf("%d\n", sol);

	return 0;
}
