#include <cstdio>

const int MAX = 1002;

int n, MOD;
int d[MAX][MAX];

void precalc()
{
	int i, j;

	for (i = 1; i <= 1000; ++i)
		for (j = 1; j <= 1000; ++j)
		{
			int x = i ^ j;

			d[i][j] = (MOD + d[i - 1][j] + d[i][j - 1] - d[i - 1][j - 1] + x) % MOD;
		}
}

int main()
{
	int i, j;
	int x1, y1, x2, y2;
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);

	scanf("%d %d\n", &n, &MOD);

	precalc();

	for (i = 1; i <= n; ++i)
	{
		scanf("%d %d %d %d", &x1, &y1, &x2, &y2);

		if (x2 <= 1000 && y2 <= 1000)
		{
			printf("%d\n", (2 * MOD + d[x2][y2] - d[x1 - 1][y2] - d[x2][y1 - 1] + d[x1 - 1][y1 - 1]) % MOD);
			continue;
		}

		if (MOD == 2)
		{
			int p = ((y2 - y1) / 2) % 2;

			if (y2 - y1 % 2 == 1)
			{
				if (x1 ^ y2 == 1)
					p = (p + 1) % 2;				
			}

			int sol = ((x2 - x1) / 2) % 2;
			if ((x2 - x1) % 2 == 1)
			{
				if (p == 1)
					sol = (sol + 1) % 2;
			}

			printf("%d\n", sol);
			continue;
		}

		printf("%d\n", MOD / 2);
	}

	return 0;
}
