//by Puni Andrei-Paul

#include <cstdio>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

int left[26][26], nr1[26][26], nr2[26][26], need[26];
int total_need, n,m;

//nrX[i][j] = nr de cartonase care au pus partea X in sus ...

stack <int> l[26][26];

#define Nmax 1000100

char A[Nmax], B[Nmax], sir[Nmax];

void read()
{
    FILE *f = fopen("teroristi.in","r");
    
    fscanf(f, "%d %d\n", &n, &m);
    
    fscanf(f, "%s\n", sir+1);
    
    for (int i = 1; i <= n; ++i)
    {
        sir[i] -= 'a';
        ++need[(int)sir[i]];
    }
    
    for (int i = 1; i <= m; ++i)
    {
        fscanf(f, "%c %c\n", &A[i], &B[i]);
        if (A[i] > B[i])
            swap(A[i],B[i]);
        A[i] -= 'a';
        B[i] -= 'a';
        ++left[(int)A[i]][(int)B[i]];
        l[(int)A[i]][(int)B[i]].push(i);
    }
    
    fclose(f);
}

void solve()
{
    for (int i = 0; i < 26; ++i)
        total_need += need[i];
        
    //back greedy
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 0; j < 26; ++j)
        {
            if (left[(int)sir[i]][j] > 0)
            {
                --left[(int)sir[i]][j];
                ++nr1[(int)sir[i]][j];
                --need[(int)sir[i]];
                --total_need;
                break;
            }
            
            if (left[j][(int)sir[i]] > 0)
            {
                --left[j][(int)sir[i]];
                ++nr2[j][(int)sir[i]];
                --need[(int)sir[i]];
                --total_need;
                break;
            }
        }
    }

    vector<int> litere;
    
    for (int i = 0; i < 26; ++i)
        litere.push_back(i);

    bool ok = true;

    while (total_need > 0 && ok)
    {
        ok = false;
        //de dragul randommului :P
        random_shuffle(litere.begin(),litere.end());
        
        for (vector<int>::iterator it = litere.begin(); it != litere.end(); ++it)
        if (need[*it] > 0)
        {
            for (int i = 0; i < *it; ++i)
            for (int j = i; j < 26; ++j)
            if (left[i][j] > 0 && nr1[i][*it] > 0)
            {
                --left[i][j];
                ++nr1[i][j];

                --nr1[i][*it];
                ++nr2[i][*it];

                --total_need;
                --need[*it];
                ok = true;
                break;
            }

            if (need[*it] < 1) continue;

            for (int i = *it; i < 26; ++i)
            for (int j = i; j < 26; ++j)
            if (left[i][j] > 0 && nr2[*it][i] > 0)
            {
                --left[i][j];
                ++nr1[i][j];

                --nr2[*it][i];
                ++nr1[*it][i];

                --total_need;
                --need[*it];
                ok = true;
                break;
            }

            if (need[*it] < 1) continue;

            for (int i = 0; i < *it; ++i)
            for (int j = i; j < 26; ++j)
            if (left[i][j] > 0 && nr1[j][*it] > 0)
            {
                --left[i][j];
                ++nr2[i][j];

                --nr1[j][*it];
                ++nr2[j][*it];

                --total_need;
                --need[*it];
                ok = true;
                break;
            }

            if (need[*it] < 1) continue;

            for (int i = *it; i < 26; ++i)
            for (int j = i; j < 26; ++j)
            if (left[i][j] > 0 && nr2[*it][j] > 0)
            {
                --left[i][j];
                ++nr2[i][j];

                --nr2[*it][j];
                ++nr1[*it][j];

                --total_need;
                --need[*it];
                ok = true;
                break;
            }
        }
    }
}

void write()
{
    FILE *f = fopen("teroristi.out","w");
    
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 0; j < 26; ++j)
        {
            if (nr1[(int)sir[i]][j] > 0)
            {
                fprintf(f, "%d ", l[(int)sir[i]][j].top());
                l[(int)sir[i]][j].pop();
                --nr1[(int)sir[i]][j];
                break;
            }

            if (nr2[j][(int)sir[i]] > 0)
            {
                fprintf(f, "%d ", l[j][(int)sir[i]].top());
                l[j][(int)sir[i]].pop();
                --nr2[j][(int)sir[i]];
                break;
            }
        }
    }
    
    fclose(f);
}

int main()
{
    read();
    
    solve();
    
    write();

    return 0;
}