#include<stdio.h>
#include<vector>
#define maxn 100100

using namespace std;

vector< int > vecini[ maxn ];
vector< int > cost[ maxn ];
vector< int > dist[ maxn ];
int MAX, maxi[ maxn ], sel[ maxn ];
long long REZ = 0;

int get_max( int where )
{
	sel[ where ] = 1;
	int nr_vec = vecini[ where ].size();
	for( int i = 0; i < nr_vec; ++i)
	{
		if( sel[ vecini[ where ][ i ] ] == 1 ) continue;
		int val = get_max( vecini[ where ][ i ] );
		if( maxi[ where ] < val + dist[ where ][ i ] )
			maxi[ where ] = val + dist[ where ][ i ];
	}
	return maxi[ where ];
}


int ver( int where, int cost )
{
	sel[ where ] = 1;
	int nr_vec = vecini[ where ].size();
	if( nr_vec == 1 && where != 1)
	{
		if( cost != MAX ) return 0;
		else return 1;
	}
	for( int i = 0; i < nr_vec; ++i)
	{
		if( sel[ vecini[ where ][ i ] ] == 1 ) continue;
		int val = ver( vecini[ where ][ i ] , cost + dist[ where ][ i ]);
		if( val == 0) return 0;
	}
	return 1;
}
int calc_max( int where, int cost )
{
	sel[ where ] = 1;
	int nr_vec = vecini[ where ].size();
	if( nr_vec == 1 && where != 1)
	{
		maxi [ where ] = cost;
		return maxi[ where ];
	}
	for( int i = 0; i < nr_vec; ++i)
	{
		if( sel[ vecini[ where ][ i ] ] == 1 ) continue;
		int val = calc_max( vecini[ where ][ i ] , cost + dist[ where ][ i ]);
		if( val > maxi [ where ] ) maxi[ where ] = val;
	}
	return maxi[ where ];
	

}
void increment( int where )
{
	sel[ where ] = 1;
	int nr_vec = vecini[ where ].size();
	if( nr_vec == 1 && where != 1)
		return ;
	
	for( int i = 0; i < nr_vec; ++i)
	{
		if( sel[ vecini[ where ][ i ] ] == 1 ) continue;
		int val = maxi[ where ] - maxi[ vecini[ where ][ i ] ] ;
		dist[ where ][ i ] += val;
		REZ += val * cost[ where ][ i ];
		if( val == 0 ) increment( vecini[ where ][ i ] );
	}

}


int main()
{
	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);
	
	int n;
	scanf("%d", &n);
	for( int i = 1; i < n; ++i)
	{
		int a, b, c, d;
		scanf("%d %d %d %d", &a, &b, &d, &c);// 60% din cazuri c = 1
		vecini[ a ].push_back( b ); vecini[ b ].push_back( a );
		cost[ a ].push_back( c ); cost[ b ].push_back( c );
		dist[ a ].push_back( d ); dist[ b ].push_back( d );
		
	}
		
	MAX = get_max( 1 );
	
	memset( sel, 0, sizeof( sel ));
	while( !ver( 1 , 0 ) )
	{
		memset( sel, 0, sizeof( sel ));memset( maxi, 0, sizeof( maxi ));
		calc_max( 1, 0 );
		memset( sel, 0, sizeof( sel ));//memset( maxi, 0, sizeof( maxi ));
		increment( 1 );
		memset( sel, 0, sizeof( sel ));memset( maxi, 0, sizeof( maxi ));
	}
	
	printf("%lld\n", REZ);
	
	return 0;
}
