// O(M * N^2)

#include <stdio.h>
#include <stdlib.h>

#define NMAX 2050

int d[NMAX][NMAX], max[2][NMAX];
int i, j, k, N, M, c, a, Tlast, T, Tc, C, B;

int main()
{
	freopen("bcrc.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
		{
			d[i][j] = abs(i - j);

			if (N - d[i][j] < d[i][j])
				d[i][j] = N - d[i][j];
		}

	c = 0;
	for (i = 0; i < N; i++)
		max[c][i] = -1;

	max[c][0] = Tlast = 0;

	for (k = 1; k <= M; k++)
	{
		scanf("%d %d %d", &T, &C, &B);
		C--;

		if (Tlast < T)
		{
			a = c;
			c = 1 - c;

			for (i = 0; i < N; i++)
				max[c][i] = max[a][i];

			for (i = 0; i < N; i++)
			{
				j = (i + 1) % N;
				Tc = Tlast + 1;
				while (j != i && Tc <= T)
				{
					if (max[a][i] > max[c][j])
						max[c][j] = max[a][i];

					j = (j + 1) % N;
					Tc++;
				}

				j = (i + N - 1) % N;
				Tc = Tlast + 1;
				while (j != i && Tc <= T)
				{
					if (max[a][i] > max[c][j])
						max[c][j] = max[a][i];

					j = (j + N - 1) % N;
					Tc++;
				}
			}

			Tlast = T;
		}
		
		if (max[c][C] >= 0)
			max[c][C] += B;
	}

	freopen("bcrc.out", "w", stdout);

	B = 0;
	for (i = 0; i < N; i++)
		if (max[c][i] > B)
			B = max[c][i];

	printf("%d\n", B);

	return 0;
}