#include <stdio.h>
#include <stdlib.h>

#define NMAX 2050
#define XMAX 8090
#define INF 1100000000

int b[XMAX], t[XMAX], c[XMAX], d[NMAX][NMAX];
int i, j, k, m, M, N, T, C, B, bmax, bmin, p;

int main()
{
	freopen("bcrc.in", "r", stdin);
	scanf("%d %d", &N, &M);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
		{
			d[i][j] = abs(i - j);

			if (N - d[i][j] < d[i][j])
				d[i][j] = N - d[i][j];
		}

	for (i = 0; i < XMAX; i++)
		b[i] = -1;

	b[0] = t[0] = c[0] = p = 0;

	freopen("log.txt", "w", stdout);

	for (m = 1; m <= M; m++)
	{
		scanf("%d %d %d", &T, &C, &B);
		C--;

		bmax = -1;

		for (i = 0; i < XMAX; i++)
			if (b[i] >= bmax && T - t[i] >= d[c[i]][C])
				bmax = b[i];

		if (bmax >= 0)
		{
			bmax += B;

			bmin = INF;

			for (i = 0; i < XMAX; i++)
				if (b[i] < bmin)
					bmin = b[i], p = i;

			printf("m = %d: C = %d; bmax = %d; bmin = %d\n", m, C, bmax, bmin);

			if (bmin < bmax)
			{
				b[p] = bmax;
				t[p] = T;
				c[p] = C;
			}
			else
				fprintf(stderr, "refusing candy-box\n");
		}
		else
			printf("m = %d: C = %d -> unreachable box\n", m, C);
	}

	bmax = 0;

	for (i = 0; i < XMAX; i++)
		if (b[i] > bmax)
			bmax = b[i];

	freopen("bcrc.out", "w", stdout);
	printf("%d\n", bmax);

	return 0;
}
