#include <stdio.h>
#include <math.h>

#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 21000

#define eps 1e-7

#define dy(a) (v[a].second)
#define y(a) (v[a].first)
#define equal(a, b) (fabs(a - b) < eps)

vector<pair<double, double> > v;
double a, b, T, tok, t;
int dq[NMAX];
double tx[NMAX];
int i, j, k, N, x, cand;

int main()
{
    freopen("campion.in", "r", stdin);
    
    scanf("%d %lf", &N, &T);
    
    for (i = 0; i < N; i++)
    {
        scanf("%lf %lf", &a, &b);
        v.push_back(make_pair(-a, b));
    }    
     
    sort(v.begin(), v.end());
    
    for (i = 0; i < N; i++)
    {
        y(i) = -y(i);
        //dy(i) = -dy(i);
    }
        
    dq[x = 1] = 0;
    tx[1] = 0.0;

    for (i = 1; i < N; i++)
    {
        cand = 1;
        tok = 0.0;
        
        while (x >= 1 && cand)
        {
            if (equal(y(dq[x]), y(i)))
            {
                if (equal(tx[x], 0.0) || equal(dy(dq[x]), dy(i)))
                {
                    tok = tx[x];
                    break;                
                }    
                else
                    cand = 0;
            }    
            else
            if (equal(dy(dq[x]), dy(i)) || (dy(dq[x]) > dy(i)) )
                    cand = 0;
            else
            {
                // compute the intersection: y(dq[x]) + t * dy(dq[x]) = y(i) + t* dy(i)
                
                t = (y(dq[x]) - y(i)) / (dy(i) - dy(dq[x]));
                
                if ((t < T) || equal(t, T))
                {
                    if (equal(t, tx[x]) || (t > tx[x]))
                    {
                        tok = t;
                        break;
                    }
                    else
                    {
                        tok = t;
                        x--;
                    }        
                }
                else
                    cand = 0;    
            }
        }
        
        if (cand)
        {
            dq[++x] = i;
            tx[x] = tok;
        }    
    }    
    
    freopen("campion.out", "w", stdout);
    printf("%d\n", x);
    
    return 0;
}
