#include <stdio.h>

#define GMAX 200
#define WMAX 100

int height, width;
int length;

char grid[GMAX][GMAX+1];
char word[WMAX+1];
long long int dp[WMAX][GMAX][GMAX];

long long int sum;

int main(void) {
    int p, i, j;
    FILE *f;

    f = fopen("grid.in", "r");
    fscanf(f, "%i %i", &height, &width);
    fscanf(f, "%i", &length);
    for (i = 0; i < height; i++) {
        fscanf(f, "%s", grid[i]);
    }
    fscanf(f, "%s", word);
    fclose(f);

    for (p = 0; p < length; p++) {
        for (i = 0; i < height; i++) {
            for (j = 0; j < width; j++) {
		// incorrect letter
                if (grid[i][j] != word[p]) {
                    dp[p][i][j] = 0;
                    continue;
                }
                // first letter
                if (p == 0) {
                    dp[p][i][j] = 1;
                    continue;
                }
                // sum of the neighbours
                sum = 0;
                if (i+1 != height && j-1 != -1) sum += dp[p-1][i+1][j-1];
                if (i+1 != height) sum += dp[p-1][i+1][j];
                if (i+1 != height && j+1 != width) sum += dp[p-1][i+1][j+1];
                if (j-1 != -1) sum += dp[p-1][i][j-1];
                if (j+1 != width) sum += dp[p-1][i][j+1];
                if (i-1 != -1 && j-1 != -1) sum += dp[p-1][i-1][j-1];
                if (i-1 != -1) sum += dp[p-1][i-1][j];
                if (i-1 != -1 && j+1 != width) sum += dp[p-1][i-1][j+1];
                dp[p][i][j] = sum;
            }
        }
    }

    // total sum
    sum = 0;
    for (i = 0; i < height; i++) {
        for (j = 0; j < width; j++) {
            sum += dp[length-1][i][j];
        }
    }

    f = fopen("grid.out", "w");
    fprintf(f, "%lli\n", sum);
    fclose(f);
}