// solution written by Michal 'misof' Forisek
#include <iostream>
#include <vector>
#include <string>
#include <cctype>
using namespace std;

int digit(char c) { return isdigit(c) ? c-'0' : c-'a'+10; }
long long cnt[37][37][37][37], a[4], fix[4];

int main() {
        int N, D;
        cin >> N >> D;
        vector<string> PIN(N);
        for (int n=0; n<N; ++n) {
                cin >> PIN[n];
                for (int keep=0; keep<16; ++keep) {
                        for (int i=0; i<4; ++i) 
                                if (keep & 1<<i) a[i]=digit( PIN[n][i] );
                                else a[i]=36;
                        ++cnt[a[0]][a[1]][a[2]][a[3]];
                }
        }
        for (a[0]=0; a[0]<37; ++a[0])
        for (a[1]=0; a[1]<37; ++a[1])
        for (a[2]=0; a[2]<37; ++a[2])
        for (a[3]=0; a[3]<37; ++a[3]) {
                int f = (a[0]<36) + (a[1]<36) + (a[2]<36) + (a[3]<36);
                long long c = cnt[a[0]][a[1]][a[2]][a[3]];
                fix[f] += c*(c-1)/2;
        }
        if (D==1) cout << fix[3] << endl;
        if (D==2) cout << fix[2] - 3*fix[3] << endl;
        if (D==3) cout << fix[1] - 2*fix[2] + 3*fix[3] << endl;
        if (D==4) cout << fix[0] - fix[1] + fix[2] - fix[3] << endl;
}
