

#include <iostream>
#include <fstream>
#include <algorithm>
#include <cassert>
#include <memory.h>
using namespace std;

const char iname[] = "gaz.in";
const char oname[] = "gaz.out";

const int MAX_N  = 405;
const int MAX_Gi = 1005;
const int INF    = 0x3f3f3f3f;

int bst[2][MAX_N * MAX_Gi], r[2][MAX_N * MAX_Gi];

int main(void) {
    FILE *fi = fopen(iname, "r");
    int L, P, D, C, N, G[MAX_N], S[MAX_N];

    assert(fscanf(fi, "%d %d %d %d", &L, &P, &D, &C) == 4);
    assert(1 <= L && L <= 1000);
    assert(1 <= P && P <= 5000);
    assert(1 <= D && D <= 5000);
    assert(1 <= C && C <= 5000);
    assert(fscanf(fi, "%d", &N) == 1);
    assert(1 <= N && N <= 2000);
    for (int i = 0; i < N; ++ i) {
        assert(fscanf(fi, "%d", &G[i]) == 1);
        assert(1 <= G[i] && G[i] <= 1000);
	}

    S[N] = 0;
    for (int i = N - 1; i >= 0; -- i)
        S[i] = G[i] + S[i + 1];

    int stp = 0;
    memset(bst[stp], INF, sizeof bst[stp]);
    for (int j = G[0]; j <= S[0]; ++ j)
        bst[stp][j] = P;

    for (int i = 1; i < N; ++ i) {
        stp ^= 1;
        memset(bst[stp], INF, sizeof bst[stp]);
        r[stp ^ 1][0] = bst[stp ^ 1][0];
        for (int j = 1; j <= S[i - 1]; ++ j)
            r[stp ^ 1][j] = min(bst[stp ^ 1][j], r[stp ^ 1][j - 1]);
        for (int j = G[i]; j <= S[i]; ++ j) {
            bst[stp][j] = bst[stp ^ 1][j + G[i - 1]] + max(0, j - L) * C;
            bst[stp][j] = min(bst[stp][j], r[stp ^ 1][j + G[i - 1] - 1] + P);
        }
    }

    fprintf(fopen(oname, "w"), "%d\n", bst[stp][G[N - 1]] + S[0] * D);
    printf("%d\n", bst[stp][G[N - 1]] + S[0] * D);
    fclose(fi);
    return 0;
}
