/*
	Implementare cu backtracking
		20 de puncte
*/

#include<fstream>

using namespace std ;

int st[3001], viz[3001], n, top, nrsol ;

int Valid(int top, int i)
{
	if (top == i) return 1 ;
	if ((top > i) && (st[i] != top)) return 0 ;
	return 1 ;
}

void Back(int top)
{
	int i ;
	if (top == n+1) nrsol++ ;
	else
		for (i=1 ; i<=n ; i++)
			if (!viz[i] && Valid(top, i))
			{
				viz[i] = 1 ;
				st[top] = i ;
				Back(top+1) ;
				viz[i] = 0 ;
			}
}

int main()
{
	ifstream fin("petrecere.in") ;
	fin>>n ;
	fin.close() ;
	
	Back(1) ;
	
	ofstream fout("petrecere.out") ;
	fout<<nrsol<<"\n" ;
	fout.close() ;
	
	return 0 ;
}
