//100p n^2 memorizare Marius Nicoli
#include <stdio.h>
#define DIM 1002
#define INF 0x7f7f7f7f

int A[DIM][DIM], L[DIM][DIM], C[DIM][DIM], D[DIM][DIM];
int N, i, j, ii;

int min(int a, int b) {
	return a<b?a:b;
}

int rec(int i, int j) {
	if (D[i][j] != INF)
		return D[i][j];
	if (j == N-i+1) {
		D[i][j] = A[i][j];
		return D[i][j];
	}
	if (j==N-i) {
		D[i][j] = 2*A[i][j] + A[i+1][j] + A[i][j+1];
		return D[i][j];
	}
	
	D[i][j] = min( 	
				(L[i][N-i] - L[i][j-1]) * (N-i+1 - j) + 
				(L[i+1][N-(i+1)+1] - L[i+1][j-1]) * (N-i+1 - j) + 
				2 * (L[i][N-i+1] - L[i][j-1]) - A[i][N-i+1] - A[i][j] + 
				rec(i+1,j),
				
				(C[N-j][j] - C[i-1][j]) * (N-i+1 - j) + 
				(C[N-(j+1)+1][j+1] - C[i-1][j+1]) * (N-i+1 - j) + 
				2 * (C[N-j+1][j] - C[i-1][j]) - A[N-j+1][j] - A[i][j] + 
				rec(i,j+1)
			);
	return D[i][j];
	
}

int main(){
	
	FILE *f = fopen("triunghi.in", "r");
	FILE *g = fopen("triunghi.out", "w");
	fscanf(f,"%d",&N);
	for (ii=1;ii<=N;ii++)
		for (j = 1, i = ii; i>=1; j++, i--) {
			fscanf(f,"%d",&A[i][j]);
			C[i][j] = C[i-1][j] + A[i][j];
			L[i][j] = L[i][j-1] + A[i][j];
			D[i][j] = INF;
		}
	
		
	fclose(f);
	

	fprintf(g,"%d",rec(1,1));
	fclose(g);
	return 0;
}