#include <iostream>
#include <fstream>
#include <algorithm>
#include <cassert>
using namespace std;

const char iname[] = "triunghi.in";
const char oname[] = "triunghi.out";

const int MAX_N = 1005;

#define FOR(i, a, b)  for (int i = (a); i <= (b); ++ i)
#define FORR(i, b, a) for (int i = (b); i >= (a); -- i)

int T[MAX_N][MAX_N], a[2][MAX_N], b[2][MAX_N], bst[2][MAX_N];

int main(void) {
    FILE *fi = fopen(iname, "r");
    int n;

    assert(fscanf(fi, "%d", &n) == 1);
    assert(1 <= n && n <= 1000);
    FOR (i, 1, n) FOR (j, 1, i)
        assert(fscanf(fi, "%d", &T[i][j]) == 1);
    fclose(fi);

    int stp = 0;
    FOR (j, 1, n) a[stp][j] = b[stp][j] = T[n][j], bst[stp][j] = 0;
    FORR (i, n - 1, 1) {
        stp ^= 1;
        FOR (j, 1, i) {
            a[stp][j] = a[stp ^ 1][j + 1] + T[i][j];
            b[stp][j] = b[stp ^ 1][j]     + T[i][j];

            bst[stp][j] = min(bst[stp ^ 1][j] + (2 * a[stp][j] - T[i][j] - T[n][j+n-i]) + (a[stp][j] + a[stp ^ 1][j] - T[n][j+n-i]) * (n - i),
                              bst[stp ^ 1][j + 1] + (2 * b[stp][j] - T[i][j] - T[n][j]) + (b[stp][j] + b[stp ^ 1][j + 1] - T[n][j]) * (n - i));
        }
    }

    fprintf(fopen(oname, "w"), "%d\n", bst[stp][1]);
    printf("%d\n", bst[stp][1]);

    return 0;
}
