# include <fstream>
# include <iostream>
# include <set>
# include <algorithm>
# define DIM 303
using namespace std;
set<int>V;
int n, m, a[DIM][DIM], K, L, Lmax, X, Y;

void read ()
{
	ifstream fin ("submatrix.in");
	fin>>n>>m>>K;
	for(int i=1;i<=n;i++)
		for (int j=1;j<=m;j++)
			fin>>a[i][j];
	if (n>m)
		L=m;
	else
		L=n;
}

int bun (int N)
{
	int nrd;
	for (int ii=1;ii<=n-N+1;++ii)
		for (int jj=1;jj<=m-N+1;++jj)
		{
			nrd=0;
			for(int i=ii;i<=ii+N-1 && nrd<=K;++i)
				for (int j=jj;j<=jj+N-1 && nrd<=K;++j)
					if (!binary_search(V.begin(), V.end(), a[i][j]))
					{
						++nrd;	
						V.insert(a[i][j]);
					}
			if (nrd<=K)
				return 1;
			V.clear ();
		}
	return 0;
}			
					

void solve ()
{
	for (int l=L;l;--l)
		if (bun(l))
		{
			Lmax=l;
			return;
		}
}	

int main ()
{
	read ();
	solve ();
	ofstream fout ("submatrix.out");
	fout<<Lmax<<"\n";
	return 0;
}

