using namespace std;

#include <map>
#include <set>
#include <queue>
#include <ctime>
#include <cmath>
#include <stack>
#include <queue>
#include <cstdio>
#include <bitset>
#include <vector>
#include <fstream>
#include <algorithm>

#define f first
#define s second
#define II inline
#define ll long long
#define mp make_pair
#define pb push_back
#define CC(A) memset((A),0,sizeof((A)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i) = (a);(i) <= (b);++(i))
#define REP(i,b) for(int (i) = 0;(i) < (b);++(i))
#define FORit(it,V) for(__typeof(V.begin()) it = V.begin();it != V.end();++it)

#define IN "submatrix.in"
#define OUT "submatrix.out"
#define V_MAX (1<<17)
#define N_MAX (1<<9)

typedef pair<int,int> pi;
typedef vector<int> VI;

int sum,N,M,K;
int A[N_MAX][N_MAX],C[V_MAX],Q[V_MAX];

II void scan()
{
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);
	
	scanf("%d%d%d",&N,&M,&K);
	
	FOR(i,1,N)
	FOR(j,1,M)
	{
		scanf("%d",&A[j][i]);
		Q[++Q[0]] = A[j][i];
	}
}

II int find(int val)
{
	int m,step;
	for(step = 1;step <= Q[0];step <<= 1);
	for(m = 1;step;step >>= 1)
		if(m + step <= Q[0] && Q[m + step - 1] < val)
			m += step;
	return m;
}

II void add(int val)
{
	if(!C[val]) ++sum;
	++C[val];
}

II void del(int val)
{
	--C[val];
	if(!C[val]) --sum;
}

II bool compute(int G)
{
	FOR(i,G,N)
	{
		CC(C);
		sum = 0;
		
		FOR(j,1,M)
		{
			FOR(k,i - G + 1,i)
				add(A[j][k]);
			
			if(j < G)
				continue;
			
			if(sum <= K)
				return true;
			FOR(k,i - G + 1,i) 
				del(A[j - G + 1][k]);
		}
	}
	return false;
}

II void solve()
{
	sort(Q+1,Q+Q[0]+1);
	
	int aux = Q[0];
	Q[0] = 1;
	FOR(i,2,aux)
		if(Q[i] ^ Q[i-1])
			Q[++Q[0]] = Q[i];
	
	FOR(i,1,N)
	FOR(j,1,M)
		A[j][i] = find(A[j][i]);
	
	int m,step;
	for(step = 1;step <= min(N,M);step <<= 1);
	for(m = 1;step;step >>= 1)
		if(m + step <= min(N,M) && compute(m + step) )
			m += step;
	
	printf("%d\n",m);
}

int main()
{
	scan();
	solve();
	return 0;
}
