#include <cstdio>
#include <list>
#include <cstring>
#define MAXN 10010
using namespace std;
int N,M;
list<int> G[MAXN],Gt[MAXN];
char used[MAXN],usedt[MAXN];
int Nu,Nut;
list<int> L;

void BFS(int start){
	L.push_back(start);
	while (!L.empty()){
		int nod=*(L.begin());
		while (!G[nod].empty()){
			int vecin=*(G[nod].begin());
			if (used[vecin]==0){
				++Nu;
				used[vecin]=1;
				L.push_back(vecin);
			}
			G[nod].pop_front();
		}
		L.pop_front();
	}
}

void BFSt(int start){

	L.push_back(start);
	while (!L.empty()){
		int nod=*(L.begin());
		while (!Gt[nod].empty()){
			int vecin=*(Gt[nod].begin());
			if (usedt[vecin]==0){
				++Nut;
				usedt[vecin]=1;
				L.push_back(vecin);
			}
			Gt[nod].pop_front();
		}
		L.pop_front();
	}
}


int main(){

	scanf("%d%d",&N,&M);
	
	Nu=1;
	Nut=1;
	
	memset(used,0,sizeof(used));
	memset(usedt,0,sizeof(usedt));

	used[1]=1;
	usedt[1]=1;
	
	int TC;
	if (N==Nu && N==Nut){
		TC=1;
		printf("1\n");
		fflush(stdout);
	} else TC=0;

	int X,Y;
	while (TC==0){
		printf("0\n");
		fflush(stdout);

		scanf("%d%d",&X,&Y);
		G[X].push_back(Y);
		if (used[X]) BFS(X);

		Gt[Y].push_back(X);
		if (usedt[Y]) BFSt(Y);

		if (N==Nu && N==Nut) { TC=1; printf("1\n"); fflush(stdout); }
	}

	return 0;
}
