#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int N, M, final;
vector<int> G[10005], Gt[10005];
int viz[10005], timp[10005];

void DFS(int nod) {
	if(viz[nod]) return;
	viz[nod]=1;
	for(vector<int>::iterator it=G[nod].begin(); it!=G[nod].end(); it++) {
		DFS((*it));
	}
	timp[++final]=nod;
}

void BFS(int nod) { //pe graful transpus
	int p;
	queue<int> Q;
	viz[nod]=1;
	Q.push(nod);
	while(!Q.empty()) {
		p=Q.front(); Q.pop();
		for(vector<int>::iterator it=Gt[p].begin(); it!=Gt[p].end(); it++) {
			if(!viz[(*it)]) {
				viz[(*it)]=1;
				Q.push((*it));
			}
		}
	}
}

int main() {
	int i, x, y, nr;
	cin>>N>>M;
	cout<<"0\n";
	cout.flush();
	int ok=1;
	while(ok) {
		cin>>x>>y;
		G[x].push_back(y);
		Gt[y].push_back(x);
		final=0; nr=0; ok=0;
		memset(timp, 0, sizeof(timp));
		memset(viz, 0, sizeof(viz));
		DFS(x);
		memset(viz, 0, sizeof(viz));
	    for(i=final; i>=1; i--) {
			//fac BFS dupa timp[i]
			if(!viz[timp[i]]) {
				nr++;
				BFS(timp[i]);
			}
		}
		if(nr>1) {
			ok=1;
			cout<<"0\n";
			cout.flush();
		}
		else {
			ok=0;
			cout<<"1\n";
			cout.flush();
		}
	}
	return 0;
}