#include <iostream>
#include <queue>
using namespace std;


struct nod{
    vector<int> v;
    bool s;
    nod():s(false){}
};

void fill(vector<nod>& graf,int n,int& nr){
    nod& temp=graf[n];

    if(temp.s){
        queue<int> noduri;

        for(int i=0;i<temp.v.size();i++){
            if(!graf[temp.v[i]].s){
                noduri.push(temp.v[i]);
            }
        }

        while(!noduri.empty()){
            nod& temp=graf[noduri.front()];
            noduri.pop();

            temp.s=true;
            nr++;
            for(int i=0;i<temp.v.size();i++){
                if(!graf[temp.v[i]].s){
                    noduri.push(temp.v[i]);
                }
            }
        }
    }
}



int main(){
    int n,m;
    scanf("%d %d",&n,&m);

    vector<nod> graf_d(n);
    vector<nod> graf_s(n);
    int d=1;int s=1;
    graf_d[0].s=true;
    graf_s[0].s=true;

    while(s<n or d<n){
        cout<<"0\n";cout.flush();
        int x,y;
        scanf("%d %d",&x,&y);
        x--;y--;

        graf_d[x].v.push_back(y);
        fill(graf_d,x,d);

        graf_s[y].v.push_back(x);
        fill(graf_s,y,s);
    }

    cout<<"1\n";cout.flush();
    return 0;

}

