#include <algorithm>
#include <vector>
#include <bitset>
using namespace std;

#define pb push_back
#define DIM 10005

vector <int> g[DIM],gt[DIM];
int postviz[DIM];
bitset <DIM> viz;
int n,m,k,nrcc;

void df (int nod)
{
    vector <int> :: iterator it;

    viz[nod]=1;
    for (it=g[nod].begin (); it!=g[nod].end (); ++it)
        if (!viz[*it])
            df (*it);
    postviz[nod]=++k;
}

void dft (int nod)
{
    vector <int> :: iterator it;
    viz[nod]=0;

    for (it=gt[nod].begin (); it!=gt[nod].end (); ++it)
        if (viz[*it])
            dft (*it);
}

inline int conex ()
{
    int i;

    nrcc=k=0;
    viz.reset ();
    for (i=1; i<=n; ++i)
        if (!viz[i])
        {
            if (++nrcc>1)
                return 0;
            df (i);
        }
    nrcc=0;
    for (i=n; i>=1; --i)
        if (viz[postviz[i]])
        {
            if (++nrcc>1)
                return 0;
            dft (postviz[i]);
        }
    return 1;
}

int main ()
{
    int x,y;

    scanf ("%d%d",&n,&m);
    do
    {
        printf ("0\n"); fflush (stdout);
        scanf ("%d%d",&x,&y);
        g[x].pb (y);
        gt[y].pb (x);
    }
    while (!conex ());
    printf ("1\n"); fflush (stdout);

    return 0;
}
