#include <iostream>
#include <fstream>

using namespace std;

#define INF 500

ifstream fin("kmax.in");
ofstream fout("kmax.out");

unsigned int n, k, r, nr, c = 1, a[300];
bool mark[300];

typedef unsigned int _ui;

inline unsigned int fact(unsigned int x, unsigned int m)
{
	if (x == 1) return 1;
	else return (x * fact(x - 1, m) % m);
}

inline void gen(unsigned int x)
{
	unsigned int oldc;
	
	if (x == n + 1)
	{
		if (nr == r - 1) nr = 0;
		else ++nr;
		
		--c;
		
		return;
	}
	
	for (unsigned int i = 1; i <= n; ++i)
	{
		if (!mark[i])
		{
			mark[i] = true; a[x] = i; oldc = c;
			
			if (i > a[x - 1]) ++c;
			else c = 1;
			
			if (c <= k) gen(x + 1);
			else
			{
				mark[i] = false;
				c = oldc;
				break;
			}
				
			mark[i] = false;
			c = oldc;
		}
	}	
}

int main()
{
	fin >> n >> k >> r;
	
	if (k == 1)
	{
		fout << 1; return 0;
	}
	if (k == n)
	{
		fout << fact(n, r) % r;
		return 0;
	}
	if (k == n - 1)
	{
		fout << (fact(n, r) - 1) % r;
		return 0;
	}
	
	a[0] = INF;
	
	gen(1);
	fout << nr;
	
	return 0;
}
