#include <fstream>
#include <set>

#define NMAX 310
using namespace std;

multiset<int> S;

int N, M, K, A[NMAX][NMAX], Found, Sol;

inline void Insereaza(int x)
{
	if (S.find(x) == S.end())
		Found++;
	
	S.insert(x);
}

inline void Deleteaza(int x)
{
	S.erase(S.find(x) );
	
	if (S.find(x) == S.end())
		Found--;
}

inline int Minim(int a, int b)
{
	if (a > b) return b;
	else return a;
}

void Citire(void)
{
	ifstream fin("submatrix.in");
	
	fin >>N >>M >>K;

	int i, j;
	
	for (i = 1; i <= N; i++)
		for (j = 1; j <= M; j++)
			fin >>A[i][j];
	
	fin.close();
}

void Solve(void)
{
	int st, end,m, i, j, k, l, ii, jj, ok = 0;
	
	end = Minim(N, M);
	st = 0;
	
	while(st <= end)
	{
		m = (st + end)  / 2;
		
		ok = 0;
		
		for (i = 1; i <= N - m + 1 && !ok; i++)
		{
			Found = 0;
			S.clear();
			for (ii = i; ii <= i + m - 1; ii++)
				for (jj = 1; jj <= m; jj++)
					Insereaza(A[ii][jj]);
				
			if (Found <= K) Sol = m, st = m + 1, ok = 1;
			
			for (j = 1; Found > K && j <= M - m; j++)
			{
				for (ii = i; ii <= i + m - 1; ii++)
					Deleteaza(A[ii][j]), Insereaza(A[ii][j+m]);
				if (Found <= K) Sol = m, st = m + 1, ok = 1;
			}
		}
		
		if (!ok) end = m - 1;
	}
}

void Afiseaza(void)
{
	ofstream fout("submatrix.out");
	
	fout <<Sol;
	
	fout.close();
}

int main()
{
	Citire();
	
	Solve();
	
	Afiseaza();
	
}
