#include<stdio.h>
struct elem
{
	unsigned int val;
	int aparitii;
};
struct nod
{
	elem elm;
	nod *s,*d;
};

int n,m,k,mat_elems;
unsigned int mat[305][305];
nod *heap;

int add2heap(nod *nd,unsigned int val)
{
	nod *tmp;
	if(val == nd->elm.val)
	{
		nd->elm.aparitii++;
		return 0;
	}
	else if(val < nd->elm.val)
	{
		if(nd->s == 0)
		{
			tmp = new nod;
			tmp->s = tmp->d = 0;
			tmp->elm.val = val;
			tmp->elm.aparitii = 1;
			nd->s = tmp;
			return 1;
		}
		else
			return add2heap(nd->s,val);
	}
	else
	{
		if(nd->d == 0)
		{
			tmp = new nod;
			tmp->s = tmp->d = 0;
			tmp->elm.val = val;
			tmp->elm.aparitii = 1;
			nd->d = tmp;
			return 1;
		}
		else
			return add2heap(nd->d,val);
	}
}

int takeSimHeap(nod *nd,unsigned int val, int cnt)
{
	if(val == nd->elm.val)
	{
		if(cnt == nd->elm.aparitii)
			return 1;
		else return 0;
	}
	else if(val <= nd->elm.val)
		return takeSimHeap(nd->s,val,cnt);
	else
		return takeSimHeap(nd->d,val,cnt);
}

void deleteRecHeap(nod *nd)
{
	if(nd==0)return;
	if(nd->s)deleteRecHeap(nd->s);
	if(nd->d)deleteRecHeap(nd->d);
	delete nd;
}

int makeDifHeaps(nod *main_heap,nod *sec_heap)//walk on sec, test on main
{
	if(sec_heap==0)return 0;
	int sum = 0;
	if(sec_heap->s)sum += makeDifHeaps(main_heap, sec_heap->s);
	if(sec_heap->d)sum += makeDifHeaps(main_heap, sec_heap->d);
	sum += takeSimHeap(main_heap,sec_heap->elm.val,sec_heap->elm.aparitii);
	return sum;
}

int testMatrix(int sl,int sc, int lvl)
{
	int i,j;
	nod *tmp_heap = 0;
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			if((i<sl||i>=sl+lvl)||(j<sc||j>=sc+lvl))
			{
				if(tmp_heap)
				{
					add2heap(tmp_heap,mat[i][j]);
				}
				else
				{
					tmp_heap = new nod;
					tmp_heap->s = tmp_heap->d = 0;
					tmp_heap->elm.val = mat[i][j];
					tmp_heap->elm.aparitii = 1;
				}
			}
	int outs = makeDifHeaps(heap,tmp_heap);
	deleteRecHeap(tmp_heap);
	if(mat_elems - outs <= k)
		return lvl;
	else return 0;
}

int main()
{
	int i,j;
	freopen("submatrix.in","r",stdin);
	freopen("submatrix.out","w",stdout);
	scanf("%d %d %d",&n,&m,&k);
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			scanf("%u",&mat[i][j]); 
	heap = new nod;
	heap->elm.val = mat[1][1];
	heap->elm.aparitii = 1;
	heap->s = heap->d = 0;
	mat_elems++;
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			if(i+j!=2)
				mat_elems += add2heap(heap,mat[i][j]);
	int lvl = n;
	if(lvl>m)lvl = m;
	int gasit = 0;
	while(!gasit&&lvl>=1)
	{
		for(i=1;i<=n-lvl+1;i++)
			for(j=1;j<=m-lvl+1;j++)
			{
				gasit = testMatrix(i,j,lvl);
				if(gasit)break;
			}
		lvl--;
	}
	printf("%d",gasit);
	return 0;
}
