#include<ifstream.h>
#include<stdio.h>
#include<set>

using namespace std;

#define Nmax 10005

set <int> l[Nmax],li[Nmax];
int t[Nmax],ti[Nmax];
int N,M;
char nr[Nmax],nri[Nmax];
int Sum,Sumi;

inline int find(int x)
{
    int y=x,z;
    for(; t[x] ;x=t[x]);
    while( t[y] )
        {
        z = t[y];
        t[y]=x;
        y=z;
        }
    return x;
}

inline void unite(int x,int y)
{
    x=find(x);
    t[y]=x;
    set<int>::iterator it;
    for(it=l[y].begin();it!=l[y].end();++it)
        l[x].insert( *it );
    l[y].clear();
}

inline int findi(int x)
{
    int y=x,z;
    for(; ti[x] ;x=ti[x]);
    while( ti[y] )
        {
        z = ti[y];
        ti[y]=x;
        y=z;
        }
    return x;
}

inline void unitei(int x,int y)
{
    x=findi(x);
    ti[y]=x;
    set<int>::iterator it;
    for(it=li[y].begin();it!=li[y].end();++it)
        li[x].insert( *it );
    li[y].clear();
}

int main()
{
    int a,b,ok;
    scanf("%d %d",&N,&M);
    int i;
    for(i=1,ok=0;!ok && i<=M;++i)
        {
        cout << "0\n";
        cout.flush();
        scanf("%d %d",&a,&b);
        if (!nr[a])
            nr[a]++ , Sum++;
        if (!nri[b])
            nri[b]++ , Sumi++;
        if (find(a) != find(b) && b!=1)
            if (!t[b])
                {
                l[find(a)].insert(b);
                unite(a,b);
                }
            else
            if (findi(b)==findi(find(b)))
                {
                l[find(a)].insert(find(b));
                unite(a,find(b));
                }

        if (findi(a) != findi(b) && a!=1)
            if (!ti[a])
                {
                li[findi(b)].insert(a);
                unitei(b,a);
                }
            else
            if (find(a)==find(findi(a)))
                {
                li[findi(b)].insert(findi(a));
                unitei(b,findi(a));
                }

        if ((int)l[1].size()==N-1 && (int)li[1].size()==N-1 && Sum==N && Sumi==N)
            ok=1;
        }

    cout << "1\n";
    cout.flush();
    return 0;
}
