#include <stdio.h>
#define MAXN 301
#define FOR(i,a,b) for (i=a;i<=b;++i)

int n,k,r,i,j,l;
int Komb[MAXN][MAXN];
int dp[MAXN][MAXN];
int ossz[MAXN];

inline int min(int a,int b)
{
    if (a < b) return a;
    return b;
}

int main()
{
    freopen("kmax.in","r",stdin);
    freopen("kmax.out","w",stdout);

    scanf("%d %d %d\n",&n,&k,&r);

    Komb[1][0] = 1;
    Komb[1][1] = 1;
    FOR (i,2,n)
    {
        Komb[i][0] = 1;
        Komb[i][i] = 1;
        FOR (j,1,i-1) Komb[i][j] = (Komb[i-1][j]+Komb[i-1][j-1]) % r;
    }

    dp[1][1] = 1;
    ossz[1] = 1;
    ossz[0] = 1;

    FOR (i,2,n)
    {
        FOR (j,0,i-2)
        {
            FOR (l,1,min(i-j-1,k))
            {
                dp[i][l] += ((Komb[i-1][j]*ossz[j]) % r)*dp[i-j-1][l];
                dp[i][l] %= r;
            }
        }

        FOR (l,1,k-1)
        {
            dp[i][l+1] += dp[i-1][l];
            dp[i][l+1] %= r;
        }

        FOR (l,1,k-1)
        {
            ossz[i]+=dp[i][l];
            ossz[i] %= r;
        }
    }

    /*FOR (i,1,n)
    {
        FOR (j,1,k)
            printf("%d ",dp[i][j]);
        printf("\n");
    }

    FOR (i,1,n) printf("%d\n",ossz[i]);*/
    if (k > 1) printf("%d\n",(ossz[n]+dp[n][k]) % r);
    else       printf("1\n");

    return 0;
}

