#include <stdio.h>
#include <vector>
#include <algorithm>
#define MAXN 301
#define MAXK 300*300+10
#define FOR(i,a,b) for(i=a;i<=b;++i)

using namespace std;

vector<int> v;
vector<int>::iterator it;
int n,m,k,i,j,l,db,res;
int t[MAXN][MAXN];
int szamok[MAXK];
int viz[MAXK];

int valid(int x,int y,int m)
{
    int i,j,res=0;

    FOR (i,1,db) viz[i] = 0;

    FOR (i,x,x+m-1)
        FOR (j,y,y+m-1)
            if (!viz[t[i][j]])
            {
                res++;
                viz[t[i][j]] = 1;
            }

    if (res <= k) return 1;
    return 0;

}

int poz(int x)
{
    int a=1,b=db;
    while (a < b)
    {
          if (szamok[a] == x) b = a;
          else if (szamok[b] == x) a = b;
          else if (szamok[(a+b) /2] < x) a = (a+b)/2 + 1;
          else if (szamok[(a+b) /2] > x) b = (a+b)/2 - 1;
          else if (szamok[(a+b) /2] == x)
          {
              a = (a+b)/2;
              b = (a+b)/2;
          }
    }

    return a;
}

int main()
{
    freopen("submatrix.in","r",stdin);
    freopen("submatrix.out","w",stdout);

    scanf("%d %d %d\n",&n,&m,&k);
    FOR (i,1,n)
    {
        FOR (j,1,m)
        {
            scanf("%d ",&t[i][j]);
            v.push_back(t[i][j]);
        }
        scanf("\n");
    }

    sort(v.begin(),v.end());

    it = v.begin();
    db = 1;
    szamok[db] = *it;
    while (it != v.end())
    {
          while ((it != v.end()) && ((*it) == szamok[db])) ++it;
          if (it != v.end())
          {
              db++;
              szamok[db] = *it;
              ++it;
          }
    }

    FOR (i,1,n)
        FOR (j,1,m)
            t[i][j] = poz(t[i][j]);

    FOR (i,1,n)
        FOR (j,1,m)
            FOR (l,1,n)
            {
                if ((i+l-1 <= n) && (j+l-1 <= m))
                {
                    if ((valid(i,j,l)) && (l > res)) res = l;
                }
            }

    printf("%d\n",res);

    return 0;
}
