#include <stdio.h>
#include <vector>
#include <queue>
#include <fstream>
#include <algorithm>
#include <string>
#include <math.h>
#define IN "submatrix.in"
#define OUT "submatrix.out"
#define L 305
#define P 666013

using namespace std;

int n, m, k;
int mat[L][L], mod[L][L];

struct lol
{
    int inf;
    int ap;
};

vector <lol> V[P*2];
vector <lol> :: iterator it;
int Rez;

void citire()
{
    scanf ("%d %d %d", &n, &m, &k);
    for (int i=0;i<n;i++)
        for (int j=0;j<m;j++)
        {
            scanf ("%d", &mat[i][j]);
            mod[i][j]=mat[i][j]%P+P;
        }
}

int cauta(int X,int Nr)
{
    for (int i=0;i<V[Nr].size();i++)
        if (V[Nr][i].inf==X)
        {
            V[Nr][i].ap++;
            return 1;
        }
    return 0;
}

int sterge(int nr,int x)
{
    int kk=0;
    for (it=V[x].begin(); it!=V[x].end();it++, kk++)
    {
        lol MM=*it;
        if (MM.inf == nr)
        {
            MM.ap--;
            V[x][kk].ap--;
            if (MM.ap==0)
            {
                V[x].erase(it);
                return 1;
            }
            return 0;
        }
    }
    return 0;
}

int ok(int lg)
{
    lol Pct;
    Pct.ap=1;
    int num=0;
    for (int l=0 ; l<n-lg+1 ; l++)
        {
            num=0;
            for (int i=l;i<l+lg;i++)
                for (int j=0;j<lg;j++)
                    if (!cauta(mat[i][j], mod[i][j]))
                    {
                        Pct.inf=mat[i][j];
                        V[mod[i][j]].push_back(Pct);
                        num++;
                    }
            if (num<=k)
            {
                for (int i=l;i<l+lg;i++)
                    for (int j=0;j<l+lg;j++)
                        sterge(mat[i][j],  mod[i][j]);

                return 1;
            }

            for (int j=1;j<m-lg+1;j++)
            {
                for (int o=l;o<l+lg;o++)
                    num-=sterge(mat[o][j-1], mod[o][j-1]);

                for (int o=l;o<l+lg;o++)
                    if (!cauta(mat[o][j+lg-1], mod[o][j+lg-1]))
                    {
                        Pct.inf=mat[o][j+lg-1];
                        V[mod[o][j+lg-1]].push_back(Pct);
                        num++;
                    }
                if (num<=k)
                {
                      for (int o=l;o<l+lg;o++)
                        for (int h=j;h<j+lg;h++)
                            sterge(mat[o][h],  mod[o][h]);
                    return 1;
                }
            }
            for (int o=l;o<l+lg;o++)
                for (int h=m-lg;h<m;h++)
                    sterge(mat[o][h],  mod[o][h]);
        }
    return 0;
}

void solve()
{
    int st=1;
    int dr=min(n,m);
    int mij;
    while (st<=dr)
    {
        mij=(st+dr)>>1;
        if (ok(mij))
        {
            if (mij>Rez)
                Rez=mij;
            st=mij+1;
        }
        else
            dr=mij-1;
    }
    printf("%d\n", Rez);
}

int main ()
{
    freopen (IN , "r",  stdin);
    freopen (OUT ,  "w",  stdout);
    citire();
    solve();
    printf("\n");
    return 0;
}

