using namespace std;
#include<cstdio>
#include<vector>
const int MAX_N = 10007;
int N, low[MAX_N], niv[MAX_N], M;
vector<int>G[MAX_N];
bool gi[MAX_N], go[MAX_N];
int Si, Se;
inline void DF(int x, int n)
{
	if(niv[x]) return;
	unsigned i; int y;
	low[x] = niv[x] = n;
	for(i = 0; i < G[x].size(); ++i)
	{
		y = G[x][i];
		DF(y, n+1);
		if(low[y] < low[x]) low[x] = low[y];
	}
	
}
inline void DFS(int x)
{
	if(niv[x]) return;
	unsigned i; int y;
	niv[x] = 1;
	for(i = 0; i < G[x].size(); ++i)
	{
		y = G[x][i];
		DFS(y);
		if(low[y] < low[x]) low[x] = low[y];
	}
	
}
int main()
{
	scanf("%d %d",&N,&M);
	int x, y, i, ok;
	for(;M;--M)
	{
		ok = 0;
		if( Se == N && Si == N )
		{
			for(i = 1; i <= N; ++i) niv[i] = 0;
			DF(1, 1);
			for(i = 1; i <= N; ++i) niv[i] = 0;
			DFS(1);
			for(i = 1, ok = 1; i <= N; ++i)
				if(low[i] != 1) ok = 0;
		}
		if(ok == 0)
		{
			printf("0\n");
			fflush(stdout);
		}
		else
		{
			printf("1\n");
			fflush(stdout);
			return 0;
		}
		scanf("%d %d",&x,&y);
		if(!gi[y]) { gi[y] = 1; Si++; }
		if(!go[x]) { go[x] = 1; Se++; }
		G[x].push_back(y);
	}
	printf("1\n");
	fflush(stdout);
	return 0;
}
