#include <cstdio>
#include <vector>

using namespace std;

const int MAX_N = 10005;

char din[MAX_N], to[MAX_N];
int N, M, Nri = 1, Nrf = 1, run = 1;
vector <int> Gin[MAX_N], Gout[MAX_N];

void dfp(int nod)
{
    if(!din[nod])
    {
        din[nod] = 1;
        ++Nri;
    }
    
    for(vector <int> ::iterator it = Gin[nod].begin(); it != Gin[nod].end(); ++it)
        if(!din[*it])
            dfp(*it);
}

void dfm(int nod)
{
    if(!to[nod])
    {
        to[nod] = 1;
        ++Nrf;
    }

    for(vector <int> ::iterator it = Gout[nod].begin(); it != Gout[nod].end(); ++it)
        if(!to[*it])
            dfm(*it);
}

void solve()
{
    int x, y;
    scanf("%d %d", &x, &y);

    Gin[x].push_back(y);
    Gout[y].push_back(x);
    
    if(din[x] == 1)
        dfp(x);

    if(to[y] == 1)
       dfm(x);

    if(Nri == N && Nrf == N)
    {
        printf("1\n");
        fflush(stdout);
        run = 0;
    }
    else
    {
        printf("0\n");
		fflush(stdout);
	}
/*    fprintf(stderr, "%d ", Nri);
    for(int i = 1; i <= N; ++i)
        fprintf(stderr, "%d ", din[i]);
    fprintf(stderr, "\n%d ", Nrf);
    for(int i = 1; i <= N; ++i)
        fprintf(stderr, "%d ", to[i]);
    fprintf(stderr, "\n\n");   */
}

int main()
{
/*    freopen("conex.in","rt",stdin);
    freopen("conex.out","wt",stdout);  */

    scanf("%d %d", &N, &M);

    din[1] = 1;
    to[1] = 1;
    if(N > 1)
    {
    	printf("0\n");
    	fflush(stdout);
	}
	
    else
    {
    	printf("1\n");
    	fflush(stdout);
    	return 0;
	}

    for(int i = 1; i <= M && run; ++i)
        solve();
    return 0;
}
