#include <fstream>
#include <algorithm>

using namespace std;

const int MAX_N = 305;

ifstream fin ("submatrix.in");
ofstream fout ("submatrix.out");

int N, M, K, P, A[MAX_N][MAX_N], V[MAX_N * MAX_N], Sol;
char viz[MAX_N * MAX_N];

void citire()
{
	fin >> N >> M >> K;
	
	for(int i = 1; i <= N; ++i)
		for(int j = 1; j <= M; ++j)
		{
			fin >> A[i][j];
			V[++P] = A[i][j];
		}
}

void norm()
{
	sort(V+1, V+P+1);
	P = unique(V+1, V+P+1) - V-1;
	
	for(int i = 1; i <= N; ++i)
		for(int j = 1; j <= M; ++j)
			A[i][j] = lower_bound(V+1, V+P+1, A[i][j]) - V;
			
	/*for(int i = 1; i <= N; ++i)
	{
		for(int j = 1; j <= M; ++j)
			fprintf(stderr, "%d ", A[i][j]);
			
		fprintf(stderr, "\n");
	}*/
}

void solve()
{
	for(int i = 1; i <= N; ++i)
		for(int j = 1; j <= M; ++j)
		{
			memset(viz, 0, sizeof viz);
		
			int Nrm = 1;
			viz[A[i][j]] = 1;
			for(int l = 1; l <= N; ++l)
			{
				if(i + l > N || j + l > M) break;
				
				for(int x = i; x <= i+l; ++x)
					if(!viz[A[x][j+l]])
					{
						viz[A[x][j+l]] = 1;
						++Nrm;
					}
				
				for(int x = j; x <= j+l; ++x)
					if(!viz[A[i+l][x]])
					{
						viz[A[i+l][x]] = 1;
						++Nrm;
					}
					
				if(l > Sol && Nrm <= K)
					Sol = l;
			}
		}
		
	//fprintf(stderr, "%d\n", Sol);	
	fout << Sol+1 << "\n";
}

int main()
{
	citire();
	norm();
	solve();
	return 0;
}
