#include <cstdio>
#include <vector>
using namespace std;

#define NMAX 10050

vector <int> graf[NMAX];

long ok, a, b, m, n, aux, mnum, viz, num, visited[NMAX];


void DFS(long node)
{
	if (visited[node] != viz)
	{
		visited[node] = viz;
		++num;
		if (graf[node].size())
		{
			for (long i = 0; i <= graf[node].size(); ++i)
				if (graf[node][i])
					DFS(graf[node][i]);
		}
	}
}

int conex()
{
	num = 0;
	++viz;
	DFS(b);
	if (num != n)
		return 0;
	
	num = 0;
	++viz;
	DFS(a);
	if (num != n)
		return 0;

	for (long i = n; i >= 1; --i)
	{
		if (i != a && i != b)
		{
			num = 0;
			++viz;
			DFS(i);
			if (num != n)
				return 0;
		}
	}
	
	return 1;
}

int main()
{
	scanf("%ld %ld", &n, &m);
	
	if (n == 1)
	{
		printf("1\n");
		fflush(stdout);
		return 0;
	}
	else
	{
		printf("0\n");
		fflush(stdout);
	}

	scanf("%ld %ld", &a, &b);
	graf[a].push_back(b);
	while (mnum <= m)
	{
		++mnum;
		if (mnum < n)
			aux = 0;
		else
			aux = conex();

		if (aux)
		{
			printf("%ld\n", aux);
			fflush(stdout);
			return 0;
		}
		else
		{
			printf("%ld\n", aux);
			fflush(stdout);
			scanf("%ld %ld", &a, &b);
			graf[a].push_back(b);
		}
	}

	printf("%ld\n", conex());
	
	return 0;
}

