#include <fstream>

#include <cstdlib>

using namespace std;

#define BASE 10000
#define SIZE 10000

int factn(int n){
        int p=1;
        while(n){
            p*=n;
            n--;
        }
        return p;
}

void prod(int* a,int* b,int* c){
    int i,j,t,l=0;
    for(i=1;i<a[0]+b[0];i++)
        c[i]=0;
    t=0;
    for(i=1;i<=a[0];i++)
        for(j=1;j<=b[0]||t;j++){
            if(i+j-1>l)
                l=i+j-1;
            c[i+j-1]+=a[i]*b[j]+t;
            if(c[i+j-1]>=BASE){
                    t=c[i+j-1]/BASE;
                    c[i+j-1]%=BASE;
                }
            else
                t=0;
        }
    c[0]=l;
}
int* init(){
    int* tmp=new int[SIZE];
    int i;
    for(i=0;i<SIZE;i++)
        tmp[i]=0;
    return tmp;
    }

int* init(int n){
    int i=1;
    int* t=init();
    while(n){
        t[i++]=n%BASE;
        n/=BASE;
        }
    t[0]=i-1;
    return t;
    }

int div(int* a,int b, int* c){
        int i,t=0;
        int* x=init();
        int* w=init();
        w[0]=a[0];
        for(i=a[0];i>0;i--)
            w[a[0]-i+1]=a[i];
        for(i=1;i<=a[0];i++){
            x[i]=(t*BASE+w[i])/b;
            t=(t*BASE+w[i])%b;
        }
        int s=0;
        for(i=1;i<SIZE;i++)
            if(x[i]){
                s=i;
                break;
            }
        for(i=1;i<SIZE;i++)
            if(x[i])
                t=i;
        c[0]=t-s+1;
        for(i=1;i<=t;i++)
            c[i]=x[t-i+1];

        return t;
}

void sum(int* a,int* b){
        int i,t=0;
        for(i=1;i<=a[0]||i<=b[0]||t;i++){
                a[i]+=b[i]+t;
                if(a[i]>=BASE){
                    t=1;
                    a[i]-=BASE;
                }
                else
                    t=0;
            }

}

void sub(int* a,int* b){
        int i;
        int t=0;

        for(i=1;i<=b[i]||t;i++){
            a[i]-=b[i];
            a[i]-=t;
            if(a[i]<0){
                a[i]+=BASE;
                t=1;
            }
            else
                t=0;
        }
}

int* fact(int n,int k){
    int* m=init(n);
    int* a=init(1);

    int* x=init(1);
    int* y=init(1);
    int* aux;


    int i;
    for(i=n;i>n-k;i--){
        prod(x,m,y);
        aux=x;
        x=y;
        y=aux;
        sub(m,a);
    }

    return y;
}


int* res(int n,int k){
    if(k==n)
        return init(1);
    else{
            int* f=fact(n,k);
            int* r=res(n,k+1);
            int* t=init();
            for(int i=0;i<SIZE;i++)
                t[i]=f[i];
            div(t,factn(k),f);
            sub(f,r);


            return f;
    }
}

int main()
{
    ifstream in("kmax.in");
    ofstream out("kmax.out");

    int n,k,r;

    in>>n>>k>>r;

    if(n<10){

            int l=0;
            int st[10];
            int i,j,max;
            int ct=0;
            for(i=0;i<n;i++)
                st[i]=0;
            while(l>=0){
                    if(st[l]==n){
                            st[l]=0;
                            l--;
                            continue;
                        }
                    else
                        st[l]++;

                    for(i=0;i<l;i++)
                        if(st[l]==st[i])
                            break;
                    if(i<l)
                        continue;

                    if(l==n-1){
                            j=1;
                            max=0;
                            for(i=1;i<n;i++)
                                if(st[i]>st[i-1]){
                                    j++;
                                    if(j>max)
                                        max=j;
                                }
                                else
                                    j=1;
                            if(max<=k)
                                ct++;
                            continue;
                        }

                    l++;
                }

            out<<ct%r<<'\n';
    }
    else{
            int* c=res(n,k);
            int* x=init();
            int y=div(c,r,x);

            out<<y<<'\n';
        }

	return 0;
}
