program conexx;
type Lista=^TipLista;
     TipLista=record
                nod:integer;
                leg:Lista;
              end;
     muchii=array[1..10000] of Lista;
     vizitat=array[1..10000] of boolean;
     vec=array[1..10000] of integer;

var muc:muchii;
    n,x,y:integer;
    viz,nodConex:vizitat;
    v:vec;
    m,k:longint;

  Procedure Init;
    var i:integer;
    begin
      For i:=1 to n do
       begin
        muc[i]:=nil;
        nodConex[i]:=false;
       end;
    end;

  Procedure InitViz;
    var i:integer;
    begin
      For i:=1 to n do
         viz[i]:=false;
    end;

  Procedure Add(var muc:muchii);
    var nou:lista;
    begin
      new(nou);
      nou^.nod:=y;
      nou^.leg:=nil;
      nou^.leg:=muc[x];
      muc[x]:=nou;
    end;

  Function NuEste(l:lista;y:integer):boolean;
    var el:lista;
    begin
      el:=l;
      NuEste:=true;
      while el<>nil do
          begin
            If el^.nod=y then
                begin
                  NuEste:=false;
                  break;
                end;
            el:=el^.leg;
          end;
    end;

  Function Vecin(a,b:integer):boolean;
    var el:lista;
    begin
      el:=muc[a];
      Vecin:=false;
      while el<>nil do
        begin
          If el^.nod=b then
                begin
                  Vecin:=true;
                  break;
                end;
          el:=el^.leg;
        end;
    end;

  Procedure ParcurgeLatime(nodPlecare:integer;var conex:boolean);
    var i,j,h:integer;
    begin
      InitViz;
      conex:=false;
      v[1]:=nodPlecare;
      viz[nodPlecare]:=true;
      i:=1;
      j:=1;
      while i<=j do
        begin
          For h:=1 to n do
             If Vecin(v[i],h) and (not viz[h]) then
               begin
                 j:=j+1;
                 v[j]:=h;
                 viz[h]:=true;
                 If j=n then conex:=true;
               end;
          i:=i+1;
        end;
    end;

  Function GrafTareConex:boolean;
    var i,nr:integer;
        conex:boolean;
    begin
      nr:=0;
      GrafTareConex:=false;
      For i:=1 to n do
        If not Nodconex[i] then
           begin
             ParcurgeLatime(i,conex);
             If conex then
                  begin
                    nodConex[i]:=true;
                    nr:=nr+1;
                  end
                   else break;
           end
            else nr:=nr+1;
      If nr=n then GrafTareConex:=true;
    end;

  Function SuntDrumuri:boolean;
   var i:integer;
   begin
     SuntDrumuri:=true;
     For i:=1 to n do
        If muc[i]=nil then
          begin
            SuntDrumuri:=false;
            break;
          end;
   end;
begin
  readln(n,m);
  Init;
  k:=0;
  writeln('0');
  flush(output);
  while (k<=m) do
     begin
       k:=k+1;
       read(x,y);
       If NuEste(muc[x],y) then Add(muc);
       If SuntDrumuri then
        begin
         If GrafTareConex then
            begin
              writeln('1');
              flush(output);
              break;
            end
             else
               begin
                 writeln('0');
                 flush(output);
               end;
        end
         else
          begin
             writeln('0');
             flush(output);
          end;
     end;
end.
