#include <stdio.h>
#include <string.h>
#include <set>
#include <algorithm>
using namespace std;
set <int > s;
const int n_max = 301;
//const int dbg =1;
int cnt, n, m, k;
int v[n_max*n_max],
	a[n_max][n_max],
	norm[n_max*n_max];
	
inline int pz(int x)
{
	 return lower_bound(norm+1, norm+norm[0]+1, x)-norm;
}
inline int MIN(int x, int y)
{
	if (x<y)
		return x;
	return y;
}

void add_line(int x, int y, int z)
{
	int l;
	for (int i =  x; i <= x+z-1; ++ i)
	{
		l = pz(a[i][y]);
		if (v[l] == 0)
			++cnt;
		++v[l];
	}
}

void del_line(int x, int y, int z)
{
	int l;
	for (int i =  x; i <= x+z-1; ++ i)
	{
		l = pz(a[i][y]);
		--v[l];
		if (v[l] == 0)
			--cnt;
	}
}

int verif(int x)
{
	cnt = 0;
	int i, j;
	for (i = 1; i <= n-x; ++ i) //Setam linia de sus
	{
		memset(v, 0, sizeof(v));
		for (j = 1; j <= x; ++ j) 
			add_line(i,j,x);
		if (cnt <= k)
			return 1;
		for (; j<= m; ++ j)
		{
			add_line(i,j,x);
			del_line(i,j-x,x);
			if (cnt <= k)
			{
				return 1;
			}
		}
	}
	return 0;
}

int main()
{
	int i,j;
	set <int>::iterator it;
	freopen("submatrix.in","r",stdin);
	freopen("submatrix.out","w",stdout);
	scanf("%d %d %d", &n ,&m, &k);
	for (i = 1; i <= n; ++ i)
		for (j = 1; j <= m; ++ j)
		{
			scanf("%d ", &a[i][j]);
			s.insert(a[i][j]); //Pregatim normalizarea
		}
	// Normalizam
	for (it = s.begin(); it!=s.end(); ++it)
		norm[++norm[0]] = *it;
	int step = 1<<9;
	for (i = 0; i<= MIN(n,m) && step > 0; step>>=1)
		if (i+step <= MIN(n,m) && verif(i+step))
				i+=step;
	printf("%d", i);
}

	
