#include <cstdio>

using namespace std;

#define MAXN 305

int N, K, R;
int din[2][MAXN][MAXN], sum[2][MAXN][MAXN];
// sum[i][j][k] == SUM(din[i][j][l], l <= k)

int main() {
    freopen("kmax.in", "rt", stdin);
    freopen("kmax.out", "wt", stdout);

    scanf("%d %d %d", &N, &K, &R);

    din[1][1][1] = 1;
    sum[1][1][1] = 1;
    for (int i = 2, step = 0; i <= N; i++, step ^= 1) {
        // din[i][1][k]
        for (int k = 1; k <= i; k++) {
            din[step][1][k] = 0;
            for (int l = 1; l <= K && l <= i - 1; l++) {
                din[step][1][k] += sum[1 ^ step][l][i - 1] - sum[1 ^ step][l][k - 1];
                if (din[step][1][k] < 0) {
                    din[step][1][k] += R;
                }
                if (din[step][1][k] >= R) {
                    din[step][1][k] -= R;
                }
            }

            sum[step][1][k] = sum[step][1][k - 1] + din[step][1][k];
            if (sum[step][1][k] >= R) {
                sum[step][1][k] -= R;
            }
        }

        // din[i][j][k]
        for (int j = 2; j <= K && j <= i; j++) {
            for (int k = 1; k <= i; k++) {
                din[step][j][k] = sum[1 ^ step][j - 1][k - 1];

                sum[step][j][k] = sum[step][j][k - 1] + din[step][j][k];
                if (sum[step][j][k] >= R) {
                    sum[step][j][k] -= R;
                }
            }
        }
    }

    int SUM = 0;
    for (int j = 1; j <= N && j <= K; j++) {
        for (int k = 1; k <= N; k++) {
            SUM += din[N & 1][j][k];
            if (SUM >= R) {
                SUM -= R;
            }
        }
    }
    printf("%d\n", SUM);

    return 0;
}
