#include <stdio.h>
#include <vector>
#include <algorithm>

#define NMAX 301

using namespace std;

long good_matrixes;

long n,m,KA;
long a[NMAX][NMAX];
long kount;
vector<long> ciffs;
void putin(long cif) {
	if (!binary_search(ciffs.begin(),ciffs.end(),cif)) {
		vector<long>::iterator it = upper_bound(ciffs.begin(),ciffs.end(),cif);
		kount++;
		ciffs.insert(it,cif);
	}
}

int main (void) {
	FILE * fi = fopen("submatrix.in","rt");
	FILE * fo = fopen("submatrix.out","wt");

	fscanf(fi,"%ld %ld %ld",&n,&m,&KA);
	for (long i=0; i<n; i++)
		for (long j=0; j<m; j++)
			fscanf(fi,"%ld",&a[i][j]);

	good_matrixes=0;
	long greatest_len=0;

	for (long i=0; i<n; i++)
		for (long j=0; j<m; j++)
		{
			long len=0;
			kount=0;
			ciffs.clear();

			while ((i+len<n) && (j+len<m) && (kount<=KA)) {
				for (long k=0; k<=len-1; k++)
					putin(a[i+len][j+k]);
				for (long k=0; k<=len-1; k++)
					putin(a[i+k][j+len]);
				putin(a[i+len][j+len]);

				if (kount<=KA)
					if (len>greatest_len)
						greatest_len=len;

				len++;
			}
		}

	fprintf(fo,"%ld\n",greatest_len+1);

	fclose(fi);
	fclose(fo);
	return 0;
}