// Savin Tiberiu
// Solutie O(N^2 * K)

#include <stdio.h>
#include <algorithm>

using namespace std;

#define NMAX 310

int A[NMAX][NMAX];
int comb[NMAX][NMAX];
int N, K;
int MOD;

int main() {
  freopen("kmax.in", "r", stdin);
  freopen("kmax.out", "w", stdout);

  scanf("%d %d %d ", &N, &K, &MOD);

  int i, j, l;
  for (i = 1; i <= K; i++) {
    A[1][i] = 1;
  }

  // combinari
  for (i = 1; i <= N; i++) {
    comb[i][1] = i;
    comb[i][i] = 1;
  }

  for (i = 3; i <= N; i++) {
    for (j = 2; j < i; j++) {
      comb[i][j] = (comb[i - 1][j] + comb[i - 1][j - 1]) % MOD;
    }
  }

  for (i = 2; i <= N; i++) {
    for (j = 1; j <= K; j++) {
      A[i][j] = (A[i - 1][j - 1] + A[i - 1][j]) % MOD;
      for (l = 1; l < i; l++) {
        int x;
        x = (A[l][K - 1] * A[i - l - 1][j]) % MOD;
        x = (x * comb[i - 1][l]) % MOD;
        A[i][j] = (A[i][j] + x) % MOD;
      }
    }
  }

  printf("%d ", A[N][K]);
  return 0;
}
