/*
	Airinei Adrian, Iasi
	Complexitate O(N^4) optimizat
*/
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define MAXN 310

int N, M, K;
int A[MAXN][MAXN], cnt[MAXN*MAXN];

int solve(void)
{
	int i, j, k, L, x, y, num, res = 1;

	for(i = 1; i <= N; i++)
		for(j = 1; j <= M; j++)
		{
			num = 0;
			for(L = 1; i-L+1 >= 1 && j-L+1 >= 1; L++)
			{
				for(x = i; x >= i-L+1; x--)
					if(cnt[A[x][j-L+1]] == 0)
						num++, cnt[A[x][j-L+1]] = 1;
				for(y = j; y > j-L+1; y--)
					if(cnt[A[i-L+1][y]] == 0)
						num++, cnt[A[i-L+1][y]] = 1;
				if(num > K) break ;
			}
			res = max(res, L-1);
			for(x = i-L+1; x <= i; x++)
				for(y = j-L+1; y <= j; y++)
					cnt[A[x][y]] = 0;
		}
	return res;
}

vector<int> V;
int main(void)
{
	freopen("submatrix.in", "rt", stdin);
	freopen("submatrix.out", "wt", stdout);

	int i, j, k;
	scanf("%d %d %d", &N, &M, &K);
	for(i = 1; i <= N; i++)
		for(j = 1; j <= M; j++)
			scanf("%d", &A[i][j]), V.push_back(A[i][j]);

	vector<int>::iterator it;
	sort(V.begin(), V.end());
	V.resize(unique(V.begin(), V.end())-V.begin());
	for(i = 1; i <= N; i++)
		for(j = 1; j <= M; j++)
		{
			it = lower_bound(V.begin(), V.end(), A[i][j]);
			A[i][j] = (int)(it-V.begin());
		}

	printf("%d\n", solve());

	return 0;
}







