using namespace std;

#include <map>
#include <set>
#include <queue>
#include <ctime>
#include <cmath>
#include <stack>
#include <queue>
#include <cstdio>
#include <bitset>
#include <vector>
#include <fstream>
#include <algorithm>

#define f first
#define s second
#define II inline
#define ll long long
#define oo (1<<30)
#define mp make_pair
#define pb push_back
#define CC(A) memset((A),0,sizeof((A)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i) = (a);(i) <= (b);++(i))
#define REP(i,b) for(int (i) = 0;(i) < (b);++(i))
#define FORit(it,V) for(__typeof(V.begin()) it = V.begin();it != V.end();++it)

#define IN "stalpi.in"
#define OUT "stalpi.out"
#define bit(x) (1<<((x-2)))

typedef pair<int,int> pi;
typedef vector<int> VI;

int N,E,A[1<<8];
int C[3][15][201][201];

II void scan()
{
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);
	
	scanf("%d%d",&N,&E);
	FOR(i,2,N)
		scanf("%d",A+i);
}

II int compute(int D)
{
	bool ok = true;
	FOR(i,2,N)
		if(A[i] - A[i-1] > D)
			ok = false;
	if(ok)
		return 0;
	
	memset(C,100,sizeof(C));
	
	int X(0),Y(1),Z(2);
	
	for(int i = 1;i <= N;++i)
	for(int x = A[1];x <= A[N];++x) 
		C[0][i][x][x] = abs(A[i] - x); 
	for(int i = 1;i < N;++i)
	for(int x1 = A[1];x1 <= A[N];++x1)
	for(int x2 = x1;x2 <= x1 + D;++x2)		
		C[1][i][x1][x2] = abs(A[i] - x1) + abs(A[i+1] - x2);
	
	FOR(k,2,N-1)
	{
		FOR(i,1,N - k)
		FOR(x1,A[1],A[N])
		FOR(x2,A[1],A[N])
		{
			C[Z][i][x1][x2] = oo;
			if( (x2 - x1) / D > k)
				break;
			
			for(int xx1 = x1;xx1 <= min(x2,x1 + D);++xx1)
			for(int xx2 = max(xx1,x2 - D);xx2 <= x2;++xx2)
				C[Z][i][x1][x2] = min(C[Z][i][x1][x2],C[X][i+1][xx1][xx2] + abs(A[i] - x1) + abs(A[i+k] - x2) );
		}
		
		X = (++X == 3 ? 0 : X);
		Y = (++Y == 3 ? 0 : Y);
		Z = (++Z == 3 ? 0 : Z);
	}
	
	return C[Y][1][ A[1] ][ A[N] ];
}

II void solve()
{
	if(N == 3)
	{
		int rez = oo;
		FOR(x,A[1],A[3])
			if( abs(A[2] - x) <= E)
				rez = min(rez,max(x - A[1],A[3] - x) );
		printf("%d\n",rez);
		return;
	}
	
	int best = oo;
	FOR(i,2,N)
		best = min(best,A[i] - A[i-1]);
	
	if(N <= 15 && A[N] <= 200)
	{
		int m,step;
		for(step = 1;step <= 10000;step <<= 1);
		for(m = 10000;step;step >>= 1)
			if(m > step && compute(m - step) <= E)
				m -= step;
		printf("%d\n",m);
		
		return;
	}
	
	printf("%d\n",best);
}

int main()
{
	scan();
	solve();
	return 0;
}
