// Balan Catalin
// 8 Apr 2010 - 10:26
// ONI 2010 - Proba 2 - diff
#include <cstdio>
#include <cstdlib>
#include <fstream>

using namespace std;

#define NMAX 131072
#define FIN "diff.in"
#define FOUT "diff.out"


inline int min(int a, int b)
{
	return (a<b?a:b);
}
inline int max(int a, int b)
{
	return (a>b?a:b);
}


int main()
{

	int D[2][NMAX];
	int rez[2][NMAX];
	
	ifstream in(FIN);
	ofstream out(FOUT);
	int n,m;
	in>>n;
	in>>m;

	D[0][0] = D[0][1] = 0;
	int maxim[2] = {n+1};
	int minim[2] = {n+2};
	D[0][n+2] = D[1][n+2] = 3000000;
	D[0][n+1] = D[1][n+1] = -3000000;
	int r0 = 0;
	int x1 = -10;
	for (int i = 1; i <= n; ++i)
	{
		int x;
		in>>x;
		if (x) 
		{
			D[0][i] = D[0][i-1] + 1;
			D[1][i] = D[1][i-1] - 1;
		} else {
			D[1][i] = D[1][i-1] + 1;
			D[0][i] = D[0][i-1] - 1;
		}

		if ( D[0][i] > D[0][maxim[0]])
			maxim[0]= i;
		if ( D[1][i] > D[1][maxim[1]])
			maxim[1]= i;

		if (x + x1 == 1) r0 = i;
		x1 = x;
	}

	for (int g = 0; g < 2; ++g)
	{
		for (int i = maxim[g]; i >= 0; --i)
		{
			if ( D[g][i] < D[g][ minim[g] ])
				minim[g]= i;
		}
		for (int i = minim[g]; i < maxim[g]; ++i)
		{
			rez[g][ D[g][ maxim[g] ] - D[g][i] ] = i+1; 
		}
//		for (int i = 0; i <= 10; ++i)
//			fprintf(stderr, "%d ", rez[g][i]);
//		fprintf(stderr, "\n %d %d\n", maxim[g], minim[g]);
	}
	for (;m;--m)
	{
		int k;
		in>>k;	

		if ( k == 0 ) 
		{
			out<<r0-1<<' '<<r0<<'\n';
			continue;
		}
		int g = 0;
		if ( k < 0 ) g = 1, k*=-1;
		
		if ( D[g][maxim[g]] - D[g][minim[g]] < k )
		{
			out<<"-1\n";
			continue;
		}
		out<<rez[g][k]<<' '<<maxim[g]<<'\n';
		
	}

	return EXIT_SUCCESS;
}

