// Balan Catalin
// 8 Apr 2010 - 9:13
// ONI 2010 - Proba 2 - minuni
#include <cstdlib>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

#define NMAX 100042
#define FIN "minuni.in"
#define FOUT "minuni.out"

// PARSARE

#define CHUNK 8192
char g_buf[CHUNK];
int g_p = CHUNK-1;

inline int get()
{
	int x = 0;
	while ( g_buf[g_p] < '0' || g_buf[g_p] > '9' )
		if ( ++g_p >= CHUNK ) { fread(g_buf, 1, CHUNK, stdin); g_p = 0;}

	while ( g_buf[g_p] >= '0' && g_buf[g_p] <= '9' )
	{
		x = x*10+g_buf[g_p]-'0';
		if ( ++g_p >= CHUNK ) { fread(g_buf, 1, CHUNK, stdin); g_p = 0;}
	}
	return x;
}

// END PARSARE

int Lt[NMAX], Rt[NMAX], ind[NMAX];
long long rez[NMAX];

bool cmp( int a, int b )
{
	return Lt[a] < Lt[b];
}

struct nod
{
	int st, dr;
	vector<nod*> fii;
};
nod *root;

void addNode( nod *p, int lt, int rt )
{
	if (lt < p->st || rt > p->dr) return;
	if (p->fii.empty())
	{
		nod *q = new nod;
		q->st = lt;
		q->dr = rt;
		p->fii.push_back(q);
		long long rez;
		if (p != root)
			rez = 1LL * (lt - p->st +1) * (p->dr - rt + 1);
		else 
			rez = 1ll * lt * (p->dr-rt);
		printf("%lld\n", rez);
//		fprintf(stderr, "%d %d %d %d - %lld\n", p->st, p->dr, lt, rt, rez);
		return;
	}
	int sz = p->fii.size();
	for (int i = 0; i < sz; ++i)
	{
		nod *w = p->fii[i];;
		if (w->st < lt && w->dr > rt)
		{
			addNode( w, lt, rt);
			return;
		}
	}
	vector<nod*> aux;
	for (int i = 0; i < sz; ++i)
	{
		while ( i < sz && p->fii[i]->st > lt && p->fii[i]->dr < rt)
		{
			aux.push_back( p->fii[i] );
			p->fii[i] = p->fii[sz-1];
			p->fii.pop_back();
			--sz;
		}
	}
//	fprintf(stderr, "\n# ");
//	for (int i = 0; i < sz; ++i)
//	{
//		fprintf(stderr, "%d ", p->fii[i]->st);
//	}
//	fprintf(stderr, "\n");
	nod *q = new nod;
	q->st = lt;
	q->dr = rt;
	q->fii.assign(aux.begin(), aux.end());
	p->fii.push_back(q);
	
	long long rez;
	if ( p != root )
		rez = 1LL * (lt - p->st +1) * (p->dr - rt + 1);
	else 
		rez = 1ll * lt * (p->dr-rt);
	printf("%lld\n", rez);
//	fprintf(stderr, "%d %d %d %d - %lld\n", p->st, p->dr, lt, rt, rez);
	sz = aux.size();
	
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	int m = get();
	int n = get();
	root = new nod;
	root->st = 0;
	root->dr = m+1;
	for (int i = 1; i <= n; ++i)
	{
		int lt = get();
		int rt = get();
		addNode( root, lt, rt );

	}


	return EXIT_SUCCESS;
}

