#include <cstdio>
#define MAXN 100010
#define MAXL 200020
using namespace std;
int N,M,K;
int diff[MAXN],maxdiff[MAXN],mindiff[MAXN];
struct interval {int first,last;}  sol[MAXL];


void build_sol(int X,int Y){

	int ref=diff[X-1];
	for (int i=X;i<=Y;++i) {
		int dtu=diff[i]-ref;
		sol[dtu+N+1].first=X;
		sol[dtu+N+1].last=i;
	}
}

int main(){

	freopen("diff.in","r",stdin);
	freopen("diff.out","w",stdout);

	scanf("%d%d",&N,&M);

	diff[0]=0;


	int x;

	int lastmin=0,lastmax=0;

	for (int i=1;i<=N;++i) {
		scanf("%d",&x);
		if (x==0) diff[i]=diff[i-1]-1; else diff[i]=diff[i-1]+1;
		maxdiff[i]=lastmin;
		mindiff[i]=lastmax;
		if (diff[i]>diff[lastmax]) lastmax=i;
		if (diff[i]<diff[lastmin]) lastmin=i;
	}


	
	int MDIF=-(N+1);
	int PMDIF=0;
	
	for (int i=1;i<=N;++i)
		if ((diff[i]-diff[maxdiff[i]])>MDIF) { MDIF=diff[i]-diff[maxdiff[i]]; PMDIF=i; }
	

	build_sol(maxdiff[PMDIF]+1,PMDIF);
	
	int MNDIF=(N+1);
	int PMNDIF=0;

	for (int i=1;i<=N;++i)
		if ((diff[i]-diff[mindiff[i]])<MNDIF) { MNDIF=diff[i]-diff[mindiff[i]]; PMNDIF=i; }

	build_sol(mindiff[PMNDIF]+1,PMNDIF);


	int att0=0;

	for (int i=2;i<=N;++i)
		if (diff[i]-diff[i-2]==0){
			sol[N+1].first=i-1;
			sol[N+1].last=i;
			att0=1;
			i=N+1;
		}


	for (int i=1;i<=M;++i){
		scanf("%d",&K);
		if (K==0){
			if (att0) printf("%d %d\n",sol[N+1].first,sol[N+1].last); else printf("-1\n");
		} else if (K>=MNDIF && K<=MDIF)
			printf("%d %d\n",sol[N+1+K].first,sol[N+1+K].last);
		else printf("-1\n");
	}


	fclose(stdin);
	fclose(stdout);

	return 0;
}
