#include <cstdio>
#define INF 1000000000
using namespace std;
int N,E;
int dist[100];
int dyn[60][10010],deq[10010];
struct element{ 
	int coord;
	int valoare;
} Dq[10010];


void make_deq(int stalp,int distanta){

	int p=1,u=1;
	Dq[p].coord=0;
	Dq[p].valoare=dyn[stalp][0];
	deq[0]=dyn[stalp][0];

	for (int i=1;i<=dist[N];++i){
		if ((Dq[p].coord+distanta)<i) ++p;
		++u;
		Dq[u].coord=i;
		Dq[u].valoare=dyn[stalp][i];
		while (u>p && Dq[u].valoare<Dq[u-1].valoare){
			element aux=Dq[u];
			Dq[u]=Dq[u-1];
			Dq[u-1]=aux;
			--u;
		}

		deq[i]=Dq[p].valoare;
	}
}


int diferenta(int stalp,int coord){

	int rez=dist[stalp]-coord;
	if (rez<0) rez=-rez;
	return rez;
}



int verif(int D){

	for (int i=1;i<=dist[N];++i) dyn[2][i]=INF;
	for (int i=0;i<=D;++i) dyn[2][i]=diferenta(2,i);

	make_deq(2,D);

	for (int i=3;i<N;++i){
		for (int j=0;j<=dist[N];++j){
			dyn[i][j]=diferenta(i,j)+deq[j];
			if (dyn[i][j]>INF) dyn[i][j]=INF;
		}
		make_deq(i,D);
	}

	int efmin=INF;
	for (int i=dist[N];(dist[N]-i)<=D && i>=0;--i)
		if (dyn[N-1][i]<efmin) efmin=dyn[N-1][i];

	if (efmin<=E) return 1; else return 0;
}

	

int main(){

	freopen("stalpi.in","r",stdin);
	freopen("stalpi.out","w",stdout);


	scanf("%d%d",&N,&E);

	dist[1]=0;
	for (int i=2;i<=N;++i) 
		scanf("%d",&dist[i]);

	fclose(stdin);


	int suplimit=0;
	for (int i=2;i<=N;++i)
		if ((dist[i]-dist[i-1])>suplimit) suplimit=dist[i]-dist[i-1];
	int rez=suplimit;
	suplimit--;
	int inflimit=0;

	while (inflimit<=suplimit){
		int m=(inflimit+suplimit)/2;
		if (verif(m)){
			rez=m;
			suplimit=m-1;
		} else inflimit=m+1;
	}

	printf("%d\n",rez);

	fclose(stdout);
	
	return 0;
}
