#include <iostream>
#include <queue>
#include <vector>
using namespace std;

int N, M, sol, D[500001];
vector<int> Gt[500001];

void BFS(int nod) {
	queue<int> Q;
	int i, p;
	Q.push(nod);
	while(!Q.empty()) {
		p=Q.front(); Q.pop();
		for(vector<int>::iterator it=Gt[p].begin(); it!=Gt[p].end(); it++) {
			if(!D[(*it)]) {
				D[(*it)]=D[p]+1;
				Q.push((*it));
			}
		}
	}
}

int BFS2(int nod) {
	queue<int> Q;
	int i, p, nr=0;
	Q.push(nod);
	while(!Q.empty()) {
		p=Q.front(); Q.pop();
		for(vector<int>::iterator it=Gt[p].begin(); it!=Gt[p].end(); it++) {
			if(D[p]+1<D[(*it)]) {
				D[(*it)]=D[p]+1;
				nr++;
				Q.push((*it));
			}
		}
	}
	return nr;
}

int main() {
	FILE *f1=fopen("minuni.in", "r"), *f2=fopen("minuni.out", "w");
	int i, j, p, q, x, y, nr;
	fscanf(f1, "%d %d\n", &N, &M);
	for(i=1; i<N; i++) {
		Gt[i+1].push_back(i);
	}
	for(i=1; i<=M; i++) {
		fscanf(f1, "%d %d\n", &x, &y);
		memset(D, 0, sizeof(D));
		sol=0;
		BFS(y);
		Gt[y].push_back(x);
		nr=BFS2(y);
		sol=(nr*(N-y+1));
		fprintf(f2, "%d\n", sol);
	}
	fclose(f1); fclose(f2);
	return 0;
}
		