/* this is so awesome */
#include <fstream>
#include <algorithm>
using namespace std;

const int NMAX = 51;
const bool Left = false, Right = true;

int normalize(const short dist[], const int sp, const int N, const int dmax, const int E, bool& direction)
{
	int e, sl = 0, sr = 0, i;
	
	if (sp == 1)
		sl = E + 1;
	else {
		e = dist[sp] - dmax;
		for (i = sp - 1; i && e > 0 && sl <= E; --i) {
			sl += e;
			e += dist[i] - dmax;
		}
		if (e > 0) sl = E + 1;
	}
	
	if (sp == N)
		sr = E + 1;
	else {
		e = dist[sp] - dmax;
		for (i = sp + 1; i != N && e > 0 && sr <= E; ++i) {
			sr += e;
			e += dist[i] - dmax;
		}
		if (e > 0) sr = E + 1; 
	}
	
	if (sr > sl) {
		direction = Left;
		return (sl <= E) ? sl : -1;
	}
	else {
		direction = Right;
		return (sr <= E) ? sr : -1;
	}
		
	
}

void changeleft(short dist[], const int sp, const int N, const int dmax)
{
	int e = dist[sp] - dmax;
	dist[sp] = dmax;
	for (int i = sp - 1; i; --i) {
		e += dist[i] - dmax;
		if (e <= 0) {
			dist[i] = e + dmax;
			break;
		}
		else dist[i] = dmax;
	}
}

void changeright(short dist[], const int sp, const int N, const int dmax)
{	
	int e = dist[sp] - dmax;
	dist[sp] = dmax;
	for (int i = sp + 1; i != N; ++i) {
		e += dist[i] - dmax;
		if (e <= 0) {
			dist[i] = e + dmax;
			break;
		}
		else dist[i] = dmax;
	}
}

bool check(const short origdist[], const int N, const int dmax, int E)
{
	short dist[NMAX] = {};
	memcpy(dist, origdist, (N + 1) * sizeof(short));
	bool stop = false;
	bool direction;
	while(!stop) {
		stop = true;
		int emax = 0, pozmax;
		bool dir;
		for (int i = 1; i != N; ++i)
			if (dist[i] > dmax) {
				stop = false;
				int e = normalize(dist, i, N, dmax, E, dir);
				if (e == -1) return false;
				if (e > emax) {
					emax = e;
					pozmax = i;
					direction = dir;
				}
			}
		if (!stop) {
			if (direction == Left) {
				changeleft(dist, pozmax, N, dmax);
				E -= emax;
			}
			else {
				changeright(dist, pozmax, N, dmax);
				E -= emax;
			}
		}
	}
	return true;
}

int main()
{
	short dist[NMAX] = {}, Dmax, x1, x2;
	int N, E, dbin, d;
	ifstream f1("stalpi.in");
	f1 >> N >> E;
	f1 >> x1;
	dist[1] = x1;
	for (int i = 2; i != N; ++i) {
		f1 >> x2;
		dist[i] = x2 - x1;
		Dmax = max(Dmax, dist[i]);
		x1 = x2;
	}
	for (dbin = 1; dbin <= Dmax; dbin <<= 1);
	for (d = 0; dbin ; dbin >>= 1)
		if (d + dbin <= Dmax && !check(dist, N, d + dbin, E)) d += dbin;
		
	ofstream f2("stalpi.out");
	f2 << d + 1 << endl;
	f2.close();
}
