#include <algorithm>
using namespace std;

#define INF 0x3f3f3f3f
#define MAX 10005
#define DIM 55

int best[DIM][DIM][MAX];
int n,e,sol,efort;
int d[DIM];

void read ()
{
    int i;

    scanf ("%d%d",&n,&e);
    for (i=1; i<n; ++i)
        scanf ("%d",&d[i]);
}

void do_brut1 ()
{
    int i;

    sol=max (d[1],d[2]);
    for (i=0; i<=e; ++i)
    {
        sol=min (sol,max (d[1]+i,d[2]-i));
        sol=min (sol,max (d[1]-i,d[2]+i));
    }
    printf ("%d",sol);
}

void back (int stalp)
{
    int i,cur,pas,nraux;

    if (stalp==n)
    {
        cur=0;
        for (i=2; i<n; ++i)
            cur=max (cur,d[i]-d[i-1]);
        sol=min (sol,cur);
    }
    else
        for (pas=0; pas+efort<=e && d[stalp-1]<=d[stalp]-pas; ++pas)
        {
            d[stalp]-=pas;
            efort+=pas;
            back (stalp+1);
            efort-=pas;
            d[stalp]+=pas;
        }
}

void do_laba1 ()
{
    int i;

    if (n>15)
    {
        for (i=1; i<n; ++i)
            sol=max (sol,d[i]);
        printf ("%d",sol-13-e/n);
    }
    else
    {
        sol=INF;
        back (2);
        printf ("%d",sol);
    }
}

int main ()
{
    freopen ("stalpi.in","r",stdin);
    freopen ("stalpi.out","w",stdout);

    read ();
    if (n==3)
        do_brut1 ();
    else
        do_laba1 ();

    return 0;
}
