#include <fstream>

using namespace std;

ifstream fin("minuni.in");
ofstream fout("minuni.out");

unsigned long long int n, m, x, y, n1, n2;

inline void multi(unsigned long long x, unsigned long long y)
{
	if (x > y)
	{
		multi(y, x); return;
	}
	
	n1 = x * (y % 1000); n2 = x * (y / 1000);
	int suf = n1 % 1000; n1 /= 1000;
	fout << n1 + n2 << suf;
	if (!suf) fout << "00";
	fout << "\n";
}

int main()
{
	fin >> n >> m;
	
	while (m)
	{
		fin >> x >> y; --m;
		if (x >= 100000 && y >= 100000)
		{
			multi(x, n - y + 1);
		}
		else
		{
			fout << x * (n - y + 1) << "\n";
		}
	}
}
