#include <fstream>
#include <vector>

using namespace std;

ifstream i_file("minuni.in");
ofstream o_file("minuni.out");

int N;
int x, y;
int M;
long int Moves;

vector<vector<long int>> Vector;

long int GetDist(int x, int y)
{
	if( Vector[x][y] == 0 )
	{
		return y-x;
	}
	else return Vector[x][y];
}
int main()
{
	i_file>>N>>M;
	Vector.reserve(N+1);
	vector<long int> SubVector;
	SubVector.insert(SubVector.begin(), N+1, 0);
	Vector.insert(Vector.begin(), N+1, SubVector);
	
	

	for(int i=1; i<=M;i++)
	{
		i_file>>x>>y;
		Vector[x][y] = 1;
		Moves=0;

		for(int i = 1; i<=x; i++)
		{
			for(int j = y;  j<=N; j++)
			{
				if(GetDist(i, j) != GetDist(i,x) + GetDist(y,j))
				{
					Moves++;
				}

			}
		}
		
		
		o_file<<Moves<<"\n";
		
	}
}