#include <fstream>
#include <algorithm>
#define IN "stalpi.in"
#define OUT "stalpi.out"

using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

int a[52][10002];
int cost[52][10002];
int D;
int Rez=10000;
int Poz[52];
int E, n, Final;

void citire()
{
    fin>>n>>E;
    Rez=0;
    for (int i=2;i<=n;i++)
    {
        fin>>Poz[i];
        if (Poz[i]-Poz[i-1]>=Rez)
            Rez=Poz[i]-Poz[i-1];
    }
    Final = Poz[n];
    for (int i=2;i<=n;i++)
        for (int j=0;j<=Final;j++)
        {
            if (j<Poz[i])
                cost[i][j]=Poz[i]-j;
            else
                cost[i][j]=j-Poz[i];
        }
}

int ok(int D)
{
    int C;
    for (int i=1;i<n;i++)
        for (int j=0;j<=Final;j++)
            a[i][j]=0x3f3f3f3f;
    a[1][0]=0;
    for (int ii=2;ii<n;ii++)
        for (int j=0;j<=Final;j++)
        {
            C=cost[ii][j];
            for (int k=max(j-D, 0);k<=j;k++)
                a[ii][j]= min(a[ii][j], a[ii-1][k] + C);
            if (ii==n-1 && Final-j<=D)
                if (a[ii][j]<=E)
                    return 1;
        }
    return 0;
}

void solve()
{
    int st=1;
    int dr=Rez;
    int mij;
    while (st<=dr)
    {
        mij=(st+dr)>>1;
        if (ok(mij))
        {
            if (mij<Rez)
                Rez=mij;
            dr=mij-1;
        }
        else
            st=mij+1;
    }
    fout<<Rez<<"\n";
}

int main()
{
    citire();
    if (Final==0)
        fout<<"0\n";
    else
        solve();
    return 0;
}
