#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

#define LL long long
#define inf 2000000000
#define NM 100005

int N, M;

int A[NM], B[NM], P[NM];

bool cmpp(int i, int j)
{
	return B[i] < B[j];
}

void baga30()
{
	for (int i = 0; i <= M; ++i) P[++P[0]] = i;
	
	sort(P + 1, P + P[0] + 1, cmpp);
	
	for (int i = 1; i <= M; ++i)
	{
		int bst = 0;
		
		for (int j = P[0]; j >= 1; --j)
		{
			int icur = P[j];
			
			if (B[icur] <= B[i]) break;
			
			if (icur > i) continue;
			if (A[icur] > A[i]) continue;
			
			if (A[icur] > A[bst]) bst = icur;
		}	
		
		LL ans1 = (LL) (A[i] - A[bst]) * (LL) (N - B[i] + 1);
		LL ans2 = (LL) A[bst] * (LL) (B[bst] - B[i]);
		
		printf("%lld\n", ans1 + ans2);
	}	
}

int main()
{
	freopen("minuni.in", "r", stdin);
	freopen("minuni.out", "w", stdout);
	
	scanf ("%d %d", &N, &M);
	
	A[0] = 0, B[0] = N + 1;
	
	for (int i = 1; i <= M; ++i) scanf("%d %d", &A[i], &B[i]);
	
	baga30();
	
	return 0;
}