#include <iostream>
#include <string>

using namespace std;

#define NM 55
#define DM 10005
#define inf 200000000

int D[NM], EMIN[DM][2], DMAX, deq[DM];

int N, E;

inline int ab (int nr)
{
	if (nr >= 0) return nr;
	return -nr;
}

int efmin70(int dst)
{
	for (int i = 0; i <= DMAX; ++i) EMIN[i][1] = inf;

	EMIN[0][1] = 0;

	for (int i = 2; i <=N ; ++i)
	{
		int cur = i%2, prev = !cur;

		for (int j = 0; j <= DMAX; ++j)
			EMIN[j][cur] = inf;

		for (int j = 1; j <= DMAX; ++j)
		{
			int bst = inf;

			int cst = ab (D[i] - j);

			for (int jj = max(0,j - dst); jj < j; ++jj)
				bst = min (bst, EMIN[jj][prev]);

			EMIN[j][cur] = bst + cst;
		}
	}

	return EMIN[DMAX][N%2];
}

int efmin100(int dst)
{
	for (int i = 0; i <= DMAX; ++i) EMIN[i][1] = inf;

	EMIN[0][1] = 0;

	for (int i = 2; i <=N ; ++i)
	{
		int cur = i%2, prev = !cur;

		for (int j = 0; j <= DMAX; ++j)
			EMIN[j][cur] = inf;

		int st = 0, dr = -1;

		for (int j = 1; j <= DMAX; ++j)
		{
			while (st <= dr && deq[st] < j - dst) ++st;

			while (st <= dr && EMIN[j-1][prev] <= EMIN[deq[dr]][prev]) --dr;

			deq[++dr] = j - 1;

			int cst = ab (D[i] - j);

			int bst = inf;

			if (st <= dr) bst = EMIN[deq[st]][prev];

			EMIN[j][cur] = bst + cst;
		}
	}

	return EMIN[DMAX][N%2];
}

int main()
{
	freopen ("stalpi.in", "r", stdin);
	freopen ("stalpi.out", "w", stdout);

	scanf ("%d %d", &N, &E);

	int st = 1, dr = 1;

	for (int i = 2; i <= N; ++i)
	{
		scanf ("%d", &D[i]);
		dr = max(dr, D[i] - D[i-1]);
	}

	DMAX = D[N];

	if(DMAX > 200)
	while (st < dr)
	{
		int mij = (st + dr)/2;

		if (efmin100(mij) <= E) dr = mij;
		else st = mij + 1;
	}
	else
	while (st < dr)
	{
		int mij = (st + dr)/2;

		if (efmin70(mij) <= E) dr = mij;
		else st = mij + 1;
	}

	int ans = st;

	printf ("%d", ans);

	return 0;
}
