#include <fstream>

using namespace std;

int v[100000];
int n;

struct precalc{
        int s,e;
};

struct data{
        int s,e;
        int k;
        data* l, *r;
};

data* init(int s,int e){
        data* tmp=(data*)malloc(sizeof(data));
        tmp->s=s;
        tmp->e=e;
        if(s!=e){
                int m=(s+e)/2;
                tmp->l=init(s,m);
                tmp->r=init(m+1,e);
                tmp->k=tmp->l->k+tmp->r->k;
        }
        else{
            if(v[e])
                tmp->k=1;
            else
                tmp->k=-1;
            tmp->l=tmp->r=NULL;
        }
        return tmp;
}

data* root;

precalc find(int k,data* node=root){
    precalc tmp;
    if(k==node->k){
        tmp.s=node->s;
        tmp.e=node->e;
        return tmp;
    }
    else{
        if(node->r){
            tmp=find(k,node->r);
            if(tmp.s>=0)
                return tmp;
        }
        if(node->l){
            tmp=find(k,node->l);
            if(tmp.s>=0)
                return tmp;
        }
        tmp.s=-1;
        return tmp;
    }
}

precalc search(int k,data* node=root){
    int l,r,x,d,f;
    l=node->s;
    r=node->e;
    x=node->k;
    if(x>k)
        d=1;
    else
        d=0;

    f=0;

    while(f<10&&l<r&&k!=x){
        if(d)x-=1;
        else x+=1;
        if(v[l]==d)
            l++;
        else if(v[r]==d)
            r--;
        else if(l>0&&v[l-1]==!d)
            l--;
        else if(r<n-1&&v[r+1]==!d)
            r++;
        else {
            if(d)x+=2;
            else x-=2;
            if(f%2){l++;f++;}
            else {r--;f++;}
        }
    }
    if(k==x){
            precalc tmp;
            tmp.s=l;
            tmp.e=r;
            return tmp;
    }
    else{
        precalc tmp;
        tmp=search(k,node->r);
        if(tmp.s>=0)
            return tmp;
        tmp=search(k,node->l);
        return tmp;
    }
}

int main(){
    ifstream in("diff.in");
    ofstream out("diff.out");

    int m;

    in>>n>>m;

    int i,j;

    for(i=0;i<n;i++)
        in>>v[i];

    int k;
    if(n<=4000){
        precalc sol[20000];
        for(i=0;i<20000;i++){
                sol[i].s=-1;
        }
        int sum;
        for(i=0;i<n;i++){
            sum=0;
            for(j=i;j<n;j++){
                if(v[j])
                    sum++;
                else
                    sum--;
                sol[sum+10000].e=j;
                sol[sum+10000].s=i;
            }
        }

        while(m--){
            in>>k;
            k+=10000;
            if(sol[k].s>=0)
                out<<sol[k].s+1<<' '<<sol[k].e+1<<'\n';
            else
                out<<"-1\n";
        }
    }
    else{
        root=init(0,n-1);
        while(m--){
                in>>k;
                precalc tmp=find(k);
                if(tmp.s==-1)
                    tmp=search(k);
                if(tmp.s>=0)
                    out<<tmp.s+1<<' '<<tmp.e+1<<'\n';
                else
                    out<<"-1\n";
        }
    }

    return 0;
}
