#include <fstream>
#include <map>
#include <vector>

using namespace std;

struct ltstr
{
  bool operator()(const int s1, const int s2) const
  {
    return s1<s2;
  }
};

#define SIZE 10000
#define BASE 1000

int* init(){
    int* t=new int[SIZE];
    memset(t,0,SIZE*sizeof(int));
    return t;
}

void load(int* t,int n){
    memset(t,0,SIZE*sizeof(int));
    int i=1;
    while(n){
            t[i]=n%BASE;
            n/=BASE;
            i++;
    }
    t[0]=i-1;
}

void prod(int* a,int* b,int* c){
        memset(c,0,SIZE*sizeof(int));
        int i,j,t=0,s=0;
        for(i=1;i<=b[0];i++)
            for(j=1;j<=a[0]||t;j++){
                c[j+i-1]+=a[j]*b[i]+t;
                if(c[j+i-1]>=BASE){
                        t=c[j+i-1]/BASE;
                        c[j+i-1]%=BASE;
                }
                else
                    t=0;
                if(j+i-1>s)
                    s=j+i-1;
            }
        c[0]=s;
}

int main(){
    ifstream in("minuni.in");
    ofstream out("minuni.out");

    int n,m;

    in>>n>>m;

    int a,b;
    int i;

    //map<int,vector<int>,ltstr> roads;

    int* p1,*p2,*r;

    p1=init();
    p2=init();
    r=init();

    while(m--){
        in>>a>>b;
        /*if(roads[a].find(b))
            out<<"0\n";
        else{*/
            load(p1,n-b+1);
            load(p2,a);
            prod(p1,p2,r);
            out.fill('0');
            out<<r[r[0]];
            for(i=r[0]-1;i>0;i--){
                    out.width(3);
                    out<<r[i];
            }
            out<<'\n';
        //}

    }

    return 0;
}
