#include <stdio.h>
#include <set>
#include <vector>
#include <queue>

using namespace std;
const int k_max = 200002;
int nl, n, m, timestamp;
pair <int, int> arb[4*k_max];

vector < pair < int, pair < int , int > > > v;
priority_queue < int > pq;
int in[k_max][3],
	norm[k_max];
inline int get_pos(int x)
{
	return lower_bound(norm+1,norm+nl+1,x)-norm;
}
void a_set(int val, int x, int y, int l, int r, int pos)
{
	if (x<= l && r<= y)
	{
		if (arb[pos].second < timestamp)
		{
			arb[pos].first = val;
			arb[pos].second = timestamp;
		}
		return;
	}
	int mij = (l+r)/2;
	if ( x<= mij)
		a_set(val, x, y, l, mij, 2*pos);
	if (y > mij)
		a_set(val, x, y, mij+1, r, 2*pos+1);
}
pair < int, int> a_get(int x, int l, int r, int pos)
{
	pair <int, int> sol;
	if (l == r)
		return arb[pos];
	int mij = (l+r)/2;
	if (x<= mij)
		sol = a_get(x, l, mij, 2*pos);
	if (x > mij)
		sol = a_get(x, mij+1, r, 2*pos+1);
	if (arb[pos].second > sol.second)
		sol = arb[pos];
	return sol;
}
void preprocess()
{
	int depth = 0, i;
	for (i = 1; i <= n; ++ i)
		v.push_back(make_pair(in[i][0], make_pair(in[i][1], i)));
	sort(v.begin(), v.end());
	int p = 0;
	for (i = 1; i <= nl; ++ i)
	{
		if (v[p].first == i)
		{
			++depth;
			in[v[p].second.second][3] = depth;
			pq.push(-v[p].second.first);
			++p;
		}
		if (!pq.empty() && pq.top()== -i)
		{
			pq.pop();
			--depth;
		}
	}
}



int main()
{
	int i;
	freopen("minuni.in","r",stdin);
	freopen("minuni.out","w",stdout);
	scanf("%d %d", &n, &m);
	for (i = 1; i <= m; ++ i)
	{
		scanf("%d %d", &in[i][0], &in[i][1]);
		pq.push(-in[i][0]);
		pq.push(-in[i][1]);
	}
	//Normalizam
	while (!pq.empty())
		norm[++nl] = -pq.top(), pq.pop();
	for (i = 1; i <= m; ++ i)
	{
		in[i][0] = get_pos(in[i][0]);
		in[i][1] = get_pos(in[i][1]);
	}
	// Trebuie preprocesata adancimea finala a intervalelor
	preprocess();


	pair <int, int> t;
	int k;
	for (i = 1; i <= m; ++ i)
	{
		
		t = a_get(in[i][0],1,nl,1);
		k = t.first;
		if (k!= 0)
			printf("%lld\n",(long long)(norm[in[i][0]]-norm[in[k][0]])*(n-norm[in[i][1]]+1) + (long long)(norm[in[k][1]]-norm[in[i][1]])*norm[in[i][0]] - ((long long)(norm[in[i][0]]-norm[in[k][0]])* (long long)(norm[in[k][1]]-norm[in[i][1]])));
		else
			printf("%lld\n",(long long)norm[in[i][0]]*(n-norm[in[i][1]]+1));
		timestamp = in[i][3];
		a_set(i,norm[in[i][0]],in[i][1]-1,1,nl,1);			
	}
	return 0;
}


