#include <stdio.h>
#include <string.h>

const int inf = 1<<30;
const int n_max = 64;
const int k_max = 10010;
int e, n;
int a[n_max],
	d[n_max][k_max];

int min(int x, int y)
{
	if (x < y)
		return x;
	return y;
}
int ABS(int x)
{
	if (x<0)
		return -x;
	return x;
}
int verif(int x)
{
	int i, j, k;
	memset(d,-1,sizeof(d));
	d[1][0] = 0;
	for (i = 2; i < n; ++ i)
		for (j = i-1; j <= a[n-1]; ++ j)
		{
			d[i][j] = inf;
			for (k = j-1; k >=j-x && k > -1; --k)
			if (d[i-1][k] != -1)
				d[i][j] = min(d[i][j], d[i-1][k]);
			d[i][j] += ABS(a[i-1]-j);
		}
	int sol = inf;
	for (i = a[n-1]; i >= a[n-1]-x && i > -1; --i)
		if (d[n-1][i]!=-1)
			sol = min(sol, d[n-1][i]);
//	printf("Pt %d a dat %d\n", x, sol);
	if (sol <= e)
		return 1;
	return 0;
}


int main()
{
	int i;
	freopen("stalpi.in","r",stdin);
	freopen("stalpi.out","w",stdout);
	scanf("%d %d", &n, &e);
	for (i = 1; i < n; ++ i)
		scanf("%d", &a[i]);
	int step;
	for (step = 1; step <= 10000; step<<=1)
		;
	for (i = 0; step; step>>=1)
		if (i+step <= 10000 && !verif(i+step))
			i+=step;
	printf("%d\n", i);
	return 0;
}