#include <cstdio>

using namespace std;

#define MAXN 100005

int N, M;
int v[MAXN], sum[MAXN];
int solL[MAXN * 2], solR[MAXN * 2];

#define solL(i) solL[i + MAXN]
#define solR(i) solR[i + MAXN]

int main() {
    freopen("diff.in", "rt", stdin);
    freopen("diff.out", "wt", stdout);

    scanf("%d %d", &N, &M);
    sum[0] = 0;
    int MAX = 0, MAXi = 0, MIN = 0, MINi = 0;

    int MaxSub = 0, MaxL = 0, MaxR = 0, MinSub = 0, MinL = 0, MinR = 0;
    for (int i = 1; i <= N; i++) {
        scanf("%d", v + i);
        if (v[i] == 0) {
            v[i] = -1;
        }

        if (v[i - 1] == -v[i]) {
            solL(0) = i - 1;
            solR(0) = i;
        }

        sum[i] = sum[i - 1] + v[i];
        if (sum[i] > MAX) {
            MAX = sum[i];
            MAXi = i;
        }
        if (sum[i] < MIN) {
            MIN = sum[i];
            MINi = i;
        }

        if (sum[i] - MIN > MaxSub) {
            MaxSub = sum[i] - MIN;
            MaxL = MINi + 1;
            MaxR = i;
        }
        if (sum[i] - MAX < MinSub) {
            MinSub = sum[i] - MAX;
            MinL = MAXi + 1;
            MinR = i;
        }
    }

    int sum = 0;
    for (int i = MinL; i <= MinR; i++) {
        sum += v[i];
        solL(sum) = MinL;
        solR(sum) = i;
    }

    sum = 0;
    for (int i = MaxL; i <= MaxR; i++) {
        sum += v[i];
        solL(sum) = MaxL;
        solR(sum) = i;
    }

    for (int i = 0; i < M; i++) {
        int diff;
        scanf("%d", &diff);
        if (diff < -N || diff > N || solL(diff) == 0) {
            printf("-1\n");
        } else {
            printf("%d %d\n", solL(diff), solR(diff));
        }
    }

    return 0;
}
