#include <stdio.h>

#define NMAX 100002

int V[NMAX];
int S[NMAX];
int N, M;
int H[NMAX][4];

int main() {
  freopen("diff.in", "r", stdin);
  freopen("diff.out", "w", stdout);

  scanf("%d %d ", &N, &M);

  int i;
  int min = 0, max = 0, pmin = 0, pmax = 0;
  for (i = 1; i <= N; i++) {
    int x, y;
    scanf("%d ", &x);
    if (x == 0) {
      S[i] = S[i - 1] - 1;
    } else {
      S[i] = S[i - 1] + 1;
    }
    x = S[i] - S[pmin];
    y = S[i] - S[pmax];
    H[i][0] = x;
    H[i][1] = pmin;
    H[i][2] = y;
    H[i][3] = pmax;

    if (S[i] < min) {
      min = S[i];
      pmin = i;
    }

    if (S[i] > max) {
      max = S[i];
      pmax = i;
    }

  }

  for (i = 1; i <= M; i++) {
    int x, D, sx = -1, sy = -1;
    scanf("%d ", &D);
    for (x = 1; x <= N; x++) {
      if (H[x][0] == D) {
        sx = x;
        sy = H[x][1] + 1;
      }

      if (H[x][2] == D) {
        sx = x;
        sy = H[x][3] + 1;
      }
    }

    if (sx == -1) {
      printf("-1\n");
    } else {
      printf("%d %d\n", sy, sx);
    }
  }

  return 0;
}
