/*
	Airinei Adrian
	Complexitate O(M^2), brute-force
*/
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define MAXN 100100
#define llong long long

int N, M;
int viz[MAXN], Ind[MAXN];
pair<int, int> query[MAXN];

void read_and_solve(void)
{
	int i, j, k, a, b, amax;

	scanf("%d %d\n", &N, &M);

	for(i = 1; i <= M; i++)
	{
		scanf("%d %d\n", &a, &b);
		query[i].first = a, query[i].second = b;
		amax = 0;
		k = 0;
		for(j = i-1; j >= 1; j--)
			if(query[j].first < a && query[j].second > b && query[j].first > amax)
			{ amax = query[j].first; k = j; }
		if(k == 0)
			printf("%lld\n", (llong)query[i].first*(N-query[i].second+1));
		else
		{
			int p = query[k].first, q = query[k].second;
			printf("%lld\n", (llong)a*(q-b)+(llong)(a-p)*(N-b+1)-(llong)(a-p)*(q-b));
		}
	}
}

int main(void)
{
	freopen("minuni.in", "rt", stdin);
	freopen("minuni.out", "wt", stdout);

	read_and_solve();

	return 0;
}
