#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 10002

int N, F;
int D[NMAX];
int poz[NMAX];

int main() {
  freopen("stalpi.in", "r", stdin);
  freopen("stalpi.out", "w", stdout);

  scanf("%d %d ", &N, &F);

  int i;
  for (i = 1; i < N; i++) {
    scanf("%d ", &D[i]);
  }

  int dist = D[N - 1] / (N - 1);

  for (i = 1; i < N; i++) {
    poz[i] = dist * i;
    if (i <= D[N - 1] % (N - 1)) {
      poz[i]++;
    }
  }
  poz[N - 1] = D[N - 1];

  int E = 0, diff;
  for (i = 1; i < N; i++) {
    if (poz[i] < D[i]) {
      diff = D[i] - poz[i];
      E += diff;
    } else {
      diff = poz[i] - D[i];
      E += diff;
    }
  }

  int nr = E - F;
  for (int i = 1; nr; i++) {
    if (i == N - 1) {
	i = 1;
    }

    if (poz[i] < D[i]) {
      poz[i]++;
      nr--;
    } else if (poz[i] > D[i]) {
      nr--;
      poz[i]--;
    }
  }

  int ret = D[1];
  for (i = 2; i < N; i++) {
    if (poz[i] - poz[i - 1] > ret) {
      ret = poz[i] - poz[i - 1];
    }
  }

  printf("%d ", ret);
  return 0;
}
