# include <fstream>
# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
# include <cmath>
# define DIM 2010
# define pb push_back
# define db (double)
using namespace std;
struct ceva{
	int t, x, y, r, a, b, c, d;
	ceva(){}
	ceva(int T, int X, int Y, int R, int A, int B, int C, int D){
		t=T;x=X;y=Y;r=R;a=A;b=B;c=C;d=D;}
	};
vector<ceva>C;
vector<int>G[DIM];	
int n, t0, t1, d[DIM], sol, in[DIM], v[DIM], T[DIM], c[DIM], l[DIM];

void read ()
{
	ifstream fin ("cuiburi.in");
	fin>>n;
	int t, a, b, c, d, x, y, r;
	for(int i=1;i<=n;++i)
	{
		fin>>t;
		if (t==0)
		{
			++t0;
			fin>>a>>b>>c>>d;
			C.pb(ceva(t, 0, 0, 0, a, b, c, d));
		}
		else
		{
			++t1;
			fin>>x>>y>>r;
			C.pb(ceva(t, x, y, r, 0, 0, 0, 0));
		}
	}
}

int cuib0(int i, int j)
{
	if (C[i].a>=C[j].a && C[i].b>=C[j].b && C[i].c<=C[j].c && C[i].d<=C[j].d)
		return 1;
	return 0;
}

void cnstr0 ()
{
	for (int i=0;i<n;++i)
		for(int j=0;j<n;++j)
			if (i!=j && !l[i] && cuib0(i, j))
			{
				if (cuib0(j, i))
				{
					++c[i];
					c[j]=-1;
					l[j]=1;
				}
				else
					G[i].pb(j);
				in[j]=1;
			}
}
				
void misca (int S)
{
	for (int i=0;i<n;++i)
		d[i]=-1, v[i]=0;
	int k;
	queue<int>Q;
	Q.push(S);
	v[S]=1;
	d[S]=c[S];
	while (Q.size())
	{
		k=Q.front();
		Q.pop();
		v[k]=0;
		for(vector<int>::iterator I=G[k].begin();I<G[k].end();++I)
			if (d[k]+c[*I]+1>=d[*I])
			{
				d[*I]=d[k]+c[*I]+1;
				if (!v[*I])
				{
					Q.push(*I);
					v[*I]=1;
				}
				if (d[*I]>sol)sol=d[*I];
			}
	}
}

				
void solve0 ()
{
	cnstr0();
	for (int i=0;i<n;i++)
		if (!in[i])
			misca(i);
}

int cuib1 (int i, int j)
{
	double d=sqrt((db C[i].x-db C[j].x)*(db C[i].x-db C[j].x)+(db C[i].y-db C[j].y)*(db C[i].y-db C[j].y));
	if (d+db C[i].r<=db C[j].r)
		return 1;
	return 0;
}

void cnstr1 ()
{
	for(int i=0;i<n;++i)
		for (int j=0;j<n;++j)
			if (i!=j && !l[i] && cuib1(i, j))
			{
				if (cuib1(j, i))
				{
					++c[i];
					c[j]=-1;
					l[j]=1;
				}
				else
					G[i].pb(j);
				in[j]=1;
			}
}

void solve1 ()
{
	cnstr1();
	for(int i=0;i<n;++i)
		if (!in[i])
			misca(i);
}

int cuib (int i, int j)
{
	if (C[i].t==0 && C[j].t==0)return cuib0(i, j);
	if (C[i].t==1 && C[j].t==1)return cuib1(i, j);
	if (C[i].t==0 && C[j].t==1)
	{
		double r=sqrt((db C[i].a-db C[i].c)*(db C[i].a-db C[i].c)+(db C[i].b-db C[i].d)*(db C[i].b-db C[i].d))/2;
		double x, y, d;
		x=(C[i].a+C[i].c)/2;
		y=(C[i].b+C[i].d)/2;
		d=sqrt((x-db C[j].x)*(x-db C[j].x)+(y-db C[j].y)*(y-db C[j].y));
		if (d+r<=db C[j].r)return 1;
		return 0;
	}
	double dmin=1000000000;
	// i - cerc     j- drpt
	if (C[i].x>=C[j].a && C[i].x<=C[j].c && C[i].y>=C[j].b && C[i].y<=C[j].d)
	{
		if (dmin<C[i].x-C[j].a)dmin=C[i].x-C[j].a;
		if (dmin<C[i].y-C[j].b)dmin=C[i].y-C[j].b;
		if (dmin<C[j].c-C[i].x)dmin=C[j].c-C[i].x;
		if (dmin<C[j].d-C[i].y)dmin=C[j].d-C[i].y;
		if (dmin>=C[i].r)return 1;
	}
	return 0;
}
		 

void cnstr()
{
	for(int i=0;i<n;++i)
		for(int j=0;j<n;++j)
			if (i!=j && !l[i] && cuib(i, j))
			{
				if (cuib(j, i))
				{
					++c[i];
					c[j]=-1;
					l[j]=1;
				}
				else
					G[i].pb(j);
				in[j]=1;
			}
}

void solve ()
{
	cnstr();
	for(int i=0;i<n;++i)
		if (!in[i])
			misca(i);
}

int main()
{
	read ();
	if (t0==n)
		solve0 ();
	else
		if (t1==n)
			solve1();
		else
			solve ();
	ofstream fout ("cuiburi.out");
	fout<<sol+1;
	return 0;
}
