using namespace std;

#include <set>
#include <map>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>
#include <vector>
#include <cstdio>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <algorithm>

#define II inline
#define f first
#define s second
#define oo (1<<30)
#define pb push_back
#define mp make_pair
#define ll long long
#define Size(V) ((V).size())
#define CC(V) memset((V),0,sizeof((V)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);++(i) )
#define REP(i,b) for(int (i)=0;(i)<(b);++(i))
#define FORit(it,V) for(__typeof((V).begin()) it = ((V).begin());it != ((V).end());++it)

#define IN "cuiburi.in"
#define OUT "cuiburi.out"
#define N_MAX (1<<11)

typedef pair<int,int> pi;
typedef vector<int> VI;

int N,G[N_MAX],C[N_MAX],Q[N_MAX];
bool type[N_MAX];
vector< pair<pi,pi> > V(N_MAX);
vector<VI> A(N_MAX); 

II void scan()
{
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);
	scanf("%d",&N);
	
	int tip;
	
	FOR(i,1,N)
	{
		scanf("%d",&tip);
		type[i] = (bool)tip;
		if(!tip)
			scanf("%d%d%d%d",&V[i].f.f,&V[i].f.s,&V[i].s.f,&V[i].s.s);
		else
			scanf("%d%d%d",&V[i].f.f,&V[i].f.s,&V[i].s.f);
	}
}

II double dist(int x1,int y1,int x2,int y2)
{
	double rem = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
	return sqrt(rem);
}

II bool se_cuibareste(int i,int j)
{
	vector<pi> P;
	if(!type[i])
	{
		P.pb( mp(V[i].f.f,V[i].f.s) );
		P.pb( mp(V[i].f.f,V[i].s.s) );
		P.pb( mp(V[i].s.f,V[i].f.s) );
		P.pb( mp(V[i].s.f,V[i].s.s) );
	}
	else
	{
		P.pb( mp(V[i].f.f - V[i].s.f,V[i].f.s) );
		P.pb( mp(V[i].f.f,V[i].f.s - V[i].s.f)  );
		P.pb( mp(V[i].f.f + V[i].s.f,V[i].f.s)  );
		P.pb( mp(V[i].f.f,V[i].f.s + V[i].s.f)  );
	}
	
	bool ok = true;
	if(!type[j])
	{
		FORit(it,P)
			if( !(V[j].f.f <= it->f && it->f <= V[j].s.f && V[j].f.s <= it->s && it->s <= V[j].s.s) )
				ok = false;
	}
	else
	{
		FORit(it,P)
			if( dist(it->f,it->s,V[j].f.f,V[j].f.s) > (double)V[j].s.f + 1e-4)
				ok = false;
	}
	return ok;
}

II void solve()
{
	FOR(i,1,N)
	FOR(j,i+1,N)
		if( se_cuibareste(i,j) )
		{ 
			//printf("%d il tine pe %d\n",i,j); 
			
			++G[i];
			A[j].pb(i);
		}
		else if( se_cuibareste(j,i) )
		{
			//printf("%d il tine pe %d\n",j,i); 
			
			++G[j];
			A[i].pb(j);
		}	
		
	
	FOR(i,1,N)
		if(!G[i] )
			Q[++Q[0]] = i;
	
	FOR(i,1,Q[0])
	{
		int nod = Q[i];
		FORit(it,A[nod])
		{
			--G[*it];
			C[*it] = max(C[*it],C[nod] + 1);
			if(!G[*it])
				Q[++Q[0]] = *it;
		}
	}	
	
	int rez = 0;
	FOR(i,1,N)
		rez = max(C[i],rez);
	printf("%d\n",rez + 1);
}

int main()
{
	scan();
	solve();
	return 0;
}
