// BALAN CATALIN
// 11 Apr 2010 - 10:23
// ONI 2010 - Baraj 2 - telefon

#include <cstdio>
#include <cstdlib>
#include <bitset>
using namespace std;

#define NMAX 100042

// PARSARE

#define CHUNK 8192
char Pbuf[CHUNK];
int Pp = CHUNK-1;
inline int get()
{
	while (Pbuf[Pp] < '0' || Pbuf[Pp] > '9')
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	int x = 0;	


	while (Pbuf[Pp] >= '0' && Pbuf[Pp] <= '9')
	{
		x = x*10+Pbuf[Pp]-'0';
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	}
	return x;

}

// END PARSARE

int next[NMAX];
int grad[NMAX];
int viz[NMAX];
int prev[NMAX];
int root[NMAX];

typedef pair < int, int > pr;
pr cycle[NMAX];
pr path[NMAX];
pr moves[NMAX];
int nrP = 0, nrC = 0, madeMoves = 0, distinct = 0, n;

inline void gasestePath(int start)
{
	pr aux, aux2;
	++distinct;
	aux.first = start;
	int now = start;
	while (viz[now] == 0)
	{
		viz[now] = distinct;
		if (!prev[next[now]]) prev[next[now]] = now;
		aux.second = now;
		now = next[now];
	}
	if (viz[now] == distinct)
	{
		aux.second = prev[now];
		path[++nrP] = aux;
		aux.first = now;
		aux.second = now;
		++distinct;
		viz[now] = distinct;
		while (viz[next[now]] != distinct)
		{
			now = next[now];
			viz[now] = distinct;
			aux.second = now;
		}
		cycle[++nrC] = aux;
		root[nrC] = nrP;
	} else {
		aux.first = aux.second;;
		aux.second = path[nrP].first;
		moves[++madeMoves] = aux;
		path[nrP].first = start;
	}

}

inline void gasesteCycle( int start )
{
	pr aux;
	aux.first = start;
	++distinct;
	int now = start;
	viz[now] = distinct;

	while (viz[next[now]] != distinct)
	{
		now = next[now];
		aux.second = now;
		viz[now] = distinct;
	}
	cycle[++nrC] = aux;
	root[nrC] = 0;
}

int main()
{
	freopen("telefon.in", "r", stdin);
	freopen("telefon.out", "w", stdout);
	
	n = get();
	for (int i = 1; i <= n; ++i)
	{
		next[i] = get();
		grad[next[i]]++;
	}
	for (int i = 1; i <= n; ++i)
	{
		if (grad[i] == 0)
		gasestePath(i);
	}
	for (int i = 1; i <= n; ++i)
	{
		if (!viz[i])
		gasesteCycle(i);
	}

/*
	fprintf(stderr, "PATHS\n");
	for (int i = 1; i <= nrP; ++i)
	{
		fprintf(stderr, "%d - %d %d\n", i, path[i].first, path[i].second);	
	}
	fprintf(stderr, "\nCYCLES\n");
	for (int i = 1; i <= nrC; ++i)
	{
		fprintf(stderr, "%d - %d %d %d\n", i, cycle[i].first, cycle[i].second, root[i]);	
	}
	fprintf(stderr, "\nMOVES MADE\n");
	for (int i = 1; i <= nrC; ++i)
	{
		fprintf(stderr, "%d - %d %d\n", i, moves[i].first, moves[i].second);	
	}
*/
	if (nrC == 1)
	{
		int nrMoves = madeMoves;
		if (nrP == 1)
			nrMoves++;
		printf("%d\n", nrMoves);
		if (nrP == 1) printf("%d %d\n", cycle[1].second, path[1].first);
		for (int i = 1; i <= madeMoves; ++i)
			printf("%d %d\n", moves[i].first, moves[i].second);
	} else {
		int nrMoves = madeMoves + nrC;
		printf("%d\n", nrMoves);

		for (int i = 1; i <= madeMoves; ++i)
			printf("%d %d\n", moves[i].first, moves[i].second);

		for (int i = 1; i < nrP; ++i)
			printf("%d %d\n", cycle[i].second, path[i+1].first);

		for (int i = (nrP>0?nrP:1); i < nrC; ++i)
			printf("%d %d\n", cycle[i].second, cycle[i+1].first);
		if (nrP > 0) printf("%d %d\n", cycle[nrC].second, path[1].first);
		else 		 printf("%d %d\n", cycle[nrC].second, cycle[1].first);

	}


	return EXIT_SUCCESS;
}

