// BALAN CATALIN
// 11 Apr 2010 - 10:46
// ONI 2010 - baraj 2 - teroristi

#include <cstdio>
#include <cstdlib>
#include <list>
using namespace std;

#define NMAX 1000010
#define SIGMA 27

char text[NMAX];
int care[NMAX]; // ce pereche e pusa la litera i
int cate[SIGMA][SIGMA];
int total[SIGMA];
int luate[SIGMA];
int needed[SIGMA];
list<int> G[SIGMA][SIGMA]; // pozitiile perechilor i j
list<int> unde[SIGMA]; // pozitiile literelor

int main()
{
	freopen("teroristi.in", "r", stdin);
	freopen("teroristi.out", "w", stdout);
	int n,m;
	scanf("%d %d\n", &n, &m);
	gets(text);
	for (int i = 0; i < n; ++i)
	{
		++needed[text[i]-'a'];
		unde[ text[i]-'a' ].push_back(i);
	}

	for (int i = 1; i <= m; ++i)
	{
		char aux[10];
		gets(aux);
		int x = aux[0]-'a';
		int y = aux[2]-'a';
//		fprintf(stderr, "%d %d\n", x, y);
		cate[x][y]++;
		G[x][y].push_back(i);
		total[x]++;
		total[y]++;
	}

/*	
	for (int i = 0; i < SIGMA; ++i)
	{
		if (!total[i] ) continue;
		fprintf(stderr, "\n%d - ", i);
		for (int j = 0; j < SIGMA; ++j)
		{
			fprintf(stderr, "%d ", cate[i][j]);
		}
	}
*/

	for ( int st = 0; st < SIGMA; ++st)
	{
		while (cate[st][st] && needed[st])
		{
			--needed[st];
			--cate[st][st];
			int pos = unde[st].back();
			unde[st].pop_back();
			care[pos] = G[st][st].back();
			G[st][st].pop_back();
			++luate[st];
			++luate[st];
		}
		luate[st] += cate[st][st];

	}

	for ( int st = 0; st < SIGMA; ++st)
	{
		if (!needed[st]) continue;
		for ( int dr = 0; dr < SIGMA; ++dr)
		{
			if (st == dr) continue;
			while (cate[st][dr] && needed[st] && ( (total[dr] - luate[dr]) > needed[dr]) )
			{
				--needed[st];
				--cate[st][dr];
				int pos = unde[st].back();
				unde[st].pop_back();
				care[pos] = G[st][dr].back();
				G[st][dr].pop_back();
				++luate[st];
				++luate[dr];
			}
			luate[st] += cate[st][dr];
		}
	}
	for (int dr = 0; dr < SIGMA; ++dr)
	{
		if (!needed[dr]) continue;
		for (int st = 0; st < SIGMA; ++st)
		{
			while (cate[st][dr] && needed[dr])
			{
				--needed[dr];
				--cate[st][dr];
				int pos = unde[dr].back();
				unde[dr].pop_back();
				care[pos] = G[st][dr].back();
				G[st][dr].pop_back();
			}
		}
	}

	for (int i = 0; i < n; ++i)
		printf("%d ", care[i]);
	printf("\n");

	return EXIT_SUCCESS;
}

