#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <utility>
#include <algorithm>
using namespace std;

#define NMAX 502

// PARSARE

#define CHUNK 8192
char Pbuf[CHUNK];
int Pp = CHUNK-1;
inline int get()
{
	while (Pbuf[Pp] < '0' || Pbuf[Pp] > '9')
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	int x = 0;	


	while (Pbuf[Pp] >= '0' && Pbuf[Pp] <= '9')
	{
		x = x*10+Pbuf[Pp]-'0';
		if (++Pp >= CHUNK) { fread(Pbuf, 1, CHUNK, stdin); Pp = 0; }
	}
	return x;
}

// END PARSARE

inline int max( int a, int b )
{
	return (a>b?a:b);
}
inline int abs( int a )
{
	return (a>0?a:-a);
}

int dx[4] = {0,1,0,-1};
int dy[4] = {1,0,-1,0};
int p[NMAX][NMAX];
int pmax[NMAX][NMAX];
int nmod, T, n, MOD;
deque< pair< int, int> > Q;
int ind[NMAX*NMAX];

inline bool cmp( int a, int b )
{
	return p[a/nmod][a%nmod] > p[b/nmod][b%nmod];
}
int main()
{
	freopen("v2d.in", "r", stdin);
	freopen("v2d.out", "w", stdout);

	n = get();
	T = get();
	MOD = get();
	int nn = n*n;
	nmod = n+5;

	for (int i = 1, l = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j, ++l)
		{
			p[i][j] = get();
			ind[l] = i*nmod + j;
		}


	for (int time = 1; time <= T; ++time)
	{
		sort( ind+1, ind+nn+1, cmp );
		// initialize
		int luate = 0, i = 1;
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				pmax[i][j] = -100;
		while (!Q.empty()) Q.pop_back();	
		luate = 0;
		while (luate < nn)
		{
			int val;
			if (Q.empty() || ( i<=nn && ( !Q.empty() && Q.front().first <= p[ ind[i]/nmod ][ ind[i]%nmod] )))
			{
				val = p[ ind[i]/nmod ][ ind[i]%nmod ];
				while ( i<=nn && val == p[ ind[i]/nmod ][ ind[i]%nmod ] ){
					Q.push_front( make_pair( p[ ind[i]/nmod ][ ind[i]%nmod ], ind[i] ) );
					++i;
				}
			}
			deque< pair< int, int> >::iterator it;
			val = Q.front().first;
			while ( Q.front().first == val )
			{
				int x = Q.front().second / nmod;
				int y = Q.front().second % nmod;
				Q.pop_front();

				for (int d = 0; d < 4; ++d)
				{
					int nx = x + dx[d];
					int ny = y + dy[d];
					if (nx < 1 || nx > n || ny < 1 || ny > n) continue;
					if (pmax[nx][ny] < val-1)
					{
						pmax[nx][ny] = val-1;
						++luate;
						Q.push_back( make_pair( val-1, nx*nmod+ny ) );
					}
				}
			}
		}

		for (int i = 1, l = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j, ++l)
			{
				p[i][j] = time + 1 + ( ( p[i][j] + time*pmax[i][j] ) % MOD);
				ind[l] = i*nmod+j;
			}

	}


	int s = 0;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
		{
			s=(s+p[i][j])%MOD;
		}

	printf("%d\n", s);

	return EXIT_SUCCESS;
}

