#include <fstream.h>
#include <math.h>

ifstream fi("v2d.in");
ofstream fo("v2d.out");

long long t,a[500][500],n,q,b[500][500];

void citire(){
	fi>>n;
	fi>>t;
	fi>>q;
	int i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			fi>>a[i][j];
	fi.close();
}

void init(){
	int i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			a[i][j]=b[i][j];
}

long long detMax(int ii,int jj){
	int i,j;
	long long max=-1000000000,sum=0;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			if(!(ii==i && jj==j)){
				sum=a[i][j]-abs(ii-i);
				sum-=abs(jj-j);
				if(sum>max)
					max=sum;
			}
	return max;
}

void rezolvare(){
	int i,j,z;
	for(z=2;z<=t+1;z++){
		for(i=1;i<=n;i++)
			for(j=1;j<=n;j++)
				b[i][j]=z+((a[i][j]+(z-1)*detMax(i,j))%q);
		init();
	}		
			
		
}

void afisare(){
	long long sum=0;
	int i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++){
			sum+=a[i][j];
			sum%=q;
		}
	fo<<sum<<'\n';
}

int main(){
	citire();
	rezolvare();
	afisare();
	return 0;
}
	
			

