#include<stdio.h>

int n,nrd,nrc,ok1,ok2,dinamic[2001],maxim;

struct drept {
	int lx,ly,rx,ry,arie;
} d[2001];

struct cerc {
	int x,y,r,arie;
} c[2001];

FILE *f,*g;

void read ()
{
	int i,cc;
	f=fopen("cuiburi.in","r");
	fscanf(f,"%d",&n);
	for (i=1;i<=n;++i)
	{
		fscanf(f,"%d",&cc);
		if (!cc)
		{
			ok1=1;
			++nrd;
			fscanf(f,"%d%d%d%d",&d[nrd].lx,&d[nrd].ly,&d[nrd].rx,&d[nrd].ry);
			d[nrd].arie=(d[nrd].rx-d[nrd].lx)*(d[nrd].ry-d[nrd].ly);
		}
		else
		{
			ok2=1;
			++nrc;
			fscanf(f,"%d%d%d",&c[nrc].x,&c[nrc].y,&c[nrc].r);
		}
	}
	fclose(f);
}

void quick (int st, int dr)
{
	int x,i=st,j=dr;
	drept aux;
	x=d[(st+dr)/2].arie;
	while (i<=j)
	{
		while (d[i].arie>x)
			++i;
		while (x>d[j].arie)
			--j;
		if (i<=j)
		{
			aux=d[i];
			d[i]=d[j];
			d[j]=aux;
			++i;
			--j;
		}
	}
	if (st<j)
		quick(st,j);
	if (i<dr)
		quick(i,dr);
}

int incape (int j, int i)
{
	if (d[j].lx>=d[i].lx && d[j].ly>=d[i].ly && d[j].rx<=d[i].rx && d[j].ry<=d[i].ry)
		return 1;
	return 0;
}

void solve1 ()
{
	int i,max,j;
	quick (1,nrd);
	// acum le am sortate, fac dinamica
	dinamic[n]=1;
	for (i=n-1;i>=1;--i)
	{
		max=0;
		for (j=n;j>i;--j)
			if ( incape (j,i) )
				if (dinamic[j]>max)
					max=dinamic[j];
		dinamic[i]=max+1;
		if (dinamic[i]>maxim)
			maxim=dinamic[i];
	}
	f=fopen("cuiburi.out","w");
	fprintf(f,"%d",maxim);
	fclose(f);
}

void quick2 (int st, int dr)
{
	int x,i=st,j=dr;
	cerc aux;
	x=c[(st+dr)/2].r;
	while (i<=j)
	{
		while (c[i].r>x)
			++i;
		while (x>c[j].r)
			--j;
		if (i<=j)
		{
			aux=c[i];
			c[i]=c[j];
			c[j]=aux;
			++i;
			--j;
		}
	}
	if (st<j)
		quick2(st,j);
	if (i<dr)
		quick2(i,dr);
}

int incape2 (int j, int i)
{
	if (c[j].x+c[j].r<=c[i].x+c[i].r && c[j].y+c[j].r<=c[i].y+c[i].r && c[j].x-c[j].r>=c[i].x-c[i].r && c[j].y-c[j].r>=c[i].y-c[i].r)
		return 1;
	return 0;
}

void solve2 ()
{
	int i,j,max;
	quick2 (1,nrc);
	dinamic[n]=1;
	for (i=n-1;i>=1;--i)
	{
		max=0;
		for (j=n;j>i;--j)
			if ( incape2 (j,i) )
				if (dinamic[j]>max)
					max=dinamic[j];
		dinamic[i]=max+1;
		if (dinamic[i]>maxim)
			maxim=dinamic[i];
	}
	f=fopen("cuiburi.out","w");
	fprintf(f,"%d",maxim);
	fclose(f);
}

int incape3 (int j, int i)         //cercu j in dreptunghiu i
{
	if (c[j].x+c[j].r<=d[i].rx && c[j].y+c[j].r<=d[i].ry && c[j].x-c[j].r>=d[i].lx && c[j].y-c[j].r>=d[i].ly)
		return 1;
	return 0;
}

int incape4 (int j,int i)         //dreptunghiu j in cercu i  
{
	if (c[i].x-c[i].r<d[j].lx && c[i].y-c[i].r<d[j].ly && c[i].x+c[i].r>d[j].rx && c[i].y+c[i].r>d[j].ry)
		return 1;
	return 0;
}

void solve3 ()
{
	int i,j,max,v[2001],poz=0,tip[2001],dinamic[2001];
	quick (1,nrd);
	quick2 (1,nrc);
	// interclasare
	// i merge pe dreptunghiuri
	// j merge pe cercuri
	i=1;
	j=1;
	while (i<=nrd && j<=nrc)
	{
		if (c[j].r*c[j].r>=d[i].arie)
		{
			v[++poz]=j;
			tip[poz]=0;
			++j;
		}
		else
		{
			v[++poz]=i;
			tip[poz]=1;
			++i;
		}
	}
	if (j<=nrc)
		for (i=j;i<=nrc;++i)
		{
			v[++poz]=i;
			tip[poz]=0;
		}
	else
		for (j=i;j<=nrd;++j)
		{
			v[++poz]=j;
			tip[poz]=1;
		}
	dinamic[n]=1;
	for (i=n-1;i>=1;--i)
	{
		max=0;
		if (tip[i])
		{
			for (j=n;j>i;--j)
				if (tip[j] && incape (v[j],v[i]) && dinamic[j]>max)
					{max=dinamic[j];}
				else
					{if (!tip[j] && incape3 (v[j],v[i]) && dinamic[j]>max)
						{max=dinamic[j];}}
		}
		else
		{
			for (j=n;j>i;--j)
				if (!tip[j] && incape2 (v[j],v[i]) && dinamic[j]>max)
				{max=dinamic[j];}
				else
				{
					if (tip[j] && incape4 (v[j],v[i]) && dinamic[j]>max)
					{max=dinamic[j];}
				}
		}
		dinamic[i]=max+1;
		if (dinamic[i]>maxim)
			maxim=dinamic[i];
	}
	f=fopen("cuiburi.out","w");
	fprintf(f,"%d",maxim);
	fclose(f);
}

int main ()
{
	read ();
	if (!ok2) //numa dreptunghiuri
		solve1 ();
	else
		if (!ok1) // numa cercuri
			solve2 ();
		else
			solve3 ();
	return 0;
}