#include <stdio.h>
#define NMAX 202
#define HMAX 400005
#define INF 1000000000
#define TMAX 55
int n,t,mod,A[TMAX][NMAX][NMAX],B[TMAX][NMAX][NMAX],rez;
void read()
{
	scanf("%d%d%d",&n,&t,&mod);
	int i,j;
	for (i=1; i<=n; i++)
		for (j=1; j<=n; j++)
			scanf("%d",&A[1][i][j]);
}
inline int modul(int x)
{
	return x<0 ? -x : x;
}
inline int max(int x,int y)
{
	return x>y ? x : y;
}
void init(int z)
{
	int i,j;
	for (i=1; i<=n; i++)
		for (j=1; j<=n; j++)
			B[z][i][j]=-INF;
}
void solve()
{
	int z,i,j,p,q,val;
	for (z=1; z<=t; z++)
	{
		init(z);
		for (i=1; i<=n; i++)
			for (j=1; j<=n; j++)
				for (p=1; p<=n; p++)
					for (q=1; q<=n; q++)
					{
						if (i!=p || j!=q)
						{
							val=A[z][i][j]-modul(i-p)-modul(j-q);
							B[z][p][q]=max(B[z][p][q],val);
						}
					}
		for (i=1; i<=n; i++)
			for (j=1; j<=n; j++)
				A[z+1][i][j]=z+1+((A[z][i][j]+z*B[z][i][j]) % mod);
	}
}
void prepare_rez()
{
	int i,j;
	for (i=1; i<=n; i++)
		for (j=1; j<=n; j++)
		{
			rez+=A[t+1][i][j];
			if (rez>=mod)
				rez%=mod;
		}
}
int main()
{
	freopen("v2d.in","r",stdin);
	freopen("v2d.out","w",stdout);
	read();
	solve();
	prepare_rez();
	printf("%d\n",rez);
	return 0;
}
