#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

#define Nmax 100010

struct nod {int x, d, c;} aux;

int n, N, i, Cmax;
int Poz[Nmax], Niv[Nmax], Cst[Nmax], viz[Nmax], T[Nmax];
vector <nod> V[Nmax];
long long sol;

void citire () {
	
	int t;
	
	scanf ("%d", &n);
	for (int i = 1; i < n; i++) {
		scanf ("%d %d %d %d", &t, &aux.x, &aux.d, &aux.c);
		V[t].push_back (aux);
		T[aux.x] = t;
	}
}

void dfs (int nod, int niv) {
	
	Niv[nod] = niv;
	
	int i;
	for (i = 0; i < (int)V[nod].size (); i++) {
		Cst[V[nod][i].x] = Cst[nod] + V[nod][i].d;		
		dfs (V[nod][i].x, niv + 1);
	}
}

void rezolva () {
	
	int nod, tata, j; viz[0] = 1;
	for (i = 1; i <= n; i++) {
		
		nod = Poz[i]; viz[nod] = 1;
		if (!viz[ T[nod] ]) {
			tata = T[nod]; Cmax = 0;
			viz[tata] = 1;
			
			for (j = 0; j < (int) V[tata].size (); j++) {
				nod = V[tata][j].x;
				if ( Cst[nod] > Cmax )
					Cmax = Cst[nod];
			}
			
			Cst[tata] = Cmax; 
			for (j = 0; j < (int) V[tata].size (); j++) {
				nod = V[tata][j].x;
				sol+= (long long) ( (long long) V[tata][j].c * (long long) (Cmax - Cst[nod]) );
			}
		}
	}
}

int cmp (int a, int b) {
	return Niv[a] > Niv[b];
}

int main () {

	freopen ("arb.in", "r", stdin);
	freopen ("arb.out", "w", stdout);
	
	citire ();
	dfs (1, 1);
	
	for (i = 1; i <= n; i++)
		Poz[i] = i;
	
	sort (Poz + 1, Poz + 1 + n, cmp);
	
	rezolva ();
	printf ("%lld", sol);
	
	return 0;
}
