#include <cstdio>
#include <algorithm>
#include <math.h>

using namespace std;

#define Nmax 2010

struct drept {int x1, y1, x2, y2;} d[Nmax];
struct margine {int x, y, tip;} L[Nmax];

int n, tip, N;
int Poz[Nmax], bst[Nmax];
double d1, d2;
long long D1, D2, D3, D4, R;

void citire () {
	
	scanf ("%d", &n);
	for (int i = 1; i <= n; i++) {
		scanf ("%d", &tip);
		if (tip == 0) {
			N++;
			scanf ("%d %d %d %d", &d[N].x1, &d[N].y1, &d[N].x2, &d[N].y2);
			L[i].tip = 0;
			L[i].x = d[N].x1;
			L[i].y = d[N].y1;
		}
		else {
			N++;
			scanf ("%d %d %d", &d[N].x1, &d[N].y1, &d[N].x2);
			L[i].tip = 1;
			L[i].x = d[N].x1 - d[N].x2;
			L[i].y = d[N].y1 - d[N].x2;
		}
		
		Poz[i] = i;
	}
}


int egal (double X, double Y) {
	X-= Y;
	if (X < 0) X = -X;
	if (X <= 0.000000000001) return 1;
	return 0;
}

long long dist (int x1, int y1, int x2, int y2) {
	return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

int inclus (int a, int b) {
	
	if (L[a].tip == 0) {
		if (L[b].tip == 0) { // Corect
			if (d[a].x1 >= d[b].x1 && d[a].x2 <= d[b].x2 && d[a].y1 >= d[b].y1 && d[a].y2 <= d[b].y2) 
				return 1;
			return 0;
		}
		
		else { // Corect
			D1 = dist (d[b].x1, d[b].y1, d[a].x1, d[a].y1), D2 = dist (d[b].x1, d[b].y1, d[a].x1, d[a].y2);
			D3 = dist (d[b].x1, d[b].y1, d[a].x2, d[a].y1), D4 = dist (d[b].x1, d[b].y1, d[a].x2, d[a].y2);
			
			R = d[b].x2 * d[b].x2;
			
			if (R >= D1 && R >= D2 && R >= D3 && R >= D4) return 1;
			return 0;
		}
	}
	
	else {
		if (L[b].tip == 0) { // Corect			
			if ( d[a].x1 - d[a].x2 >= d[b].x1 && d[a].x1 + d[a].x2 <= d[b].x2 && d[a].y1 - d[a].x2 >= d[b].y1 && d[a].y1 + d[a].x2 <= d[b].y2 )
				return 1;
			else
				return 0;
		}
		
		else { // Corect
			d1 = (double) dist (d[a].x1, d[a].y1, d[b].x1, d[b].y1);
			d1 = sqrt (d1);
			d1 += (double) d[a].x2;
			d2 = (double) d[b].x2;
			
			if ( d1 < d2 || egal (d1, d2) )
				return 1;
			else
				return 0;
		}
	}
	
	return 1;
}

int cmp (int a, int b) {
	
	if (L[a].x == L[b].x) {
		if (L[a].y == L[b].y) {
			if ( inclus (a, b) ) 
				return 0;
			return 1;
		}
		
		return L[a].y < L[b].y;
	}
	
	return L[a].x < L[b].x;
}

int main () {

	freopen ("cuiburi.in", "r", stdin);
	freopen ("cuiburi.out", "w", stdout);
	
	citire ();
	sort (Poz + 1, Poz + n + 1, cmp);
	
	int sol, o, oo, i, j;
	
	bst[1] = 1; sol = 1;
	for (i = 2; i <= n; i++) {
		oo = Poz[i];
		
		bst[i] = 1;
		for (j = i - 1; j >= 1; j--) {
			o = Poz[j];
			if ( bst[i] < bst[j] + 1 && inclus (oo, o) )
				bst[i] = bst[j] + 1;
		}
		
		if (bst[i] > sol) sol = bst[i];
	}
	
	printf ("%d", sol);
	
	return 0;
}
