#include <cstdio>
#include <algorithm>
#include <stdlib.h>
using namespace std;

#define Nmax 505

int n, T, Q;
int P[Nmax][Nmax], Pmax[Nmax][Nmax];

void citire () {
	
	int i, j;
	
	scanf ("%d %d %d", &n, &T, &Q);
	for (i = 0; i < n; i++)
		for (j = 0; j < n; j++)
			scanf ("%d", &P[i][j]);
}


void rezolva () {
	
	int i, j, k, l, z;
	for (z = 1; z <= T; z++) {
		
		for (i =0; i < n; i++) 
			for (j = 0; j < n; j++) {
				Pmax[i][j] = - (1 << 30);
				for (k = 0; k < n; k++)
					for (l = 0; l < n; l++) {
						if (k != i || l != j) {
							Pmax[i][j] = max (Pmax[i][j], P[k][l] - ( abs (k - i) + abs (l - j) ));
						}
					}
			}
		
		for (i = 0; i < n; i++) {
			for (j = 0; j < n; j++) {
				P[i][j] = z + 1 + ((P[i][j] + z * Pmax[i][j]) % Q);
				P[i][j]%= Q;
				
				if (P[i][j] < 0) {
					P[i][j]+= Q;
				}
			}
		}
	}
	
	int sol = 0;
	for (i = 0; i < n; i++) 
		for (j = 0; j < n; j++) {
			sol+= P[i][j];
			sol%= Q;
		}
	
	printf ("%d", sol);
}

int main () {

	freopen ("v2d.in", "r", stdin);
	freopen ("v2d.out", "w", stdout);
	
	citire ();
	rezolva ();
	
	return 0;
}
