#include <cstdio>

#define Nmax 1010
#define Qmax 20010

struct query {int L1, L2, C1, C2;} Q[Qmax];

int T, P, i, lmax, cmax;
int A[Nmax][Nmax], S[Nmax][Nmax];

void matrice () {

	int i, j;
	for (i = 1; i <= lmax; i++)
		for (j = 1; j <= cmax; j++)
			A[i][j] = i ^ j;
	
	for (i = 1; i <= lmax; i++)
		for (j = 1; j <= cmax; j++) {
			S[i][j] = A[i][j] + S[i-1][j] + S[i][j - 1] - S[i - 1][j - 1];
			S[i][j]%= P;
			if (S[i][j] < 0) S[i][j]+= P;
		}
	
	int rez, L1, L2, C1, C2;
	for (i = 1; i <= T; i++) {
		L1 = Q[i].L1; L2 = Q[i].L2;
		C1 = Q[i].C1; C2 = Q[i].C2;
		
		rez = S[L2][C2];
		rez = ((rez - S[L1 - 1][C2]) + P) %P;
		if (rez < 0) rez+= P;
		rez = ((rez - S[L2][C1 - 1]) + P) %P;
		if (rez < 0) rez+= P;
		rez = (rez + S[L1 - 1][C1 - 1]) % P;
		if (rez < 0) rez+= P;
		
		printf ("%d\n", rez);
	}
}



void doi () {
	
	int i, rez, L1, L2, C1, C2, lc, ll;
	
	for (i = 1; i <= T; i++) {
		L1 = Q[i].L1; L2 = Q[i].L2;
		C1 = Q[i].C1; C2 = Q[i].C2;
		
		lc = C2 - C1 + 1;
		ll = L2 - L1 + 1;
		
		if (lc % 2 == 0) {
			rez = lc * ll / 2;
			rez%= P;
		}
		
		else {
			rez = (lc - 1) * ll / 2;
			if (ll % 2 == 0) {
				rez+= ll / 2;
				rez%= P;
			}
			
			else {
				if ((L1 + C1) % 2 == 0)
					rez+= ll / 2;
				else
					rez+= ll / 2 + 1;
				
				rez%= P;
			}
		}
		
		printf ("%d\n", rez);
	}
}

int main () {

	freopen ("xor.in", "r", stdin);
	freopen ("xor.out", "w", stdout);
	
	scanf ("%d %d", &T, &P);
	for (i = 1; i <= T; i++) {
		scanf ("%d %d %d %d", &Q[i].L1, &Q[i].C1, &Q[i].L2, &Q[i].C2);
		if (lmax < Q[i].L2) lmax = Q[i].L2;
		if (cmax < Q[i].C2) cmax = Q[i].C2;
	}
	
	if (lmax <= 1001 && cmax <= 1001) matrice ();
	else {
		if (P == 2) {
			doi ();
		}
		
		else {
			printf ("Incorect!");
		}
	}
	
	return 0;
}
