#include<stdio.h>
struct cuibc
{
	int x, y, r;
};
struct cuibd
{
	int lx,ly, rx, ry;
};

struct cuib
{
	int tip, ref;
};

int n,itc,itd;
int mat[2005][2005];
cuib c[2005];
cuibc cc[2005];
cuibd cd[2005];
int cul[2005];
int atcul[2005];
int nocul[2005];
int indcul;
double dist(int x1, int y1, int x2, int y2)
{
	return (x1 - x2)*(x1 - x2) + (y1 - y2)*(y1 - y2);
}

int comparad(int a, int b)
{
	cuibd dr1, dr2;
	dr1 = cd[c[a].ref];
	dr2 = cd[c[b].ref];
	if(dr1.ly > dr2.ry)
		return 0;
	if(dr1.ry < dr2.ly)
		return 0;
	if(dr1.lx > dr2.rx)
		return 0;
	if(dr1.rx < dr2.lx)
		return 0;
	return 1;
}

int comparac(int a, int b)
{
	cuibc ce1, ce2;
	ce1 = cc[c[a].ref];
	ce2 = cc[c[b].ref];
	double dis;
	dis = dist(ce1.x,ce1.y,ce2.x,ce2.y);
	if(dis > ce1.r + ce2.r)
		return 0;
	return 1;
}

int comparam(int a, int b)
{
	cuibd dr;
	cuibc ce;
	dr = cd[c[a].ref];
	ce = cc[c[b].ref];
	int pctx, pcty; //crd cmapdc
	if(ce.x > dr.rx && ce.y < dr.ly)
	{
		pctx = dr.rx;
		pcty = dr.ly;
	}
	else if(ce.x < dr.lx && ce.y < dr.ly)
	{
		pctx = dr.lx;
		pcty = dr.ly;
	}
	else if(ce.x > dr.rx && ce.y > dr.ry)
	{
		pctx = dr.rx;
		pcty = dr.ry;
	}
	else if(ce.x < dr.lx && ce.y > dr.ry)
	{
		pctx = dr.lx;
		pcty = dr.ry;
	}
	else if(dr.ly > ce.y)
	{
		pctx = ce.x;
		pcty = dr.ly;
	}
	else if(dr.ry < ce.y)
	{
		pctx = ce.x;
		pcty = dr.ry;
	}
	else if(dr.rx < ce.x)
	{
		pctx = dr.rx;
		pcty = ce.y;
	}
	else
	{
		pctx = dr.lx;
		pcty = ce.y;
	}
	double dis;
	dis = dist(pctx,pcty,ce.x,ce.y);
	if(dis>ce.r)return 0;
	return 1;
}

int compara(int a, int b)
{
	if(c[a].tip == 0 && c[b].tip == 0)
		return comparad(a,b);
	else if(c[a].tip == 1 && c[b].tip == 1)
		return comparac(a,b);
	else if(c[a].tip == 0 && c[b].tip == 1)
		return comparam(a,b);
	else 
		return comparam(b,a);
}

void coloreaza(int l, int culoare)
{
	int min,max,i;
	if(cul[l] != 0)
	{
		min = culoare;
		max = cul[l];
		if(min > max){min = max; max = culoare;}
		atcul[max] = min;
	}
	else
	{
		nocul[culoare]++;
		cul[l] = culoare;
		for(i=0;i<n;i++)
			if(mat[l][i]&&i!=l)
				coloreaza(i,culoare);
	}
}

int main()
{
	freopen("cuiburi.in","r",stdin);
	freopen("cuiburi.out","w",stdout);
	scanf("%d", &n);
	int i,j,t,at,bt,ct,dt;
	for(i=0; i<n; i++)
	{
		scanf("%d", &t);
		c[i].tip = t;
		if(t==0)
		{
			scanf("%d %d %d %d", &at, &bt, &ct, &dt);
			c[i].ref = itd;
			cd[itd].lx = at;
			cd[itd].ly = bt;
			cd[itd].rx = ct;
			cd[itd].ry = dt;
			itd++;
		}
		else
		{
			scanf("%d %d %d", &at, &bt, &ct);
			c[i].ref = itc;
			cc[itc].x = at;
			cc[itc].y = bt;
			cc[itc].r = ct;
			itc++;
		}
	}
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
		{
			if(i==j)mat[i][j] = 1;
			else mat[i][j] = compara(i,j);
		}
	for(i=0;i<n;i++)
		coloreaza(i, i+1);
	for(i=n;i>1;i--)
		if(atcul[i]!=0)
		{
			nocul[atcul[i]] += nocul[i];
			nocul[i] = 0;
		}
	int max = 1;
	for(i=1;i<=n;i++)
		if(nocul[i]>max)max = nocul[i];
	printf("%d\n", max);
	return 0;
}
