#include<cstdio>
#include <algorithm>
#include<vector>

using namespace std;

struct smsg
{
	int c1,c2,ipoz;
};

struct stsol
{
	int ch, ipoz;
};

vector<smsg> list;
vector<stsol> vsol;
int n,m;
int have[30], need[30];
char msg[1000005];
int fol[1000005];


bool cmp( smsg a, smsg b )
{
	int difa,difb;
	difa = have[a.c1] - need[a.c1];
	if(have[a.c2] - need[a.c2] < difa)
		difa = have[a.c2] - need[a.c2];
	difb = have[b.c1] - need[b.c1];
	if(have[b.c2] - need[b.c2] < difb)
		difb = have[b.c2] - need[b.c2];
	if(difa == difb)
	{
		difa = have[a.c1] - need[a.c1];
		if(have[a.c2] - need[a.c2] > difa)
			difa = have[a.c2] - need[a.c2];
		difb = have[b.c1] - need[b.c1];
		if(have[b.c2] - need[b.c2] > difb)
			difb = have[b.c2] - need[b.c2];
		return difa < difb;
	}
	return difa < difb;
}

int main()
{
	smsg tmp;
	int i,it;
	char ch,ch2, junk[30];
	freopen("teroristi.in","r",stdin);
	freopen("teroristi.out","w",stdout);
	scanf("%d %d", &n, &m);
	scanf("%s", msg);
	for(i=0;i<m;i++)
	{
		scanf("%s", junk);
		ch = junk[0];
		scanf("%s", junk);
		ch2 = junk[0];
		
		tmp.c1 = ch-'a';
		tmp.c2 = ch2-'a';
		tmp.ipoz = i+1;
		have[tmp.c1]++;
		have[tmp.c2]++;
		list.push_back(tmp);
	}
	for(i=0;i<n;i++)
	{
		it = msg[i]-'a';
		need[it]++;
	}

	stsol tmpsol;
	sort( list.begin(), list.end(), cmp );
	for(i=0;i<m;i++)
	{
		tmp = list[i];
		if(need[tmp.c1] == 0 && need[tmp.c2] != 0)
		{
			tmpsol.ipoz = tmp.ipoz;
			tmpsol.ch = tmp.c2;
			need[tmp.c2]--;
		}
		else if(need[tmp.c1] != 0 && need[tmp.c2] == 0)
		{
			tmpsol.ipoz = tmp.ipoz;
			tmpsol.ch = tmp.c1;
			need[tmp.c1]--;
		}
		else if(need[tmp.c1] != 0 && need[tmp.c2] != 0)
		{
			if(have[tmp.c1]-need[tmp.c1] < have[tmp.c2] - need[tmp.c2])
			{
				tmpsol.ipoz = tmp.ipoz;
				tmpsol.ch = tmp.c1;
				need[tmp.c1]--;
			}
			else
			{
				tmpsol.ipoz = tmp.ipoz;
				tmpsol.ch = tmp.c2;
				need[tmp.c2]--;
			}
		}
		vsol.push_back(tmpsol);
		sort( list.begin()+1+i, list.end(), cmp );
	}
	int j;
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			if(msg[i]-'a' == vsol[j].ch && !fol[j])
			{
				printf("%d ", vsol[j].ipoz);
				fol[j] = 1;
				break;
			}
		}
	}
	return 0;
}
