#include <stdio.h>
#include <math.h>
#include <vector>
#include <queue>
#define FOR(i,a,b) for(i=a;i<=b;++i)
#define MAXN 2010

using namespace std;

struct cuib
{
    int t;
    int lx,ly,rx,ry,r;
};

int n,i,j,k;
int res;
cuib v[MAXN];
int pred[MAXN];
int r[MAXN];
int viz[MAXN],voltid[MAXN];
vector<int> g[MAXN];
queue<int> q;
vector<int>::iterator it;


double dist(int x1,int y1,int x2,int y2)
{
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

int benne(int x,int y)
{
    if (v[x].t)
    {
        if (v[y].t)
        {
            if ((dist(v[x].lx,v[x].ly,v[y].lx,v[y].ly)+v[x].r) <= v[y].r) return 1;
            return 0;
        }
        else
        {
            if ((v[y].lx <= v[x].lx-v[x].r) && (v[y].ly <= v[x].ly-v[x].r) && (v[y].rx >= v[x].lx+v[x].r) && (v[y].ry >= v[x].ly+v[x].r)) return 1;

            return 0;
        }
    }
    else
    {
        if (v[y].t)
        {
            if ((dist(v[x].lx,v[x].ly,v[y].lx,v[y].ly) <= v[y].r) && (dist(v[x].rx,v[x].ly,v[y].lx,v[y].ly) <= v[y].r) &&
                (dist(v[x].lx,v[x].ry,v[y].lx,v[y].ly) <= v[y].r) && (dist(v[x].rx,v[x].ry,v[y].lx,v[y].ly) <= v[y].r)) return 1;
            return 0;
        }
        else
        {
            if ((v[x].lx >= v[y].lx) && (v[x].ly >= v[y].ly) && (v[x].rx <= v[y].rx) && (v[x].ry <= v[y].ry)) return 1;
            return 0;
        }
    }
}

int main()
{
    freopen("cuiburi.in","r",stdin);
    freopen("cuiburi.out","w",stdout);

    scanf("%d\n",&n);
    FOR (i,1,n)
    {
        scanf("%d ",&v[i].t);
        if (!v[i].t) scanf("%d %d %d %d\n",&v[i].lx,&v[i].ly,&v[i].rx,&v[i].ry);
        else         scanf("%d %d %d\n",&v[i].lx,&v[i].ly,&v[i].r);
    }

    FOR (i,1,n)
        FOR (j,1,n)
            if ((i != j) && (benne(i,j) && (((!voltid[i]) &&  (i < j)) || (!benne(j,i)))))
            {
                if (benne(j,i)) voltid[i] = 1;
                g[i].push_back(j);
                pred[j]++;
            }

    FOR (i,1,n)
        if (!pred[i])
        {
            q.push(i);
            r[i] = 1;
            if (r[i] > res) res = r[i];
            viz[i] = 1;
        }

    /*FOR (i,1,n) printf("%d ",pred[i]);
    printf("\n");

    FOR (i,1,n)
    {
        printf("%d :",i);
        for (it = g[i].begin();it!=g[i].end();++it) printf("%d ",*it);
        printf("\n");
    }*/

    while (!q.empty())
    {
        k = q.front();
        q.pop();
        for (it = g[k].begin();it!=g[k].end();++it)
        {
            pred[*it]--;
            if ((!pred[*it]) && (!viz[*it]))
            {
                q.push(*it);
                viz[*it] = 1;
            }
            if (r[k]+1 > r[*it]) r[*it] = r[k]+1;
            if (r[*it] > res) res = r[*it];
        }
    }

    /*for (k = q.begin();k!=q.end();++k) printf("%d ",*k);
    printf("\n");*/

    printf("%d\n",res);

    return 0;
}
