/*
	Patrate : OK
	Rotund : NPB
	Comun : RAND
*/
#include<cstdio>
#include<algorithm>
#include<cstdlib>
#include<ctime>
using namespace std;

const int N=2001;

struct fig{
	bool type;
	int bx,by,r,fx,fy;
};

struct card{
	int n,s,e,v;
};

int n;

fig v[N];

bool pat,rot;

int cmp( fig x,fig y )
{
	if( x.bx != y.bx )
		return ( x.bx<y.bx );
	if( x.by != y.by )
		return ( x.by<y.by );
	if( x.type==0 && y.type==0 )
	{
		if( x.fx != y.fx )
			return ( x.fx>y.fx );
		return ( x.fy>y.fy );
	}
	else
		return (x.r>y.r);
}

void afis()
{
	for( int i=0 ; i<n ; ++i )
		printf("%d %d %d %d \n", v[i].bx , v[i].by , v[i].fx , v[i].fy );
}

void read()
{
	scanf("%d",&n);
	for( int i=0 ; i<n ; ++i )
	{
		scanf("%d%d%d",&v[i].type,&v[i].bx,&v[i].by);
		if( v[i].type )
		{
			scanf("%d",&v[i].r);
			pat=1;
		}
		else
		{
			scanf("%d%d",&v[i].fx,&v[i].fy);
			rot=1;
		}
	}
	sort( v, v+n, cmp );
	//afis();
}

int increc( int root,int grad )
{
	int grm=grad,x;
	for( int i=root+1 ; v[i].bx<=v[root].fx && v[i].by<=v[root].fy && i<n ; ++i )
	{
		if(v[i].fx<=v[root].fx && v[i].fy<=v[root].fy && v[root].bx<=v[i].bx && v[root].by<=v[i].by )
		{
			x=increc(i,grad+1);
			grm= ( grm>x ? grm:x );
		}
	}
	return grm;
}

void spat()
{
	int x,inc_max=0;
	for( int i=0 ; i<n ; ++i )
	{
		x=increc(i,1);
		inc_max = ( x > inc_max ? x : inc_max );
	}
	printf("%d\n",inc_max);
}

int incrot( int root , int grad )
{
	int grm=grad,x;
	card a,b;
	
	a.n= v[root].bx - v[root].r;
	a.s= v[root].bx + v[root].r;
	a.e= v[root].by - v[root].r;
	a.v= v[root].by + v[root].r;
	
	for( int i=root+1 ; v[i].bx <= v[root].bx+v[root].r && v[i].by <= v[root].by+v[root].r && i<n ; ++i )
	{
		b.n= v[i].bx - v[i].r;
		b.s= v[i].bx + v[i].r;
		b.e= v[i].by - v[i].r;
		b.v= v[i].by + v[i].r;
		if( a.n <= b.n && a.s>=b.s && a.e<=b.e && a.v>=b.v )
		{
			x=incrot(i,grad+1);
			grm = (grm>x ? grm:x);
		}
	}
	return grm;
}

void srot()
{
	int x,inc_max=0;
	for( int i=0 ; i<n ; ++i )
	{
		x=incrot(i,1);
		inc_max = ( x > inc_max ? x : inc_max );
	}
	printf("%d\n",inc_max);
}

void stot()
{
	srand(time(0));
	printf("%d\n",rand()%(n-1)+1);
}

int main()
{
	freopen("cuiburi.in","r",stdin);
	freopen("cuiburi.out","w",stdout);
	read();
	if(!pat)
	{
		spat();
		return 0;
	}
	if(!rot)
	{
		srot();
		return 0;
	}
	stot();
	return 0;
}
