#include <cstdio>
#include <ctime>
#define MAX 1001

int matrix[MAX+1][MAX+1];
int x1,y1,x2,y2;
int tests,p;
long long sum;
int time_passed;

void generate();
//void show();

int main() {
	freopen("xor.in","r",stdin);
	freopen("xor.out","w",stdout);

	scanf("%d",&tests);
	scanf("%d",&p);

	generate();

	for(int i=1;i<=tests;i++) {
		scanf("%d",&x1);
		scanf("%d",&y1);

		scanf("%d",&x2);
		scanf("%d",&y2);

		if(x1 > MAX || y1 > MAX || x2 > MAX || y2 > MAX)
			printf("0\n");
		else {
			for(int a=x1;a<=x2;a++)
				for(int b=y1;b<=y2;b++)
					sum+=matrix[a][b];
			printf("%lld\n",sum%p);
			sum = 0;
		}
	}

	fclose(stdin);
	fclose(stdout);

	//show();

	return (0);
}

void generate() {
	for(int i=1;i<=(MAX);i++)
		for(int k=1;k<=MAX;k++)
			matrix[i][k] = i ^ k;
}

/*void show() {
	for(int i=1;i<=MAX;i++) {
		for(int k=1;k<=MAX;k++)
			printf("%d ",matrix[i][k]);
		printf("\n");
	}
}*/
