#include <stdio.h>
#define NMAX 1024
#define n 1000
int a[NMAX][NMAX];
int MOD;
void precalc(){
	for(int i = 1; i <= n; ++i)
		for(int j = 1; j <= n; ++j){
			a[i][j] = (a[i-1][j] + a[i][j-1] -a[i-1][j-1] + (i ^ j)) % MOD;
			while(a[i][j] < 0) a[i][j] += MOD;
		}
	/*for(int i = 1; i <= 20; ++i){
		for(int j = 1; j <= 20; ++j)
			printf("%d ",(i ^ j )% MOD);
		printf("\n");
	}*/
}
int case1(int x1, int y1,int x2,int y2){
	int sol = a[x2][y2] - a[x1-1][y2] - a[x2][y1-1] + a[x1-1][y1-1];
	if(sol >= 0) return sol;
	int cat = -sol / MOD; cat++;
	sol += cat*MOD;
	while(sol >= MOD) sol -= MOD;
	while(sol < 0) sol += MOD;
	return sol;
}
int case2(int x1, int y1, int x2, int y2){
	int L1 = x2-x1+1, L2 = y2-y1+1;
	if(L1 == 2) return L2 & 1;
	if(L2 == 2) return L1 & 1;
	if( L1%MOD ==0 || L2%MOD==0) return 0;
	return x1 ^ y1;
}
int case3(int x1, int y1,int x2, int y2){
	int s = 0;
	for(int i = x1; i <= x2; ++i)
		for(int j = y1; j <= y2; ++j)
			s = (s + (j ^i)) %MOD;
	return s;
}
int main(){
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);
	int t;
	scanf("%d%d", &t, &MOD);
	if(MOD != 2) 
		precalc();
	for(int i = 1; i <= t; ++i){
		int x1, y1, x2 ,y2;
		scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
		if(MOD == 2) printf("%d\n", case2(x1,y1, x2,y2));
		else if(x2 <= n && y2 <= n) printf("%d\n", case1(x1, y1, x2, y2));
		else printf("%d\n", case3(x1,y1,x2, y2));
	}
	return 0;
}
