#include <stdio.h>
#include <vector>

using namespace std;

#define maxn 2010
#define pb push_back

long n, i, nc, tip, nod, nd, j, k, sol, nv[maxn], d[maxn], imp[maxn], coa[maxn];
struct cerc
{
	long x, y, r, nr;
} c[maxn];
struct drept
{
	long x1, y1, x2, y2, nr;
} dr[maxn];
vector<long> v[maxn];

inline long dist(long a, long b, long c, long d)
{
	return (a-c)*(a-c)+(b-d)*(b-d);
}

long d_d(long d1, long d2)
{
	if(dr[d1].x1<=dr[d2].x1 && dr[d2].x2<=dr[d1].x2 && dr[d1].y1<=dr[d2].y1 && dr[d2].y2<=dr[d1].y2)
		return 1;
	return 0;
}

long d_c(long d1, long c1)
{
	if(dr[d1].x1<=c[c1].x-c[c1].r && c[c1].r+c[c1].x<=dr[d1].x2 && dr[d1].y1<=c[c1].y-c[c1].r && c[c1].r+c[c1].y<=dr[d1].y2)
		return 1;
	return 0;
}

long c_d(long c1, long d1)
{
	if( dist(c[c1].x, c[c1].y, dr[d1].x1, dr[d1].y1)<=c[c1].r*c[c1].r &&
		dist(c[c1].x, c[c1].y, dr[d1].x1, dr[d1].y2)<=c[c1].r*c[c1].r &&
		dist(c[c1].x, c[c1].y, dr[d1].x2, dr[d1].y1)<=c[c1].r*c[c1].r &&
		dist(c[c1].x, c[c1].y, dr[d1].x2, dr[d1].y2)<=c[c1].r*c[c1].r)
		return 1;
	return 0;
}

long c_c(long c1, long c2)
{
	if(dist(c[c1].x, c[c1].y, c[c2].x, c[c2].y)<=(c[c1].r-c[c2].r)*(c[c1].r-c[c2].r) && c[c1].r>=c[c2].r)
		return 1;
	return 0;
}

int main()
{
	freopen("cuiburi.in", "r", stdin);
	freopen("cuiburi.out", "w", stdout);
	scanf("%d", &n);
	for(i=1; i<=n; i++)
	{
		scanf("%d", &tip);
		if(tip==0)
		{
			nd++;
			scanf("%d%d%d%d", &dr[nd].x1, &dr[nd].y1, &dr[nd].x2, &dr[nd].y2);
			dr[nd].nr=1;
			for(j=1; j<nd; j++)
			{
				if(dr[nd].x1==dr[j].x1 && dr[nd].x2==dr[j].x2 && dr[nd].y1==dr[j].y1 && dr[nd].y2==dr[j].y2)
				{
					dr[j].nr++;
					nd--;
					break;
				}
			}
		}
		else
		{
			nc++;
			scanf("%d%d%d", &c[nc].x, &c[nc].y, &c[nc].r);
			c[nc].nr=1;
			for(j=1; j<nc; j++)
			{
				if(c[nc].x==c[j].x && c[nc].y==c[j].y && c[nc].r==c[j].r)
				{
					c[j].nr++;
					nc--;
					break;
				}
			}
		}
	}
	for(i=1; i<=nd; i++)
	{
		d[i]=imp[i]=dr[i].nr;
	}
	for(i=1; i<=nc; i++)
	{
		d[i+nd]=imp[i+nd]=c[i].nr;
	}
	n=nc+nd;
	for(i=1; i<=nd; i++)
		for(j=1; j<=nd; j++)
			if(d_d(i, j) && i!=j)
			{
				v[i].pb(j);
				nv[j]++;
			}
	for(i=1; i<=nd; i++)
		for(j=1; j<=nc; j++)
			if(d_c(i, j))
			{
				nv[j+nd]++;
				v[i].pb(j+nd);
			}
	for(i=1; i<=nc; i++)
		for(j=1; j<=nd; j++)
			if(c_d(i, j))
			{
				nv[j]++;
				v[i+nd].pb(j);
			}
	for(i=1; i<=nc; i++)
		for(j=1; j<=nc; j++)
			if(c_c(i, j) && i!=j)
			{
				nv[j+nd]++;
				v[i+nd].pb(j+nd);
			}
	for(i=1; i<=n; i++)
	{
		if(nv[i]==0)
		{
			coa[++coa[0]]=i;
		}
	}
	for(i=1; i<=coa[0]; i++)
	{
		nod=coa[i];
		sol=max(sol, d[nod]);
		for(j=0; j<v[nod].size(); j++)
		{
			nv[v[nod][j]]--;
			if(nv[v[nod][j]]==0)
			{
				coa[++coa[0]]=v[nod][j];
			}
			d[v[nod][j]]=max(d[v[nod][j]], d[nod]+imp[v[nod][j]]);
		}
	}
	printf("%d\n", sol);
	return 0;
}