using namespace std;
#include<cstdio>
#include<vector>
#include<cmath>
#include<cstdlib>
#define pb push_back
#define ll long long
const int MAX_N = 2007;
struct cuib { int  x, y, rx, ry; bool cerc; };
cuib A[MAX_N]; int N;
vector<int>G[MAX_N];
int sol, post[MAX_N], ord[MAX_N], P, g[MAX_N], bst[MAX_N];
char viz[MAX_N];
char M[MAX_N][MAX_N];
bool interDD( cuib A, cuib B ) // drept A se cuibareste in drept B ?
{
	if( A.x >= B.x && A.rx <= B.rx && A.y >= B.y && A.ry <= B.ry) return 1;
	return 0;
}
inline ll dist( int x1, int y1, int x2, int y2)
{
	return (x1 - x2) * (x1-x2) + (y1 - y2)*(y1-y2);
}
inline bool interCC( cuib A, cuib B) // cerc A in B ?
{
	ll d = dist( A.x, A.y, B.x, B.y);
	double dd = sqrt((double)d);
	if( d >= 1LL*(A.rx + B.rx)*(A.rx + B.rx) ) return 0;
	if( A.rx == B.rx && A.x == B.x && A.y == B.y) return 1;
	if( dd + A.rx <= B.rx) return 1;
	return 0;
}
inline bool in(int x, int y, cuib A)
{
	if( dist(x,y, A.x, A.y) <= 1LL*A.rx * A.rx ) return 1;
	return 0;
}
inline bool interDC( cuib A, cuib B) // drept A in inter lui cercB?
{
	if(in( A.x, A.y, B) && in( A.x, A.ry, B ) && in( A.rx, A.y, B) && in( A.rx, A.ry, B )) return 1;
	return 0;
}
inline bool interCD( cuib A, cuib B) // cerc A in inter drept B?
{
	if( A.x < B.x || A.x > B.rx || A.y > B.ry || A.y < B.y || interDC(B, A)) return 0;
	if(in( B.x, B.y, A) || in( B.x, B.ry, A ) || in( B.rx, B.y, A) || in( B.rx, B.ry, A )) return 0;
	return 1;
}
void DF(int x)
{
	if(viz[x]) return;
	viz[x] = 1;
	unsigned i;
	for(i = 0; i < G[x].size(); ++i)
		DF(G[x][i]);
	post[++P] = x;
}
inline bool identice(cuib A, cuib B)
{
	if( A.cerc == B.cerc && A.x == B.x && A.y == B.y && A.rx == B.rx && A.ry == B.ry ) return 1;
	return 0;
}
int main()
{
	freopen("cuiburi.in","r",stdin); freopen("cuiburi.out","w",stdout);
	scanf("%d",&N);
	int i, cerc, j;
	for(i = 1; i <= N; ++i)
	{
		scanf("%d",&cerc);
		A[i].cerc = cerc;
		if(cerc) scanf("%d%d%d",&A[i].x, &A[i].y, &A[i].rx); 
		else scanf("%d%d%d%d",&A[i].x, &A[i].y, &A[i].rx, &A[i].ry);
	}
	for(i = 1; i <= N; ++i)
		for(j = 1; j <= N; ++j)
			if( i!=j )
			{
				if( identice(A[i], A[j]) )
				{
					M[i][j] = M[j][i] = 1;
					if(i < j) G[i].pb(j), g[j]++;
				}
				else if( A[i].cerc && A[j].cerc )
				{
					if( interCC(A[i],A[j]) ) G[i].pb(j), g[j]++, M[i][j] = 1;
				}
				else if(A[i].cerc && !A[j].cerc)
				{
					if( interCD(A[i], A[j])) G[i].pb(j), g[j]++, M[i][j] = 1;
				}
				else if( !A[i].cerc && !A[j].cerc )
				{
					if(interDD(A[i], A[j])) G[i].pb(j), g[j]++, M[i][j] = 1;
				}
				else if(interDC(A[i], A[j])) G[i].pb(j), g[j]++, M[i][j] = 1;
			}
	for(i = 1; i <= N; ++i)
		if(!g[i]) DF(i);
	for(i = 1; i <= P; ++i)
		ord[i] = post[N-i+1];
	bst[1] = 1;
	for(i = 2; i <= N; ++i)
	{
		bst[i] = 1;
		for(j = i - 1; j; --j)
			if(M[ord[j]][ord[i]] == 1 && bst[i] < bst[j] + 1)
				bst[i] = bst[j] + 1;
		if(bst[i] > sol) sol = bst[i];
	}
	printf("%d\n",sol);
	return 0;
}
