#include <iostream>
#include <vector>
#include <queue>
//#include <conio.h>
using namespace std;
#define INF 99999999

int N, Dmax, Dmin, viz[100001], deq[100001], C[3][3];
long long sol, D[100001];
vector<pair<int, int> > G[100001];

void DetArbore(int nod) {
	int p, q;
	vector<pair<int, int> > X;
	queue<int> Q;
	viz[nod]=1; Q.push(nod);
	D[nod]=0;
	while(!Q.empty()) {
		p=Q.front(); Q.pop();
		for(vector<pair<int, int> >::iterator it=G[p].begin(); it!=G[p].end(); it++) {
			if(!viz[(*it).first]) {
				D[(*it).first]=D[nod] + (*it).second;
				viz[(*it).first]=1;
				Q.push((*it).first);
				X.push_back(make_pair((*it).first, (*it).second));
			}
		}
		G[p].clear();
		for(vector<pair<int, int> >::iterator it=X.begin(); it!=X.end(); it++) {
			deq[p]++;
			G[p].push_back(make_pair((*it).first, (*it).second));
		}
		X.clear();
	}
}

void DFS(int nod) {
	for(vector<pair<int, int> >::iterator it=G[nod].begin(); it!=G[nod].end(); it++) {
		DFS((*it).first);
	}
	
	long long t=0;
	for(vector<pair<int, int> >::iterator it=G[nod].begin(); it!=G[nod].end(); it++) {
	    t=max(t, D[(*it).first] + (*it).second);
	}
    for(vector<pair<int, int> >::iterator it=G[nod].begin(); it!=G[nod].end(); it++) {
        sol+=(t - D[(*it).first] -	(*it).second);
	}		
	
    D[nod]=t;	
}

int main() {
	FILE *f1=fopen("arb.in", "r"), *f2=fopen("arb.out", "w");
	int i, j, p, q, d, c, x, y;
	fscanf(f1, "%d\n", &N);
	if(N==3) {
		for(i=1; i<N; i++) {
		    fscanf(f1, "%d %d %d %d\n", &x, &y, &d, &c);
			G[x].push_back(make_pair(y, d));
		    G[y].push_back(make_pair(x, d));
			C[x][y]=C[y][x]=c;
		}
	}
	else {
	    for(i=1; i<N; i++) {
		    fscanf(f1, "%d %d %d %d\n", &x, &y, &d, &c);
		    G[x].push_back(make_pair(y, d));
		    G[y].push_back(make_pair(x, d));
	    }
	}
	DetArbore(1);
	if(N==3) {
		int nr=0;
		for(i=1; i<=N; i++) {
			if(deq[i]==0) {
				nr++;
			}
		}
		if(nr==1) {
			sol=0;
		}
		else if(nr==2) {
			int maxim=0;
			for(vector<pair<int, int> >::iterator it=G[1].begin(); it!=G[1].end(); it++) {
				if((*it).second>maxim) {
					maxim=(*it).second;
				}
			}
			sol=0;
			for(vector<pair<int, int> >::iterator it=G[1].begin(); it!=G[1].end(); it++) {
				sol+=((maxim-(*it).second)*C[1][(*it).first]);
			}
		}
	}
	else {
	    Dmax=0; Dmin=INF; sol=0;
	    for(i=1; i<=N; i++) {
		    if(deq[i]==0) {
			    //nodul i este frunza
			    //Dmax=max(Dmax, D[i]);
			    //Dmin=min(Dmin, D[i]);
			    D[i]=0;
		    }
	    }
		DFS(1);
	}
	//cazul cind am numai muchii de cost 1
	fprintf(f2, "%lld\n", sol);
	fclose(f1); fclose(f2);
	return 0;
}
	