#include <fstream>
#include <algorithm>
#define IN "v2d.in"
#define OUT "v2d.out"
#define L 505
#define oo 0x3f3f3f


using namespace std;

ifstream fin (IN);
ofstream fout (OUT);

int mat[L][L];
int mat2[L][L];
int d1[L][L];
int d2[L][L];
int d3[L][L];
int d4[L][L];
int Q[L];
int Poz[L];
int q, n, t;

void citire()
{
    fin>>n>>t>>q;
    for (int i=0;i<n;i++)
        for (int j=0;j<n;j++)
            fin>>mat[i][j];
}

void calc()
{
    int inc=0, sf, V;
    //pe linii de la st la dr
    for (int i=0;i<n;i++)
    {
        Q[inc=1]=mat[i][0];
        Poz[sf=1]=0;
        for (int j=1;j<n;j++)
        {
            d1[i][j]=max(d1[i][j], Q[inc] - (j-Poz[inc]));
            d3[i][j]=max(d3[i][j], Q[inc] - (j-Poz[inc]));
            mat2[i][j]= max(mat2[i][j], Q[inc] - (j-Poz[inc]));

            V=mat[i][j];
            while (sf>=inc && V> Q[sf]-(j-Poz[sf]))
                sf--;
            Q[++sf]=V;
            Poz[sf]=j;
        }
    }
    //pe linii de la dr la st
    for (int i=0;i<n;i++)
    {
        Q[inc=1]=mat[i][n-1];
        Poz[sf=1]=n-1;
        for (int j=n-2;j>=0;j--)
        {
            if (Q[inc] - (Poz[inc]-j) > d2[i][j])
                d2[i][j] = Q[inc] - (Poz[inc]-j);

            if (Q[inc] - (Poz[inc]-j) > d4[i][j])
                d4[i][j] = Q[inc] - (Poz[inc]-j);

            if (Q[inc] - (Poz[inc]-j) > mat2[i][j])
                mat2[i][j] = Q[inc] - (Poz[inc]-j);


            V=mat[i][j];
            while (sf>=inc && V> Q[sf]-(Poz[sf]-j))
                sf--;
            Q[++sf]=V;
            Poz[sf]=j;
        }
    }

    // pe coloane de la jos in sus
    for (int i=0;i<n;i++)
    {
        Q[inc=1]=mat[0][i];
        Poz[inc=1]=0;
        for (int j=1;j<n;j++)
        {
            if (Q[inc] - (j-Poz[inc]) > d1[j][i])
                d1[j][i]= Q[inc] - (j-Poz[inc]);

            if (Q[inc] - (j-Poz[inc]) > d2[j][i])
                d2[j][i]= Q[inc] - (j-Poz[inc]);

            if (Q[inc] - (j-Poz[inc]) > mat2[j][i])
                mat2[j][i]= Q[inc] - (j-Poz[inc]);

            V=mat[j][i];
            while (sf>=inc && V> Q[sf]-(j-Poz[sf]))
                sf--;
            Q[++sf]=V;
            Poz[sf]=j;
        }
    }
    // pe coloane de sus in jos
    for (int i=0;i<n;i++)
    {
        Q[inc=1]=mat[n-1][i];
        Poz[sf=1]=n-1;
        for (int j=n-2;j>=0;j--)
        {
            if (Q[inc] - (Poz[inc]-j) > d3[j][i])
                d3[j][i]= Q[inc] - (Poz[inc]-j);

            if (Q[inc] - (Poz[inc]-j) > d4[j][i])
                d4[j][i]= Q[inc] - (Poz[inc]-j);

            if (Q[inc] - (Poz[inc]-j) > mat2[j][i])
                mat2[j][i]= Q[inc] - (Poz[inc]-j);

            V=mat[j][i];
            while (sf>=inc && V> Q[sf]-(Poz[sf]-j))
                sf--;
            Q[++sf]=V;
            Poz[sf]=j;
        }
    }

    for (int i=1;i<n;i++)
        for (int j=1;j<n;j++)
        {
            d1[i][j]=max(d1[i][j], d1[i-1][j-1]-2);
            d1[i][j]=max(d1[i][j], mat[i-1][j-1]-2);
        }
    for (int i=1;i<n;i++)
        for (int j=n-2;j>=0;j--)
        {
            d2[i][j]= max(d2[i][j], d2[i-1][j+1]-2);
            d2[i][j]=max(d2[i][j], mat[i-1][j+1]-2);
        }
    for (int i=n-2;i>=0;i--)
        for (int j=1;j<n;j++)
        {
            d3[i][j]= max(d3[i][j], d3[i+1][j-1]-2);
            d3[i][j]=max(d3[i][j], mat[i+1][j-1]-2);
        }
    for (int i=n-2;i>=0;i--)
        for (int j=n-2;j>=0;j--)
        {
            d4[i][j]= max(d4[i][j], d4[i+1][j+1]-2);
            d4[i][j]=max(d4[i][j], mat[i+1][j+1]-2);
        }
}

void fa()
{
    //fac matricea
    for (int i=0;i<n;i++)
        for (int j=0;j<n;j++)
        {
            if (i && j)
            {
                mat2[i][j]=max(mat2[i][j], d1[i-1][j-1]-2);
                mat2[i][j]=max(mat2[i][j], mat[i-1][j-1]-2);
            }

            if (i && j<n-1)
            {
                mat2[i][j]=max(mat2[i][j], d2[i-1][j+1]-2);
                mat2[i][j]=max(mat2[i][j], mat[i-1][j+1]-2);
            }
            if (i<n-1 && j)
            {
                mat2[i][j]= max( mat2[i][j], d3[i+1][j-1]-2);
                mat2[i][j]= max(mat2[i][j], mat[i+1][j-1]-2);
            }

            if (i<n-1 && j<n-1)
            {
                mat2[i][j]= max(mat2[i][j], d4[i+1][j+1]-2);
                mat2[i][j]= max(mat2[i][j], mat[i+1][j+1]-2);
            }
        }
}


void solve()
{
    long R;
    for (int niv=1;niv<=t;niv++)
    {
        calc();
        fa();
        R=0;
        for (int i=0;i<n;i++)
        {
            for (int j=0;j<n;j++)
            {
                d1[i][j]=d2[i][j]=d3[i][j]=d4[i][j]=-oo;
                mat[i][j]=niv+1+((mat[i][j] + niv*mat2[i][j])%q);
                //fout<<mat2[i][j]<<" ";
                R+=mat[i][j];
                R%=q;
                mat2[i][j]=-oo;
            }
            //fout<<"\n";
        }
           // fout<<"\n";
    }
    fout<<R<<"\n";
}

int main ()
{
    citire();
    solve();
    return 0;
}
