#include <stdio.h>
#include <string.h>

FILE *f=fopen("teroristi.in", "r");
FILE *g=fopen("teroristi.out", "w");



char s[1000001];
char v[1000001][2];
int evidenta[1000001];
int pozitie[1000001];
int nrs[50];
int nrv[50];

int n, m;


typedef struct nod
{
	int i;
	int poz;
	struct nod *adr;
};

nod *l[50];

typedef struct sir
{
	int i;
	struct sir *adr;
};

sir *ss[50];


void read()
{
	fscanf(f, "%d%d", &n, &m);
	char cv;
	fscanf(f, "%c", &cv);
	fgets(s, 1000000, f);
	
	
	for (int j=0; j<n; j++)
	{
		nrs[s[j]-'a'+1]++;
		int cv1=s[j]-'a'+1;
		if (ss[cv1]==NULL)
		{
			ss[cv1]=new sir;
			ss[cv1]->i=j;
			ss[cv1]->adr=NULL;
		}
		else
		{
			sir *p=new sir;
			p->i=j;
			p->adr=ss[cv1];
			ss[cv1]=p;
		}
	}	
	
	for (int i=1; i<=m; i++)
	{
		fscanf(f, "%c%c%c%c", &v[i][0], &cv, &v[i][1], &cv);
		nrv[v[i][0]-'a'+1]++;
		if (nrv[v[i][0]-'a'+1]!=nrv[v[i][1]-'a'+1])
			nrv[v[i][1]-'a'+1]++;
		
		int cv1=v[i][0]-'a'+1;
		int cv2=v[i][1]-'a'+1;
		
		if (l[cv1]==NULL)
		{
			l[cv1]=new nod;
			l[cv1]->i=i;
			l[cv1]->poz=0;
			l[cv1]->adr=NULL;
		}
		else
		{
			nod *p=new nod;
			p->i=i;
			p->poz=0;
			p->adr=l[cv1];
			l[cv1]=p;
		}
		if (cv2!=cv1)
		{
			if (l[cv2]==NULL)
			{
				l[cv2]=new nod;
				l[cv2]->i=i;
				l[cv2]->poz=1;
				l[cv2]->adr=NULL;
			}
			else
			{
				nod *q=new nod;
				q->i=i;
				q->poz=1;
				q->adr=l[cv2];
				l[cv2]=q;
			}
		}
	}
	
}

void program()
{
	int iesire=1;
	while (iesire)
	{
		iesire = 0;
		for (int i=1; i<=27; i++)
		{
			if (nrv[i]==nrs[i] && nrs[i]!=0)
			{
				iesire=1;
				nod * p = l[i];
				sir * q = ss[i];
				while (p && nrs[i] && q)
				{
					if (!evidenta[p->i])
					{
						evidenta[p->i]=1;
						if (i!=v[p->i][1-p->poz]-'a'+1)
							nrv[v[p->i][1-p->poz]-'a'+1]--;
						
						pozitie[q->i]=p->i;
					
						nrs[i]--;
						nrv[i]--;
						p=p->adr;
						q=q->adr;
					}
					else
						p=p->adr;
				}
				if (p!=NULL)
					l[i]=p;
				if (q!=NULL)
					ss[i]=q;
			}
		}		
	}
	for (int i=1; i<=27; i++)
	{
		while (nrs[i]!=0)
		{
			nod *p=l[i];
			int max=-1000001;
			int maxi=-1;
			while (p)
			{
				if (nrv[v[p->i][1-p->poz]-'a'+1]-nrs[v[p->i][1-p->poz]-'a'+1]>max && !evidenta[p->i])
				{
					max=nrv[v[p->i][1-p->poz]-'a'+1]-nrs[v[p->i][1-p->poz]-'a'+1];
					maxi=p->i;
				}
				p=p->adr;
			}
			if (maxi!=-1)
			{
				p=l[i];
				while (p->i!=maxi)
					p=p->adr;
				nrs[i]--;
				nrv[i]--;
				if (i!=v[p->i][1-p->poz]-'a'+1)
					nrv[v[p->i][1-p->poz]-'a'+1]--;
				evidenta[p->i]=1;
				pozitie[ss[i]->i]=p->i;
				ss[i]=ss[i]->adr;
			}
		}
	}
	
	for (int k=0; k<n; k++)
		fprintf(g, "%d ", pozitie[k]);
}
		




int main()
{
	read();
	program();
	
	fclose(f);
	fclose(g);
	return 0;
}
