#include <cstdio>
#include <vector>
#include <utility>
#include <bitset>
#include <cstdlib>
#include <ctime>

using namespace std;
typedef long long int64;

FILE* fin=fopen("arb.in","rb");
FILE* fout=fopen("arb.out","w");

//<parsare>
const int maxb=8192;
char buf[maxb];
int ptr=maxb;

inline int getInt(){
	int nr=0;
	while(buf[ptr]<'0'||'9'<buf[ptr]){
		if(++ptr>=maxb){
			fread(buf,1,maxb,fin),ptr=0;
		}
	}
	while('0'<=buf[ptr]&&buf[ptr]<='9'){
		nr=nr*10+buf[ptr]-'0';
		if(++ptr>=maxb){
			fread(buf,1,maxb,fin),ptr=0;
		}
	}
	return nr;
}
//</parsare>

#define MAX 100005
#define min(a,b) (((a)<(b))?(a):(b))

struct edg{
	int t,y,d,c;
	edg(int _t,int _y,int _d,int _c):t(_t),y(_y),d(_d),c(_c){}
};

vector<edg> nod[MAX];
bitset<MAX> nf;
int64 cost=0;
int n;

int main(){
	int x,y,d,c;
	n=getInt();
	
	for(int i=0;i<n-1;i++){
		x=getInt(),y=getInt(),d=getInt(),c=getInt();
		nod[x].push_back(edg(x,y,d,c));
		nf[x]=true;
	}
	
	if(n==3){
		if(nod[1][0].d<nod[1][1].d){
			cost=nod[1][0].c*(nod[1][1].d-nod[1][0].d));
		}else{
			cost=nod[1][1].c*(nod[1][0].d-nod[1][1].d));
		}
	}else{
		srand(clock());
		cost=rand();
	}
	
	fprintf(fout,"%lld",cost);
	
	fclose(fin);
	fclose(fout);
	return 0;
}
