#include <fstream>

using namespace std;

const int MAX_N = 505;

ifstream fin ("v2d.in");
ofstream fout ("v2d.out");

int N, T, Q, P[2][MAX_N][MAX_N], Pmax[2][MAX_N][MAX_N];

void citire()
{
	fin >> N >> T >> Q;

	for(int i = 1; i <= N; ++i)
		for(int j = 1; j <= N; ++j)
			fin >> P[1][i][j];
}

int dist(int i, int j, int x, int y)
{
	return abs(i-x) + abs(j-y);
}

void solve()
{
	int act = 0, vit = 0;

	for(int z = 1; z <= T; ++z)
	{
		act = z & 1;
		vit = act ^ 1;

		for(int i = 1; i <= N; ++i)
			for(int j = 1; j <= N; ++j)
			{
				int cst = 0;

				for(int x = 1; x <= N; ++x)
					for(int y = 1; y <= N; ++y)
					{
						if(x == i && y == j) continue;

						cst = max(cst, P[act][x][y] - dist(i, j, x, y));
					}

				P[vit][i][j] = z+1 + ((P[act][i][j] + z*cst) % Q);
				Pmax[act][i][j] = cst;
			}
		
/*		for(int i = 1; i <= N; ++i)
		{
			for(int j = 1; j <= N; ++j)
				fout << Pmax[act][i][j] << " ";
			fout << "\n";
		}
		
		fout << "\n\n";	*/
	}

	int sol = 0;
	for(int i = 1; i <= N; ++i)
		for(int j = 1; j <= N; ++j)
			sol = (sol + P[vit][i][j]) % Q;

	fout << sol;
}

int main()
{
	citire();
	solve();
	
	return 0;
}
