#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

#define maxN 100100

using namespace std;

int N, i, j, sol;
vector <int> G[maxN], d[maxN], mcost[maxN];
int viz[maxN], cst, a, b, dist, dmax[maxN];
int cost[maxN], cmax[maxN], maxim;

void df(int nod, int cat) {
	int fiu, i, ok = 0;
	if (viz[nod])	return;
	viz[nod] = 1;

	for (i = 0; i < G[nod].size(); i++) {
		fiu = G[nod][i];
		if (!viz[fiu]) {
			df(fiu, cat + d[nod][i]);
			cmax[nod] = max(cmax[nod], cmax[fiu]);
			ok = 1;
		}
	}

	if (ok == 0) {
		cmax[nod] = cat;
		cost[nod] = 0;
		return;
	}
	cost[nod] = cmax[nod] - cat;
}

void df2(int nod, int cat) {
	int i, fiu, dif;
	if (viz[nod])	return;
	viz[nod] = 1;

	for (i = 0; i < G[nod].size(); i++) {
		fiu = G[nod][i];
		if (!viz[fiu]) {
//			fprintf(stderr, "%d %d    %d %d %d\n", nod, fiu, cat, d[nod][i], cost[fiu]);
			dif = maxim - cat - d[nod][i] - cost[fiu];
//			fprintf(stderr, "%d\n\n", dif);
			sol += dif * mcost[nod][i];
			df2(fiu, cat + dif + d[nod][i]);
		}
	}	
}

int main() {	
	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);

	scanf("%d", &N);

	for (i = 1; i < N; i++) {
		scanf("%d%d%d%d", &a, &b, &dist, &cst);
		G[a].push_back(b); d[a].push_back(dist); mcost[a].push_back(cst);
		G[b].push_back(a); d[b].push_back(a); mcost[b].push_back(cst);
	}

	df(1, 0);
	maxim = cmax[1];

	memset(viz, 0, sizeof(viz));
	df2(1, 0);

	printf("%d\n", sol);


	return 0;
}
