#include <iostream>
#include <string>

using namespace std;

#define NM 1005
#define TM 20005

int SUM[NM][NM], T, P, lmax, cmax, L[TM][2], C[TM][2], ANS[TM];

int A[30][30];

inline void baga2t()
{
	int L1, L2, C1, C2; 
	
	for (int i = 1; i <= T; ++i)
	{
		int ans = 0;
		
		L1 = L[i][0];
		C1 = C[i][0];
		L2 = L[i][1];
		C2 = C[i][1];
		
		int cols = C2 - C1 + 1;
		int lins = L2 - L1 + 1;
		
		int pl = (cols)/2;
		int dl = (cols)/2;
		
		if (cols % 2) if ((L1 ^ C1) % 2) ++pl;
									else ++dl;
		
		pl %= 2;
		dl %= 2;
		
		ans = pl * lins/2 + dl * lins/2;
		
		if (lins % 2) ans += pl;
		
		ans %= 2;

		ANS[i] = ans;	
	}	
}

inline void baga4t()
{
	int L1, L2, C1, C2; 
	
	for (int i = 1; i <= lmax; ++i)
		for (int j = 1; j <= cmax; ++j)
		{	
			//SUM[i][j] = (((i ^ j) % P) + SUM[i-1][j] + SUM[i][j-1] - SUM[i-1][j-1]) % P;
			
			SUM[i][j] += ((i ^ j)%P);
			if (SUM[i][j] >= P) SUM[i][j] -= P;
			
			SUM[i][j] += SUM[i-1][j];
			if (SUM[i][j] >= P) SUM[i][j] -= P;
			
			SUM[i][j] += SUM[i][j-1];
			if (SUM[i][j] >= P) SUM[i][j] -= P;
			
			SUM[i][j] -= SUM[i-1][j-1];
			if (SUM[i][j] < 0) SUM[i][j] += P;
			
			
		}	
	
	for (int i = 1; i <= T; ++i)
	{
		L1 = L[i][0];
		C1 = C[i][0];
		L2 = L[i][1];
		C2 = C[i][1];
		
		int ans = (SUM[L2][C2] - SUM[L1-1][C2] - SUM[L2][C1-1] + SUM[L1-1][C1-1] + 2*P) % P;
		
		ANS[i] = ans;
	}	
}

inline void verifica()
{
	int L1, L2, C1, C2; 
	
	for (int i = 1; i <= T; ++i)
	{
		L1 = L[i][0];
		C1 = C[i][0];
		L2 = L[i][1];
		C2 = C[i][1];
		
		int ans = 0;
		
		for (int l = L1;l <= L2; ++l)
			for (int c = C1; c <= C2; ++c)
				ans=(ans + (l ^ c)) % P;
		
		//printf ("%d\n", ans);	
			
		if (ans != ANS[i])
		{
			//printf ("Gresit");
			return ;
		}		
	}	
	
	//printf ("Corect");
}	

inline void bagab()
{
	int L1, L2, C1, C2; 
	
	for (int i = 1; i <= T; ++i)
	{
		L1 = L[i][0];
		C1 = C[i][0];
		L2 = L[i][1];
		C2 = C[i][1];
		
		ANS[i] = 0;
		
		for (int l = L1;l <= L2; ++l)
			for (int c = C1; c <= C2; ++c)
				ANS[i]=(ANS[i] + (l ^ c)) % P;
	}	
}	

int main()
{
	freopen ("xor.in", "r", stdin);
	freopen ("xor.out", "w", stdout);
	
	scanf ("%d %d", &T, &P);
	
	for (int i = 1; i <= T; ++i) 
	{	
		scanf ("%d %d %d %d", &L[i][0], &C[i][0], &L[i][1], &C[i][1]);
		lmax = max (lmax, L[i][1]);
		cmax = max (cmax, C[i][1]);
	}	
	
	if (P == 2) baga2t();
	else if (lmax <= 1000 && cmax <= 1000) baga4t();
	     else bagab(); 
	
	for (int i = 1; i <= T; ++i)
		printf ("%d\n", ANS[i]);
	
	//verifica(); 
	
	return 0;
}