#include <cstdio>

FILE *fin=fopen("xor.in","r");
FILE *fout=fopen("xor.out","w");

#define MAX 1024

int a[MAX][MAX];

int p;

inline int mod(int a)
{
    if (a>=0)
        return a%p;
    else
        return a+p*(1+(-a)/p);
}

int main()
{
    int t;
    fscanf(fin,"%d %d",&t,&p);
    a[0][0]=0;
    for (int i=1; i<MAX; i++)
        a[0][i]=a[i][0]=0;

    for (int i=1; i<MAX; i++)
    {
        for (int j=1; j<MAX; j++)
        {
            a[i][j]=mod(a[i][j-1]+a[i-1][j]-a[i-1][j-1]+(i^j));
            //fprintf(fout,"%d ",a[i][j]);
        }
        //fputc('\n',fout);
    }
    for (int k=0; k<t; k++)
    {
        unsigned int l1,l2,c1,c2;
        fscanf(fin,"%u %u %u %u",&l1,&c1,&l2,&c2);
        for (int i=sizeof(unsigned int)*8-1; i>=0; i--)
        {
            if ((l1&l2&c1&c2)&(1<<i))
            {
                l1&=~(1<<i);
                l2&=~(1<<i);
                c1&=~(1<<i);
                c2&=~(1<<i);
                continue;
            }
            if ((l1|l2|c1|c2)&(1<<i))
                break;
        }
        if (p==2)
        {
            int res;
            res=(((l2-l1+1)>>1)&1)*(c2-c1+1);
            res=res&1;
            if (((l2-l1+1)&1)&&((c2-c1+1)&1))
            {
                res+=l2^l1;
                res=res&1;
            }
            fprintf(fout,"%d\n",res);
            continue;
        }
        if ((c2<MAX)&&(l2<MAX))
        {
            fprintf(fout,"%d\n",mod(a[l2][c2]-a[l1-1][c2]-a[l2][c1-1]+a[l1-1][l2-1]));
            continue;
        }
        int sum=0;
        for (int i=l1; i<=l2; i++)
            for (int j=c1; j<=c2; j++)
                sum=mod(sum+i^j);
        fprintf(fout,"%d\n",sum);
    }
    fclose(fin);
    fclose(fout);
    return 0;
}
