#include <fstream>
#include <algorithm>
#include <cmath>
using namespace std;

ifstream in("v2d.in");
ofstream out("v2d.out");

int x[510][510],n,q,t,s,z,k,l,xm[510][510],i,j;

inline int dist(int i, int j, int k, int l)
{
	int ret = i-k;
	if(i<k)
		ret*=-1;
	if(j<l)
		ret+=l-j;
	else
		ret+=j-l;
	return ret;
}

int main()
{
	in>>n>>t>>q;
	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			in>>x[i][j];
	for(z=1; z<=t; z++)
	{
		memset(xm,-32000,sizeof(xm));
		for(i=0; i<n; i++)
			for(j=0; j<n; j++)
				for(k=0; k<n; k++)
					for(l=0; l<n; l++)
						if((i!=k || j!=l) && xm[i][j] < x[k][l]-dist(i,j,k,l))
							xm[i][j] =x[k][l]-dist(i,j,k,l);
		for(i=0; i<n; i++)
			for(j=0; j<n; j++)
				x[i][j] = z+1+(x[i][j]+z*xm[i][j])%q;
	}
	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			s += x[i][j];
	out<<s%q;
	return 0;
}