#include <stdio.h>
#define maxN    1001
#define maxM    20100

inline int max (int a, int b) {
    return a > b ? a : b;
}

int A[maxN][maxN], S[maxN][maxN];
int N, P, X1[maxM], Y1[maxM], X2[maxM], Y2[maxM];

void brut () {
    int i, j;

    for (i = 1; i <= 1000; ++ i)
        for (j = 1; j <= 1000; ++ j)
            A[i][j] = i ^ j;

    for (i = 1; i <= 1000; ++ i)
        for (j = 1; j <= 1000; ++ j)
            S[i][j] = (P + S[i - 1][j] + S[i][j - 1] + A[i][j] - S[i - 1][j - 1]) % P;

    for (i = 1; i <= N; ++ i)
        printf("%d\n", (3 * P + S[X2[i]][Y2[i]] - S[X2[i]][Y1[i] - 1] - S[X1[i] - 1][Y2[i]] + S[X1[i] - 1][Y1[i] - 1]) % P);
}

void do_p_2 () {
    int a, b, c, d;
    int pare_x, pare_y, impare_x, impare_y;

    for (int i = 1; i <= N; ++ i) {
        a = X1[i];
        b = X2[i];
        c = Y1[i];
        d = Y2[i];

        pare_x = (b / 2) - (a - 1) / 2;
        impare_x = b - a + 1 - pare_x;

        pare_y = (d / 2) - (c - 1) / 2;
        impare_y = d - c + 1 - pare_y;

        printf("%d\n", ((pare_x * impare_y) + (pare_y * impare_x)) % 2);
    }
}

void do_egale() {
    int i, j, Sum;

    for (i = 1; i <= N; ++ i) {
        for (j = Y1[i], Sum = 0; j <= Y2[i]; ++ j)
            Sum = (Sum + (X1[i] ^ j)) % P;
        printf("%d\n", Sum);
    }
}

int main () {
    int i;
    int xmax = 0, ymax = 0;

    freopen("xor.in", "r", stdin);
    freopen("xor.out", "w", stdout);

    scanf("%d%d", &N, &P);

    for (i = 1; i <= N; ++ i) {
        scanf("%d%d%d%d", &X1[i], &Y1[i], &X2[i], &Y2[i]);
        xmax = max(xmax, X2[i]);
        ymax = max(ymax, Y2[i]);
    }

    if (xmax <= 1000 && ymax <= 1000)
        brut();
    else if (P == 2)
        do_p_2();
    else if (X1[1] == X2[1])
        do_egale(); 
    else
        for (i = 1; i <= N; ++ i)
            printf("0\n");
}

