#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define MAX_N 100010
#define pb push_back

int n, p, q, d_edge, c_edge;
int h[MAX_N], use[MAX_N], tata[MAX_N], c_tata[MAX_N];
long long c[MAX_N], sol;
vector <int> G[MAX_N], cost[MAX_N], d[MAX_N];

void cit() {

	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 1; i < n; i++) { 
    	scanf("%d %d %d %d", &p, &q, &d_edge, &c_edge);
		G[p].pb(q); G[q].pb(p);
		cost[p].pb(c_edge); cost[q].pb(c_edge);
		d[p].pb(d_edge); d[q].pb(d_edge);
	}
}

void dfs(int nod, int dist) {
	use[nod] = 1;

	int len = G[nod].size(), hmax = 0;
	for (int i = 0; i < len; i++)
		if (!use[G[nod][i]]) {
			c_tata[G[nod][i]] = cost[nod][i];
			tata[G[nod][i]] = nod;
			dfs(G[nod][i], dist + d[nod][i]);

			hmax = max(hmax, h[G[nod][i]]);
		}

	if (len == 1) {
    	h[nod] = dist;
		c[nod] = c_tata[nod]; 
	}
	else {
		int sum = 0;
    	for (int i = 0; i < len; i++) {
			if (tata[G[nod][i]] == nod) {
				if (h[G[nod][i]] < hmax)
	            	sol = sol + 1LL * c[G[nod][i]] * (hmax - h[G[nod][i]]);
				sum = sum + c[G[nod][i]];
			}
		}

		c[nod] = min(sum, c_tata[nod]);
		h[nod] = hmax;
	}
}

int main() {

	cit();
	dfs(1, 0);
	printf("%lld\n", sol);

	return 0;
}
