#include <stdio.h>

#define MAX_N 1024

int T, P;
long long x1, y1, x2, y2;
int mat[MAX_N][MAX_N], sum[MAX_N][MAX_N];

inline int calc_sum(long long lin, long long st, long long dr) {
	if (lin % 2 == 1) { //am 0 1 0 1 0 1 0 1 ...
		if (st % 2 == dr % 2) 
			return (1 - st % 2 + ((dr - st) / 2) % 2) % 2;
		else return (calc_sum(lin, st + 1, dr) + 1 - st % 2) % 2;
	}
	else {
        if (st % 2 == dr % 2)
            return (st % 2 + ((dr - st) / 2) % 2) % 2;
        else return (calc_sum(lin, st + 1, dr) + st % 2) % 2;
	}
}

int main() {

	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);

	scanf("%d %d", &T, &P);

	for (int i = 1; i < MAX_N; i++)
		for (int j = 1; j < MAX_N; j++) {
			mat[i][j] = (i ^ j) % P;
        	sum[i][j] = (sum[i][j - 1] + sum[i - 1][j] - sum[i - 1][j - 1] + mat[i][j]) % P;
		}
			
	for (; T; T--) {
		scanf("%lld %lld %lld %lld", &x1, &y1, &x2, &y2);	

		if (P != 2) {
			int val = (sum[x2][y2] - sum[x2][y1 - 1] - sum[x1 - 1][y2] + sum[x1 - 1][y1 - 1]) % P;
			if (val < 0) val += P;
			printf("%d\n", val);
		}
		else {
            int s1 = calc_sum(x1, y1, y2);
			int s2 = calc_sum(x1 + 1, y1, y2);

			printf("%lld\n", ((((x2 - x1 + 1) / 2) % 2) * ((s1 + s2) % 2) + ((x2 - x1 + 1) % 2) * s1) % 2);
		}
	}

	return 0;
}
