#include <fstream>
#include <cstdio>
#include <cmath>
#define maxn 502

using namespace std;

int n,t,q,z;
int P[maxn][maxn],pmax[maxn][maxn];

int pa(int i, int j, int p, int q)
{
    return P[i][j]-(abs(i-p)+abs(j-q));
}

int calc(int lin, int col)
{
    int max=0;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
            if(i!=lin || j!=col)
            {
                int x=pa(i,j,lin,col);
                if(max<x)
                    max=x;
            }
    return max;
}

int main()
{
    ifstream f("v2d.in");
    freopen("v2d.out","w",stdout);
    f>>n>>t>>q;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
            f>>P[i][j];
    z=1;
    while(z<=t)
    {
        for(int i=1;i<=n;i++)
            for(int j=1;j<=n;j++)
                pmax[i][j]=calc(i,j);
        z++;
        for(int i=1;i<=n;i++)
            for(int j=1;j<=n;j++)
                P[i][j]=z+((P[i][j]+(z-1)*pmax[i][j])%q);
    }
    int s=0;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        {
            s+=P[i][j];
            s%=q;
        }
    printf("%d\n",s);
    fclose(stdout);
    return 0;
}
