#include <fstream>
#include <cstdio>
#include <cmath>

using namespace std;

int T,p;
int l1,l2,c1,c2;
int nrlin,nrcol,pow1,pow2,maxim1,maxim2,total,sum;
long long cate[100],cate2[100];

void rezolva(int l1, int l2, long long int cate[],int &maxim)
{
    pow1=pow2=0;
    int aux=l1;
    while(aux)
    {
        aux/=2;
        pow1++;
    }
    aux=l2;
    while(aux)
    {
        aux/=2;
        pow2++;
    }
    for(int i=pow1+1;i<pow2;i++)
    {
        cate[i]=pow(2.0,i-1);
        if(i>maxim)
            maxim=i;
        for(int j=i-1;j>=1;j--)
            cate[j]=cate[i]/2;
    }
    for(int i=l1;i<pow(2.0,pow1);i++)
    {
        int aux=i,k=0;
        while(aux)
        {
            cate[k]+=aux%2;
            if(k>maxim)
                maxim=k;
            aux/=2;
            k++;
        }
    }
    for(int i=pow(2.0,pow2-1);i<=l2;i++)
    {
        int aux=i,k=0;
        while(aux)
        {
            cate[k]+=aux%2;
            if(k>maxim)
                maxim=k;
            aux/=2;
            k++;
        }
    }
}

int main()
{
    ifstream f("xor.in");
    freopen("xor.out","w",stdout);
    f>>T>>p;
    for(int i=1;i<=T;i++)
    {
        f>>l1>>c1>>l2>>c2;
        nrlin=l2-l1+1;
        nrcol=c2-c1+1;
        //pe linii
        sum=0;
        for(int i=l1;i<=l2;i++)
            for(int j=c1;j<=c2;j++)
            {
                sum+=i^j;
                sum%=p;
            }
        printf("%d\n",sum);
    }
    fclose(stdout);
    return 0;
}
