#include <stdio.h>
#include <algorithm>
#define Nmax 505
#define Tmax 51
#define LL long long
using namespace std;

// NU uita mod Q

struct indice{ int i,j; } ind[Nmax*Nmax];

int n,t,Q,i,j,z;
LL P[Nmax][Nmax],Pmax[Nmax][Nmax];
LL rez;

long long cat,cat2, TIMP=20000000LL;

inline int abs(int x){ return x>0 ? x:-x; }
inline int Maxim(int x,int y){ return x>y ? x:y; }

void brut(){
	int i,j,p,q,w;
	
	for(w=1;w<=t;++w){
		for(i=1;i<=n;++i) for(j=1;j<=n;++j) Pmax[i][j]=-1;

		for(i=1;i<=n;++i)
			for(j=1;j<=n;++j)
				for(p=1;p<=n;++p)
					for(q=1;q<=n;++q)
						if(!(p==i && q==j))
							Pmax[p][q]=Maxim(Pmax[p][q],P[i][j]-abs(i-p)-abs(j-q));
	
		for(i=1;i<=n;++i)
			for(j=1;j<=n;++j)
				P[i][j] = w+1 + (P[i][j] + w*Pmax[i][j]) % Q;
	}
	
}

inline int cmp(indice a, indice b){
	return P[a.i][a.j] > P[b.i][b.j];
}

void better_brut(){
	int i,j,wh; LL mx,w;
	
	for(i=1;i<=n;++i)
		for(j=1;j<=n;++j) ind[++z].i=i, ind[z].j=j;
	
	for(w=1; w<=t; ++w){
		// sortez descr dupa putere
		sort(ind+1,ind+z+1,cmp); 
		
		for(i=1;i<=n;++i)
			for(j=1;j<=n;++j){
				
				mx=0;
				for(wh=1; wh<=n*n && P[ind[wh].i][ind[wh].j] > mx; ++wh)
					if( !( ind[wh].i==i && ind[wh].j==j ) )
						mx=Maxim(mx,(LL)(P[ind[wh].i][ind[wh].j]-(LL)abs(i-ind[wh].i)-(LL)abs(j-ind[wh].j)));
				
				Pmax[i][j]=mx;
			}
		// actualizez puteri
		for(i=1;i<=n;++i)
			for(j=1;j<=n;++j)
				P[i][j] = (LL)w+1 + (LL)(P[i][j] + (LL)w*Pmax[i][j]) % (LL)Q ;
	}
}

int main(){
	freopen("v2d.in","r",stdin);
	freopen("v2d.out","w",stdout);
	scanf("%d%d%d",&n,&t,&Q);
	for(i=1;i<=n;++i)
		for(j=1;j<=n;++j) scanf("%d",&P[i][j]);
	
	cat=n*n*n*n*t;
	cat2=n*n*n*t;
		
	/*if(cat < TIMP)
		brut();
	else
	if(cat2 < TIMP)*/
	better_brut();

	for(i=1;i<=n;++i)
		for(j=1;j<=n;++j)
			rez=(LL)((rez+P[i][j]) % (LL)Q);

	printf("%lld\n",rez);
	fclose(stdin); fclose(stdout);
	return 0;
}
