#include<stdio.h>
#define infile "arb.in"
#define outfile "arb.out"
#define nmax (100*1013)
struct lista
{
	int n,c,d,p; //nodul, costul, distanta si pozitia
} l[nmax<<1];
struct nod
{
	int p; //poz catre lista
	int hmax; //inaltimea maxima
} no[nmax]; //informatiile nodurilor
char viz[nmax]; //viiiiiiz
int nrl; //numarul de elemente din lista
int n; //nr-ul de noduri
long long cmin; //costul minim

inline int max(int a, int b)
{
	if(a>b) return a; return b;
}

inline void push(int x, int y, int d, int c)
{
	++nrl, l[nrl].n=y, l[nrl].d=d, l[nrl].c=c, l[nrl].p=no[x].p, no[x].p=nrl;
}

void read()
{
	int i,a,b,c,d;
	scanf("%d\n",&n);
	for(i=1;i<n;i++)
	{
		scanf("%d %d %d %d\n",&a,&b,&d,&c);
		push(a,b,d,c);
		push(b,a,d,c);
	}
}

int init_dfs(int x)
{
	int hmax=0,i;
	viz[x]=1;
	
	for(i=no[x].p;i;i=l[i].p)
		if(!viz[l[i].n])
			hmax=max(hmax,l[i].d+init_dfs(l[i].n));
	no[x].hmax=hmax;
	return hmax;
}

void solve_dfs(int x)
{
	int i;
	viz[x]=2;
	for(i=no[x].p;i;i=l[i].p)
		if(viz[l[i].n]!=2)
		{
			cmin+=(no[x].hmax-no[l[i].n].hmax-l[i].d)*l[i].c;
			solve_dfs(l[i].n);
		}
}

void write()
{
	printf("%lld\n",cmin);
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	
	read();
	init_dfs(1);
	solve_dfs(1);
	write();
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
