#include<stdio.h>
#define infile "v2d.in"
#define outfile "v2d.out"
#define nmax 513
struct vrajitor
{
	int x,y,p;
	int d;
} v[nmax*nmax],w[nmax*nmax];
int p[nmax][nmax]; //pueterea fiecareui vrajitor
int pm[nmax][nmax]; // puterea maxima simtita de un vrajitor
int n; //numarul de vrajitori
int t; //numarul de zile
int modulo; ////>:)
int sp; //suma tuturor valorilor din ziua T+1

inline int modul(int x)
{
	if(x<0) return -x; return x;
}

inline int dist(int l1, int c1, int l2, int c2)
{
	return modul(l1-l2)+modul(c1-c2);
}

void read()
{
	int i,j;
	scanf("%d %d %d\n",&n,&t,&modulo);
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			scanf("%d",&p[i][j]);
}

void msort(int st, int dr)
{
	int mij=(st+dr)>>1;
	if(st<mij) msort(st,mij);
	if(mij+1<dr) msort(mij+1,dr);
	
	int st1=st,dr1=mij;
	int st2=mij+1,dr2=dr;
	int st3=1,dr3=0;
	struct vrajitor w[dr1-st1+2];
	while(dr3+st1<=dr1) w[dr3+1]=v[dr3+st1],dr3++;
	while(st2<=dr2 && st3<=dr3)
		if(w[st3].p>=v[st2].p)
			v[st1++]=w[st3++];
		else v[st1++]=v[st2++];
	while(st3<=dr3) v[st1++]=w[st3++];
}

void solve()
{
	int i,j,k,nr,mr;
	
	for(k=1;k<=t;k++)
	{
		//punem vrajitorii
		for(i=1;i<=n;i++)
			for(j=1;j<=n;j++)
				v[(i-1)*n+j].x=i, v[(i-1)*n+j].y=j, v[(i-1)*n+j].p=p[i][j];
		
		//ii sortam dupa puterea de atac
		msort(1,n*n);
		
		//initializam distanta la care ataca
		for(i=n*n;i>0;i--) v[i].d=0;
		
		//si numarul celor care ataca
		for(nr=1;v[nr].p==v[1].p;nr++); nr--;
		
		//cei care trebuie sa fie atacati
		mr=n*n;
		for(i=1;i<=n;i++)
			for(j=1;j<=n;j++)
				w[(i-1)*n+j].x=i, w[(i-1)*n+j].y=j;
		
		//primii trebuie sa atace la distanta 1
		for(i=1;i<=nr;i++) v[i].d=1, v[i].p--;
		
		//facem atacurile
		while(mr)
		{
			//vedem cei care pot fi atacati
			for(i=1;i<=mr;i++)
				for(j=1;j<=nr;j++)
					if(dist(w[i].x,w[i].y,v[j].x,v[j].y) <= v[j].d && dist(w[i].x,w[i].y,v[j].x,v[j].y)>0)
					{
						pm[w[i].x][w[i].y]=v[j].p, w[i]=w[mr--],i--;
						break;
					}
			//marim distantele
			for(i=1;i<=nr;i++) v[i].d++, v[i].p--;
			//vedem daca au aparut oameni noi
			while(v[nr+1].p>v[nr].p) ++nr, v[nr].d=1, v[nr].p--;
		}
		
		//actualizam matricea puterilor
		for(i=1;i<=n;i++)
			for(j=1;j<=n;j++)
				p[i][j]=k+1+((p[i][j]+k*pm[i][j])%modulo);
	}
}

void sum()
{
	int i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=n;j++)
			sp=(sp+p[i][j])%modulo;
}

void write()
{
	printf("%d\n",sp);
}

int main()
{
	freopen(infile,"r",stdin);
	freopen(outfile,"w",stdout);
	
	read();
	solve();
	sum();
	write();
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
