#include <cstdio>
#include <vector>
using namespace std;

#define pb push_back

const int MAX_N = 100010;

int n, mx, sol, nrfr;
int d[MAX_N];
char f[MAX_N];
vector <int> v[MAX_N], c[MAX_N], b[MAX_N];

void df(int nod, int dist)
{
	if (f[nod])
		return;
	f[nod] = 1;

	if (v[nod].empty())
	{
		if (mx < dist)
			mx = dist;
		++nrfr;
		return;
	}

	for (int i = 0; i < v[nod].size(); ++i)
	{
		int fiu = v[nod][i];

		df(fiu, dist + c[nod][i]);
	}
}

void df2(int nod, int dist)
{
	if (f[nod])
		return;
	f[nod] = 1;

	if (v[nod].empty())
	{
		d[nod] = mx - dist;
		return;
	}

	int mn = mx;

	for (int i = 0; i < v[nod].size(); ++i)
	{
		int fiu = v[nod][i];
		df2(fiu, dist + c[nod][i]);

		if (mn > d[fiu])
			mn = d[fiu];
	}

	d[nod] = mn;
}

void df3(int nod, int add)
{
	if (f[nod])
		return;
	f[nod] = 1;

	for (int i = 0; i < v[nod].size(); ++i)
	{
		int fiu = v[nod][i];
		d[fiu] -= add;

		sol += d[fiu] * b[nod][i];
		df3(fiu, add + d[fiu]);
	}
}

int main()
{
	int i;
	freopen("arb.in", "r", stdin);
	freopen("arb.out", "w", stdout);

	scanf("%d", &n);

	for (i = 1; i < n; ++i)
	{
		int x, y, z, cc;
		scanf("%d %d %d %d", &x, &y, &z, &cc);

		v[x].pb(y);
		c[x].pb(z);
		b[x].pb(cc);
	}

	df(1, 0);

	if (nrfr == 1)
	{
		printf("0\n");
		return 0;
	}

	memset(f, 0, sizeof(f));
	df2(1, 0);

	if (n == 3)
	{
		int sol = 0;
		int fiu1 = v[1][0], fiu2 = v[1][1];

		if (d[fiu1] > d[fiu2])
			sol = (d[fiu1] - d[fiu2]) * b[1][0];
		else
			sol = (d[fiu2] - d[fiu1]) * b[1][1];

		printf("%d\n", sol);
		return 0;
	}
	memset(f, 0, sizeof(f));
	df3(1, 0);

	printf("%d\n", sol);

	return 0;
}
