#include<stdio.h>
#include<vector>
#include<algorithm>
#define pb push_back
#define ff first
#define ss second
#define mkp make_pair

const int maxn = 100100;
const int INF = 1000000000;
using namespace std;

vector<pair<int,pair<int,int> > > VECT[maxn];
long long DIN[maxn],MA[maxn];
int DIST[maxn],VER[maxn],N;


void dfs(int nod)
{
	if (VER[nod]) return ;
	VER[nod] = 1;
	for(int i = 0;i < VECT[nod].size(); ++i)
	{
		int vec = VECT[nod][i].ff;
		int dist = VECT[nod][i].ss.ff;
		int cost = VECT[nod][i].ss.ss;
		dfs(vec);
		if (VER[vec] == 2)DIN[nod] += DIN[vec];
		if (VER[vec] == 2)DIST[nod] = max(DIST[nod],DIST[vec] + dist);
	}
	int move = 1;
	for(int i = 0;i < VECT[nod].size(); ++i)
	{
		int vec = VECT[nod][i].ff;
		if (VER[vec] == 1) continue;		
		move = 0;		
		int dist = VECT[nod][i].ss.ff;
		int cost = VECT[nod][i].ss.ss;
		int dif = DIST[nod] - DIST[vec] - dist;
		int aux = min(MA[vec],(long long)cost);
		MA[nod] += aux;
		DIN[nod] += (long long)aux * dif;
	}
	if (move) MA[nod] = INF;
	VER[nod] = 2;
	
}


int main()
{
	freopen("arb.in","r",stdin);
	freopen("arb.out","w",stdout);
	scanf("%d\n",&N);
	for(int i = 1;i < N; ++i)
	{
		int x,y,dist,cost;
		scanf("%d %d %d %d\n",&x,&y,&dist,&cost);
		VECT[x].pb(mkp(y,mkp(dist,cost)));
		VECT[y].pb(mkp(x,mkp(dist,cost)));
	}
	dfs(1);
	printf("%lld\n",DIN[1]);
	return 0;
}


