//Code by Patcas Csaba
//Time complexity: O(t * n^2)
//Space complexity: O(1)
//Method: Partial sums
//Implementation time: 5 minutes

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>

#include <cctype>
#include <ctime>
#include <cassert>

using namespace std;

#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORI(it, X) for(__typeof((X).begin()) it = (X).begin(); it !=(X).end(); ++it) 
#define REPEAT do{ 
#define UNTIL(x) }while(!(x)); 

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define MP make_pair
#define ALL(x) x.begin(), x.end()

#define IN_FILE "xor.in"
#define OUT_FILE "xor.out"
#define MAX_N 1000

ifstream fin(IN_FILE);
ofstream fout(OUT_FILE);

int test, p;
int x1, y1, x2, y2;
VVI sums(MAX_N + 1, VI(MAX_N + 1));

void BuildSums()
{
	FOR(i, 1, MAX_N)
		FOR(j, 1, MAX_N)
			sums[i][j] = (sums[i - 1][j] + sums[i][j - 1] - sums[i - 1][j - 1] + (i ^ j)) % p;
}

int main()
{
	//Read data
	fin >> test >> p;
	BuildSums();
	FORN(t, test)
	{
		int x1, y1, x2, y2;
		fin >> x1 >> y1 >> x2 >> y2;
		int ans = (sums[x2][y2] - sums[x2][y1 - 1] - sums[x1 - 1][y2] + sums[x1 - 1][y1 - 1]) % p;
		fout << ans << endl;
	}
	fin.close();

	//Solve

	//Write data
	fout.close();

	return 0;
}