/**/
#include <stdio.h>

#define ll long long

int P, T;

ll count(ll x, ll bit)
{
	ll c = (x / (bit<<1)) * bit, rest = x % (bit<<1);
	if (rest >= bit)
		c += bit;
	else
		c += rest;
	return c;
}

ll solve(ll x, ll y)
{
	ll zx = 0, zy = 0, bit;
	ll sum = 0;

	++x; ++y;
	for (bit = 1; bit <= x || bit <= y; bit <<= 1)
	{
		zx = count(x, bit);
		zy = count(y, bit);
			
		sum += (((zx * (y-zy) + (x-zx) * zy) % P) * bit) % P;
		if (sum >= P)
			sum -= P;
	}
	return sum;
}

int main()
{
	int x1, y1, x2, y2;
	ll Res;
	
	freopen("xor.in", "r", stdin);
	freopen("xor.out", "w", stdout);
	
	for (scanf("%d %d", &T, &P); T; --T)
	{
		scanf("%d %d %d %d", &x1, &y1, &x2, &y2);
		Res = solve(x2, y2);
		Res -= solve(x2, y1-1);
		if (Res < 0) Res += P;
		Res -= solve(x1-1, y2);
		if (Res < 0) Res += P;
		Res += solve(x1-1, y1-1);
		if (Res >= P) Res -= P;
		printf("%lld\n", Res);
	}
	
    return 0;
}
