// O(M^2)

#include <stdio.h>
#include <stdlib.h>

#define NMAX 2050
#define MMAX 50100

int T[MMAX], C[MMAX], B[MMAX], d[NMAX][NMAX], bmax[MMAX], ant[MMAX];
int i, j, k, N, M, b;

int main()
{
	freopen("bcrc.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
		{
			d[i][j] = abs(i - j);

			if (N - d[i][j] < d[i][j])
				d[i][j] = N - d[i][j];
		}

	T[0] = C[0] = bmax[0] = 0;

	for (k = 1; k <= M; k++)
	{
		bmax[k] = -1;
		ant[k] = -1;

		scanf("%d %d %d", &T[k], &C[k], &B[k]);
		C[k]--;

		for (i = 0; i < k; i++)
		{
			if (T[k] - T[i] >= d[C[i]][C[k]] && bmax[i] >= 0)
				b = bmax[i] + B[k];
			else
				b = -1;

			if (b > bmax[k])
				bmax[k] = b,
				ant[k] = i;
		}
	}

	freopen("bcrc.out", "w", stdout);

	b = 0;
	for (i = 1; i <= M; i++)
		if (bmax[i] > b)
			b = bmax[i],
			k = i;

	printf("%d\n", b);
/*
	fprintf(stderr, "printing solution\n");

	printf("solution:\n");

	M = 0;

	while (1)
	{
		printf("%06d (k = %d): Room %d - %d candies\n", T[k], k, C[k], B[k]);
		M++;

		if (T[k] == 0)
			break;

		k = ant[k];
	}

	printf("--- %d boxes of candies\n", M);
*/
	return 0;
}
