// O(M * N * logN)

#include <stdio.h>
#include <stdlib.h>

#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 2050

int d[NMAX][NMAX], max[2][NMAX], poz[NMAX];
vector<int> Ti[NMAX], bmax[NMAX];
int i, j, k, N, M, T, C, B, b, li, ls, m, ok;

int main()
{
	freopen("bcrc.in", "r", stdin);

	scanf("%d %d", &N, &M);

	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
		{
			d[i][j] = abs(i - j);

			if (N - d[i][j] < d[i][j])
				d[i][j] = N - d[i][j];
		}

	for (i = 0; i < N; i++)
	{
		Ti[i].clear();
		bmax[i].clear();
		poz[i] = 0;
	}

	Ti[0].push_back(0);
	bmax[0].push_back(0);

	for (k = 0; k < M; k++)
	{
		scanf("%d %d %d", &T, &C, &B);
		C--;

		b = -1;

		for (i = 0; i < N; i++)
		{
			li = poz[i];
			ls = bmax[i].size() - 1;
			ok = -1;

			while (li <= ls)
			{
				m = (li + ls) >> 1;

				if (T - Ti[i][m] >= d[i][C])
					ok = m, li = m + 1;
				else
					ls = m - 1;
			}

			if (ok >= 0 && bmax[i][ok] > b)
				b = bmax[i][ok];
		}

		if (b >= 0)
		{
			b += B;

			Ti[C].push_back(T);
			bmax[C].push_back(b);

			ls = bmax[C].size();
			
			if (ls - poz[C] > NMAX)
				poz[C] = ls - NMAX;
		}
	}

	freopen("bcrc.out", "w", stdout);
	b = 0;

	for (i = 0; i < N; i++)
	{
		ls = bmax[i].size();

		if (ls > 0 && bmax[i][ls - 1] > b)
			b = bmax[i][ls - 1];
	}

	printf("%d\n", b);

	return 0;
}
