#include <stdio.h>
#include <string.h>

#define NMAX 12600000
#define VMAX 46342

#define getbit(poz) (x[poz >> 3] & (1 << (q & 7)))
#define setbit(poz) (x[poz >> 3] |= (1 << (q & 7)))

unsigned char x[NMAX], x1[VMAX];
//int l[VMAX];
int i, j, A, B, C, p, q, cnt;

int main()
{
	memset(x1, 0, sizeof(x1));

	x1[1] = 1;

	for (i = 2; i < VMAX; i++)
		if (!x1[i])
		{
			//fprintf(stderr, "%d\n", i);

			if (i * i < VMAX)
				for (j = i * i; j < VMAX; j += i * i)
					x1[j] = 1;
		}

	freopen("nasa.in", "r", stdin);

	scanf("%d %d", &A, &B);

	memset(x, 0, sizeof(x));

	cnt = B - A + 1;

	/*
	if (A == 1)
	{
		setbit(0);
		cnt--;
	}
	*/

	for (i = 2; i < VMAX && i * i<= B; i++)
		if (!x1[i])
		{
			p = i * i;

			C = p * (A / p);

			if (C < A)
				C += p;

			while (C <= B && C >= A)
			{
				/*
				if (i >= 1000)
					fprintf(stderr, "%d\n", C);
				*/

				q = C - A;

				if (!(getbit(q)))
				{
					cnt--;
					setbit(q);
				}

				C += p;
			}
		}

	freopen("nasa.out", "w", stdout);

	printf("%d\n", cnt);

	/*
	q = 0;
	for (i = 2; i < VMAX; i++)
		if (!x1[i])
			l[++q] = i;

	cnt = 0;
	for (i = A; i <= B; i++)
	{
		p = 1;

		for (j = 1; j <= q && l[j] * l[j] <= i; j++)
			if (i % (l[j] * l[j]) == 0)
			{
				p = 0;
				break;
			}

		cnt += p;
	}

	printf("%d\n", cnt);
	*/
	return 0;
}
