/* TO DO: elimina looseri din start */
#include <stdio.h>
#include <algorithm>
#include <queue>

using namespace std;

#define MAX_N 20005
#define FIN "campion.in"
#define FOUT "campion.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define EPS 1e-9
#define f first
#define s second
#define mp make_pair

int N, T, P[MAX_N], P2[MAX_N], Res; char champ[MAX_N];
pair<int, int> E[MAX_N];
priority_queue<pair<double, pair<int, int> > > H;
double current_time;

inline void insert_event(int i, int j)
{
   if (E[i].s < E[j].s) return;
   double time = E[i].s != E[j].s && E[i].f != E[j].f ? (double)(E[j].f-E[i].f)/(double)(E[i].s-E[j].s) : 1e13;
   if (current_time < time+EPS && time < T+EPS) H.push(mp(-time, mp(j, i)));
}

int main(void)
{
   int i, j;
   double t;

   freopen(FIN, "r", stdin);
   freopen(FOUT, "w", stdout);

   scanf("%d %d", &N, &T);
   FOR (i, 0, N) scanf("%d %d", &E[i].f, &E[i].s);

   sort(E, E+N);
   reverse(E, E+N);
   FOR (i, 0, N) champ[i] = (E[i].f == E[0].f);

   FOR (i, 0, N) P[i] = P2[i] = i;
   FOR (i, 1, N) insert_event(P[i], P[i-1]);

   while (!H.empty() && -H.top().f < (double)T+EPS)
   {
       current_time = -H.top().f;
       i = H.top().s.f; j = H.top().s.s;
       H.pop();
       if (P2[j] != P2[i]+1) continue;
       P[P2[i]] = j; P[P2[j]] = i;
       swap(P2[i], P2[j]);
       if (!P2[j]) champ[j] = 1;
       if (P2[j]-1 >= 0) insert_event(j, P[P2[j]-1]);
       if (P2[i]+1 < N) insert_event(P[P2[i]+1], i);
   }

   FOR (i, 0, N)
   {
       if (i > 0 && E[i] == E[i-1] && champ[i-1]) champ[i] = 1;
       Res += champ[i];
   }
   printf("%d\n", Res);

   return 0;
}